#!/usr/local/bin/oraperl  

# -----------------------
# filename: colls_search.pl
# 
# written June/July 1997
# author Barbara Mihalas
# copyright Forepoint LLC
# -----------------------

#In colls_search.pl
#=======================
#sub dummy_parse
#sub parse 
#sub main_routine
#sub print_all_docs_selected
#sub print_search_resultsA
#sub SearchByModel 
#sub SearchByDoctype
#sub SearchByCatnum
#=======================

#In colls_search1.pl
#=======================
#sub SearchByCapacity
#sub SearchByCategory 
#sub SearchByFormnum
#sub SearchByKeyword;
#sub SearchGeneral;
#sub SearchGeneralNoCap;
#sub PrintInput
#=======================

$DEBUG=0;

#require('/oradata/disk4/httpddv/cgi-bin/cdata/COLLS/pldv/pkg_utils.pl');
require('/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/pkg_utils.pl');
#require('/oradata/disk4/httpddv/cgi-bin/cdata/COLLS/pldv/pkg_write_colls_forms.pl');
require('/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/pkg_write_colls_forms.pl');
#require('/oradata/disk4/httpddv/cgi-bin/cdata/COLLS/pldv/colls_search1.pl');
require('/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/colls_search1.pl');

$htdochome   = "http://www.carrier.com/wp";

   &html_header( 'COLLS Search Results');

   $logfile = 'logs/COLLSSRCH.log';
   open (LOGFILE, ">>$logfile") ;

#===========  oraperl setup =====================
$ENV{'ORACLE_HOME'}= "/usr/oracle";
$ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
$ENV{'WOW_UID'}= "wow_user/wow_user";
$ENV{'ORACLE_SID'}= "mindy";
# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit" if 0;
# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;
# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;
# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');
# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', 'wow_user', 'wow_user')	|| die $ora_errstr;
# ==============  end of oraperl setup =======================

#=====================Define global cursors=========================


#=========== body of  program =====================

  $buffer = $ENV{'QUERY_STRING'};

  &parse;
  $searchtype = $value[0];

  for ($ichk = 0; $ichk <= $#value; $ichk++)
  {
      &write_comment("NAME: $name[$ichk], VALUE: $value[$ichk]");
  }

  &main_routine ($searchtype);

#=========== end body of program =================


# ================= oraperl cleanup ========================
# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;

# ==============  end of oraperl cleanup =====================


#===========  start of subroutines ===================
#===============================================
sub dummy_parse
{
   $value[0] = 'BYMODEL';
   $name[0]  = 'search';
   $name[1]  = 'MODELNO';
   $value[1] = '51';
   $name[2]  = 'MODELNO';
   $value[2] = '24';
   $name[3]  = 'MODELNO';
   $value[3] = '28';
   $name[4]  = 'MODELNO';
   $value[4] = '53';
   $name[5]  = 'MODELNO';
   $value[5] = '77';
   $name[6]  = 'DOCTYPE';
   $value[6] = '3';
}   

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $buffer);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       &write_comment( "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> ");
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

# *********************************************
sub main_routine
{
   local  ($search) = @_;

   &write_comment("Number of values is $#value ");

   $search =~ tr/a-z/A-Z/;
   &write_comment( " input search parameter is $search ");

   if ($search eq 'BYMODEL')
   {
      &SearchByModel;
   }
   elsif ($search eq 'BYCATEGORY')
   {
      &SearchByCategoryA;
   }
   elsif ($search eq 'BYCAPACITY')
   {
      &SearchByCapacityA;
   }
   elsif ($search eq 'BYDOCTYPE')
   {
      &SearchByDoctype;
   }
   elsif ($search eq 'BYKEYWORD')
   {
      &SearchByKeyword;
   }
   elsif ($search eq 'BYFORMNUM')
   {
      &SearchByFormnumA;
   }
   elsif ($search eq 'BYCATNUM')
   {
      &SearchByCatnum;
   }
   elsif ($search eq 'GENERAL')
   {
      &SearchGeneral;
   }
   else
   {
      return;
   } 
}

#============================================

#============================================
sub SearchByModel 
{
 # if ($DEBUG) 
 #  &PrintInput;

   local($PDF_MODEL_LIST_ALLMODELS) =
             "SELECT docformnum, doc_descr, pdf_filename, pdf_filesize,
                     docid, doccatnum,  doctype_id, doctype
                FROM colls_doctype_0
               WHERE doctype_id = :1
               ORDER BY docformnum";


   local($DISTINCT_DOCID) =
             "SELECT DISTINCT docid, docformnum
                FROM colls_doctype_0
               WHERE docid IN (SELECT DISTINCT docid
                                 FROM n_doc_model_assoc
                                WHERE modelid IN (:1, :2, :3, :4, :5) )
                 AND doctype_id LIKE :6
               ORDER BY docformnum";


   local($GET_DOCINFO) =
             "SELECT docid, docformnum, doc_descr, pdf_filename, pdf_filesize, 
                     doccatnum, doctype_id, doctype
                FROM colls_doctype_0
               WHERE docid = :1";


   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";


   local($csrdistinct) = &ora_open($lda, $DISTINCT_DOCID) 
                          || print "<!-- failed to open cursor $DISTINCT_DOCID -->\n";

   local($csrdocinfo)  = &ora_open($lda, $GET_DOCINFO)
                          || print "<!-- failed to open cursor $GET_DOCINFO -->\n";

   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "<!-- failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS  -->\n";

   local($csrpdflist) = &ora_open ($lda, $PDF_MODEL_LIST_ALLMODELS)
                 || print "<!-- failed to open cursor $PDF_MODEL_LIST_ALLMODELS --> \n";
   

   print "<!-- Query is $DISTINCT_DOCID  --> \n";

   for ($i=0; $i<= $#value; $i++)
   {
      &write_comment( "$i, NAME: $name[$i]; VALUE: $value[$i] ");
   }

   $imdl = 0;
   $idtype = 0;

   $ALLMODELS='N';
   $ALLDOCTYPES='N';
   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELNO')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdl[$imdl] = '%%';
         }
         &write_comment( "Model ID is $mdl[$imdl]");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtype[$idtype] = '%%';
         }
         &write_comment( "Doctype ID is $dtype[$idtype]");
         $idtype++;
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_by_model_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

# group selected models in sets of 5; fill last set if needed
#============================================================
   $imdlmod = int($imdl/5);
   &write_comment("imdl is $imdl; idtype is $idtype");
  print "<!-- Number of models is 5*$imdlmod + ($imdl - 5*$imdlmod) <BR> -->";

   if ( $imdl > 5 * $imdlmod)
   {   
      for ($im=$imdl; $im<= 5*$imdlmod + 5; $im++)
      {
         $mdl[$im] = $mdl[$imdl-1];
         &write_comment( "for index $im, the modelid is $mdl[$im]");
      }
   }

   $idtypemod = int( $idtype/5);
   &write_comment("idtype is $idtype; idtypemod is $idtypemod; remainder is $idtype - 5*$idtypemod");
#  &write_comment("$mdl[0], $mdl[1], $mdl[2], $mdl[3], $mdl[4], $dtype0");

#-----------------------------------------------------
   if ( $ALLMODELS eq 'N')
   {
      &write_comment("allmodels=N and alldoctypes=N or Y");
   
      $stbind = &ora_bind ($csrdistinct, $mdl[0], $mdl[1], $mdl[2], $mdl[3], $mdl[4], 
                                 $dtype[0] );
      print "<!-- bind status for csrdistinct is $stbind <BR> -->\n";
   
      $ipdf = 0;
   
      for ($jmod=0; $jmod<=$imdlmod; $jmod++)
      {
         $jm0 = $jmod*5;
         for ($jdtmod=0; $jdtmod<=$idtypemod; $jdtmod++)
         {
            $jd0 = $jdtmod*5;
            $stbind = &ora_bind ($csrdistinct, $mdl[$jm0+0], $mdl[$jm0+1], $mdl[$jm0+2], $mdl[$jm0+3], $mdl[$jm0+4], 
                                 $dtype[$jd0+0]); 
            print "<!-- bind status for csrdistinct is $stbind <BR> -->\n";
 
            while ( ($docidlist[$ipdf], $formnumlist[$ipdf]) = &ora_fetch($csrdistinct) )
            {   
               $bindstatus = &ora_bind($csrdocinfo, $docidlist[$ipdf]);
               print "<!-- bind status for docinfo is $bindstatus -->";

               ($docid[$ipdf], $docformnum[$ipdf], $doctitle[$ipdf], $pdfname[$ipdf],
               $pdfsize[$ipdf],  $doccatnum[$ipdf], $doctype_id[$ipdf], $doctype[$ipdf])
               = &ora_fetch($csrdocinfo);

               $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
               &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );

               $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
               print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
               $pdfmodel[$ipdf] = "";
               while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
               {
                  $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
               }
               $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
               $ipdf++;
            }
         }
      }
      $ipdf--;

      $write_form = 'colls_by_model.sh';
      &print_search_resultsA($write_form);
   }
#-----------------------------------------------------
   elsif ($ALLMODELS eq 'Y' && $ALLDOCTYPES eq 'N')
   {

      &write_comment("allmodels=Y and alldoctypes=N");

      $ipdf=0;
      for ($jdtmod=0; $jdtmod<=$idtypemod; $jdtmod++)
      {
         $jd0 = $jdtmod*5;
         $stbind = &ora_bind ($csrpdflist, $dtype[$jd0+0]);
         print "<!-- bind status is $stbind <BR> -->\n";

         while ( ($docformnum[$ipdf], $doctitle[$ipdf], $pdfname[$ipdf], 
                  $pdfsize[$ipdf], $docid[$ipdf], $doccatnum[$ipdf], $doctype_id[$ipdf],
                  $doctype[$ipdf]) 
                = &ora_fetch($csrpdflist) )
         {
            $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
            &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
            $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
            print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
            $pdfmodel[$ipdf] = "";
            while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
            {
               $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
            }
            $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
            $ipdf++;
         }
      }
      $ipdf--;
      $write_form = 'colls_by_model.sh';
      &print_search_resultsA($write_form);
   }

#----------------------------------------------------
   else  # $ALLMODELS = 'Y' and $ALLDOCTYPES = 'Y'
   {
      $write_form = 'colls_by_model.sh';
      &print_all_docs_selected($write_form);
   }
 

   &ora_close($csrpdflist);
   &ora_close($csrdocinfo);
   &ora_close($csrdistinct);
   &ora_close($csrdocmdl);

   &html_footer;
}

#*********************************************************
# Print the return if all documents are selected
#*********************************************************
sub print_all_docs_selected
{

   local($colls_form) = @_;

   $backimage = "$htdochome/com_cl5/cl5_media/new_search.gif";

   print "<TABLE WIDTH=440><TR><TD>\n";
   print "<FONT SIZE=2 FACE=\"Ariel,Helvetica\"> \n";
   print "<CENTER>\n";
   print "Use your browser's <B>back</B> button to reload and modify \n";
   print "your previous search criteria, <BR>\n";
   print " or use the <B>NEW SEARCH</B> button at the bottom of the page.<P>\n";
   print "</CENTER>\n";
   print "</TD></TR></TABLE>\n";
  
   &write_comment("Number of documents found is NNDOCS = $NNDOCS; NDOCS = $NDOCS");

   print "<TABLE WIDTH=440><TR><TD>\n";
   print "<FONT SIZE=4>About 580 documents match your query. </FONT><P>\n";
   print "Try being more restrictive with your search criteria. <P>\n";
   print "</TD></TR></TABLE>\n";

   print "<TABLE WIDTH=440>\n";
   print "<TR><TD ALIGN=\"CENTER\">\n";
   print "<A HREF=\"http://wwwd.carrier.com:6399/cgi-bin/cdata/COLLS/$colls_form\">\n";
   print "<IMG SRC=\"$backimage\" BORDER=0 ></A>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";
} 

#*********************************************************
# Print the 
#*********************************************************
sub print_cap_values_switched
{

   local($colls_form) = @_;

   $backimage = "$htdochome/com_cl5/cl5_media/new_search.gif";

   print "<TABLE WIDTH=440><TR><TD>\n";
   print "<FONT SIZE=2 FACE=\"Ariel,Helvetica\"> \n";
   print "<CENTER>\n";
   print "Use your browser's <B>back</B> button to reload and modify \n";
   print "your previous search criteria, <BR>\n";
   print " or use the <B>NEW SEARCH</B> button at the bottom of the page.<P>\n";
   print "</CENTER>\n";
   print "</TD></TR></TABLE>\n";
  
   &write_comment("Number of documents found is NNDOCS = $NNDOCS; NDOCS = $NDOCS");

   print "<TABLE WIDTH=440><TR><TD>\n";

   print "<P>The value you entered for minimum capacity is larger than\n";
   print "the value entered for maximum capacity.  Please reload the \n";
   print "form and choose a valid range.<P>\n";

   print "</TD></TR></TABLE>\n";

   print "<TABLE WIDTH=440>\n";
   print "<TR><TD ALIGN=\"CENTER\">\n";
   print "<A HREF=\"http://wwwd.carrier.com:6399/cgi-bin/cdata/COLLS/$colls_form\">\n";
   print "<IMG SRC=\"$backimage\" BORDER=0 ></A>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";
} 

#*********************************************************
# Print the 
#*********************************************************
sub print_cap_values_needed
{

   local($colls_form) = @_;

   $backimage = "$htdochome/com_cl5/cl5_media/new_search.gif";

   print "<TABLE WIDTH=440><TR><TD>\n";
   print "<FONT SIZE=2 FACE=\"Ariel,Helvetica\"> \n";
   print "<CENTER>\n";
   print "Use your browser's <B>back</B> button to reload and modify \n";
   print "your previous search criteria, <BR>\n";
   print " or use the <B>NEW SEARCH</B> button at the bottom of the page.<P>\n";
   print "</CENTER>\n";
   print "</TD></TR></TABLE>\n";
  
   &write_comment("Number of documents found is NNDOCS = $NNDOCS; NDOCS = $NDOCS");

   print "<TABLE WIDTH=440><TR><TD>\n";

   print "<P>You failed to enter at least one end of the capacity range. \n";
   print "Please reload the form and enter values for both minumum and \n";
   print "maximum capacity. \n";

 # print "<FONT SIZE=4>About 580 documents match your query. </FONT><P>\n";
 # print "Try being more restrictive with your search criteria. <P>\n";

   print "</TD></TR></TABLE>\n";

   print "<TABLE WIDTH=440>\n";
   print "<TR><TD ALIGN=\"CENTER\">\n";
   print "<A HREF=\"http://wwwd.carrier.com:6399/cgi-bin/cdata/COLLS/$colls_form\">\n";
   print "<IMG SRC=\"$backimage\" BORDER=0 ></A>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";
} 
#*********************************************************
# Print the results header and the result links
#*********************************************************
sub print_search_resultsA
{

   local($colls_form) = @_;

   $NDOCS = $ipdf-1;
   $NNDOCS = $ipdf;
   $NNDOCSP = $ipdf +1;

   $GET_EQPCAT = "SELECT eqpcat 
                    FROM colls_eqpcat
                   WHERE docid = :1
                     AND eqpcatid IS NOT NULL";

   $GET_EQPSUBCAT = 
                 "SELECT eqpsubcat 
                    FROM colls_eqpcat
                   WHERE docid = :1
                     AND eqpsubcatid IS NOT NULL";

   $GET_EQPSUBSUBCAT = 
                 "SELECT eqpsubsubcat 
                    FROM colls_eqpcat
                   WHERE docid = :1
                     AND eqpsubsubcatid IS NOT NULL";

   $csrcat = &ora_open($lda, $GET_EQPCAT)
                   || print "failed to open cursor $GET_EQPCAT <BR>\n";

   $csrsubcat = &ora_open($lda, $GET_EQPSUBCAT)
                   || print "failed to open cursor $GET_EQPSUBCAT <BR>\n";

   $csrsubsubcat = &ora_open($lda, $GET_EQPSUBSUBCAT)
                   || print "failed to open cursor $GET_EQPSUBSUBCAT <BR>\n";
 
   print "<P><BR><P>\n";

   $backimage = "$htdochome/com_cl5/cl5_media/new_search.gif";
#  &write_comment("back image is $backimage");

   print "<TABLE WIDTH=440><TR><TD>\n";
   print "<FONT SIZE=2 FACE=\"Ariel,Helvetica\"> \n";
   print "<CENTER>\n";
   print "Use your browser's <B>back</B> button to reload and modify \n";
   print "your previous search criteria, <BR>\n";
   print " or use the <B>NEW SEARCH</B> button at the bottom of the page.<P>\n";
   print "</CENTER>\n";
   print "</TD></TR></TABLE>\n";
  
   &write_comment("Number of documents found is NNDOCS = $NNDOCS; NDOCS = $NDOCS");

   print "<TABLE WIDTH=440>\n";
   print "<UL>\n";

   if ($NNDOCSP == 0)
   {
      print "<TABLE WIDTH=440><TR><TD>\n";
      print "<FONT SIZE=4> No documents match the query.<P></FONT>\n";
      print "Try being less restrictive with your search criteria.<P> \n";
      print "</TD></TR></TABLE>\n";
   }


   if ($NNDOCS >= 0)
   {
      if($NNDOCS == 0)
      {
         print "<FONT SIZE=4>$NNDOCSP document matches your query: </FONT>\n";
      }
      elsif ($NNDOCS > 0 && $NNDOCS < 150 )
      {
         print "<FONT SIZE=4>$NNDOCSP documents match your query: </FONT>\n";
      }
      elsif ($NNDOCS > 100)
      {
         print "<TABLE WIDTH=440><TR><TD>\n";
         print "<FONT SIZE=4>About $NNDOCS documents match your query. </FONT><P>\n";
         print "The first 100 documents are listed below.<BR>\n";  
         print "Try being more restrictive with your search criteria. <P>\n";
         print "</TD></TR></TABLE>\n";
         $NNDOCS = 99;
      }
      print "<P>\n";

      for ($ip=0; $ip <= $NNDOCS; $ip++)
      {
         $icat=0;
         $iscat=0;
         $isscat=0;

         $bindcat       = &ora_bind($csrcat,       $docid[$ip]);
         $bindsubcat    = &ora_bind($csrsubcat,    $docid[$ip]);
         $bindsubsubcat = &ora_bind($csrsubsubcat, $docid[$ip]);

         while ( ($eqpcat[$icat]) = &ora_fetch($csrcat) )
         {
            $icat++;
         }
         while ( ($eqpsubcat[$iscat]) = &ora_fetch($csrsubcat) )
         {
            $iscat++;
         }
         while ( ($eqpsubsubcat[$isscat]) = &ora_fetch($csrsubsubcat) )
         {
            $isscat++;
         }

         $ipp = $ip +1;
         print "$ipp.  \n";
         print "<FONT SIZE=3><B>Model: $pdfmodel[$ip] </B></FONT> \n";
         print " <FONT SIZE=2> ($doctype[$ip] )</FONT>\n";
         print "<BR>\n";
         print "<UL>\n";


         if ($search eq 'BYCATEGORY')
         {
            print " <FONT SIZE=2>Category: $ecatdesc[$ip] </FONT><BR>\n";
         }
          
         print "<FONT SIZE=2>Title: $doctitle[$ip]</FONT><BR>\n";

         $user_agent =  $ENV{'HTTP_USER_AGENT'};
         print "<!-- user_agent is $user_agent; --> \n";
         ($b1, $b2, $b3, $b4)  =  split(';', $user_agent );

         print "<!--  b1=$b1; b2=$b2; b3=$b3; b4=$b4 --> \n";
         if ($b2 eq ' MSIE 4.0')
         {
            print "<A TARGET=\"EXTERNAL\" \n";
            print " HREF=\"http://mork.infomall.org/private/commercial/downloads_l1/$pdfname[$ip].PDF\">\n";
         }
         else 
         {
            print "<A  \n";
            print " HREF=\"http://mork.infomall.org/private/commercial/downloads_l1/$pdfname[$ip].PDF\">\n";
         }

      #  print "<A HREF=\"http://mork.infomall.org/private/commercial/downloads_l1/$pdfname[$ip].PDF\">\n";

         print "<IMG SRC=\"$htdochome/com_cl5/cl5_media/pdf_icon.gif\" WIDTH=\"16\" HEIGHT=\"22\" \n";
         print "ALIGN=\"MIDDLE\" BORDER=\"0\"> \n";

         print "<FONT SIZE=2>$docformnum[$ip]</FONT></A> \n";
         print "<FONT SIZE=2>($pdfsizekb[$ip] kb)</FONT> \n";
         print "<FONT SIZE=2>; Catalog Number: $doccatnum[$ip]</FONT> \n";
         if ($search eq 'BYKEYWORD')
         {
             print "<BR><FONT SIZE=2>keyword: $kword[$ip]</FONT>\n";
         }
         print "</UL><P>\n";
      }
      print "</UL>\n";
      print "</TABLE>\n";
   }
   print "<TABLE WIDTH=440>\n";
   print "<TR><TD ALIGN=\"CENTER\">\n";
   print "<A HREF=\"http://wwwd.carrier.com:6399/cgi-bin/cdata/COLLS/$colls_form\">\n";
   print "<IMG SRC=\"$backimage\" BORDER=0 ></A>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";

   &ora_close($csrcat);
   &ora_close($csrsubcat);
   &ora_close($csrsubsubcat);
}

#*********************************************************
  
#*********************************************************
sub SearchByDoctype
{
   if ($DEBUG) { &PrintInput; }

   local($SBY_DOCTYPE) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE doctype_id IN (:1, :2, :3, :4, :5)
                  AND docid in (SELECT DISTINCT docid 
                                  FROM n_doc_model_assoc
                                 WHERE modelid LIKE :6)
                ORDER BY docformnum";

   local($SALL_DOCTYPES) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid in (SELECT DISTINCT docid 
                                  FROM n_doc_model_assoc
                                 WHERE modelid LIKE :1)
                ORDER BY docformnum";

   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";

   &write_comment ("SBY_DOCTYPE cursor is $SBY_DOCTYPE");
   &write_comment ("SBY_DOCTYPE cursor is $SALL_DOCTYPES");

#=====================End of local cursors=========================

   local($csrdoctype) = &ora_open($lda, $SBY_DOCTYPE)
                  || print "failed to open cursor $SBY_DOCTYPE<BR>\n";
             
   local($csralldoctypes) = &ora_open($lda, $SALL_DOCTYPES) 
                  || print "failed to open cursor $SALL_DOCTYPES<BR>\n";

   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "<!-- failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS  -->\n";

   $idtype = 0;
   $imdl   = 0;

   $ALLDOCTYPES='N';
   $ALLMODELS='N';
   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELNO')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdl[$imdl] = '%%';
         }
         &write_comment( "Model ID stem is $mdl[$imdl]");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtype[$idtype] = '%%';
         }
         &write_comment( "Doctype ID is $dtype[$idtype]");
         $idtype++;
      }
      elsif ($name[$i]  eq 'Reset.x')
      {
         &write_doctype_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

#==============================================================
   if ($idtype == 0)
   {
      $write_form = 'colls_by_doctype.sh';
      &print_all_docs_selected($write_form);
    # print "You will need to select one or more document types <BR>\n";
    # print "or select the \"All Document Types\" option to initiate<BR>\n";
    # print "a meaningful search. <P>\n";
    # &write_doctype_form;
      $html_footer;
      return;
   }
   

# group selected doctypes in sets of 5; fill last set if needed
#==============================================================
   $idtmod = int($idtype/5);
   &write_comment("idtype is $idtype");
#  print "Number of selected doctypes is 5*$idtmod + ($idtype - 5*$idtmod) <BR>\n";

   if ( $idtype > 5 * $idtmod)
   {   
      for ($idt=$idtype; $idt<= 5*$idtmod + 5; $idt++)
      {
         $dtype[$idt] = $dtype[$idtype-1];
         &write_comment( "for index $im, the doctypeid is $dtype[$idt]");
      }
   }

 # print "doctype[0] is $doctype[0]; model stem is $mdl[0]<BR>\n";

# Search for All document types
#===============================

   if ($ALLDOCTYPES eq 'Y')
   {
      if ($ALLMODELS eq 'Y')
      {
         $write_form = 'colls_by_doctype.sh';
         &print_all_docs_selected($write_form);
      }
      else
      {
       # &write_comment("Query is $SALL_DOCTYPES ");
         $ipdf = 0;
   
         $bindmdl = "$mdl[0]";
         &write_comment("doctype is ALL; bind model is $bindmdl ");
   
         $bindstatus = &ora_bind($csralldoctypes, $bindmdl);
         &write_comment("bind status is $bindstatus ");
   
   # docid, model, modelid, doctype_id, doctype, doc_descr, 
   # docformnum, doccatnum, pdf_filename, pdf_filesize
   #---------------------------------------------------
         while ( ($docid[$ipdf], $doctype_id[$ipdf],
                $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
                $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csralldoctypes) )
         {
            $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
            $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
            print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
            $pdfmodel[$ipdf] = "";
            while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
            {
               $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
            }
            $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
            $ipdf++;
            &write_comment("in loop");
         }
      #  &write_comment("ipdf = $ipdf");
         $ipdf--;

         $write_form = 'colls_by_doctype.sh';
         &print_search_resultsA($write_form);
      }
   }
# Search for a selected subset of document types
#===============================================

   else                    # $ALLDOCTYPES = 'N'
   {
      &write_comment("model is $mdl[0]; number of doctypes is $idtype");
      if ( $ALLMODELS eq 'Y')
      {
         $bindmdl = "%%";
      }
      else
      {
         $bindmdl = "$mdl[0]";
      }

      $ipdf=0;
      for ($jdt=0; $jdt<=$idtmod; $jdt++)
      {
         $jd0 = $jdt*5;
         $bindstatus = &ora_bind ($csrdoctype, $dtype[$jd0+0], $dtype[$jd0+1], 
                  $dtype[$jd0+2], $dtype[$jd0+3], $dtype[$jd0+4], $bindmdl ); 
         print "<!-- bind status is $stbind <BR> -->\n";

         while ( ($docid[$ipdf],  $doctype_id[$ipdf],
            $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
            $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csrdoctype) )
         {
            $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
            $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
            print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
            $pdfmodel[$ipdf] = "";
            while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
            {
               $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
            }
            $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
            $ipdf++;
         }
      }
      $ipdf--;

      $write_form = 'colls_by_doctype.sh';
      &print_search_resultsA($write_form);
   }

   &html_footer;
}
 
#*********************************************************

#*********************************************************
sub SearchByCatnum
{

   if ($DEBUG) { &PrintInput; }

   $DOCID1     = 
              "SELECT DISTINCT doccatnum, docformnum
                 FROM colls_doctype_0
                WHERE doccatnum IN (:1, :2, :3, :4, :5)
                   OR upper(doccatnum) LIKE :6
                ORDER BY docformnum";

   local($BY_CATNUM) =
              "SELECT DISTINCT       docid,         docformnum,    title, 
                      pdf_filename,  pdf_filesize,   doccatnum,     doctype_id, 
                      doctype       
                 FROM colls_document
                WHERE doccatnum IN (:1, :2, :3, :4, :5)
                   OR upper(doccatnum) LIKE :6
                ORDER BY docformnum";

   local($BY_CATNUM1) =
              "SELECT DISTINCT       docid,         docformnum,    title, 
                      pdf_filename,  pdf_filesize,   doccatnum,     doctype_id, 
                      doctype       
                 FROM colls_document
                WHERE doccatnum IN (:1, :2, :3, :4, :5)
                  AND upper(doccatnum) NOT LIKE :6
                ORDER BY docformnum";

   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";

#=====================End of global cursors=========================

   local($csrcatnum) = &ora_open($lda, $BY_CATNUM)
                  || print "failed to open cursor BY_CATNUM $BY_CATNUM<BR>\n";
             
   local($csrcatnum1) = &ora_open($lda, $BY_CATNUM1) 
                  || print "failed to open cursor BY_CATNUM1 $BY_CATNUM1 <BR>\n";

   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS <BR>\n";

   $imdl   = 0;
   $ifnum  = 0;

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'CATNUM')
      {
         $fm[$ifnum] = $value[$i]; 
         $fm[$ifnum] +~ tr/a-z/A-Z/;
         &write_comment( "Catalog number is $fm[$ifnum]");
         $ifnum++;
      }
      elsif ($name[$i] eq 'CATNUMSTR')
      {
         $cnstr = $value[$i]; 
         $cnstr +~ tr/a-z/A-Z/;
         if ($cnstr eq "")
         {
            $cnstr = "XXXXXX";
         }
         &write_comment( "Catalog number is $cnstr");
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_formnum_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

# 
#==============================================================

   $ifn = int($ifnum/5);
   &write_comment("ifnum is $ifnum");
#  print "Number of selected catalog numbers is 5*$ifn + ($ifnum - 5*$ifn) <BR>\n";

   if ( $ifnum > 5 * $ifn)
   {   
      for ($if=$ifnum; $if<= 5*$ifn + 5; $if++)
      {
         $fm[$if] = $fm[$ifnum-1];
         &write_comment( "for index $if, the catnum is $fm[$if]");
      }
   }

   $ipdf = 0;

   $jf0 = 0;
   $bfmstr = "%$cnstr%";
   $stbind = &ora_bind ($csrcatnum, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                  $bfmstr); 
   print "<!-- csrcatnum bind status is $stbind <BR> -->\n";

   while ( ($docid[$ipdf],   $docformnum[$ipdf], $doctitle[$ipdf],   $pdfname[$ipdf], 
            $pdfsize[$ipdf], $catnum,  $doctype_id[$ipdf], $dtypetmp )
          = &ora_fetch($csrcatnum) )
   {
      $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
      $doccatnum[$ipdf] = $catnum;
      $doctype[$ipdf]   = $dtypetmp;

      $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
      print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
    
      $pdfmodel[$ipdf] = "";
      while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
      {
         $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
      }
      $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
      print "<!-- docid $docid[$ipdf]; doccatnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
      &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
      $ipdf++;
   }

   for ($jf=1; $jf<=$ifn; $jf++)
   {
      $jf0 = $jf*5;
      $stbind = &ora_bind ($csrcatnum1, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                  $bfmstr); 
      print "<!-- bind status is $stbind <BR> -->\n";

      while ( ($docid[$ipdf],   $docformnum[$ipdf], $doctitle[$ipdf],   $pdfname[$ipdf], 
               $pdfsize[$ipdf], $doccatnum[$ipdf],  $doctype_id[$ipdf], $doctype[$ipdf] )
             = &ora_fetch($csrcatnum1) )
      {
         $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
         $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
         $pdfmodel[$ipdf] = "";
         while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
         {
            $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
         }
         print "<!-- docid $docid[$ipdf]; catnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
         &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
         $ipdf++;
      }
   }
   $ipdf--;
   $write_form = 'colls_by_formnum.sh';
   &print_search_resultsA($write_form);

   &close($csrcatnum);
   &close($csrcatnum1);
   &close($csrdocmdl);

   &html_footer;
}


#*********************************************************
#*********************************************************
sub PrintInput
{
   print "<UL>\n";
   print "<FONT SIZE=4>Input Values from Keyword Form:</FONT><P>\n";
   print "<TABLE CELLSPACING=10  BORDER=2 >\n";
   print "<TR><TH>Index</TH><TH>Name</TH><TH>Value</TH></TR>\n";
   for ($i = 0; $i <= $fields; $i++) 
   {
       if ($value[$i] eq "")
       {  $value[$i] = "&nbsp"; }
       print "<TR><TD>$i </TD><TD> $name[$i] </TD><TD> $value[$i]</TD></TR>\n";
   }
   print "</TABLE><BR>\n";
   print "</UL>\n";
}
