DROP PACKAGE cmoddocs;
CREATE OR REPLACE PACKAGE cmoddocs AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:6377/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6377/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/wowc/';
   owihome             VARCHAR2(70)    := basehtml||'wpdv/';
   plhome              VARCHAR2(70)    := basehtml||'cgi-bin/cdata/';

   widthll             NUMBER(10)      := 162;
   baseftp             VARCHAR2(60)    := 'ftp://kayak.npac.syr.edu:6398/cdata/download/';

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;


   PROCEDURE load_com_model_search;

   PROCEDURE load_commdl_page (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2
             );

   PROCEDURE model_search_frameC;

   PROCEDURE com_model_search;

   PROCEDURE list_matching_models (
             general_type           IN VARCHAR2,
             cooling_capacity       IN VARCHAR2,
             airflow                IN VARCHAR2
             );

   PROCEDURE commdl_page_frameC (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2
             );

   PROCEDURE load_path1_page (
             unittype              IN VARCHAR2,
             modelno               IN VARCHAR2,
             str                   IN VARCHAR2
             );

   PROCEDURE path1_page_frameC (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2,
             str                   IN VARCHAR2
             );

END cmoddocs;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cmoddocs IS

/*======================================================*/
   PROCEDURE load_com_model_search  IS

   BEGIN

   CCUTIL.chtml_header_frame('load commercial path 3 model search'); 

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME SRC="'||wowhtml||'CMODDOCS.model_search_frameC"');
        htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
        htp.p('<FRAME SRC="'||wowhtml||'CMODDOCS.com_model_search" ');
         htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('<NOFRAME>');
    htp.p('<P><BR>This is a placeholder for load_com_model_search');
    htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_com_model_search;
/*======================================================*/
   PROCEDURE model_search_frameC  IS

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;

   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_featured_product;
   CCUTIL.caw_featured_technology;
   CCUTIL.caw_new_gif1;
   CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR ALIGN="center" WIDTH="100">');
-- htp.p('<P>');
   htp.p('</CENTER>');

   htp.p('<CENTER>');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END model_search_frameC;
/*======================================================*/
   PROCEDURE com_model_search  IS

   gentype              VARCHAR2(50);
   gentype1             VARCHAR2(50);
   mncptb               fieldTblType;
   mxcptb               fieldTblType;
   mnaftb               fieldTblType;
   mxaftb               fieldTblType;

   coolcapstr           VARCHAR2(50);
   airflowstr           VARCHAR2(50);
 
   irec                 NUMBER(10);

   CURSOR get_gentypes IS
   SELECT distinct generaltype 
     FROM commercial_products
    WHERE obsolete = 0;

   CURSOR get_minmax (gtyp IN VARCHAR2) IS
   SELECT TO_NUMBER( MIN(minclgcap)) mnc, TO_NUMBER( MAX(maxclgcap)) mxc, 
          TO_NUMBER( MIN(minairflow)) mnaf, TO_NUMBER( MAX(maxairflow)) mxaf
     FROM commercial_products
    WHERE upper(generaltype) LIKE gtyp; 

   m              get_minmax%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('commercial model search');

--|DOC Back to CAW homepage button
   CCUTIL.caw_frameD_back_header;
   htp.p('<P><P>');


   htp.p('<FONT SIZE=4>');
   htp.p('You can search for Carrier products using one of two methods:<P>');
-- htp.p('</FONT>');
   htp.p('<HR ALIGN =CENTER WIDTH=90%><BR>');
   htp.p('1. Type in a model number');
   htp.p('</FONT><BR>');
-- htp.p('<CENTER>');
   htp.p('<FORM TARGET="bodyText" METHOD="POST"');
   htp.p('ACTION="'||basewow||'cgi-bin/cdata/write_cmodel_seguepage.sh">');
   htp.p('<INPUT TYPE="text" NAME="modelno" VALUE="" SIZE="8" MAXSIZE="30">');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Search">');
   htp.p('</FORM>');


   htp.p('<HR ALIGN="CENTER" WIDTH = 90%>');
   htp.p('<P>');

   htp.p('<FONT SIZE=4>');
   htp.p('2. Select a product type and optionally enter a cooling capacity and airflow<BR>');
   htp.p('</FONT>');

   htp.p('<FORM ACTION="'||wowhtml||'CMODDOCS.list_matching_models">');
   htp.p('<SELECT NAME="general_type" SIZE="5">');
   irec := 0;
   OPEN get_gentypes;
   LOOP
      irec := irec +1;
      fetch get_gentypes into gentype;
      EXIT WHEN get_gentypes%NOTFOUND;
      gentype1 := '%'||upper(gentype)||'%'; 
      OPEN get_minmax (gentype1);
      LOOP
         FETCH get_minmax INTO m;
         EXIT WHEN get_minmax%NOTFOUND;
      END LOOP;
      CLOSE get_minmax; 
      IF (m.mnc IS NOT NULL AND m.mxc IS NOT NULL) THEN
         coolcapstr := '; (ClgCap '||m.mnc||'-'||m.mxc||')';
      ELSE coolcapstr := '';
      END IF;
      IF (m.mnaf IS NOT NULL AND m.mxaf IS NOT NULL) THEN
         airflowstr := '; (AirFlow '||m.mnaf||'-'||m.mxaf||')';
      ELSE airflowstr := '';
      END IF;
      IF (irec = 1) THEN
          htp.p('<OPTION VALUE="'||gentype||'" SELECTED >
           '||gentype||'');
--|        '||gentype||' '||coolcapstr||' '||airflowstr||'');
      ELSE
         htp.p('<OPTION VALUE="'||gentype||'">
           '||gentype||'');
--|        '||gentype||' '||coolcapstr||' '||airflowstr||'');
      END IF;
   END LOOP;
   close get_gentypes;
--|htp.p('<OPTION VALUE="NONE" SELECTED> NONE');
   htp.p('</SELECT><BR>');

   htp.p('<TABLE>');
   CCUTIL.input_table_2col(3,'Cooling Capacity (tons)','cooling_capacity','', 10, 10, '');
   CCUTIL.input_table_2col(3,'Air Flow (CFM)','airflow','', 10, 10, '');
--|htp.p('Cooling Capacity <INPUT TYPE="TEXT" NAME="cooling_capacity" VALUE="12000" SIZE=10><BR>');
--|htp.p('Air Flow <INPUT TYPE="TEXT" NAME="airflow" VALUE="500" SIZE=10 ><BR>');
   htp.p('</TABLE>');

   htp.p('<INPUT TYPE="SUBMIT" VALUE="Search">');
   htp.p('</FORM>');
-- htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END com_model_search;
/*======================================================*/
   PROCEDURE list_matching_models (
             general_type           IN VARCHAR2,
             cooling_capacity       IN VARCHAR2,
             airflow                IN VARCHAR2
             ) IS

   p                      commercial_products%ROWTYPE;
   numcoolcap1            NUMBER(10);
   numcfm1                NUMBER(10);
   generaltype            VARCHAR2(50);
   coolcap                NUMBER(20);
   cfm                    NUMBER(20);
   mincoolcap             NUMBER(10);
   maxcoolcap             NUMBER(10);
   minairflow             NUMBER(10);
   maxairflow             NUMBER(10);
   mincfm                 NUMBER(10);
   maxcfm                 NUMBER(10);

   coolcaprange           VARCHAR2(50);
   airflowrange           VARCHAR2(50);
   htmlmo                 VARCHAR2(60);
   modellink              VARCHAR2(200);
   hrefstr                VARCHAR2(200);
   modelname              VARCHAR2(60);


   CURSOR select_models (
          gentype         IN VARCHAR2,
          mincoolcap1     IN NUMBER,
          maxcoolcap1     IN NUMBER,
          mincfm1         IN NUMBER,
          maxcfm1         IN NUMBER
          ) IS
   SELECT * 
     FROM commercial_products
    WHERE (upper(generaltype) LIKE upper(gentype) )
      AND  (TO_NUMBER( minclgcap) < mincoolcap1  OR TO_NUMBER(minclgcap) IS NULL)
      AND  (TO_NUMBER( maxclgcap) > maxcoolcap1  OR TO_NUMBER(maxclgcap) IS NULL)
      AND  (TO_NUMBER(minairflow) < mincfm1   OR TO_NUMBER(minairflow) IS NULL)
      AND  (TO_NUMBER(maxairflow) > maxcfm1   OR TO_NUMBER(maxairflow) IS NULL)
      AND  obsolete = 0;

   BEGIN

   CCUTIL.chtml_header('com: list matching fields');

   CCUTIL.caw_frameD_back_header;
   htp.p('<P><P><P>');

   CCUTIL.caw_frameD_backto_modelsearch;
   htp.p('<P><P><P>');

--|htp.p('general_type is '||general_type||'<BR>');
--|htp.p('cooling_capacity is '||cooling_capacity||'<BR>');
--|htp.p('airflow is '||airflow||'<BR>');

   IF (general_type IS NULL) THEN
       generaltype  := '%%';
   ELSE generaltype := general_type;
   END IF;
   IF(cooling_capacity IS NULL) THEN
     mincoolcap := 100000;
     maxcoolcap := 0;
   ELSE 
     coolcap := TO_NUMBER( cooling_capacity);
     mincoolcap  := 1.2 * coolcap;
     maxcoolcap  := 0.8 * coolcap;
   END IF;
   IF(airflow IS NULL) THEN
     mincfm    := 100000;
     maxcfm    := 0;
   ELSE 
     cfm := TO_NUMBER (airflow);
     mincfm :=  1.2 * to_number(cfm);
     maxcfm :=  0.8 * to_number(cfm);
   END IF;

   numcoolcap1     :=   to_number(coolcap);
   numcfm1         :=   to_number(cfm); 

   htp.p('<CENTER>');

   htp.p('<FONT SIZE=4>');
   htp.p('The search for units having the selected product type and performance ');
   htp.p('produced the following results:<P><P>');
   htp.p('</FONT>');
   htp.p('<FONT SIZE=2>');
   htp.p('Models returned are within 20% of the selected performance values<BR>');
   htp.p('</FONT>');
-- htp.p('Cooling Range: min lt '||mincoolcap||'; max gt '||maxcoolcap||'<BR>');
-- htp.p('AirFlow (CFM) Range: min lt '||mincfm||'; max gt '||maxcfm||'</NOBR><P>');

   htp.p('<TABLE BORDER=4 WIDTH=70%>');
   htp.p(' <TR>');
   htp.p('      <TH> Model Type</TH>');
   htp.p('      <TH> Product Type</TH>');
   htp.p('      <TH> Cooling Range</TH>');
   htp.p('      <TH> AirFlow Range</TH>');
   htp.p(' </TR>');
   
   OPEN select_models (generaltype, mincoolcap, maxcoolcap, mincfm, maxcfm);
   LOOP
      FETCH select_models into p;
      EXIT WHEN select_models%NOTFOUND;
--|   htp.p('model is '||p.model||'; from product type '||p.generaltype||'<BR>');

      IF(p.minclgcap IS NOT NULL and p.maxclgcap IS NOT NULL) THEN
         coolcaprange :=  TO_NUMBER(p.minclgcap)||'-'||TO_NUMBER(p.maxclgcap);
      ELSE coolcaprange := 'NA';
      END IF;

      IF(p.minairflow IS NOT NULL and p.maxairflow IS NOT NULL) THEN
         airflowrange := TO_NUMBER(p.minairflow)||'-'||TO_NUMBER(p.maxairflow);
      ELSE airflowrange := 'NA';
      END IF;

      IF (p.modelalias IS NOT NULL) THEN
         modelname := p.modelalias;
      ELSE  modelname := p.model;
      END IF;

      htmlmo  := REPLACE(p.model, ' ', '+');
      htmlmo  := REPLACE(htmlmo, '-', '%2D');
      htmlmo  := REPLACE(htmlmo, '/', '%2F');
 --   htp.p(' htmlmo is '||htmlmo||'<BR>');
      hrefstr := wowhtml||'CMODDOCS.load_commdl_page?modelno='||htmlmo||'&unittype=English';
      modellink := '<A TARGET="_parent" HREF="'||hrefstr||'">'||modelname||'</A>';
      CCUTIL.table_4col_fill(3, modellink, p.generaltype, coolcaprange, airflowrange);
   END LOOP;
   CLOSE select_models;
   htp.p('</TABLE>');
   htp.p('</CENTER>');

-- htp.p('<HR ALIGN="CENTER" WIDTH = 90%>');

-- CMODDOCS.com_model_search;

   CCUTIL.chtml_footer;
   
   END list_matching_models;
/*======================================================*/
   PROCEDURE load_commdl_page (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2
             ) IS

   hrefstring             VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header_frame('load commercial path 3 model search'); 

   CCUTIL.load_comfort_atwork_ab;

   hrefstring := '?modelno='||modelno||'&unittype='||unittype;

   htp.p('<FRAMESET COLS="'||widthll||',*">');

   htp.p('<FRAME SRC="'||wowhtml||'CMODDOCS.commdl_page_frameC'||hrefstring||'"');
   htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');

   htp.p('<FRAME SRC="'||plhome||'write_commdl_fieldpage.sh'||hrefstring||'"');
   htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');

   htp.p('</FRAMESET>');
   htp.p('</FRAMESET>');

   htp.p('<NOFRAME>');
   htp.p('<P><BR>This is a placeholder for load_com_model_search');
   htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_commdl_page;
/*======================================================*/
   PROCEDURE commdl_page_frameC (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2
             ) IS

   hrefstring        VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;

   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_featured_product;
   CCUTIL.caw_featured_technology;
   CCUTIL.caw_new_gif1;
   CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR>');

   htp.p('<FONT SIZE=2>');
   IF UPPER(unittype) = 'ENGLISH' THEN
      hrefstring := '?modelno='||modelno||'&unittype=Metric';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CMODDOCS.load_commdl_page'||hrefstring||'">');
      htp.p(modelno||' (Metric Data)'); 
   ELSIF UPPER(unittype) = 'METRIC' THEN
      hrefstring := '?modelno='||modelno||'&unittype=English';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CMODDOCS.load_commdl_page'||hrefstring||'">');
      htp.p(modelno||' (English Data)'); 
   END IF;
   htp.p('</FONT>');

   htp.p('<HR>');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END commdl_page_frameC;
/*======================================================*/
   PROCEDURE load_path1_page (
             unittype              IN VARCHAR2,
             modelno               IN VARCHAR2,
             str                   IN VARCHAR2
             ) IS

   hrefstring        VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header_frame('load commercial path 3 model search'); 

   CCUTIL.load_comfort_atwork_ab;

   hrefstring := '?modelno='||modelno||'&unittype='||unittype||'&str='||str;

   htp.p('<FRAMESET COLS="'||widthll||',*">');

   htp.p('<FRAME SRC="'||wowhtml||'CMODDOCS.path1_page_frameC'||hrefstring||'"');
   htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');

   htp.p('<FRAME SRC="'||plhome||'write_path1_fieldpage.sh'||hrefstring||'"');
   htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');

   htp.p('</FRAMESET>');
   htp.p('</FRAMESET>');

   htp.p('<NOFRAME>');
   htp.p('<P><BR>This is a placeholder for load_com_model_search');
   htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_path1_page;
/*======================================================*/
   PROCEDURE path1_page_frameC (
             modelno               IN VARCHAR2,
             unittype              IN VARCHAR2,
             str                   IN VARCHAR2
             ) IS

   hrefstring        VARCHAR2(100);

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;

   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_featured_product;
   CCUTIL.caw_featured_technology;
   CCUTIL.caw_new_gif1;
   CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR>');

   htp.p('<FONT SIZE=2>');
   IF UPPER(unittype) = 'ENGLISH' THEN
      hrefstring := '?unittype=Metric&modelno='||modelno||'&str='||str;
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CMODDOCS.load_path1_page'||hrefstring||'">');
      htp.p(modelno||' (Metric Data)'); 
   ELSIF UPPER(unittype) = 'METRIC' THEN
      hrefstring := '?unittype=English&modelno='||modelno||'&str='||str;
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CMODDOCS.load_path1_page'||hrefstring||'">');
      htp.p(modelno||' (English Data)'); 
   END IF;
   htp.p('</FONT>');

   htp.p('<HR>');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END path1_page_frameC;
/*======================================================*/
END cmoddocs;
/
show errors;
/
