DROP PACKAGE ccutil;
CREATE OR REPLACE PACKAGE ccutil AS

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wp/';
   widthll             NUMBER(10)      := 162;

   PROCEDURE experiment;

  /* ---------Carrier headers and footer ------*/

   PROCEDURE  chtml_header;   --|Has Carrier Confidential statement

   PROCEDURE  chtml_header    --|Has Carrier Confidential statement
             ( title         IN VARCHAR2) ;

   PROCEDURE  chtml_header_frame  --|Has Carrier Confidential statement
             ( title         IN VARCHAR2);

   PROCEDURE  chtml_footer;

   PROCEDURE  html_header (
              title    in varchar2);

   PROCEDURE  html_footer;

   PROCEDURE  caw_frameD_back_header;

   PROCEDURE  cah_frameD_back_header;

   PROCEDURE  rc_frameD_back_header;

   PROCEDURE  sh_frameD_back_header;

   PROCEDURE  frameD_topofpage;

   PROCEDURE  caw_frameD_backto_modelsearch;

/* -------------------  utility procedures -------------- */

   PROCEDURE  table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2 );

   PROCEDURE  table_2col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2 );

   PROCEDURE  if_table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2
              );

   PROCEDURE  table_2colspan (
              fs                in integer,
              name1             in varchar2 );

   PROCEDURE  table_3col (
              fs                IN INTEGER,
              name1             IN VARCHAR2,
              name2             IN VARCHAR2,
              name3             IN VARCHAR2);

   PROCEDURE  table_4col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2 );

   PROCEDURE  table_4col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2 );

   PROCEDURE  table_5col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2,
              name5             in varchar2 );

   PROCEDURE  table_7col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2,
              name5             in varchar2,
              name6             in varchar2,
              name7             in varchar2 );

   PROCEDURE  input_table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              value2            in varchar2,
              sz                in integer, 
              maxlen            in integer,
              text1             in varchar2);

/* -----------Upward Navigation Links-------------- */

   PROCEDURE nav_upto_united_technologies;
   PROCEDURE nav_upto_carrier_homepage;

   PROCEDURE nav_upto_model_search;
   PROCEDURE nav_upto_carrier_search;
   PROCEDURE nav_upto_product_type;

   PROCEDURE nav_upto_commercial_products;
   PROCEDURE nav_upto_commercial_products_B;
   PROCEDURE nav_upto_commercial_products_C;

   PROCEDURE nav_upto_residential_products;
   PROCEDURE nav_upto_room_air_conditioners;
   PROCEDURE nav_upto_comfort_athome;
   PROCEDURE nav_upto_comfort_atwork;
   PROCEDURE nav_upto_com_specific_types (
             general_type         IN VARCHAR2);

   PROCEDURE nav_upto_resource_center;

/* -----------Load Frameset Inserts-------------- */

   PROCEDURE load_comfort_athome_ab;
   PROCEDURE load_comfort_atwork_ab;
   PROCEDURE load_resource_center_ab;
   PROCEDURE load_carrier_search_ab;

/* -----------Hot Links--------------------------- */

   PROCEDURE hotlink_commercial_whatsnew;
   PROCEDURE hotlink_commercial_qa;
   PROCEDURE hotlink_commercial_locator;
   PROCEDURE hotlink_com_downloads(modelno IN VARCHAR2);
   PROCEDURE caw_featured_product;
   PROCEDURE caw_featured_technology;
   PROCEDURE caw_new_gif1;
   PROCEDURE caw_case_study;
   PROCEDURE caw_colls_search;


   PROCEDURE hotlink_res_whatsnew;
   PROCEDURE hotlink_comfort_qa;
   PROCEDURE hotlink_res_locator;
   PROCEDURE hotlink_res_downloads;

   PROCEDURE hotlink_copyright;

   PROCEDURE hotlink_rac_locator;
   PROCEDURE hotlink_wahlstrom;
   PROCEDURE hotlink_text_search;

   PROCEDURE hotlink_rc_glossary;
   PROCEDURE hotlink_rc_qa;
   PROCEDURE hotlink_rc_press_releases;
   PROCEDURE hotlink_rc_external_urls;
   PROCEDURE hotlink_rc_search_tools;
   PROCEDURE hotlink_rc_event_calendar;
   PROCEDURE hotlink_rc_case_studies;
   PROCEDURE hotlink_rc_white_papers;
   PROCEDURE hotlink_rc_carrier_software;

/* -------------- Resource buttons --------------------- */

   PROCEDURE gen_resource_buttons;
   PROCEDURE com_resource_buttons;
   PROCEDURE res_resource_buttons;
   PROCEDURE search_resource_buttons;
   PROCEDURE qanda_button (URL IN VARCHAR2);
   PROCEDURE news_button (URL IN VARCHAR2);
   PROCEDURE contact_button (URL IN VARCHAR2);
   PROCEDURE register_button (URL IN VARCHAR2);

   PROCEDURE comment (
             commentstring         IN VARCHAR2
             );

END ccutil;
/
show errors;
/
/* ====================================================================== */

CREATE OR REPLACE PACKAGE BODY ccutil IS

/* =================================================================== */
   PROCEDURE experiment IS

   BEGIN

   CCUTIL.chtml_header('experiment with interface environment');

   htp.p('<CENTER>');
   htp.p('Testing http://mindy.infomall.org:6380/cgi-bin/ifc/CCUTIL.experiment');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END experiment;
/* =================================================================== */
   PROCEDURE chtml_header (
             title            IN VARCHAR2
             ) IS
   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<!-- ');
   htp.p('Carrier Corporation CONFIDENTIAL');
   htp.p('Copyright (C)1996,1997 Carrier Corporation. All Rights Reserved.');
   htp.p('-->');
   htp.p('<TITLE>'||title||'</TITLE>');
   htp.p('</HEAD>');

   htp.p('<BODY BGCOLOR=#FFFFFF>');

   END chtml_header;
/*======================================================*/
   PROCEDURE chtml_header  IS

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<!-- ');
   htp.p('Carrier Corporation CONFIDENTIAL');
   htp.p('Copyright (C)1996,1997 Carrier Corporation. All Rights Reserved.');
   htp.p('-->');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF>');

   END chtml_header;
/*======================================================*/
   PROCEDURE chtml_header_frame (
             title               IN VARCHAR2 
             ) IS
   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<!-- ');
   htp.p('Carrier Corporation CONFIDENTIAL');
   htp.p('Copyright (C)1996,1997 Carrier Corporation. All Rights Reserved.');
   htp.p('-->');
   htp.p('<TITLE>'||title||'</TITLE>');
   htp.p('</HEAD>');

   END chtml_header_frame;
/*======================================================*/
   PROCEDURE chtml_footer IS
   
   BEGIN

   htp.p('</BODY>');
   htp.p('</HTML>');

   END chtml_footer;
/*======================================================*/
    PROCEDURE  html_header (title in varchar2) IS

    BEGIN

    htp.p('<HTML>');
    htp.p('<HEAD>');
    htp.p('<TITLE>'||title||'</TITLE>');
    htp.p('</HEAD>');

    htp.p('<BODY>');

    END html_header;
/*=======================================================================*/
    PROCEDURE  html_footer is

    BEGIN

    htp.p('<BR ALIGN="center"><HR WIDTH="100">For information, contact:<BR>');
    htp.p('<ADDRESS>');
    htp.p('Barbara W. Mihalas<BR>');
    htp.p('NPAC at Syracuse University<BR>');
    htp.p('bwm@npac.syr.edu<BR>');
    htp.p('</ADDRESS>');

    htp.p('</BODY>');
    htp.p('</HTML>');

    END html_footer;
/*=======================================================================*/
/*=======================================================================*/
   PROCEDURE caw_frameD_back_header  IS

   BEGIN

   htp.p('<A NAME="pagetop"></A>');
   htp.p('<A HREF="'||owihome||'com_ed1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'com_media/caw_header_back_button.gif" ');
   htp.p('ALIGN="MIDDLE" WIDTH="430" HEIGHT="32" BORDER=0></A>');

   END caw_frameD_back_header;
/*=======================================================================*/
   PROCEDURE  caw_frameD_backto_modelsearch IS

   BEGIN

   htp.p('<A HREF="'||wowhtml||'CMODDOCS.com_model_search">');
   htp.p(' back to model search</A><BR>');

   END  caw_frameD_backto_modelsearch;
/*=======================================================================*/
   PROCEDURE cah_frameD_back_header  IS

   BEGIN

   htp.p('<A NAME="pagetop"></A>');
   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif" ');
   htp.p('ALIGN="MIDDLE" WIDTH="430" HEIGHT="32" BORDER=0></A>');

   END cah_frameD_back_header;
/*=======================================================================*/
   PROCEDURE rc_frameD_back_header  IS

   BEGIN

   htp.p('<A NAME="pagetop"></A>');
   htp.p('<A HREF="'||owihome||'nao_rc1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'nao_media/rc_header_back_button.gif" ');
   htp.p('ALIGN="MIDDLE" WIDTH="420" HEIGHT="20" BORDER=0');
   htp.p(' HSPACE=12 VSPACE=6></A>');

   END rc_frameD_back_header;
/*=======================================================================*/
   PROCEDURE sh_frameD_back_header  IS

   BEGIN

   htp.p('<A NAME="pagetop"></A>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'nao_media/sh_header_back_button.gif" ');
   htp.p('ALIGN="MIDDLE" WIDTH="430" HEIGHT="32" BORDER=0></A>');

   END sh_frameD_back_header;
/*=======================================================================*/
   PROCEDURE frameD_topofpage IS

   BEGIN

   htp.p('<P ALIGN="RIGHT">');
   htp.p('<I>(<A HREF="#pagetop">top of page</A></I>)');
   htp.p('</P>');

   END frameD_topofpage;
/*=======================================================================*/
/*=======================================================================*/
   PROCEDURE  table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2
              ) IS

   BEGIN

   htp.p('<TR><TD><FONT SIZE='||fs||'> '|| name1 ||'</FONT>
         </TD><TD><FONT SIZE='||fs||'> '|| name2 ||'</FONT></TD></TR>');

   END table_2col; 

/*=======================================================================*/
   PROCEDURE  if_table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2
              ) IS

   BEGIN

   IF (name2 IS NOT NULL) THEN
      htp.p('<TR><TD><FONT SIZE='||fs||'> '|| name1 ||'</FONT>
         </TD><TD><FONT SIZE='||fs||'> '|| name2 ||'</FONT></TD></TR>');
   END IF;

   END if_table_2col; 
/*=======================================================================*/
   PROCEDURE  table_2colspan (
              fs                in integer,
              name1             in varchar2
              ) IS

   BEGIN

   htp.p('<TR><TD COLSPAN=2><FONT SIZE='||fs||'> '|| name1 ||'</FONT>
         </TD></TR>');

   END table_2colspan; 
/*=====================================================================*/

   PROCEDURE  table_3col (
              fs                IN INTEGER,
              name1             IN VARCHAR2,
              name2             IN VARCHAR2,
              name3             IN VARCHAR2
              ) IS

   BEGIN

   htp.p('<TR> <TD><FONT SIZE='||fs||'> '|| name1 ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| name2 ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| name3 ||'</FONT></TD></TR>');

   END table_3col; 

/*=======================================================================*/
   PROCEDURE  table_4col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2
              ) IS

   BEGIN

   htp.p('<TR><TD><FONT SIZE='||fs||'> '|| name1 ||'</FONT>
         </TD><TD><FONT SIZE='||fs||'> '|| name2 ||'</FONT>
         </TD><TD><FONT SIZE='||fs||'> '|| name3 ||'</FONT>
         </TD><TD><FONT SIZE='||fs||'> '|| name4 ||'</FONT></TD></TR>');

   END table_4col; 

/*=======================================================================*/
   PROCEDURE  table_2col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2 ) IS

   BEGIN

   htp.p('<TR><TD><FONT SIZE='||fs||'> '|| NVL(name1,'-') ||'</FONT></TD>');
   htp.p('    <TD><FONT SIZE='||fs||'> '|| NVL(name2,'-') ||'</FONT></TD></TR>');

   END  table_2col_fill;
/*=======================================================================*/
   PROCEDURE  table_4col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2
              ) IS

   BEGIN

   htp.p('<TR><TD><FONT SIZE='||fs||'> '|| NVL(name1,'-') ||'</FONT></TD>');
   htp.p('    <TD><FONT SIZE='||fs||'> '|| NVL(name2,'-') ||'</FONT></TD>');
   htp.p('    <TD><FONT SIZE='||fs||'> '|| NVL(name3,'-') ||'</FONT></TD>');
   htp.p('    <TD><FONT SIZE='||fs||'> '|| NVL(name4,'-') ||'</FONT></TD></TR>');

   END table_4col_fill; 

/*=======================================================================*/
   PROCEDURE  table_5col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2,
              name5             in varchar2
              ) IS


   BEGIN

   htp.p('<TR> <TD><FONT SIZE='||fs||'> '|| NVL(name1,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name2,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name3,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name4,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name5,'-') ||'</FONT></TD></TR>');

   END table_5col_fill; 
/*=====================================================================*/
   PROCEDURE  table_7col_fill (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              name3             in varchar2,
              name4             in varchar2,
              name5             in varchar2,
              name6             in varchar2,
              name7             in varchar2 
              ) IS


   BEGIN

   htp.p('<TR> <TD><FONT SIZE='||fs||'> '|| NVL(name1,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name2,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name3,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name4,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name5,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name6,'-') ||'</FONT></TD>');
   htp.p('     <TD><FONT SIZE='||fs||'> '|| NVL(name7,'-') ||'</FONT></TD></TR>');

   END table_7col_fill; 

/*=====================================================================*/

   PROCEDURE  input_table_2col (
              fs                in integer,
              name1             in varchar2,
              name2             in varchar2,
              value2            in varchar2,
              sz                in integer,
              maxlen            in integer,
              text1             in varchar2 
              ) IS

   BEGIN

   htp.p('<TR><TD><FONT SIZE='||fs||'>'|| name1 ||'</FONT></TD>');
   htp.p('<TD><FONT SIZE='||fs||'><INPUT TYPE="text" NAME="'||name2||'" 
                 VALUE="'||value2||'" SIZE ="'||sz||'" 
                 MAXLENGTH="'||maxlen||'" >'||text1||'</FONT></TD></TR>');

   END input_table_2col; 

/*=====================================================================*/
/* -----------Upward Navigation Links-------------- */
/*=====================================================================*/
   PROCEDURE nav_upto_united_technologies IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<I>United Technologies</I></FONT><BR>');

   END nav_upto_united_technologies;
/*=====================================================================*/
   PROCEDURE nav_upto_model_search IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A HREF="'||basehtml||'cdata/model_number.html"  TARGET="_parent">');
   htp.p('<I>Model Search</I></A></FONT><BR>');

   END nav_upto_model_search;
/*=====================================================================*/
   PROCEDURE nav_upto_carrier_homepage IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A HREF="'||owihome||'nao_hm1/index.html" TARGET="_parent">');
   htp.p('<B><I>Carrier Homepage</I></B></A></FONT><BR>');

   END nav_upto_carrier_homepage;
/*=====================================================================*/
   PROCEDURE nav_upto_carrier_search IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<B><I>Carrier Search</I></B></A></FONT><BR>');

   END nav_upto_carrier_search;
/*=====================================================================*/
   PROCEDURE nav_upto_product_type IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A HREF="'||basehtml||'cdata/product_type.html"  TARGET="_parent">');
   htp.p('<I>Product Type</I></A></FONT><BR>');

   END nav_upto_product_type;
/*=====================================================================*/
   PROCEDURE nav_upto_commercial_products IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER><I>Go to</I><BR>');
   htp.p('<A TARGET="_parent"
      HREF="'||wowhtml||'CPUT.load_commercial_ptypes">');
   htp.p('<I>Comfort at Work Products</I></A><P>');
   htp.p('</CENTER>');
   htp.p('</FONT>');

   END nav_upto_commercial_products;
/*=====================================================================*/
   PROCEDURE nav_upto_commercial_products_B IS

   BEGIN

   htp.p('<FONT SIZE=2> <I>Go to</I><BR>');
   htp.p('<A TARGET="_parent"
      HREF="'||wowhtml||'CPUT.load_commercial_ptypes_B">');
   htp.p('<I>Comfort at Work Products</I></A>');
   htp.p('</FONT><BR>');

   END nav_upto_commercial_products_B;
/*=====================================================================*/
   PROCEDURE nav_upto_commercial_products_C IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER><I>Go to</I><BR>');
   htp.p('<A TARGET="_parent"
      HREF="'||wowhtml||'CPUT.load_commercial_ptypes">');
   htp.p('<I>Comfort at Work Products</I></A><P>');
   htp.p('</CENTER>');
   htp.p('</FONT>');

   END nav_upto_commercial_products_C;
/*=====================================================================*/
   PROCEDURE nav_upto_residential_products IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A TARGET="_parent" HREF="'||wowhtml||'RESMOD.load_res_ptypes">');
   htp.p('<I>Residential Products</I></A>');
   htp.p('</FONT><BR>');

   END nav_upto_residential_products;
/*=====================================================================*/
   PROCEDURE nav_upto_room_air_conditioners IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A TARGET="_parent"
      HREF="'||wowhtml||'RESFLD.load_res_dfields?general_type=Room+Air+Conditioners">');
   htp.p('<I>Room Air Conditioners</I></A>');
   htp.p('</FONT><BR>');

   END nav_upto_room_air_conditioners;
/*=====================================================================*/
   PROCEDURE nav_upto_comfort_athome IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A TARGET="_parent" HREF="'||owihome||'res_hm1/index.html">');
   htp.p('<B><I>Comfort at Home</I></B></A>');
   htp.p('</FONT><BR>');

   END nav_upto_comfort_athome;
/*=====================================================================*/
   PROCEDURE nav_upto_comfort_atwork IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A TARGET="_parent" HREF="'||owihome||'com_ed1/index.html">');
   htp.p('<B><I>Comfort at Work</I></B></A>');
   htp.p('</FONT><BR>');

   END nav_upto_comfort_atwork;
/*=====================================================================*/
   PROCEDURE nav_upto_com_specific_types (
             general_type         IN VARCHAR2) IS

   htmlgen            VARCHAR2(50);

   BEGIN

   htp.p('<FONT SIZE=2>');
   htmlgen := REPLACE(general_type, ' ', '+'); 
   htmlgen := REPLACE(htmlgen, '-', '%2D'); 
   htp.p('<CENTER><I>Go to</I><BR>');
   htp.p('<A HREF="'||wowhtml||'CPUT.load_specific_types?general_type='||htmlgen||'" 
      TARGET="_parent">');
   htp.p('<I>Specific Types</I></A><P>');
   htp.p('</CENTER>');
   htp.p('</FONT>');

   END nav_upto_com_specific_types;
/*=====================================================================*/
   PROCEDURE nav_upto_resource_center IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<I>Go to</I><BR>');
   htp.p('<A TARGET="_parent" HREF="'||owihome||'nao_rc1/index.html">');
   htp.p('<B><I>Resource Center</I></B></A>');
   htp.p('</FONT><BR>');

   END nav_upto_resource_center;
/*=====================================================================*/
/* -----------Load Frameset Inserts-------------- */
/*=====================================================================*/
   PROCEDURE load_comfort_athome_ab IS

   BEGIN

   htp.p('<FRAMESET ROWS="66,*">');
   htp.p('<FRAMESET COLS="162,*">');
        htp.p('<FRAME SRC="'||owihome||'res_hm1/res_hma1_plain.html" 
          NAME="logo" SCROLLING="no" MARGINWIDTH=1 MARGINHEIGHT=1 NORESIZE>');

        htp.p('<FRAME SRC="'||owihome||'res_hm1/res_hmb1_plain.html" 
         NAME="header" SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');
   htp.p('</FRAMESET>');

   END load_comfort_athome_ab;
/*=====================================================================*/
   PROCEDURE load_comfort_atwork_ab IS

   BEGIN

   htp.p('<FRAMESET ROWS="66,*">');
   htp.p('<FRAMESET COLS="162,*">');
        htp.p('<FRAME SRC="'||owihome||'com_ed1/com_eda1_plain.html" 
          NAME="logo" SCROLLING="no" MARGINWIDTH=1 MARGINHEIGHT=1 NORESIZE>');

        htp.p('<FRAME SRC="'||owihome||'com_ed1/com_edb1_plain.html" 
         NAME="header" SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');
   htp.p('</FRAMESET>');

   END load_comfort_atwork_ab;
/*=====================================================================*/
   PROCEDURE load_resource_center_ab IS

   BEGIN

   htp.p('<FRAMESET ROWS="66,*">');
   htp.p('<FRAMESET COLS="162,*">');
        htp.p('<FRAME SRC="'||owihome||'nao_rc1/nao_rca1.html" 
          NAME="logo" SCROLLING="no" MARGINWIDTH=1 MARGINHEIGHT=1 NORESIZE>');

        htp.p('<FRAME SRC="'||owihome||'nao_rc1/nao_rcb1.html" 
         NAME="header" SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');
   htp.p('</FRAMESET>');

      NULL;

   END load_resource_center_ab;
/*=====================================================================*/
   PROCEDURE load_carrier_search_ab IS

   BEGIN

   htp.p('<FRAMESET ROWS="66,*">');
   htp.p('<FRAMESET COLS="162,*">');
        htp.p('<FRAME SRC="'||owihome||'nao_sh1/nao_sha1.html" 
          NAME="logo" SCROLLING="no" MARGINWIDTH=1 MARGINHEIGHT=1 NORESIZE>');

        htp.p('<FRAME SRC="'||owihome||'nao_sh1/nao_shb1.html" 
         NAME="header" SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');
   htp.p('</FRAMESET>');

   END load_carrier_search_ab;
/*=====================================================================*/
                  -----------Hot Links---------------
/*=====================================================================*/
   PROCEDURE hotlink_commercial_whatsnew IS

   BEGIN

   htp.p(' <FONT SIZE=2><A TARGET="bodyText"');
   htp.p(' HREF="'||owihome||'com_sg1/com_sgd1.html">What''s New</A></FONT><BR>');

   END hotlink_commercial_whatsnew;
/*=====================================================================*/
   PROCEDURE hotlink_res_whatsnew IS

   BEGIN

   htp.p(' <FONT SIZE=2><A TARGET="bodyText"');
   htp.p(' HREF="'||owihome||'res_sg1/res_sgd1.html">What''s New</A></FONT><BR>');

   END hotlink_res_whatsnew;
/*=====================================================================*/
   PROCEDURE hotlink_comfort_qa IS

   BEGIN

   htp.p(' <B><FONT SIZE=2><A TARGET="bodyText"');
   htp.p(' HREF="'||owihome||'res_qa1/res_qad1.html">Comfort Q&amp;A</A></FONT><BR></B>');

--|htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
--|htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   END hotlink_comfort_qa;
/*=====================================================================*/
   PROCEDURE hotlink_commercial_locator IS

   BEGIN

   htp.p(' <FONT SIZE=2><A TARGET="bodyText"');
   htp.p(' HREF="'||owihome||'com_dl1/com_dld1.html">Find a Sales Office</A>');
   htp.p('</FONT><BR>');
/*
   htp.p('<FONT SIZE=2>Commercial Products<BR>');
   htp.p('<A TARGET="bodyText" HREF="'||wowhtml||'CMODFLD.locate_dealer">');
   htp.p('Find a Sales Office</A>');
   htp.p('</FONT><BR>');
*/
   
   END hotlink_commercial_locator;
/*=====================================================================*/
   PROCEDURE hotlink_commercial_qa IS

   BEGIN

   htp.p(' <FONT SIZE=2><A TARGET="bodyText"');
   htp.p(' HREF="'||owihome||'com_qa1/com_qad1.html"><I>At Work</I> Q&amp;A</A></FONT><BR>');

   END hotlink_commercial_qa;
/*=====================================================================*/
   PROCEDURE hotlink_rac_locator IS

   BEGIN

   htp.p('<FONT SIZE=2>Room Air Conditioning<BR>');
   htp.p('Store Locator</FONT><BR>'); 

   END hotlink_rac_locator;
/*=====================================================================*/
   PROCEDURE hotlink_res_locator IS

   BEGIN

   htp.p('<B><FONT SIZE=2><A HREF="'||owihome||'res_dl1/index.html"');
   htp.p(' TARGET="_parent">Find a Dealer or Store</A></FONT></B><BR>');

   END hotlink_res_locator;
/*=====================================================================*/
   PROCEDURE hotlink_wahlstrom IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<I>Locate a </I><BR>');
   htp.p('<B><A TARGET="bodyText"
          HREF="http://www.wheretofindit.com/carrier/res_dld1.html">');
   htp.p('Dealer or Store<BR></A></B><I>near you</I>');
   htp.p('</CENTER></FONT>');

   END hotlink_wahlstrom;
/*=====================================================================*/
   PROCEDURE hotlink_text_search IS

   BEGIN

   htp.p('<CENTER><FONT SIZE=2>');
   htp.p('<A TARGET="bodyText"
        HREF="'||basehtml||'wpdv/nao_sh1/nao_shd2.html">');
   htp.p('<B>Full Text Search</B></A>');
   htp.p('</CENTER></FONT>');

   END hotlink_text_search;
/*=====================================================================*/
   PROCEDURE hotlink_com_downloads (
             modelno          IN VARCHAR2 
             ) IS

   BEGIN

   htp.p('<CENTER><FONT SIZE=2>');
   htp.p('<A TARGET="bodyText"
        HREF="'||wowhtml||'CMODDOCS.license?model_dltype='||modelno||'$pdpdf">');
   htp.p('<B>Product Data PDF for Registered Users</B></A><P>');

   htp.p('<A TARGET="bodyText"
        HREF="'||wowhtml||'CMODDOCS.license?model_dltype='||modelno||'$software">');
   htp.p('<B>Software Product for Registered Users</B></A>');
   htp.p('</FONT></CENTER><BR>');

   END hotlink_com_downloads;
/*=====================================================================*/
   PROCEDURE hotlink_res_downloads IS

   BEGIN

   htp.p('<B><FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" HREF="'||wowhtml||'RESDLUPD.res_pdf_page">');
   htp.p('Full Product Data Digest (PDD)</A></FONT><BR></B>');

   END hotlink_res_downloads;
/*=====================================================================*/
   PROCEDURE hotlink_copyright IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('Copyright &copy 1996,1997,1998<BR>Carrier');
   htp.p('Corporation.<BR>');
   htp.p('All Rights Reserved.</FONT>');


   END hotlink_copyright;
/*=====================================================================*/
   PROCEDURE hotlink_rc_glossary IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText"');
   htp.p('HREF="'||owihome||'nao_gl1/nao_gld1.html">Glossary of Terms');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_glossary;
/*=====================================================================*/
   PROCEDURE hotlink_rc_qa IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText"');
   htp.p('HREF="'||owihome||'nao_qa1/nao_qad1.html">Questions &amp; Answers');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_qa;
/*=====================================================================*/
   PROCEDURE hotlink_rc_press_releases IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText"');
   htp.p('HREF="'||owihome||'nao_rl0/nao_rld0.html">Press Releases');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_press_releases;
/*=====================================================================*/
   PROCEDURE hotlink_rc_external_urls IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_ex1/nao_exd1.html">External Web Links');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_external_urls;
/*=====================================================================*/
   PROCEDURE hotlink_rc_search_tools IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_st1/nao_std1.html">Web Search Tools');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_search_tools;
/*=====================================================================*/
   PROCEDURE hotlink_rc_event_calendar IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_cl2/nao_cld2.html">Event Calendar');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_event_calendar;
/*=====================================================================*/
   PROCEDURE hotlink_rc_case_studies IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_cs1/nao_csd1.html">Case Studies');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_case_studies;
/*=====================================================================*/
   PROCEDURE hotlink_rc_white_papers IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_wp1/nao_wpd1.html">White Papers');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_white_papers;
/*=====================================================================*/
   PROCEDURE hotlink_rc_carrier_software IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A TARGET="bodyText" ');
   htp.p('HREF="'||owihome||'nao_sw1/nao_swd1.html">Carrier Software');
   htp.p('</A><BR>');
   htp.p('</FONT>');
   htp.p('</CENTER>');

   END hotlink_rc_carrier_software;
/*=====================================================================*/

/*=====================================================================*/


/*=====================================================================*/
/* -------------- Resource buttons --------------------- */
/*=====================================================================*/
   PROCEDURE gen_resource_buttons IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/siteguide_button.gif" USEMAP="#siteguide" ALIGN=MIDDLE');
   htp.p('WIDTH="92" HEIGHT="16" BORDER="0" VSPACE="4"></A>');

   htp.p('<MAP NAME="siteguide">');
   htp.p('        <AREA SHAPE="rect" COORDS="75,0,92,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html#siteoutline2" TARGET="bodyText">');
   htp.p('        <AREA SHAPE="rect" COORDS="0,0,74,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('</MAP>');

   htp.p('<A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/register_button.gif" ALIGN=MIDDLE  VSPACE="4"');
   htp.p('BORDER="0"></A>');

   htp.p('<A HREF="'||owihome||'nao_cc1/nao_ccd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/contactcarrier_button.gif" ALIGN=MIDDLE  BORDER="0"');
   htp.p('VSPACE="4"></A>');
   htp.p('</CENTER>');

   htp.p('<P ALIGN=CENTER>');
   htp.p('<HR WIDTH="100" ALIGN=CENTER>');
   htp.p('<P ALIGN=CENTER>');
/*
   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/siteguide_button.gif" USEMAP="#siteguide"');
   htp.p(' WIDTH="92" HEIGHT="16" ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');

   htp.p('<A HREF="'||owihome||'nao_ur1/index.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/register_button.gif"');
   htp.p('ALIGN=MIDDLE  VSPACE="4" BORDER="0"></A><BR>');
   
   htp.p('<A HREF="'||owihome||'nao_cc1/index.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/contactcarrier_button.gif" ');
   htp.p('ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');
   htp.p('</CENTER>');
*/

   END gen_resource_buttons;
/*=====================================================================*/
   PROCEDURE com_resource_buttons IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/siteguide_button.gif" USEMAP="#siteguide" ALIGN=MIDDLE');
   htp.p('WIDTH="92" HEIGHT="16" BORDER="0" VSPACE="4"></A>');

   htp.p('<MAP NAME="siteguide">');
   htp.p('        <AREA SHAPE="rect" COORDS="75,0,92,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html#siteoutline2" TARGET="bodyText">');
   htp.p('        <AREA SHAPE="rect" COORDS="0,0,74,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('</MAP>');

   htp.p('<A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/register_button.gif" ALIGN=MIDDLE  VSPACE="4"');
   htp.p('BORDER="0"></A>');

   htp.p('<A HREF="'||owihome||'nao_cc1/nao_ccd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/contactcarrier_button.gif" ALIGN=MIDDLE  BORDER="0"');
   htp.p('VSPACE="4"></A>');
   htp.p('<CENTER>');

/*
   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'com_ht1/com_htd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/siteguide_button.gif"');
   htp.p(' WIDTH="92" HEIGHT="16" ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');

   htp.p('<A HREF="'||owihome||'com_ur1/com_urd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/register_button.gif"');
   htp.p('ALIGN=MIDDLE  VSPACE="4" BORDER="0"></A><BR>');
   
   htp.p('<A HREF="'||owihome||'com_cc1/com_ccd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/contactcarrier_button.gif" ');
   htp.p('ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');
   htp.p('</CENTER>');
*/

   END com_resource_buttons;
/*=====================================================================*/
   PROCEDURE res_resource_buttons IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/siteguide_button.gif" USEMAP="#siteguide" ALIGN=MIDDLE');
   htp.p('WIDTH="92" HEIGHT="16" BORDER="0" VSPACE="4"></A>');

   htp.p('<MAP NAME="siteguide">');
   htp.p('        <AREA SHAPE="rect" COORDS="75,0,92,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html#siteoutline2" TARGET="bodyText">');
   htp.p('        <AREA SHAPE="rect" COORDS="0,0,74,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('</MAP>');

   htp.p('<A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/register_button.gif" ALIGN=MIDDLE  VSPACE="4"');
   htp.p('BORDER="0"></A>');

   htp.p('<A HREF="'||owihome||'nao_cc1/nao_ccd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/contactcarrier_button.gif" ALIGN=MIDDLE  BORDER="0"');
   htp.p('VSPACE="4"></A>');
   htp.p('<CENTER>');

/*
   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'res_ht1/res_htd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/siteguide_button.gif"');
   htp.p(' WIDTH="92" HEIGHT="16" ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');

   htp.p('<A HREF="'||owihome||'res_ur1/res_urd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/register_button.gif"');
   htp.p('ALIGN=MIDDLE  VSPACE="4" BORDER="0"></A><BR>');
   
   htp.p('<A HREF="'||owihome||'res_cc1/res_ccd1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/contactcarrier_button.gif" ');
   htp.p('ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');
   htp.p('</CENTER>');
*/

   END res_resource_buttons;
/*=====================================================================*/
   PROCEDURE search_resource_buttons IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/siteguide_button.gif" USEMAP="#siteguide" ALIGN=MIDDLE');
   htp.p('WIDTH="92" HEIGHT="16" BORDER="0" VSPACE="4"></A>');

   htp.p('<MAP NAME="siteguide">');
   htp.p('        <AREA SHAPE="rect" COORDS="75,0,92,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html#siteoutline2" TARGET="bodyText">');
   htp.p('        <AREA SHAPE="rect" COORDS="0,0,74,16"');
   htp.p('HREF="'||owihome||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('</MAP>');

   htp.p('<A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/register_button.gif" ALIGN=MIDDLE  VSPACE="4"');
   htp.p('BORDER="0"></A>');

   htp.p('<A HREF="'||owihome||'nao_cc1/nao_ccd1.html" TARGET="bodyText"><IMG');
   htp.p('SRC="'||owihome||'nao_media/contactcarrier_button.gif" ALIGN=MIDDLE  BORDER="0"');
   htp.p('VSPACE="4"></A>');
   htp.p('<CENTER>');

/*
   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_ht1/index.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/siteguide_button.gif"');
   htp.p(' WIDTH="92" HEIGHT="16" ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');

   htp.p('<A HREF="'||owihome||'nao_ur1/index.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/register_button.gif"');
   htp.p('ALIGN=MIDDLE  VSPACE="4" BORDER="0"></A><BR>');
   
   htp.p('<A HREF="'||owihome||'nao_cc1/index.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'nao_media/contactcarrier_button.gif" ');
   htp.p('ALIGN=MIDDLE  BORDER="0" VSPACE="4"></A><BR>');
   htp.p('</CENTER>');
*/

   END search_resource_buttons;
/*=====================================================================*/
   PROCEDURE qanda_button (URL IN VARCHAR2) IS

   BEGIN

   htp.p('<A TARGET="_parent" HREF="'||URL||'">');
   htp.p('<IMG SRC="'||owihome||'nao_media/qanda_button.gif"
    ALIGN=MIDDLE WIDTH="52" HEIGHT="18" VSPACE="2" BORDER="0"></A>');

   END qanda_button;
/*=====================================================================*/
   PROCEDURE news_button (URL IN VARCHAR2) IS

   BEGIN

   htp.p('<A TARGET="_parent" HREF="'||URL||'">');
   htp.p('<IMG SRC="'||owihome||'nao_media/whatsnew_button.gif"
    ALIGN=MIDDLE WIDTH="52" HEIGHT="18" VSPACE="2" BORDER="0"></A>');

   END news_button;
/*=====================================================================*/
   PROCEDURE contact_button (URL IN VARCHAR2) IS

   BEGIN

   htp.p('<A TARGET="_parent" HREF="'||URL||'">');
   htp.p('<IMG SRC="'||owihome||'nao_media/contactcarrier_button.gif"
    ALIGN=MIDDLE WIDTH="52" HEIGHT="18" VSPACE="2" BORDER="0"></A>');

   END contact_button;
/*=====================================================================*/
   PROCEDURE register_button (URL IN VARCHAR2) IS

   BEGIN

   htp.p('<A TARGET="_parent" HREF="'||URL||'">');
   htp.p('<IMG SRC="'||owihome||'nao_media/register_button.gif"
    ALIGN=MIDDLE WIDTH="52" HEIGHT="18" VSPACE="2" BORDER="0"></A>');

   END register_button ;
/*=====================================================================*/
   PROCEDURE comment (
             commentstring         IN VARCHAR2
             ) IS

   BEGIN

   htp.p('<!-- '||commentstring||'  -->');

   END comment;
/*======================================================*/
   PROCEDURE caw_featured_product IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<A HREF="'||owihome||'com_ap2/com_apd2.html" TARGET="bodyText">Featured Product</A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif" ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</FONT>');

   END caw_featured_product;
/*======================================================*/
   PROCEDURE caw_featured_technology IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<A HREF="'||owihome||'com_ap3/com_apd3.html" TARGET="bodyText">Featured Technology</A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif" ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</FONT>');

   END caw_featured_technology;
/*======================================================*/
   PROCEDURE caw_new_gif1 IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<IMG SRC="'||owihome||'com_media/new_anim1.gif" ALT="new at carrier.com" ALIGN=MIDDLE WIDTH="74" ');
   htp.p('HEIGHT="13" BORDER="0" HSPACE="4"><BR>');
   htp.p('</FONT>');

   END caw_new_gif1;
/*======================================================*/
   PROCEDURE caw_case_study IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<B><A HREF="'||owihome||'com_cs2/com_csd2.html" TARGET="bodyText">Case Study</A></B><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif" ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</FONT>');

   END caw_case_study;
/*======================================================*/
   PROCEDURE caw_colls_search IS

   BEGIN

   htp.p('<FONT SIZE=2>');
   htp.p('<A HREF="'||owihome||'com_cl5/com_cl5_index.html" TARGET="bodyText">');
   htp.p('Comfort at Work<BR>Literature (COLLS)</A><BR>');
   htp.p('</FONT>');

   END caw_colls_search;
/*======================================================*/

END ccutil;
/
show errors;
/
