DROP PACKAGE cputt;
CREATE OR REPLACE PACKAGE cputt AS

   ID                  NUMBER(10);


/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   widthll             NUMBER(10)      := 162;
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wp/';
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE list_com_model_fields (
             modelno  IN VARCHAR2,
             unittype IN VARCHAR2
             );
 
   PROCEDURE load_com_product_info (
             modelno  IN VARCHAR2,
             unittype IN VARCHAR2
             );

   PROCEDURE redisplay_models (
             modelno  IN VARCHAR2,
             unittype IN VARCHAR2
             );

   PROCEDURE list_models (
             modelno     IN VARCHAR2,
             unittype    IN VARCHAR2
             );

END cputt;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cputt IS

/*======================================================*/
   PROCEDURE redisplay_models (
             modelno           IN VARCHAR2,
             unittype          IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   htmlgeneral          VARCHAR2(50);
   malias               VARCHAR2(60);
   modelnum             VARCHAR2(60);
   modelstr             VARCHAR2(60);
   htmlmodelno          VARCHAR2(70);

   CURSOR get_gentype IS
   SELECT generaltype, specifictype
   FROM   commercial_products
   WHERE  upper(model) = upper(modelno);
   
   CURSOR get_models (general_type IN VARCHAR2, 
                     specific_type IN VARCHAR2) IS
   SELECT model, modelalias
   FROM   commercial_products
   WHERE  generaltype = general_type AND specifictype = specific_type
     AND  obsolete = 0
   ORDER  BY minclgcap;

   BEGIN

   OPEN get_gentype;
   LOOP
      FETCH get_gentype into gen_type, sp_type;
      EXIT WHEN get_gentype%ROWCOUNT =1;
      EXIT WHEN get_gentype%NOTFOUND;
   END LOOP;
   CLOSE get_gentype;

   htp.p('<P>');
   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER><I>'||gen_type||' - '||sp_type||' Models</I></CENTER><P>');
   htp.p('</FONT>');

   htp.p('<CENTER>');
   OPEN get_models (gen_type, sp_type);
   LOOP
      FETCH get_models INTO modelnum, malias;
      EXIT WHEN get_models%NOTFOUND;

      IF (malias IS NOT NULL) THEN
         modelstr := malias;
      ELSE modelstr := modelnum;
      END IF;

      htmlmodelno := REPLACE (modelnum, ' ', '+');
      htmlmodelno := REPLACE (htmlmodelno, '-', '%2D');
      htp.p('<FONT SIZE=2><A TARGET="_parent"
         HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'');
         htp.p('&unittype='||unittype||'">');
      htp.p(''||modelstr||'</A></FONT><BR>');
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         htp.p('No Products Found');
      WHEN value_error THEN
         htp.p('ORA-06502 for model '||modelno||' of '||gen_type||'');
      WHEN str_line_num THEN
         htp.p('ORA-06512 for model '||modelno||' of '||gen_type||'');
   END redisplay_models;
/*======================================================*/
   PROCEDURE list_models (
             modelno     IN VARCHAR2,
             unittype    IN VARCHAR2
             ) IS
---------------------------------------------------------------
--|DOC: Called by model_number.html: path 3 from Carrier Search?
---------------------------------------------------------------
             
   gn_type           VARCHAR2(50);
   sp_type           VARCHAR2(50);

   modelnum          fieldTblType;
   modelin           VARCHAR2(50);
   modelout          VARCHAR2(50);
   i                 NUMBER(10);
   imax              NUMBER(10);
   j                 NUMBER(10);

   htmlmod           VARCHAR2(50);

   CURSOR get_model (model_name IN VARCHAR2) IS
   SELECT model 
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   CURSOR get_types (model_name IN VARCHAR2) IS
   SELECT generaltype, specifictype, model
     FROM commercial_products
    WHERE upper(model) = upper(model_name); 

   BEGIN

   CCUTIL.chtml_header('list comm models called by model number');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_comfort_atwork;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   modelin := '%'||upper(modelno)||'%';   

   i := 0;
   OPEN get_model (modelin);
   LOOP
      i := i +1;
      FETCH get_model INTO modelnum(i);
      EXIT WHEN (get_model%NOTFOUND);
  --  htp.p('i is '||i||'; modelnum(i) is '||modelnum(i)||'<BR>');
      imax := i;
   END LOOP;
   CLOSE get_model;

   IF (imax =1) THEN
      modelin := modelnum(1);
      modelin := LTRIM( RTRIM(modelin) );
      htp.p('modelin is '||modelin||' just before call to list_fields<P>');
      CPUTT.load_com_product_info(modelin, unittype);
   ELSIF (imax > 1) THEN
      FOR j IN 1 .. imax
      LOOP
         modelin := modelnum(j);
     --  htp.p('Model is *'||modelin||'*<P>');
         OPEN get_types (modelin);
         LOOP
            FETCH get_types INTO gn_type, sp_type, modelout;
            EXIT WHEN get_types%ROWCOUNT =1;
            EXIT WHEN get_types%NOTFOUND;
         END LOOP;
         htmlmod := REPLACE(modelout, ' ', '+');
         htmlmod := REPLACE(htmlmod, '-', '%2D');
         htp.p('<P><FONT SIZE=2>'||gn_type||': '||sp_type||'</FONT><BR>'); 
         htp.p('<CENTER><FONT SIZE=3>');
         htp.p('<A  TARGET="_parent"
           HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmod||'');
          htp.p('&unittype='||unittype||'">'||modelout||'</A>');
         htp.p('</FONT></CENTER><BR>'); 
         CLOSE get_types;
      END LOOP;
   END IF;

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;
   
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        htp.p('No data found in new list_models procedure<BR>');
   END list_models;
/*======================================================*/
   PROCEDURE load_com_product_info (
             modelno     IN VARCHAR2,
             unittype    IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');
   htmlmo     :=  REPLACE(htmlmo, '-', '%2D');

   CCUTIL.chtml_header_frame('load commercial product info in frames');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CPUTT.list_com_model_fields?modelno='||htmlmo||'');
        htp.p('&unittype='||unittype||'"> ');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||plhome||'write_com_fieldpage.sh?modelno='||htmlmo||'');
        htp.p('&unittype='||unittype||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');

    htp.p('<NOFRAME>');
    htp.p('<P><BR>Placeholder for NOFRAME version of load commercial product info');
    htp.p('</NOFRAME>');

    CCUTIL.chtml_footer;
   END load_com_product_info;
/*======================================================*/
   PROCEDURE list_com_model_fields (
             modelno IN VARCHAR2,
             unittype IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   pdtablename          VARCHAR2(30);
   htmlgen              VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);
   callstring           VARCHAR2(100);

   dtablename           VARCHAR2(30);
   dtablename1          VARCHAR2(35);
   modelname            VARCHAR2(50);
   fieldnametab         fieldTblType;
   fieldaliastab        fieldTblType;
   fieldrec             field_properties%ROWTYPE;
   ifield               integer;
   ifmax                integer;

   newunittype          VARCHAR2(10);
   unittype1            VARCHAR2(10) := 'English';
   unittype2            VARCHAR2(10) := 'Metric';

   cprec                commercial_products%ROWTYPE;

   CURSOR get_model_info IS
   SELECT *
     FROM commercial_products
    WHERE upper(model) = upper(modelno); 

   CURSOR get_fields_english (field_table IN VARCHAR2) IS
   SELECT * FROM  field_properties
    WHERE displayfield = 1  
      AND (units =1 OR units=0)
      AND upper(tablename) = upper(field_table)
    ORDER BY displayorder;

   CURSOR get_fields_metric (field_table IN VARCHAR2) IS
   SELECT * FROM  field_properties
    WHERE displayfield = 1  
      AND (units =2 OR units=0)
      AND upper(tablename) = upper(field_table)
    ORDER BY displayorder;

   BEGIN

   CCUTIL.chtml_header ('List Generic Display Fields');

   htp.p('<CENTER>');

   htp.p('<!--#echo var="LAST_MODIFIED"-->');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.nav_upto_comfort_atwork;
-- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
-- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.caw_featured_product;
-- CCUTIL.caw_featured_technology;
-- CCUTIL.caw_new_gif1;
-- CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</CENTER>');

   OPEN get_model_info;
   FETCH get_model_info INTO cprec;
   dtablename := cprec.datatablename;
   CLOSE get_model_info;

   htp.p('<CENTER>');
   IF (dtablename IS NOT NULL) THEN
      htp.p('<HR ALIGN="center" WIDTH="100">');
      htp.p('<FORM METHOD="POST" TARGET="bodyText"
      ACTION="'||plhome||'cs_general.sh">');
      htp.p('Select Item(s)<BR>');
      htp.p('<INPUT TYPE="HIDDEN" NAME="modelno" VALUE="'||modelno||'">');
      htp.p('<INPUT TYPE="HIDDEN" NAME="datatablename" VALUE="'||dtablename||'">');
      htp.p('<INPUT TYPE="HIDDEN" NAME="unittype" VALUE="'||unittype||'">');
      htp.p('<SELECT NAME="fieldset" SIZE="5" MULTIPLE>');
   
      IF ( UPPER(unittype) = UPPER(unittype2) ) THEN
         OPEN get_fields_metric (dtablename);
         LOOP
            fetch get_fields_metric into fieldrec;
            EXIT WHEN get_fields_metric%NOTFOUND;
            IF (fieldrec.fielddisplayname is null) THEN
               htp.p('<OPTION VALUE="'||fieldrec.fieldname||'">'||fieldrec.fieldname||'*');
            ELSE
               htp.p('<OPTION VALUE="'||fieldrec.fieldname||'">'||fieldrec.fielddisplayname||'');
            END IF;
         END LOOP;
         close get_fields_metric;
         newunittype := 'English';
      ELSE
         OPEN get_fields_english (dtablename);
         LOOP
            fetch get_fields_english into fieldrec;
            EXIT WHEN get_fields_english%NOTFOUND;
            IF (fieldrec.fielddisplayname is null) THEN
               htp.p('<OPTION VALUE="'||fieldrec.fieldname||'">'||fieldrec.fieldname||'*');
            ELSE
               htp.p('<OPTION VALUE="'||fieldrec.fieldname||'">'||fieldrec.fielddisplayname||'');
            END IF;
         END LOOP;
         close get_fields_english;
         newunittype := 'Metric';
      END IF;
      htp.p('</SELECT><BR>');
      htp.p('<INPUT TYPE="SUBMIT" VALUE="Display Specs">');
      htp.p('</FORM>');
   END IF;
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   htmlmodelno := REPLACE (modelno, ' ', '+');
   htmlmodelno := REPLACE (htmlmodelno, '-', '%2D');

/*
   htp.p('<A TARGET="_parent"');
   htp.p('HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'');
   htp.p('&unittype='||unittype2||'">');
   htp.p('<CENTER>'||modelno||':<BR>metric listing<BR></CENTER></A>');
   htp.p('<HR ALIGN="center" WIDTH="100">');
*/

   htp.p('<CENTER><FONT SIZE=2>');
   htp.p('<A TARGET="_parent"');
   htp.p('HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'');
   htp.p('&unittype='||newunittype||'">');
   htp.p(modelno||':<BR>'||newunittype||' Data<BR></CENTER></A>');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER></FONT>');

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER>');
   IF (   cprec.electronic_literature = 1 ) THEN
      callstring := 'modelno='||htmlmodelno||'&dltype=eleclit';
      htp.p('<A TARGET="bodyText" ');
      htp.p('HREF="'||plhome||'write_download_segue.sh?'||callstring||'">'); 
      htp.p('<I>Electronic Literature</I></A>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   END IF;
   IF (   cprec.electronic_catalog = 1 ) THEN
      callstring := 'modelno='||htmlmodelno||'&dtype=eleccat';
      htp.p('<A TARGET="bodyText" ');
      htp.p(' HREF="'||plhome||'write_download_segue.sh?'||callstring||'">'); 
      htp.p('<I>Electronic Catalog</I></A>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   END IF;
   IF (   cprec.cad_template = 1 ) THEN
      callstring := 'modelno='||htmlmodelno||'&dtype=template';
      htp.p('<A  TARGET="bodyText" ');
      htp.p(' HREF="'||plhome||'write_download_segue.sh?'||callstring||'">'); 
      htp.p('<I>CAD Template</I></A>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   END IF;
   IF (   cprec.engineering_software = 1 ) THEN
      callstring := 'modelno='||htmlmodelno||'&dtype=E20-II';
      htp.p('<A  TARGET="bodyText" ');
      htp.p(' HREF="'||plhome||'write_download_segue.sh?'||callstring||'">'); 
      htp.p('<I>Engineering Software</I></A>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   END IF;
   htp.p('</CENTER>');
   htp.p('</FONT>');

   CPUTT.redisplay_models (modelno, unittype);

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 ');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 ');
         CCUTIL.chtml_footer;
   END list_com_model_fields;
/*======================================================*/
END cputt;
/
show errors;
/
