DROP PACKAGE racdocs;
CREATE OR REPLACE PACKAGE racdocs AS

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   widthll             NUMBER(10)      := 162;
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wp/';
   widthll             NUMBER(10)      := 162;


   PROCEDURE write_rac_modelpage(
             general_type           IN VARCHAR2,
             specific_type          IN VARCHAR2);

   PROCEDURE load_rac_page2_res (
             modelid            IN VARCHAR2);

   PROCEDURE load_rac_page2_com (
             modelsize         in varchar2
             );

   PROCEDURE write_rac_page2_res (
             modelid            IN VARCHAR2);

   PROCEDURE write_rac_page2_com  (
             modelsize         in varchar2
             );

   PROCEDURE rac_page2_body (
             mprefix          IN VARCHAR2,
             msizenum         IN VARCHAR2,
             mcap             IN VARCHAR2,
             URL_ref          IN VARCHAR2
             );

   PROCEDURE write_rac_nav2_res (
             modelid            IN VARCHAR2);

   PROCEDURE write_rac_nav2_com (
             modelid            IN VARCHAR2);

   PROCEDURE rac_by_capacity (
             minmax         IN VARCHAR2
             );

   PROCEDURE rac_by_cap_com (
             minmax         IN VARCHAR2
             );

   PROCEDURE sizingguide_com;

END racdocs;
/
show errors;
/
/*============================================================*/

CREATE OR REPLACE PACKAGE BODY racdocs IS

/*============================================================*/
/*============================================================*/
   PROCEDURE write_rac_modelpage(
             general_type           IN VARCHAR2,
             specific_type          IN VARCHAR2
             ) IS

--|-------------------------------------------------------
--|This is called from CPUT.write_modelpage
--|-------------------------------------------------------

   mincapn              number(10);
   maxcapn              number(10);
   model                VARCHAR2(50);

   CURSOR get_models IS
   SELECT model, to_number(minclgcap), 
          to_number(maxclgcap)
     FROM commercial_products
    WHERE upper(generaltype) LIKE 'ROOM AIR%' 
      AND upper(specifictype) = upper(specific_type);

   BEGIN

   htp.p('<P><BR>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>About '||general_type||': '||specific_type||'</FONT></A><P>');
   htp.p('</CENTER>');
   htp.p('<P><HR><P>');

   OPEN get_models;
   IF (upper(specific_type) LIKE 'COOL%') THEN

      htp.p('<CENTER>');
      htp.p('<H3>Sizing Guide for Room Air Conditioners</H3><P>');
      RACDOCS.sizingguide_com;
      htp.p('</CENTER>');

      LOOP
         FETCH get_models INTO model, mincapn, maxcapn;
         EXIT WHEN get_models%NOTFOUND;
         IF (mincapn IS NOT NULL AND maxcapn IS NOT NULL) THEN
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||': Capacity Range = ');
            htp.p(mincapn||'-'||maxcapn||'</FONT><P>');
         ELSE
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||'</FONT><P>');
         END IF;
         htp.p('<UL>');
         IF (upper(model) LIKE 'TC%') THEN
            RACTXT.rac_cool_tc_text;
         ELSIF (upper(model) LIKE 'EC%') THEN
            RACTXT.rac_cool_ec_text;
         ELSIF (upper(model) LIKE 'LC%') THEN
            RACTXT.rac_cool_lc_text;
         ELSIF (upper(model) LIKE 'XC%') THEN
            RACTXT.rac_cool_xc_yc_text;
         ELSIF (upper(model) LIKE 'YC%') THEN
            RACTXT.rac_cool_xc_yc_text;
         ELSIF (upper(model) LIKE 'XCB%') THEN
            RACTXT.rac_cool_xcb_text;
         ELSIF (upper(model) LIKE 'UC%') THEN
            RACTXT.rac_cool_uc_text;
         END IF;
         htp.p('</UL>');
      END LOOP;
   ELSIF (upper(specific_type) LIKE 'HEAT COOL%') THEN
      LOOP
         FETCH get_models INTO model, mincapn, maxcapn;
         EXIT WHEN get_models%NOTFOUND;
         IF (mincapn IS NOT NULL AND maxcapn IS NOT NULL) THEN
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||': Capacity Range = ');
            htp.p(mincapn||'-'||maxcapn||'</FONT><P>');
         ELSE
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||'</FONT><P>');
         END IF;
         htp.p('<UL>');
         RACTXT.rac_heat_cool_units_text;
         htp.p('</UL>');
      END LOOP;
   ELSIF (upper(specific_type) LIKE 'HEAT PUMP%') THEN
      LOOP
         FETCH get_models INTO model, mincapn, maxcapn;
         EXIT WHEN get_models%NOTFOUND;
         IF (mincapn IS NOT NULL AND maxcapn IS NOT NULL) THEN
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||': Capacity Range = ');
            htp.p(mincapn||'-'||maxcapn||'</FONT><P>');
         ELSE
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||model||'</FONT><P>');
         END IF;
         htp.p('<UL>');
         RACTXT.rac_heat_pumps_text;
         htp.p('</UL>');
      END LOOP;
   END IF;
   CLOSE get_models;
      
   CCUTIL.chtml_footer;

   END write_rac_modelpage;
/*============================================================*/
   PROCEDURE load_rac_page2_res (
             modelid          in varchar2
             )  IS

   modelprefix       VARCHAR2(50);
   modelsizenum      VARCHAR2(20);
   mprefix           VARCHAR2(50);
   msize             VARCHAR2(20);
   mnomcap           VARCHAR2(20);
   mvolts            VARCHAR2(10);
   htmlmo            VARCHAR2(70);
   mdlsize           VARCHAR2(70);
   pagelink          VARCHAR2(20);

   model_id          number(10);
   URL_ref           VARCHAR2(50);
   mdlid             VARCHAR2(70);

/* mincap            number(10);
   maxcap            number(10);
   minmax            VARCHAR2(20);
*/
   BEGIN

   CCUTIL.chtml_header_frame('load rac page 2 - residential');
 
   model_id     := SUBSTR(modelid, 1, INSTR(modelid, '$')-1 ); 
   URL_ref      := SUBSTR(modelid, INSTR(modelid, '$') +1);
   pagelink     := SUBSTR(URL_ref, INSTR(URL_ref, '$') +1);
   URL_ref      := SUBSTR(URL_ref, 1, INSTR(URL_ref, '$') -1 );

   mdlid      := REPLACE(modelid,' ','+');
   mdlid      := REPLACE(mdlid,  '-','%2D');

   CCUTIL.load_comfort_athome_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
      htp.p('<FRAME 
       SRC="'||wowhtml||'RACDOCS.write_rac_nav2_res?modelid='||mdlid||'"');
      htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
      htp.p('<FRAME 
       SRC="'||wowhtml||'RACDOCS.write_rac_page2_res?modelid='||mdlid||'" ');
      htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('<NOFRAME>');
    htp.p('<P><BR>This is a placeholder for load_rac_page2_res');
    htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_rac_page2_res;
/*======================================================*/
   PROCEDURE load_rac_page2_com (
             modelsize         in varchar2
             )  IS

   modelprefix       VARCHAR2(50);
   modelsizenum      VARCHAR2(20);
   mprefix           VARCHAR2(50);
   msize             VARCHAR2(20);
   mnomcap           VARCHAR2(20);
   htmlmo            VARCHAR2(70);
   mdlsize           VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header_frame('load rac page 2 - residential');

   modelprefix  := SUBSTR(modelsize, 1, INSTR(modelsize, '$')-1 ); 
   modelsizenum := SUBSTR(modelsize, INSTR(modelsize, '$') +1 );
   mprefix      := REPLACE(modelprefix,' ','+');
   mprefix      := REPLACE(mprefix,'-','%2D');
   msize        := REPLACE(modelsizenum,' ','+');
   msize        := REPLACE(msize,'-','%2D');
   mdlsize      := mprefix||'$'||msize;

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
      htp.p('<FRAME 
       SRC="'||wowhtml||'CPDOCS.write_rac_nav2?modelsize='||mdlsize||'"');
      htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
      htp.p('<FRAME 
       SRC="'||wowhtml||'RACDOCS.write_rac_page2_com?modelsize='||mdlsize||'" ');
      htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('<NOFRAME>');
    htp.p('<P><BR>This is a placeholder for load_rac_page2_com');
    htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_rac_page2_com;
/*======================================================*/
   PROCEDURE write_rac_page2_res  (
             modelid           in varchar2
             )  IS

   mprefix           VARCHAR2(50);
   msizenum          VARCHAR2(20);
   mcap              VARCHAR2(20);
   volts             VARCHAR2(20);

   model_id          number(10);
   URL_ref           VARCHAR2(50);
   pagelink          VARCHAR2(20);

   CURSOR get_input_model (
          mid       IN NUMBER )
       IS
   SELECT * 
     FROM rac_units_hc  
    WHERE id = mid;

   rachcr              rac_units_hc%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header ('write RAC page 2');

   model_id     := SUBSTR(modelid, 1, INSTR(modelid, '$')-1 ); 
   URL_ref      := SUBSTR(modelid, INSTR(modelid, '$') +1);
   pagelink     := SUBSTR(URL_ref, INSTR(URL_ref, '$') +1);
   URL_ref      := SUBSTR(URL_ref, 1, INSTR(URL_ref, '$') -1 );

--|htp.p('modelid is '||modelid||'<BR>');
--|htp.p('model_id is '||model_id||'<BR>');
--|htp.p('URL_ref is '||URL_ref||'<BR>');
--|htp.p('pagelink is '||pagelink||'<BR>');

   htp.p('<A HREF= "'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif" ');
   htp.p('ALIGN=MIDDLE WIDTH="430" HEIGHT="32" BORDER="0"></A><BR>');

   IF (upper(URL_ref) = 'RESDOCS_HC_RACPAGE') THEN
      htp.p('<FONT SIZE=2>');
      htp.p('<A TARGET="bodyText"
        HREF="'||wowhtml||'RESFLD.write_res_dfieldpage?generaltype=Room+Air+Conditioners">');
      htp.p(' Back to Room Air Conditionerers</A></FONT><P><P>');
   END IF;

   OPEN get_input_model(model_id);
   LOOP
      FETCH get_input_model INTO rachcr;
      EXIT WHEN get_input_model%ROWCOUNT = 1;
      EXIT WHEN get_input_model%NOTFOUND;
   END LOOP;
   CLOSE get_input_model;

   mprefix  := rachcr.model;
   msizenum := rachcr.model_size;
   mcap     := TO_NUMBER(rachcr.cool_capacity);

   RACDOCS.rac_page2_body(mprefix, msizenum, mcap, 'res_page2');

   CCUTIL.chtml_footer;

   END write_rac_page2_res; 
/*======================================================*/
   PROCEDURE write_rac_page2_com  (
             modelsize         in varchar2
             )  IS

   mprefix           VARCHAR2(50);
   msizenum          VARCHAR2(20);
   mcap              VARCHAR2(20);

   BEGIN

   CCUTIL.chtml_header ('write RAC page 2');

   mprefix  := SUBSTR(modelsize, 1, INSTR(modelsize, '$')-1 ); 
   msizenum := SUBSTR(modelsize, INSTR(modelsize, '$') +1 , INSTR(modelsize, '$'));
   mcap     := SUBSTR(modelsize, INSTR(modelsize, '$',1,2) +1);

   RACDOCS.rac_page2_body(mprefix, msizenum, mcap, 'com');

   CCUTIL.chtml_footer;

   END write_rac_page2_com; 
/*======================================================*/
   PROCEDURE rac_page2_body (
             mprefix          IN VARCHAR2,
             msizenum         IN VARCHAR2,
             mcap             IN VARCHAR2,
             URL_ref          IN VARCHAR2
             ) IS

   modelsize1        varchar2(100);

   mmprefix          VARCHAR2(50);
   msize             VARCHAR2(20);
   mnomcap           VARCHAR2(20);
   htmlmo            VARCHAR2(70);
   cap               VARCHAR2(20);
   temp              VARCHAR2(100);

   rac_rec                   rac_units_hc%ROWTYPE;
   racf_rec                  rac_fields%ROWTYPE;
   cp_rec                    commercial_products%ROWTYPE;

   CURSOR get_default_fields (field_table IN VARCHAR2) IS
   SELECT * 
     FROM rac_fields
    WHERE displaylevel= '0' AND displaydefault= '0'
          AND pdtablename = 'RAC_UNITS';

   CURSOR get_rac_data (
          modelno   IN VARCHAR2,
          modelsz   IN VARCHAR2,
          modelcp   IN VARCHAR2
          ) IS
   SELECT * 
     FROM RAC_UNITS_HC
    WHERE model = modelno  AND model_size = modelsz
      AND TO_NUMBER(cool_capacity) = modelcp;

   BEGIN

   OPEN get_rac_data (mprefix, msizenum, mcap);
   LOOP
      FETCH get_rac_data INTO rac_rec;
      EXIT WHEN get_rac_data%ROWCOUNT =1;
      EXIT WHEN get_rac_data%NOTFOUND;
   END LOOP;
   CLOSE get_rac_data;

   htp.p('<P><BR>');
   
   htp.p('<CENTER>');
   IF (rac_rec.model LIKE 'TC%') THEN 
      htp.p('<IMG SRC="'||owihome||'rac_media/TCA081D.jpg"
             ALIGN="center" HEIGHT="150" BORDER="0" ALT="TCA">');
      htp.p('<B>TC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'EC%') THEN
      htp.p(' <IMG SRC="'||owihome||'rac_media/ECB121D_2.jpg"
              ALIGN="center" HEIGHT="150" BORDER="0" ALT="ECB">');
      htp.p('<B>EC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'LC%') THEN
      htp.p(' <IMG SRC="'||owihome||'rac_media/LCA061P_1.jpg"
                    ALIGN="center" HEIGHT="150" BORDER="0" ALT="LCA">');
      htp.p('<B>LC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'UC%') THEN
      htp.p('<IMG SRC="'||owihome||'rac_media/UCB061B_1.jpg"
                    ALIGN="center" HEIGHT="150" BORDER="0" ALT="UCB">');
      htp.p('<B>UC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'XC%') THEN
      htp.p('<IMG SRC="'||owihome||'rac_media/XCB_183d_1.jpg"
              ALIGN="center" HEIGHT="150" BORDER="0" ALT="XCB">');
      htp.p('<B>XC/YC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'HC%') THEN
      htp.p(' <IMG SRC="'||owihome||'rac_media/HCA313D.jpg"
             ALIGN="center" HEIGHT="150" BORDER="0" ALT="HCA">');
      htp.p('<B>HC Series</B><P>');
   ELSIF (rac_rec.model LIKE 'XH%') THEN
      htp.p('<IMG SRC="'||owihome||'rac_media/xh_wh.jpg"
             ALIGN="center" HEIGHT="150" BORDER="0" ALT="XH series">');
      htp.p('<B>XH Series</B><P>');
   ELSIF (rac_rec.model LIKE 'XQ%') THEN
      htp.p('<IMG SRC="'||owihome||'rac_media/xq.jpg"
             ALIGN="center" HEIGHT="150" BORDER="0" ALT="XQ series">');
      htp.p('<B>XQ Series</B><P>');
   END IF;
   htp.p('</CENTER>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>Product Data for '||mprefix||msizenum||'</FONT>');
   htp.p('</CENTER><P>');
/*
   htp.p('<CENTER><TABLE WIDTH=80% BORDER=0 CELLSPACING="4">');
   htp.p(' <TR>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_1.gif" ');
   htp.p('       ALIGN="center" HEIGHT="24" BORDER="0" ALT="Receptacle 1"></TD>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_2.gif" ');
   htp.p('       ALIGN="center" HEIGHT="24" BORDER="0" ALT="Receptacle 2"></TD>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_3.gif" ');
   htp.p('       ALIGN="center" HEIGHT="24" BORDER="0" ALT="Receptacle 3"></TD>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_4.gif" ');
   htp.p('       ALIGN="center" HEIGHT="30" BORDER="0" ALT="Receptacle 4"></TD>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_5.gif" ');
   htp.p('       ALIGN="center" HEIGHT="30" BORDER="0" ALT="Receptacle 5"></TD>');
   htp.p('      <TD><IMG SRC="'||owihome||'rac_media/receptacle_6.gif" ');
   htp.p('       ALIGN="center" HEIGHT="24" BORDER="0" ALT="Receptacle 6"></TD>');
   htp.p('</TR>');
   htp.p(' <TR>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 1</FONT></TD>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 2</FONT></TD>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 3</FONT></TD>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 4</FONT></TD>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 5</FONT></TD>');
   htp.p('      <TD><FONT SIZE=2>Receptacle 6</FONT></TD>');
   htp.p('</TR>');
   htp.p('</TABLE></CENTER>');
*/
   htp.p('<CENTER>');
   htp.p('<IMG SRC="'||owihome||'rac_media/receptacle_types.gif" WIDTH=470>');
   htp.p('</CENTER>');

   htp.p('<CENTER>');
   htp.p('<TABLE BORDER=3 WIDTH=470  CELLPADDING =2 CELLSPACING=2>');
--|CCUTIL.if_table_2col(4, 'Model', rac_rec.model); 
--|CCUTIL.if_table_2col(4, 'Model Size', rac_rec.model_size); 
   CCUTIL.if_table_2col(4, 'Cooling Capacity (Btu''s)', to_number(rac_rec.cool_capacity)); 
   CCUTIL.if_table_2col(4, 'Electric Heat Capacity', to_number(rac_rec.el_ht_capacity)); 
   CCUTIL.if_table_2col(4, 'Heat Pump Capacity', to_number(rac_rec.ht_pump_capacity)); 
   CCUTIL.if_table_2col(4, 'Volts', to_number(rac_rec.Volts)); 
   CCUTIL.if_table_2col(4, 'EER', ROUND( TO_NUMBER(rac_rec.EER),1) );
   CCUTIL.if_table_2col(4, 'Watts', to_number(rac_rec.Watts) );
   CCUTIL.if_table_2col(4, 'Amperes', ROUND( TO_NUMBER(rac_rec.Amperes),1) );
   CCUTIL.if_table_2col(4, 'Fuse_Size', TO_NUMBER(rac_rec.Fuse_Size) ); 

   CCUTIL.if_table_2col(4, 'Receptacle Type', TO_NUMBER(rac_rec.receptacle) ); 
   CCUTIL.if_table_2col(4, 'Fan Speeds', TO_NUMBER(rac_rec.Fan_Speeds) ); 
   CCUTIL.if_table_2col(4, 'Moisture', ROUND( TO_NUMBER(rac_rec.Moisture),1) ); 
   CCUTIL.if_table_2col(4, 'Max Air Flow (CFM)', TO_NUMBER(rac_rec.cfm_hi) ); 
   CCUTIL.if_table_2col(4, 'Min Air Flow (CFM)', TO_NUMBER(rac_rec.cfm) ); 
   CCUTIL.if_table_2col(4, 'Air Flow Control', rac_rec.AF_control); 
   CCUTIL.if_table_2col(4, 'Ventilation', rac_rec.Ventilation); 
   CCUTIL.if_table_2col(4, 'Exhaust', rac_rec.Exhaust); 
   CCUTIL.if_table_2col(4, '24 Hour Timer', rac_rec.timer_24_hr); 
   CCUTIL.if_table_2col(4, 'Energy Saver Switch', rac_rec.e_s_switch); 
   CCUTIL.if_table_2col(4, 'Chassis Type', rac_rec.chassis); 
   CCUTIL.if_table_2col(4, 'Installation Kit', rac_rec.installation_kit); 

   CCUTIL.if_table_2col(4, 'Height', rac_rec.height); 
   CCUTIL.if_table_2col(4, 'Width', rac_rec.width); 
   CCUTIL.if_table_2col(4, 'Depth', rac_rec.Depth); 
   temp := SUBSTR(rac_rec.weight_net, 1, INSTR(rac_rec.weight_net, '.') -1);
   CCUTIL.if_table_2col(4, 'Net Weight (lbs)', temp ); 
   temp := SUBSTR(rac_rec.weight_ship, 1, INSTR(rac_rec.weight_ship, '.') -1);
   CCUTIL.if_table_2col(4, 'Shipping Weight (lbs)', temp ); 
   htp.p('</TABLE>');
   htp.p('</CENTER>');

   END rac_page2_body;
/*======================================================*/
   PROCEDURE write_rac_nav2_res (
             modelid            IN VARCHAR2
             ) IS

   mprefix           VARCHAR2(50);
   msizenum          VARCHAR2(20);
   mcap              VARCHAR2(20);
   mvolts            VARCHAR2(20);

   modelsize1        varchar2(100);
   mmprefix          VARCHAR2(50);
   msize             VARCHAR2(20);
   mnomcap           VARCHAR2(20);
   mmvolts           VARCHAR2(10);
   htmlmo            VARCHAR2(70);
   cap               VARCHAR2(20);
   volts             VARCHAR2(10);

   model_id          number(10);
   mmid              number(10);
   mdlid             VARCHAR2(50);
   URL_ref           VARCHAR2(50);
   rachr             rac_units_hc%ROWTYPE;

/* minmax            VARCHAR2(20);
   mincap            NUMBER(10);
   maxcap            NUMBER(10);
*/
   CURSOR get_input_model (
          mid       IN NUMBER )
       IS
   SELECT * 
     FROM rac_units_hc
    WHERE id = mid;

   CURSOR get_models (
          modelno IN VARCHAR2, 
          voltage IN VARCHAR2
          ) IS
   SELECT id, model, model_size, cool_capacity, volts
     FROM RAC_UNITS_HC
    WHERE upper(model) = upper(modelno)
      AND volts = voltage
    ORDER BY to_number(cool_capacity);

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<CENTER>');
   CCUTIL.nav_upto_comfort_athome;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_residential_products;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_room_air_conditioners;   
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_comfort_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_downloads;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');

   model_id     := SUBSTR(modelid, 1, INSTR(modelid, '$')-1 ); 
   URL_ref      := SUBSTR(modelid, INSTR(modelid, '$')+1 ); 

   OPEN get_input_model (model_id);
   LOOP
      FETCH get_input_model INTO rachr;
      EXIT WHEN get_input_model%ROWCOUNT =1;
      EXIT WHEN get_input_model%NOTFOUND;
   END LOOP;
   CLOSE get_input_model;

   mprefix   := rachr.model||rachr.model_size;
   mvolts    := rachr.volts;

--|htp.p('<UL>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>Full listing for other '||mprefix||', 
           '||mvolts||' voltage models:<P>');

   OPEN get_models (rachr.model, mvolts);
   LOOP
      FETCH get_models INTO mmid, mmprefix, msize, mnomcap, mmvolts;
      EXIT WHEN get_models%NOTFOUND;
         mdlid        := mmid||'$'||URL_ref;
         mdlid        := REPLACE(mdlid,' ', '+');
         mdlid        := REPLACE(mdlid, '-', '%2D');
         cap          := TO_NUMBER(mnomcap);
         htp.p('<A  METHOD="GET"  TARGET="bodyText"
            HREF="'||wowhtml||'RACDOCS.write_rac_page2_res?modelid='||mdlid||'">');
         htp.p(mmprefix||msize||'</A>-'||cap);
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');
--|htp.p('</UL>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   RESMOD.reload_res_types;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.res_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;

   CCUTIL.chtml_footer;

   END write_rac_nav2_res;
/*============================================================*/
   PROCEDURE write_rac_nav2_com (
             modelid            IN VARCHAR2) 
             IS

   BEGIN

    NULL;

   END write_rac_nav2_com;
/*============================================================*/
   PROCEDURE rac_by_capacity (
             minmax         IN VARCHAR2
             ) IS

   sptype               VARCHAR2(50);
   smin                 number(10);
   smax                 number(10);
   xseq                 NUMBER(10);
   mname                VARCHAR2(50);
   htmlmo               VARCHAR2(50);
   msize                VARCHAR2(20);
   cap                  VARCHAR2(20);
   volts                VARCHAR2(10);
   modelsize            VARCHAR2(100);
   temp                 VARCHAR2(100);

   mincap               NUMBER(10);
   maxcap               NUMBER(10);

   mdlid                VARCHAR2(70);
   URL_ref              VARCHAR2(50);

   CURSOR get_rac_data (
          minc in number, 
          maxc in number ) IS
   SELECT * 
     FROM rac_units_hc
    WHERE to_number(cool_capacity) <= maxc
      AND to_number(cool_capacity) >= minc
      AND specific_type = 'CO'
    ORDER BY to_number(cool_capacity);

   racr                 rac_units_hc%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Room Air Conditioners by Cooling Capacity');

   URL_ref  := 'SZCH_RES';

   mincap := to_number(SUBSTR(minmax, 1, INSTR(minmax, ' ') -1 )  ); 
   maxcap := to_number(SUBSTR(minmax,    INSTR(minmax, ' ') +1 )  );

   htp.p('<A HREF= "'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif" ');
   htp.p('ALIGN=MIDDLE WIDTH="430" HEIGHT="32" BORDER="0"></A>');

   htp.p('<P><FONT SIZE=2>');
   htp.p('<A HREF='||owihome||'rac_sh1/rac_shd1.html#sizingguide">');
   htp.p(' Back to Sizing Guide </A></FONT><P><P>');

   htp.p('<CENTER>');

   htp.p('<H3>Room Air Conditioners for Cooling Range '||mincap||'-'||maxcap||' Btu''s</H3>');

   htp.p('<TABLE BORDER=3 CELLPADDING=2 WIDTH=90%>');
   htp.p(' <TR><TD ALIGN="center">Model</TD>');
   htp.p('     <TD ALIGN="center">Cooling<BR>Capacity</TD>');
   htp.p('     <TD ALIGN="center">Voltage</TD>');
   htp.p('     <TD ALIGN="center">EER</TD>');
   htp.p('     <TD ALIGN="center">Airflow (CFM)<BR>Hi/Low</TD>');
   htp.p('     <TD ALIGN="center">Height<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Width<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Depth<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Shipping<BR>Weight</TD></TR>');

   OPEN get_rac_data (mincap, maxcap);
   LOOP
      FETCH get_rac_data INTO racr;
      EXIT WHEN get_rac_data%NOTFOUND;
      msize        := racr.model_size;
      mdlid        := racr.id||'$'||URL_ref||'$'||minmax;
      mdlid        := REPLACE(mdlid,' ', '+');
      mdlid        := REPLACE(mdlid,'-', '%2D');
      htmlmo       := REPLACE(racr.model,' ','+');
      htmlmo       := REPLACE(htmlmo,'-','%2D');
      cap          := TO_NUMBER(racr.cool_capacity);
      volts        := SUBSTR(racr.volts, 1, INSTR(racr.volts,'.')-1);
      modelsize    := htmlmo||'$'||msize||'$'||cap||'$'||volts;
      mname        := racr.model||racr.model_size;
      htp.p(' <TR><TD><A  METHOD="GET"  TARGET="_top"
                  HREF="'||wowhtml||'RACDOCSZ.load_rac_page2_szchart?modelid='||mdlid||'">');
      htp.p(      mname||'</A></TD>');
      htp.p('        <A NAME="'||mname||'"></A></TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.cool_capacity)||'</TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.volts)||'</TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.EER)||'</TD>');
      htp.p('     <TD ALIGN=
                  "center">'||TO_NUMBER(racr.CFM_HI)||'/'||TO_NUMBER(racr.CFM)||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Height||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Width||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Depth||'</TD>');
      temp      := SUBSTR(racr.weight_ship, 1, INSTR(racr.weight_ship, '.') -1);
      htp.p('     <TD ALIGN="center">'||temp||'</TD>');
      htp.p('</TR>');
   END LOOP;
   CLOSE get_rac_data; 
   htp.p('</TABLE>');

   CCUTIL.chtml_footer;

   END rac_by_capacity;
/*============================================================*/
   PROCEDURE rac_by_cap_com (
             minmax         IN VARCHAR2
             ) IS

   sptype               VARCHAR2(50);
   smin                 number(10);
   smax                 number(10);
   xseq                 NUMBER(10);
   mname                VARCHAR2(50);
   htmlmo               VARCHAR2(50);
   msize                VARCHAR2(20);
   cap                  VARCHAR2(20);
   volts                VARCHAR2(10);
   modelsize            VARCHAR2(100);
   temp                 VARCHAR2(100);

   mincap               NUMBER(10);
   maxcap               NUMBER(10);

   mdlid                VARCHAR2(70);
   URL_ref              VARCHAR2(50);

   CURSOR get_rac_data (
          minc in number, 
          maxc in number ) IS
   SELECT * 
     FROM rac_units_hc
    WHERE to_number(cool_capacity) <= maxc
      AND to_number(cool_capacity) >= minc
      AND specific_type = 'CO'
    ORDER BY to_number(cool_capacity);

   racr                 rac_units_hc%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Room Air Conditioners by Cooling Capacity');

   URL_ref  := 'SZCH_RES';

   mincap := to_number(SUBSTR(minmax, 1, INSTR(minmax, ' ') -1 )  ); 
   maxcap := to_number(SUBSTR(minmax,    INSTR(minmax, ' ') +1 )  );

   htp.p('<A HREF= "'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif" ');
   htp.p('ALIGN=MIDDLE WIDTH="430" HEIGHT="32" BORDER="0"></A>');

   htp.p('<P><FONT SIZE=2>');
   temp := 'general_type=Room+Air+Conditioners&specific_type=Cool+Only'; 
   htp.p('<A HREF='||wowhtml||'RACDOCS.write_rac_modelpage?'||temp||'">');
   htp.p(' Back to Sizing Guide </A></FONT><P><P>');

   htp.p('<CENTER>');

   htp.p('<H3>Room Air Conditioners for Cooling Range '||mincap||'-'||maxcap||' Btu''s</H3>');

   htp.p('<TABLE BORDER=3 CELLPADDING=2 WIDTH=90%>');
   htp.p(' <TR><TD ALIGN="center">Model</TD>');
   htp.p('     <TD ALIGN="center">Cooling<BR>Capacity</TD>');
   htp.p('     <TD ALIGN="center">Voltage</TD>');
   htp.p('     <TD ALIGN="center">EER</TD>');
   htp.p('     <TD ALIGN="center">Airflow (CFM)<BR>Hi/Low</TD>');
   htp.p('     <TD ALIGN="center">Height<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Width<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Depth<BR>(In)</TD>');
   htp.p('     <TD ALIGN="center">Shipping<BR>Weight</TD></TR>');

   OPEN get_rac_data (mincap, maxcap);
   LOOP
      FETCH get_rac_data INTO racr;
      EXIT WHEN get_rac_data%NOTFOUND;
      msize        := racr.model_size;
      mdlid        := racr.id||'$'||URL_ref||'$'||minmax;
      mdlid        := REPLACE(mdlid,' ', '+');
      mdlid        := REPLACE(mdlid,'-', '%2D');
      htmlmo       := REPLACE(racr.model,' ','+');
      htmlmo       := REPLACE(htmlmo,'-','%2D');
      cap          := TO_NUMBER(racr.cool_capacity);
      volts        := SUBSTR(racr.volts, 1, INSTR(racr.volts,'.')-1);
      modelsize    := htmlmo||'$'||msize||'$'||cap||'$'||volts;
      mname        := racr.model||racr.model_size;
      htp.p(' <TR><TD><A  METHOD="GET"  TARGET="_top"
                  HREF="'||wowhtml||'RACDOCSZ.load_rac_page2_szchart_com?modelid='||mdlid||'">');
      htp.p(      mname||'</A></TD>');
      htp.p('        <A NAME="'||mname||'"></A></TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.cool_capacity)||'</TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.volts)||'</TD>');
      htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.EER)||'</TD>');
      htp.p('     <TD ALIGN=
                  "center">'||TO_NUMBER(racr.CFM_HI)||'/'||TO_NUMBER(racr.CFM)||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Height||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Width||'</TD>');
      htp.p('     <TD ALIGN="center">'||racr.Depth||'</TD>');
      temp      := SUBSTR(racr.weight_ship, 1, INSTR(racr.weight_ship, '.') -1);
      htp.p('     <TD ALIGN="center">'||temp||'</TD>');
      htp.p('</TR>');
   END LOOP;
   CLOSE get_rac_data; 
   htp.p('</TABLE>');

   CCUTIL.chtml_footer;

   END rac_by_cap_com;
/*============================================================*/
   PROCEDURE sizingguide_com IS

   BEGIN

   htp.p('<A NAME="sizingguide"></A>');
   htp.p('<TABLE BORDER=1 CELLPADDING=3 WIDTH=420>');
   htp.p('');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <B>Area to be<BR>cooled (sq.ft.)</B>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <B>Cooling Capacity<BR>(Btu/Hr)</B>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=5000+6000" ');
   htp.p('         TARGET="bodyText">100-250</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=5000+6000" ');
   htp.p('         TARGET="bodyText">5,000-6,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=6000+8500" ');
   htp.p('         TARGET="bodyText">250-400</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=6000+8500" ');
   htp.p('         TARGET="bodyText">6,000-8,500</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=8500+11000" ');
   htp.p('         TARGET="bodyText">400-550</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=8500+11000" ');
   htp.p('         TARGET="bodyText">8,500-11,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=11000+15000" ');
   htp.p('    TARGET="bodyText">550-875</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=11000+15000" ');
   htp.p('    TARGET="bodyText">11,000-15,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=15000+19000" ');
   htp.p('    TARGET="bodyText">875-1,200</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=15000+19000" ');
   htp.p('    TARGET="bodyText">15,000-19,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=19000+24000" ');
   htp.p('   TARGET="bodyText">1,200-1,600</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=19000+24000" ');
   htp.p('   TARGET="bodyText">19,000-24,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=24000+27000" ');
   htp.p('   TARGET="bodyText">1,600-1,800</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=24000+27000" ');
   htp.p('   TARGET="bodyText">24,000-27,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('<TR>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=27000+33000" ');
   htp.p('   TARGET="bodyText">1,800-2,800</A>');
   htp.p('   </TD>');
   htp.p('   <TD ALIGN=CENTER>');
   htp.p('   <A HREF="http://mindy.infomall.org:6390/cgi-bin/wowc/RACDOCS.rac_by_cap_com?minmax=27000+33000" ');
   htp.p('   TARGET="bodyText">27,000-33,000</A>');
   htp.p('   </TD>');
   htp.p('</TR>');
   htp.p('</TABLE>');

   END sizingguide_com;
/*============================================================*/
END racdocs;
/
show errors;
/
