DROP PACKAGE restxt;
CREATE OR REPLACE PACKAGE restxt AS

-- compiled in the new staging area 19-oct-97

   PROCEDURE RES_AIR_TREATMENT_TEXT;
   PROCEDURE RES_BOILERS_STEAM_TEXT;
   PROCEDURE RES_BOILERS_WATER_TEXT;
   PROCEDURE RES_CAC_TEXT;
   PROCEDURE RES_FANCOILS_TEXT_1;
   PROCEDURE RES_FANCOILS_TEXT_2;
   PROCEDURE RES_FANCOILS_TEXT_3;
   PROCEDURE RES_FANCOILS_ELECFURN_TEXT;
   PROCEDURE RES_GAS_FURNACES_C_TEXT;
   PROCEDURE RES_GAS_FURNACES_TEXT_1;
   PROCEDURE RES_GAS_FURNACES_TEXT_2;
   PROCEDURE RES_GAS_FURNACES_TEXT_3;
   PROCEDURE RES_GAS_FURNACES_TEXT_4;
   PROCEDURE RES_HP_TEXT;
   PROCEDURE RES_HUMIDIFIERS_TEXT;
   PROCEDURE RES_INDOOR_COILS_TEXT_1;
   PROCEDURE RES_INDOOR_COILS_TEXT_2;
   PROCEDURE RES_OIL_FURNACES_TEXT;
   PROCEDURE RES_SPLIT_SYSTEM_HP_TEXT;
   PROCEDURE RES_VENTILATORS_TEXT;
   PROCEDURE RES_ZONE_CONTROLS_TEXT;
   PROCEDURE RES_DAMPERS_TEXT;
   PROCEDURE RAC_COOL_UNITS_TEXT;
   PROCEDURE RAC_HEAT_COOL_UNITS_TEXT;
   PROCEDURE RAC_HEAT_PUMPS_TEXT;

END restxt;
/
show errors;
/
/*============================================================*/
CREATE OR REPLACE PACKAGE BODY restxt AS
/*============================================================*/
   PROCEDURE RES_AIR_TREATMENT_TEXT IS

   BEGIN

   htp.p('<B><FONT SIZE=4>Electronic and Mechanical Air Cleaners </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(1200 - 2000 CFM)</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>31MF</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Part of your total matched comfort system, our electronic');
   htp.p('air cleaners remove microscopic particles as small as .01 microns');
   htp.p('while maintaining your system''s efficiency.  Standard 5-year Limited');
   htp.p('Warranty on solid-state power pack.  Low pressure drop.</FONT>');
   htp.p('<P>');

   RESTXT97.res_31mf_txt;


   END RES_AIR_TREATMENT_TEXT;
/*============================================================*/
   PROCEDURE RES_BOILERS_STEAM_TEXT IS

   BEGIN

   htp.p('<P><FONT SIZE=4><B>Boilers </B></FONT><BR>');
   htp.p('<B><FONT SIZE=3>(75,000 to 299,000 Btuh heating)<BR>');
   htp.p('</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>BS Steam Boilers</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Cast-iron sectional design</FONT>');
   htp.p('<LI><FONT SIZE=2>');
   htp.p(' Available with either standing pilot or electronic ignition</FONT>');
   htp.p('<LI><FONT SIZE=2> Standard vent damper</FONT><BR>');

   END RES_BOILERS_STEAM_TEXT;
/*============================================================*/
   PROCEDURE RES_BOILERS_WATER_TEXT IS
 
   BEGIN

   htp.p('<B><FONT SIZE=4>Boilers </FONT></B>');
   htp.p('<B><FONT SIZE=3>(37,500 to 280,000 Btuh heating)<BR>');
   htp.p('</FONT></B>');
   htp.p('<B><FONT SIZE=3>BW1/BW2  Water Boilers</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Cast-iron sectional design</FONT>');
   htp.p('<LI><FONT SIZE=2> Circulating pumps</FONT>');
   htp.p('<LI><FONT SIZE=2> Available with either standing pilot or electronic');
   htp.p('ignition</FONT>');
   htp.p('<LI><FONT SIZE=2> Standard vent damper'); 
   htp.p('</font><li><font size=2>Availble for propane gas');
   htp.p('</FONT>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>BW3  Gas-Fired Induced-Combustion Water Boilers</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Compact units</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy installation in basement, garage, or utility');
   htp.p('room</FONT>');
   htp.p('<LI><FONT SIZE=2> Available for propane gas<BR>');
   htp.p('</FONT>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>BW4/BW5  Oil-Fired Water Boilers</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Cast-iron sectional design</FONT>');
   htp.p('<LI><FONT SIZE=2> Circulating pump</FONT>');
   htp.p('<LI><FONT SIZE=2> Tankless coil option</FONT>');

   END RES_BOILERS_WATER_TEXT;
/*============================================================*/
   PROCEDURE RES_CAC_TEXT IS
--|P.6 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<FONT SIZE=4><B>Air-Cooled Air Conditioning Units</B></FONT>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(18,000 - 60,000 Btuh cooling)<BR>');
   htp.p('</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>38TDA, 38TRA, 38BRB, 38TUA, 38CMB, 38TKB, ');
   htp.p('38CKB</FONT></B>');
   htp.p('<P>');
   htp.p('<LI><FONT SIZE=2>Outdoor condensing units offer maximum efficiency');
   htp.p('and flexibility.<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> SEERs as high as 17.0</FONT>');
   htp.p('<LI><FONT SIZE=2> Durable copper tube/aluminum fin coil construction</FONT>');
   htp.p('<LI><FONT SIZE=2> High-efficiency compressors with built-in protective');
   htp.p('<LI><FONT SIZE=2> Excellent access for service and maintenance</FONT>');
   htp.p('devices</FONT>');
   htp.p('<LI><FONT SIZE=2> PSC fan motors that are weather sealed for durability</FONT>');
   htp.p('<LI><FONT SIZE=2> Tough, baked-on powder paint finish ensures years');
   htp.p('of good looks and long life</FONT>');
   htp.p('<LI><FONT SIZE=2> Ozone friendly reusable service valves</FONT>');
   htp.p('<LI><FONT SIZE=2> Quiet sound ratings</FONT>');
   htp.p('<LI><FONT SIZE=2> 1 year parts warranty and up to 10 year warranty');
   htp.p('on compressor standard');

   RESTXT97.res_38TXA_txt;

   END RES_CAC_TEXT;
/*============================================================*/
   PROCEDURE RES_FANCOILS_TEXT_1 IS
--|P.13 of RES 95-96 mini-catalog
 
   BEGIN

   htp.p('<B><FONT SIZE=4>Heat Pump/Cooling Duty Fan Coil Units<BR>');
   htp.p('</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>FK4C, FC4B, FB4A<BR>');
   htp.p('</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>FK4C  Variable Speed</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Variable-speed fan coil utilizes carefully engineered,');
   htp.p('proven components.  Its premium features yield high efficiency,');
   htp.p('application versatility, ease of installation, and high-tech performance');
   htp.p('for outstanding year-round total home comfort.  The FK4C offers');
   htp.p('an ICM2 blower motor for up to 15% higher efficiency than a standard');
   htp.p('PSC blower motor along with an internally mounted TXV metering');
   htp.p('device.  All the FK4C models come with insulation and');
   htp.p('gasketed door seals for premium performance and quiet operation.');
   htp.p(' The multi-poised design allows for maximum application with factory-');
   htp.p('or field-installed electric heaters.<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> High efficiency, programmable multi-speed blower');
   htp.p('motor (ICM2)</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy select board with 5 amp fuse</FONT>');
   htp.p('<LI><FONT SIZE=2> Thermostatic expansion valve (TXV)</FONT>');
   htp.p('<LI><FONT SIZE=2> Rifled copper tube/aluminum fin</FONT>');
   htp.p('<LI><FONT SIZE=2> Multi-poise model</FONT>');
   htp.p('<LI><FONT SIZE=2> Permanent framed filter/filter rack</FONT>');
   htp.p('<LI><FONT SIZE=2> Prepainted 20-gauge casing</FONT>');
   htp.p('<LI><FONT SIZE=2> Modular unit available in 006 size</FONT>');
   htp.p('<LI><FONT SIZE=2> Field-installed electric heat (3-30 kW, fused, 10kW');
   htp.p('and amp; down)</FONT>');
   htp.p('<LI><FONT SIZE=2> Choice of on/off TDR (Time Delay Relay)</FONT>');
   htp.p('<LI><FONT SIZE=2> Fully durable plastic condensate pans</FONT>');
   htp.p('<LI><FONT SIZE=2> Foil-faced, ; thick, high-density insulation');
   htp.p('<BR>');
   htp.p('</FONT>');
   htp.p('<P>');
   
   RESTXT97.res_fc48_txt;

   END RES_FANCOILS_TEXT_1;
/*============================================================*/
   PROCEDURE RES_FANCOILS_TEXT_2 IS
--|P.14 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Heat Pump/Cooling Duty Fan Coil Units</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>FA4A, FH4A </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>FA4A  New Construction</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Multi-poised Fan Coil designed for the residential');
   htp.p('new construction market.  This unit comes with an attractive,');
   htp.p('heavy-duty embossed casing.  Plus we offer multi-speed motors');
   htp.p('in all sizes.<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> 1 in heavy-duty foil-faced insulation</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-speed motors in 018-036 units and 3-speed ');
   htp.p('motors in 042-060 units</FONT>');
   htp.p('<LI><FONT SIZE=2> Factory- or field-installed electric resistance heat</FONT>');
   htp.p('<LI><font size=2> Factory- installed disconnect version available</font>');
   htp.p('<LI><FONT SIZE=2> 5 amp replaceable fuse on control board</FONT>');
   htp.p('<LI><FONT SIZE=2> TDR (Time Delay Relay) is standard</FONT>');
   htp.p('<li><font size=2> Fully drainable Lexan condensate drain pan<font>');
   htp.p('<LI><FONT SIZE=2> AccuRater</FONT><FONT SIZE=1>TM </FONT><FONT SIZE=2>');
   htp.p('metering device </FONT>');
   htp.p('<P>');

   END RES_FANCOILS_TEXT_2;
/*============================================================*/
   PROCEDURE RES_FANCOILS_TEXT_3 IS

   BEGIN

   htp.p('<B><FONT SIZE=4>Heat Pump/Cooling Duty Fan Coil Units</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>FF1C, FG3A, FH4A </FONT></B>');
   htp.p('<P>');

   RESTXT97.res_ff1c_txt;


   END RES_FANCOILS_TEXT_3;
/*============================================================*/
   PROCEDURE RES_FANCOILS_ELECFURN_TEXT IS
--|P.14 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Heat Pump/Cooling Duty Fan Coil Units</FONT></B>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>FH4A  Electric Furnace</FONT></B>');
   htp.p('<P>');
   htp.p('<LI><FONT SIZE=2> Multi-poised models--accessory coils (001 and');
   htp.p('002)</FONT>');
   htp.p('<LI><FONT SIZE=2> Vertical models accessory coils (003 and 004)</FONT>');
   htp.p('<LI><FONT SIZE=2> Multi-speed motors</FONT>');
   htp.p('<LI><FONT SIZE=2> Field-installed heater packages 3-30 kW, fused,');
   htp.p('circuit breaker, non-fused </FONT>');
   htp.p('<LI><FONT SIZE=2> High-density, 1 in thick foil-faced insulation</FONT>');
   htp.p('<LI><FONT SIZE=2> 5 amp fused control board for transformer protection</FONT>');
   htp.p('<LI><FONT SIZE=2> TDR (Time Delay Relay) standard<BR>');
   htp.p('</FONT>');

   END RES_FANCOILS_ELECFURN_TEXT;
/*============================================================*/
   PROCEDURE RES_GAS_FURNACES_C_TEXT IS
--|P.16 of 95-96 RES mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Gas-Fired Condensing Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(40,000 to 140,000 Btuh heating and 18,000 to');
   htp.p('60,000 Btuh cooling) </FONT></B>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>58MVP, 58MXA</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Multipoise 4-way design for high-efficiency upflow,');
   htp.p('downflow, or horizontal installations in the home or business.');
   htp.p(' All models are 39 7/8 inches tall and 28 1/2 inches deep.  AGA/CGA');
   htp.p('certified.  </FONT>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>WeatherMaker Infinity  58MVP</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Up to 96.6% ICS AFUE rating</FONT>');
   htp.p('<LI><FONT SIZE=2> Aluminized steel primary heat exchanger with lifetime');
   htp.p('limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Patented Serpentuff</FONT><FONT SIZE=1><sup>TM');
   htp.p('</sup></FONT><FONT SIZE=2>');
   htp.p('polypropylene laminated condensing heat exchanger with lifetime');
   htp.p('limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-stage redundant slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> ICM2 variable speed inducer and blower motors with');
   htp.p('5-year limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition system with 3-year limited');
   htp.p('warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Monoport inshot burners</FONT>');
   htp.p('<LI><FONT SIZE=2> Adjustable blower speed for cooling and continuous');
   htp.p('fan</FONT>');
   htp.p('<LI><FONT SIZE=2> Convenient electronic air cleaner and humidifer');
   htp.p('terminals</FONT>');
   htp.p('<LI><FONT SIZE=2> Sidewall or vertical venting capability</FONT>');
   htp.p('<LI><FONT SIZE=2> Direct vent sealed combustion system uses 100% outdoor');
   htp.p('air</FONT>');
   htp.p('<LI><FONT SIZE=2> Low fire speed allows ultra-quiet operation</FONT>');
   htp.p('<LI><FONT SIZE=2> Propane convertible<BR>');
   htp.p('</FONT>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>WeatherMaker 9200  58MXA</FONT></B>');
   htp.p('<LI><FONT SIZE=2> 92% ICS AFUE</FONT>');
   htp.p('<LI><FONT SIZE=2> Aluminized steel and Serpentuff</FONT>');
   htp.p('<FONT SIZE=1><sup>TM</sup>');
   htp.p(' </FONT><FONT SIZE=2>heat exchangers with lifetime limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition system and Microprocessor Control');
   htp.p('Center with 3-year limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Multi-speed direct drive PSC blower</FONT>');
   htp.p('<LI><FONT SIZE=2> Redundant slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Direct vent sealed combustion</FONT>');
   htp.p('<LI><FONT SIZE=2> AGA/CGA certified for manufactured (mobile) home</FONT>');
   htp.p('<LI><FONT SIZE=2> Propane convertible </FONT>');

   restxt97.res_58mca_txt;

   
   END RES_GAS_FURNACES_C_TEXT;
/*============================================================*/
   PROCEDURE RES_GAS_FURNACES_TEXT_1 IS
--|P.17 of 95-96 RES mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Gas-Fired Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(40,000 to 133,000 Btuh heating and cooling) </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>58UHV/58UXV, 58TUA/TMA, 58UXT/58DXT </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>WeatherMaker 8000 Variable Speed Furnace 58UHV,');
   htp.p('58UXV</FONT></B>');
   htp.p('<LI><FONT SIZE=2> 80% AFUE ratings</FONT>');
   htp.p('<LI><FONT SIZE=2> Variable speed ICM2+ blower motor</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-stage heating and cooling operation</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-pass heat exchanger</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-stage gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition</FONT>');
   htp.p('<LI><FONT SIZE=2> Microprocessor based smart control</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA design certified</FONT>');
   htp.p('<LI><FONT SIZE=2> 58UXV is certified for use in California Air Quality');
   htp.p('Management Districts<BR>');
   htp.p('</FONT>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>WeatherMaker 8000 Two-Speed Furnace 58TUA, 58TMA,');
   htp.p('58DXT, 58UXT</FONT></B>');
   htp.p('<LI><FONT SIZE=2> AFUE ratings of 80%</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-pass heat exchanger</FONT>');
   htp.p('<LI><FONT SIZE=2> Inshot burner system</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-stage heating and cooling operation</FONT>');
   htp.p('<LI><FONT SIZE=2> 2-stage gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition</FONT>');
   htp.p('<LI><FONT SIZE=2> Multispeed, direct-drive PSC blower motor</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA design certified</FONT>');
   htp.p('<LI><FONT SIZE=2> 58UXT/DXT certified for use in California Air Quality');
   htp.p('Management Districts</FONT>');

   END RES_GAS_FURNACES_TEXT_1;
/*============================================================*/
   PROCEDURE RES_GAS_FURNACES_TEXT_2 IS
--|P.18 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Gas-Fired Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(44,000 to 154,000 Btuh heating and cooling)</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>58WAV, 58ZAV</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>WeatherMaker 8000 deluxe upflow gas furnace, approved');
   htp.p('for use with common flue venting and installation on combustible');
   htp.p('flooring, or in alcoves, attics, basements, closets, or utility');
   htp.p('rooms. </FONT>');
   htp.p('<P>');
   htp.p('<LI><FONT SIZE=2> AGA certified common vent draft inducer (Category');
   htp.p('I)</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition system</FONT>');
   htp.p('<LI><FONT SIZE=2> Redundant slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Solid-state blower control, 24-v wiring terminals,');
   htp.p('EAC terminals, with 3-year parts warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> 40-va transformer</FONT>');
   htp.p('<LI><FONT SIZE=2> Easily removed basepan</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-speed, PSC direct-drive blower motor</FONT>');
   htp.p('<LI><FONT SIZE=2> Aluminized steel--"Super S" exchanger');
   htp.p('cells with 20-year limited warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Propane convertible</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA approved</FONT>');
   htp.p('<P>');

   htp.p('<B><FONT SIZE=3>58PAV, 58RAV</FONT></B>');
   htp.p('<LI><FONT SIZE=2> AGA certified common vent draft inducer (Category');
   htp.p('I)</FONT>');
   htp.p('<LI><FONT SIZE=2> Hot surface ignition system</FONT>');
   htp.p('<LI><FONT SIZE=2> Redundant slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Solid-state blower control, 24-v wiring terminals,');
   htp.p('EAC terminals, with 3-year parts warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> 40-va transformer</FONT>');
   htp.p('<LI><FONT SIZE=2> Easily removed basepan</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-speed, PSC direct-drive blower motor</FONT>');
   htp.p('<LI><FONT SIZE=2> Aluminized steel--"Super S" exchanger');
   htp.p('cells with 20-year warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Propane convertible</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA approved</FONT>');

   END RES_GAS_FURNACES_TEXT_2;
/*============================================================*/
   PROCEDURE RES_GAS_FURNACES_TEXT_3 IS
--|P.19 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Gas-Fired Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(63,000 to 147,000 Btuh heating and cooling) </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>58GFA</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Upflow, continuous pilot gas furnace; approved for');
   htp.p('use with common flue venting and installation on combustible flooring,');
   htp.p('or in alcoves, attics, basements, closet, or utility rooms.</FONT>');
   htp.p('<P>');
   htp.p('<LI><FONT SIZE=2> Continuous pilot</FONT>');
   htp.p('<LI><FONT SIZE=2> Redundant main gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> Solid-state blower control, 24-v wiring terminals,');
   htp.p('EAC terminals, with 1-year limited parts warranty </FONT>');
   htp.p('<LI><FONT SIZE=2> 40-va transformer</FONT>');
   htp.p('<LI><FONT SIZE=2> Easily removed basepan</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-speed, PSC direct-drive blower motor</FONT>');
   htp.p('<LI><FONT SIZE=2> Propane convertible</FONT>');
   htp.p('<LI><FONT SIZE=2> 40 inches high</FONT>');
   htp.p('<LI><FONT SIZE=2> Slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA approved</FONT>');
   htp.p('<LI><FONT SIZE=2> Aluminized steel--"Super S" exchanger');
   htp.p('cells with 10-year limited warranty</FONT>');

   END RES_GAS_FURNACES_TEXT_3;
/*============================================================*/
   PROCEDURE RES_GAS_FURNACES_TEXT_4 IS
--|P.19 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4>Gas-Fired Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(50,000 to 125,000 Btuh heating and cooling)</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>58EFB</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Dedicated horizontal gas-fired furnaces.  AGA/CGA');
   htp.p('certified for installation on combustible flooring in attics,');
   htp.p('basements, or crawl spaces; may be suspended from the ceiling.');
   htp.p(' Gas controls and flue outlet can be mounted on front or back');
   htp.p('of furnace, allowing greater installation and service flexibility.');
   htp.p('</FONT>');
   htp.p('<P>');
   htp.p('<LI><FONT SIZE=2> Cooling relay on all models</FONT>');
   htp.p('<LI><FONT SIZE=2> Multi-speed direct-drive motor</FONT>');
   htp.p('<LI><FONT SIZE=2> Blower door interlock switch</FONT>');
   htp.p('<LI><FONT SIZE=2> 20-year heat exchanger warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Burners compatible with both propane and natural');
   htp.p('gas</FONT>');
   htp.p('<LI><FONT SIZE=2> Air filter rack option</FONT>');
   htp.p('<LI><FONT SIZE=2> Intermittent ignition system</FONT>');
   htp.p('<LI><FONT SIZE=2> Slow-opening gas valve</FONT>');
   htp.p('<LI><FONT SIZE=2> 4-pass design primary heat exchanger</FONT>');
   htp.p('<LI><FONT SIZE=2> 1-year control board warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> All units AGA/CGA approved<BR>');
   htp.p('</FONT>');
   

   END RES_GAS_FURNACES_TEXT_4;
/*============================================================*/
   PROCEDURE RES_HP_TEXT IS
--|P.7 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<FONT SIZE=4>');
   htp.p('<B>Air-Cooled Split System Heat Pump Units</B></FONT>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3> (24,000 to 60,000 Btuh cooling and 24,000 to');
   htp.p('60,000 Btuh heating)</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>38YDA<sup>*</sup>, 38YSA<sup>*</sup><BR>');
   htp.p('</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>38YDA Two-Speed Heat Pump</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Operates on low speed an average of 80% of the time</FONT>');
   htp.p('<LI><FONT SIZE=2> Efficiency ratings of up to 16.1 SEER</FONT>');
   htp.p('<LI><FONT SIZE=2> 8.8 HSPF<BR>');
   htp.p('</FONT>');
   htp.p('<B><FONT SIZE=3> 38YSA Single-Speed Heat Pump</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Designed to achieve higher heating efficiencies.</FONT>');
   htp.p('<LI><FONT SIZE=2> HSPF up to 9.1</FONT>');
   htp.p('<LI><FONT SIZE=2> SEER up to 15<BR>');
   htp.p('</FONT>');
   htp.p('<P>');

   END RES_HP_TEXT;
/*============================================================*/
   PROCEDURE RES_HUMIDIFIERS_TEXT IS

   BEGIN

   htp.p('<B><FONT SIZE=4>Humidifiers</FONT></B>');
   htp.p('<P>');
   
   RESTXT97.res_humidifier_txt;   

   htp.p('<B><FONT SIZE=3>49FH, FP, WS, BF, BG</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>49BG features side discharge for easy installation.');
   htp.p(' The 49FH and 49FP units are fan-powered, deluxe, humidifer models.');
   htp.p(' The 49WS "water saver" design delivers high capacity');
   htp.p('with reduced water consumption.  The 49BF unit is the standard');
   htp.p('model.  Humidstat and saddle valve are standard on all units.');
   htp.p('<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy pad access and homeowner maintenance</FONT>');
   htp.p('<LI><FONT SIZE=2> Efficient water usage</FONT>');
   htp.p('<LI><FONT SIZE=2> Quiet, safe, 24V DC operation</FONT>');
    
   htp.p('<li><font size=2> All models are eligible for consumer<br>');
   htp.p(' financing through the Retail Credit Program</font>');
   htp.p('<li><font size=2> 1-year parts warranty on unit and');
   htp.p(' 5-year limited warranty on all electrical components </font>');

   END RES_HUMIDIFIERS_TEXT;
/*============================================================*/
   PROCEDURE RES_INDOOR_COILS_TEXT_1 IS

   BEGIN

   RESTXT97.Ind_Evap_Coils_txt1;

   END RES_INDOOR_COILS_TEXT_1;
/*============================================================*/
   PROCEDURE RES_INDOOR_COILS_TEXT_2 IS

   BEGIN

   RESTXT97.Ind_Evap_Coils_txt2;

   END RES_INDOOR_COILS_TEXT_2;
/*============================================================*/
   PROCEDURE RES_OIL_FURNACES_TEXT IS

   BEGIN

   htp.p('<B><FONT SIZE=4>Central Station Oil-Fired Furnaces </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>(75,000 to 210,000 Btuh heating and cooling) </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>58BMA, BLA, BTA</FONT></B>');
   htp.p('<LI><FONT SIZE=2>Three basic configurations for varying needs</FONT>');
   htp.p('<LI><FONT SIZE=2> 80%+ AFUE rating</FONT>');
   htp.p('<LI><FONT SIZE=2> Cooling relay and 40-va transformer</FONT>');
   htp.p('<LI><FONT SIZE=2> Barometric draft control</FONT>');
   htp.p('<LI><FONT SIZE=2> Beckett burner</FONT>');
   htp.p('<LI><FONT SIZE=2> Direct-drive blower motor </FONT>');
   htp.p('<LI><FONT SIZE=2> Alumina-Silica combustion chamber</FONT>');
   htp.p('<LI><FONT SIZE=2> 5-year burner warranty</FONT>');
   htp.p('<LI><FONT SIZE=2> Limited lifetime heat exchanger warranty');
   htp.p('<P>');
   RESTXT97.res_58cla_txt;
   htp.p('<BR>');

   END RES_OIL_FURNACES_TEXT;
/*============================================================*/
   PROCEDURE RES_SPLIT_SYSTEM_HP_TEXT IS
--|P.8 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=4 FACE="Univers (W1)">Air-Cooled Split System Heat');
   htp.p('Pump Units</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3 FACE="Univers (W1)"> (18,000 to 60,000 Btuh cooling');
   htp.p('and 18,000 to 60,000 Btuh heating)</FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3 FACE="Univers (W1)">38YRA*, 38BYB*, 38YMA, 38AYB,');
   htp.p('38YKC, 38YCB </FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>Maximum efficiency and flexibility.  Available with');
   htp.p('matched fan coil and indoor coil units.<BR><br>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> Quiet, reliable operation</FONT>');
   htp.p('<LI><FONT SIZE=2> Factory prewired and precharged</FONT>');
   htp.p('<LI><FONT SIZE=2> 5- to 10-year compressor protection</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy installation and serviceability</FONT><P><P>');
   
   htp.p('<font size=1><strong>*</strong>When used with fancoil listed in ');
   htp.p('ARI Directory as tested combination.</font><P>');

   END RES_SPLIT_SYSTEM_HP_TEXT;
/*============================================================*/
   PROCEDURE RES_VENTILATORS_TEXT  IS

   BEGIN

   htp.p('<B><FONT SIZE=4>Ventilators </FONT></B>');
   htp.p('<P>');
   htp.p('<B><FONT SIZE=3>VA3, VB5, VC5, VL3</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>The Carrier Heat Recovery and Energy Recovery Comfort');
   htp.p('Ventilators are designed to operate as an integral part of a total');
   htp.p('HVAC system, while improving a homeowners air quality. As the Comfort Ventilators exhaust stale indoor');
   htp.p('air through the heat recovery core, fresh air drawn from outside');
   htp.p('is warmed or cooled by the energy present in the exhaust air.');
   htp.p(' Excess wintertime humidity is flushed from the house as are indoor contaminants by the HRV. ');
   htp.p('The ERV removes moisture from the incoming humid');
   htp.p('air, durring cooling season while also diluting and flushing out stale, poluted air from the home.  Operating efficiencies up to 84%.  </FONT>');
   htp.p('<P>');

   htp.p('<FONT SIZE=3>HRV features:</FONT><BR>');
   htp.p('<LI><FONT SIZE=2> Automatic defrost</FONT>');
   htp.p('<li><font size=2> Reduces humidity levels in homes durring heating season</font>');
   htp.p('<li><font SIZE=2> Dilutes and flushes indoor pollutants</font>');
   htp.p('<LI><FONT SIZE=2> Crossflow and counterflow cores</FONT>');
   htp.p('<LI><FONT SIZE=2> Prefilter for incomming airstream');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> Basic,standard, and auto controls available</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy "no tools" maintenance</FONT>');
   htp.p('<LI><FONT SIZE=2> Quiet operation</FONT>');
   htp.p('<LI><FONT SIZE=2> 5-year standard parts warranty; limited lifetime warranty on the core</FONT>');
   htp.p('<LI><FONT SIZE=2> Eligible for consumer financing through the Retail Credit Program</FONT>');
   htp.p('</FONT>');
   htp.p('<P>');
   htp.p('<font size=3>ERV features:</font><BR>');
   htp.p('<li><font size=2>Reduces humidity level of incoming outside air durring cooling seasoni');
   htp.p('<li><font SIZE=2> Dilutes and flushes indoor pollutants</font>');
   htp.p('<LI><FONT SIZE=2> Crossflow paper core</FONT>');
   htp.p('<LI><FONT SIZE=2> Prefilter for incomming airstream');
   htp.p('<LI><FONT SIZE=2> Basic latent control</FONT>');
   htp.p('<LI><FONT SIZE=2> Easy "no tools" maintenance</FONT>');
   htp.p('<LI><FONT SIZE=2> Quiet operation</FONT>');
   htp.p('<LI><FONT SIZE=2> 5-year standard parts warranty; 1-year warranty on the on the core</FONT>');
   htp.p('<LI><FONT SIZE=2> Eligible for consumer financing through the Retail Credit Program</FONT>');
   htp.p('<BR>');
   END RES_VENTILATORS_TEXT;
/*============================================================*/
   PROCEDURE RES_ZONE_CONTROLS_TEXT IS
--|P.4 of RES 95-96 mini-catalog

   BEGIN
------------------COMFORT ZONE----------------------------
   htp.p('<B><FONT SIZE=3>Comfort Zone </FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>The Comfort Zone System allows the air conditioning');
   htp.p('and heating equipment to control temperatures in up to 4 distinct');
   htp.p('spaces or zones within a building. Each zone has independent temperature');
   htp.p('settings.<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> Temperature settings can change automatically by');
   htp.p('schedule to reflect occupancy or usage</FONT>');
   htp.p('<LI><FONT SIZE=2> Motorized air volume control dampers regulate the');
   htp.p('flow of conditioned air in the zones</FONT>');
   htp.p('<LI><FONT SIZE=2> The system can selectively cool or heat certain');
   htp.p('portions of a home depending upon space temperature requirements');
   htp.p('</FONT>');
   htp.p('<P>');
------------------COMFORT ZONE: WEATHERMAKER--------------
   htp.p('<B><FONT SIZE=3>WeatherMaker Two-Zone </FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2>The WeatherMaker Two-Zone System allows the air conditioning');
   htp.p('and heating equipment to control temperatures in up to 2 distinct');
   htp.p('spaces or zones within a building. Each zone has independent temperature');
   htp.p('and mode settings controlled by a thermostat.<BR>');
   htp.p('</FONT>');
   htp.p('<LI><FONT SIZE=2> The system can change temperature settings to reflect');
   htp.p('occupancy or usage</FONT>');
   htp.p('<LI><FONT SIZE=2> System is comprised of a Two-Zone Control Center');
   htp.p('and a Duct Temperature Sensor </FONT>');
   htp.p('<P>');
------------------COMFORT ZONE: POWER SUPPY--------------
   htp.p('<B><FONT SIZE=3>Power Supply:</FONT></B>');
   htp.p('<LI><FONT SIZE=2> 24VAC, 50VA, 60Hz. Only one transformer required for');
   htp.p('a complete system</FONT>');
   htp.p('<LI><FONT SIZE=2> Add 5VA for each additional damper<BR>');
   htp.p('</FONT>');
   htp.p('<P>');
--------------COMFORT ZONE: ELECTRICAL RATINGS-------------
   htp.p('<B><FONT SIZE=3>Electrical Ratings for Actuators:</FONT></B>');
   htp.p('<LI> <FONT SIZE=2> 24VAC, 50VA, 60Hz. Supplied from WeatherMaker Control');
   htp.p('Center or Comfort Zone I/O Center.</FONT>');
   htp.p('<LI> <FONT SIZE=2> Actuators are factory mounted on dampers. Cycling');
   htp.p('time is 15 seconds.  </FONT>');
   htp.p('<P>');

   END RES_ZONE_CONTROLS_TEXT;
/*============================================================*/
   PROCEDURE RES_DAMPERS_TEXT IS
--|P.5 of RES 95-96 mini-catalog

   BEGIN

   htp.p('<B><FONT SIZE=3>Dampers</FONT></B>');
   htp.p('<LI><FONT SIZE=2> Fit a variety of ductwork shapes and sizes</FONT>');
   htp.p('<LI><FONT SIZE=2> 24VAC direct-drive actuators for smooth, quiet operation</FONT>');
   htp.p('<LI><FONT SIZE=2> Quick blade release</FONT>');
   htp.p('<LI><FONT SIZE=2> Minimum damper setting on actuators</FONT>');
   htp.p('<LI><FONT SIZE=2> Permanently lubricated bushings with a split-shaft');

   END RES_DAMPERS_TEXT;
/*============================================================*/
   PROCEDURE RAC_COOL_UNITS_TEXT IS

   BEGIN

   htp.p('<TABLE CELLSPACING=3 WIDTH=90%>');
   htp.p('<TR> <TD VALIGN="top">');

   htp.p('<B><FONT SIZE=4>TC Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Super-quiet, reliable, economical cooling for bedrooms and');
   htp.p('living areas from 100 to 600 square feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
--|htp.p('<LI>Siesta;');
   htp.p('<LI>Compact, lightweight design');
   htp.p('<LI>High-efficiency rotary compressor');
   htp.p('<LI>SureTemp; automatic thermostat');
   htp.p('<LI>Easy-access filter');
   htp.p('<LI>Noncorrosive cabinet');
   htp.p('<LI>Built-in carry handle, factory-installed expandable wing panels');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('<B>Siesta</B>');
   htp.p('<BR>');
   htp.p('<B>Fits windows 23-1/4 to 34-3/4 in. wide, minimum opening height');
   htp.p('13-3/16 in.</B>');
   htp.p('<UL>');
   htp.p('<LI>2-speed fan');
   htp.p('<LI>2-way air flow control');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('<B>Siesta II</B>');
   htp.p('<BR>');
   htp.p('<B>Fits windows 26 to 36 in. wide, minimum opening height 14-1/2');
   htp.p('in.</B>');
   htp.p('<BR>');
   htp.p('Deluxe Features:');
   htp.p('<UL>');
   htp.p('<LI>2-speed fan');
   htp.p('<LI>6-way air flow control');
   htp.p('<LI>Energy Saver switch');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('Premium Features:');
   htp.p('<UL>');
   htp.p('<LI>3-speed fan');
   htp.p('<LI>6-way air flow control');
   htp.p('<LI>Exhaust control');
   htp.p('</UL>');

   htp.p('<HR ALIGN="center" WIDTH="100"><P>');

   htp.p('<B><FONT SIZE=4>EC 12,000 Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Super-quiet, efficient, economical cooling for rooms 600 to');
   htp.p('800 square feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>Window kit included');
   htp.p('<LI>SureTemp; automatic thermostat');
   htp.p('<LI>High-efficiency rotary compressor');
   htp.p('<LI>Easy-access filter');
   htp.p('<LI>Slide-out chassis');
   htp.p('<LI>Easy installation thru-the-wall');
   htp.p('<LI>2-speed fan');
   htp.p('</UL>');

   htp.p('<HR ALIGN="center" WIDTH="100"><P>');
   htp.p('<B><FONT SIZE=4>LC Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Unobstructed view plus unsurpassed cooling comfort in bedrooms');
   htp.p('or living areas 100 to 250 square feet.<BR>');
   htp.p('</B>');
   htp.p('<BR>');
   htp.p('<B>VisionAire</B>;');
   htp.p('<UL>');
   htp.p('<LI>Low profile - less than 8 inches high');
   htp.p('<LI>Exceptionally quiet');
   htp.p('<LI>Horizontal rotary compressor and 2-motor fan design for high');
   htp.p('efficiency');
   htp.p('<LI>SureTemp &#153; thermostat - automatically maintains personal');
   htp.p('comfort levels');
   htp.p('<LI>3-speed fan control');
   htp.p('<LI>6-way adjustable air flow control');
   htp.p('<LI>Easy-access filter');
   htp.p('<LI>Noncorrosive cabinet');
   htp.p('<LI>Factory-installed expandable wing panels for easy installation');
   htp.p('</UL>');

   htp.p('<BR>');
   htp.p('<B>Fits windows 26-1/2 to 42 in. wide with a minimum opening height');
   htp.p('8-3/4 inches<BR>');
   htp.p('<BR>');
   htp.p('</B>');

   htp.p(' </TD><TD VALIGN="top">');

   htp.p('<P>');
   htp.p('<B><FONT SIZE=4>XC/YC Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>High-efficiency, energy-saving operation provides super-quiet');
   htp.p('cooling for living areas, offices and shops 500 to 1,800 square');
   htp.p('feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>SureTemp &#153; thermostat - automatically maintains personal');
   htp.p('comfort levels');
   htp.p('<LI>3-speed cooling');
   htp.p('<LI>Energy Saver switch');
   htp.p('<LI>Slide-out chassis');
   htp.p('<LI>Easy-access filter');
   htp.p('<LI>Weather Armor &#153; cabinet provides 3 times the salt corrosion');
   htp.p('protection of ordinary enamel finishes');
   htp.p('<LI>Easy installation thru-the-wall or thru-the-window with expanding');
   htp.p('wing panels');
   htp.p('<LI>Concealed control panel');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('<B>XC Series</B>');
   htp.p('<BR>');
   htp.p('<B>Fits windows 30-1/2 to 42 in. wide; minimum opening height');
   htp.p('18 in.</B>');
   htp.p('<UL>');
   htp.p('<LI>6-way air flow control');
   htp.p('<LI>Exhaust control to expel stale air');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('<B>YC Series</B>');
   htp.p('<BR>');
   htp.p('<B>Fits windows 31-1/2 to 43 in. wide; minimum opening height');
   htp.p('19 in.</B>');
   htp.p('<UL>');
   htp.p('<LI>6-way air flow control');
   htp.p('<LI>Exhaust and ventilation controls');
   htp.p('</UL>');

   htp.p('<P>');
   htp.p('<HR ALIGN="center" WIDTH="100"><P>');
   htp.p('<B><FONT SIZE=4>XCB (Electronic) Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Advanced electronic controls coupled with cool comfort in rooms');
   htp.p('from 600 to 1,200 square feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>User friendly electronic control');
   htp.p('<LI>Sleep or night setback setting');
   htp.p('<LI>Automatic fan speed control or three (3) manual settings in');
   htp.p('cooling and fan-only positions');
   htp.p('<LI>Dehumidification setting');
   htp.p('<LI>24-hour timer with factory preset start and stop times or');
   htp.p('programmable to customer''s desired times');
   htp.p('<LI>Clock');
   htp.p('<LI>Turbo setting for maximum cooling');
   htp.p('<LI>True energy save mode');
   htp.p('<LI>Dirty filter indicator');
   htp.p('<LI>Liquid crystal display');
   htp.p('<LI>set temperature and room temperature digital readout');
   htp.p('<LI>Accurate electronic temperature control');
   htp.p('<LI>Auto air circulator');
   htp.p('<LI>Weather Armor &#153; cabinet provides 3 times the salt corrosion');
   htp.p('protection of ordinary enamel finishes');
   htp.p('<LI>Accessory mounting kit available for window installation');
   htp.p('</UL>');

   htp.p('<HR ALIGN="center" WIDTH="100"><P>');
   htp.p('<B><FONT SIZE=4>UC Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Quiet, economical and reliable cooling for areas from 100 to');
   htp.p('450 square feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>Sound-minimized air movement system');
   htp.p('<LI>SureTemp &#153; thermostat - maintains set comfort levels automatically');
   htp.p('<LI>2-speed cooling');
   htp.p('<LI>Slide-out chassis');
   htp.p('<LI>Easy-access filter');
   htp.p('<LI>Weather Armor &#153; cabinet provides 3 times the salt corrosion');
   htp.p('protection of ordinary enamel finishes');
   htp.p('<LI>Easy installation thru-the-wall or thru-the-window with expanding');
   htp.p('wing panels');
   htp.p('</UL>');

   htp.p('</TD></TR>');
   htp.p('</TABLE>');

   END RAC_COOL_UNITS_TEXT;
/*============================================================*/
   PROCEDURE RAC_HEAT_COOL_UNITS_TEXT IS

   BEGIN

   htp.p('<B><FONT SIZE=4>XH/YH Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>One compact unit provides 4-seasons comfort for living areas,');
   htp.p('offices or shops 400 to 1,600 square feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>Super-quiet sound minimized air movement system');
   htp.p('<LI>High-efficiency rotary compressor');
   htp.p('<LI>SureTemp &#153; thermostat for automatic comfort control');
   htp.p('<LI>3-speed cooling');
   htp.p('<LI>2-speed heating with quick, dependable electric heating');
   htp.p('<LI>Energy Saver switch 6-way air flow control');
   htp.p('<LI>Exhaust control');
   htp.p('<LI>Ventilation control (YHB243D only)');
   htp.p('<LI>Concealed control panel');
   htp.p('<LI>Slide-out chassis');
   htp.p('<LI>WeatherArmor &#153; cabinet provides 3 times the salt corrosion');
   htp.p('protection of ordinary enamel finishes');
   htp.p('<LI>Accessory window mounting kit available');
   htp.p('</UL>');

   END RAC_HEAT_COOL_UNITS_TEXT;
/*============================================================*/
   PROCEDURE RAC_HEAT_PUMPS_TEXT IS

   BEGIN

   htp.p('<B><FONT SIZE=4>XQ Series<BR>');
   htp.p('</FONT></B>');
   htp.p('<BR>');
   htp.p('<B>Where winters are milder, year-round comfort...plus increased');
   htp.p('energy savings...for living, working areas 450 to 1,400 square');
   htp.p('feet.<BR>');
   htp.p('</B>');
   htp.p('<UL>');
   htp.p('<LI>To 35 &#176;F, uses 1/2 to 1/3 less electricity than an electric');
   htp.p('heater');
   htp.p('<LI>Super-quiet sound minimized air movement system');
   htp.p('<LI>SureTemp &#153; automatic thermostat');
   htp.p('<LI>3-speed cooling');
   htp.p('<LI>2-speed heating');
   htp.p('<LI>Energy Saver switch');
   htp.p('<LI>6-way air flow control');
   htp.p('<LI>Exhaust control');
   htp.p('<LI>Slide-out chassis');
   htp.p('<LI>WeatherArmor &#153; cabinet provides 3 times the salt corrosion');
   htp.p('protection of ordinary enamel finishes');
   htp.p('<LI>Back-up supplemental electric heat');
   htp.p('</UL>');

   END RAC_HEAT_PUMPS_TEXT;
/*============================================================*/
END restxt;
/
show errors;
/
