#============================================
#============================================

sub make_wherelike_str
{
   local (@inarray) = @_;
   local ($im, $arrstr);
    
   $arrstr = "";
   for ($im=0; $im< $#inarray; $im++)
   {
      $arrstr = " $arrstr OR \"$inarray[$im]%\" ";
   }
   $arrstr = substr($arrstr, 4);
   return $arrstr;
}

#============================================
#============================================

sub make_like_where_tmodel
{
   local ($istart, $wherestr, $bindstr, @inlist) = @_;
  
   # This query gets models and modelids where the input modelname matches
   # the beginning of the full modelname
   # ---------------------------------------------------------------------
   
   local ($SELECT_MODELS) = 
                       "SELECT model, modelid 
                          FROM n_models
                         WHERE model LIKE $wherestr";
   local (@mdlnames, @mdlids);
 
   # Open the query and bind it to the input $bindstring
   # ---------------------------------------------------------------------

   $csrmdl = &ora_open ($lda, $SELECT_MODELS) 
              || print LOGFILE "failed to open cursor $SELECT_MODELS\n";
   &ora_bind ($csrmdl, $bindstr);
   
   $imdl = 0;
   while ( ($mdl, $mdlid) = &ora_fetch($csrmdl) )
   {
      $mdlnames[$imdl] = $mdl;
      $mdlids[$imdl] = $mdlid;
      $imdl++;
   }

   if ($#mdlids == 0)
   {
      $wherestr = "LIKE  \"%%\" ";
   }
   else
   {
      
      $wherestr = "";
      for ($i=0; $i<= $#mdlids; $i++)
      {
         $ip = $i + $istart;
         $wherestr = "$wherestr OR :$ip ";
      }
      $wherestr = substr($wherestr, 4);
      $wherestr = " = $wherestr ";
   }
  
   return $wherestr; 
}
#============================================
#============================================
sub make_array
{
   local ( $formname, @mnames, @mvalues) = @_;
   local ( $i, $ifrm, @returnarray);
   
   $bindstring = "";
   $ifrm = 0;
   for ($i=0; $i < $#mnames; $i++)
   {
      if ($mnames[$i] = $formname)
      {
         $formarray[$ifrm] = $mvalues[$i];
         $ifrm++;
         $cat[$ifrm] = ":$ifrm";
         $bindstring = "$bindstring $value[$i], ";
      }
   }

   return  ($bindarray, @cat, @formarray);
}
          
#============================================
#============================================
sub make_like_array
{
   local ( $formname, @mnames, @mvalues) = @_;
   local ( $i, $ifrm, @returnarray);
   
   $bindstring = "";
   $ifrm = 0;
   for ($i=0; $i < $#mnames; $i++)
   {
      if ($mnames[$i] = $formname)
      {
         $formarray[$ifrm] = $mvalues[$i];
         $ifrm++;
         $cat[$ifrm] = ":$ifrm";
         $bindstring = "$bindstring $value[$i], ";
      }
   }

   return  ($bindarray, @cat, @formarray);
}

#*********************************************************
sub SearchByCategory 
{
   local( @lnames, @lvalues ) = @_;
}
#*********************************************************
sub SearchByCapacity
{
   local( @lnames, @lvalues ) = @_;
}
#*********************************************************
sub SearchByDoctype
{
   local( @lnames, @lvalues ) = @_;
}
#*********************************************************
sub SearchByKeyword
{
   local( @lnames, @lvalues ) = @_;
}
#*********************************************************
sub SearchByFormnum
{
   local( @lnames, @lvalues ) = @_;
}

#*********************************************************
sub SearchGeneral 
{
   local( @lnames, @lvalues ) = @_;
}
#*********************************************************

sub probably_junk
{
#  ($bindtmodelstr, @wheretmodels, @tmodels)  
#         = &make_like_array ( 'TMODEL', @lnames, @lvalues );

   ($bindsmodelstr, @wheresmodels, @smodelids) 
          = &make_array ( 'SMODEL', @lnames, @lvalues );

   ($binddocstr, @wheredoctypes, @doctypes)
          = &make_array('DOCTYPE', @lnames, @lvalues );

   for ($i=0; $i <= $#lnames; $i++) {
      if ( $lnames[$i] eq 'SHOW_OBSOLETE')
      {
          $show_obsolete = 'TRUE';
      }
   }

   $tmodelstr = &make_wherelike_str(@tmodels);

#  ($where_tmdl, $bind_tmdl) 
#       = &make_like_where ($tmodelstr, @typemodels);
#  ($where_smdl, $bind_smdl) = &make_eq_where (@selectmodels);

}
