#!/usr/local/bin/oraperl

# -----------------------
# copyright 1997 Carrier Corporation
# filename: export_tab_table.pl
# 
# written January 1997
# author Barbara Mihalas
# -----------------------

  $diagnosticlog = "logs/COLLSKW.log";

  open (LOGFILE, ">>$diagnosticlog");
   # || print "failed to open logfile $diagnosticlog \n";

# ==========================================================
# ================= oraperl setup ==========================
  $ENV{'ORACLE_HOME'}= "/usr/oracle";
  $ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
  $ENV{'WOW_UID'}= "www_user/www_user";
  $ENV{'ORACLE_SID'}= "mindy";
  print LOGFILE "query string is $ENV{'QUERY_STRING'}<BR>\n";
  print LOGFILE "oracle_home is $ENV{'ORACLE_HOME'}<BR>\n";
  print LOGFILE "PATH is $ENV{'PATH'}<BR>\n";
# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit" if 0;
# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;
# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;
# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');
# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', 'www_user', 'www_user')	|| die $ora_errstr;
# ==============  end of oraperl setup =======================
# ============================================================

# ==============  define cursors =============================

  $SELECT_USER_REG =
                 "SELECT 
                  record_id,        username,       user_pw,           user_fname, 
                  user_lname,       user_title,     user_reg_status,   user_permissions, 
                  company,          address1,       address2,          city, 
                  state,            region,         zip_code5,         zip_code4, 
                  postal_code,      country,        company_URL,       user_phone, 
                  user_fax,         user_email,     contact_id,        contact_name, 
                  contact_company,  contact_phone,  contact_fax,       contact_email, 
                  contact_location, email_ok,       ptac_req,          ltcom_req,
                  res_req,          com_req,        reg_date,          last_updated, 
                  user_phone_num,   reg_notes,      user_phone_ext,    user_phone_ext1
                  FROM user_reg
                  WHERE record_id > :1"; 


# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

  &html_header;

# Read input buffer
# read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );

# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";

# Parse input buffer
  &parse_dummy;
# &parse;

  &write_tabfile;

# &email_tabfile;

  &html_footer;

  close(LOGFILE);
# ==================end  body of program =====================
# ============================================================

# ================= oraperl cleanup ========================
# log out of the database (this is ESSENTIAL!)
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================


# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse{
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $buffer);

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";

       if ($name[$i] eq "filename") {   $outfile = $value[$i];  }
       if ($name[$i] eq "recordid") {   $recid = $value[$i];  }
       if ($name[$i] eq "email") {   $emailaddress = $value[$i];  }
   }
   $fields = $i-1;
   $numfields = $fields+1;
   print " output filename is $outfile <P>\n";
   print " last record_id is $recid <P>\n";
   print " email address is $emailaddress <P> \n";
}

# *********************************************
# This Procedure Mocks up the Parses the Input from any Form
# *********************************************
sub parse_dummy
{
    $outfile = "user_reg_22jul97.tab";
    $recid  = 0;
    $email  = "bwm@npac.syr.edu";
    $numfields = 4;
}

# *********************************************
# Read table and write out as tabfile
# *********************************************
sub write_tabfile
{
   local ($i, $numcols, @reg_entry);

   $outdir = '/oradata/disk4/carrier/bwm-admin/';

   local ($COLLS_KW)  = "SELECT keyword_id, keyword_string, keyword_display
                           FROM colls_keyword_select
                          ORDER BY keyword_id";
   
   $csra  = &ora_open($lda, $COLLS_KW) 
                     || print "failed to open $COLLS_KW \n";

#  &ora_bind($csra, $recid);

   @fldnames  = &ora_titles($csra);
   @flengths  = &ora_lengths($csra);
   @ftypes    = &ora_types($csra);

   $outfile = 'COLLS_KEYWORD_SELECT.tab';

   print " Output filename is $outfile <P>\n";
      
   open (OUTFILE, ">$outfile");
      #  || print LOGFILE "failed to open output tabfile $outfile for writing\n";;

   print LOGFILE "opened tabfile $outfile for writing\n";

   $numcols = $#fldnames;
   print LOGFILE "number of columns is $numcols \n";
   for ( $i = 0; $i <= $numcols; $i++)
   {
      print OUTFILE "$fldnames[$i]	";
      print "$fldnames[$i]	";
   }
   print OUTFILE "\n";
   print "\n";
   

#  while ($record_id,       $username,      $user_pw,          $user_fname, 
#         $user_lname,      $user_title,    $user_reg_status,  $user_permissions, 
#         $company,         $address1,      $address2,         $city, 
#         $state,           $region,        $zip_code5,        $zip_code4, 
#         $postal_code,     $country,       $company_URL,      $user_phone, 
#         $user_fax,        $user_email,    $contact_id,       $contact_name, 
#         $contact_company, $contact_phone, $contact_fax,      $contact_email, 
#         $contact_location,$email_ok,      $ptac_req,         $ltcom_req,
#         $res_req,         $com_req,       $reg_date,         $last_updated, 
#         $user_phone_num,  $reg_notes,     $user_phone_ext,   $user_phone_ext1)

   while ( (@kw) = &ora_fetch($csra) )
   {
       $numcols = $#kw;
       for ( $i = 0; $i <= $numcols; $i++)
       {
          $kw[$i] =~ s/\r\n//g;
          $kw[$i] =~ s/\n//g;
          print OUTFILE "$kw[$i]	";
        # print "$kw[$i]	";
       }
       print OUTFILE "\n";
     # print "\n";
   }
   close (OUTFILE);
   &ora_close($csra);
}

# ******************************************
# Writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";
}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Placeholder for document title</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}

