#!/usr/local/bin/oraperl  

  $DEBUG = 0;

#sub SearchByKeyword
#sub SearchGeneral 
#sub SearchGeneralNocap 
#sub SearchByCategoryA 
#sub SearchByFormnumA
#sub SearchByCapacityA
#sub PrintInput

require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_specs.pl';
require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_paths.pl';

#*********************************************************
#*********************************************************
sub SearchByKeyword
{
   if ($DEBUG) { &PrintInput; }

   local($GET_KWSTR) =
                 "SELECT keyword_id, keyword_string, keyword_display
                     FROM colls_keyword_sel
                    WHERE keyword_id = :1";  

   local($GET_KWORD) =
                 "SELECT keywordid, description
                     FROM n_keywords
                    WHERE keywordid = :1";  

   local($GET_DOCID) =
                 "SELECT keywordid, keyword, docid 
                    FROM doc_keyword
                   WHERE upper(keyword) LIKE :1";

   local($ONEMODEL)   =
                 "SELECT distinct docid, keywordid, keyword, title, docformnum,
                         doccatnum, pdf_filename, pdf_filesize, doctypeid,
                         doctype, modelid
                    FROM pdf_keyword
                   WHERE upper(keyword) LIKE :1
                     AND modelid LIKE :2
                     AND doctypeid LIKE :3
                   ORDER BY docformnum";

   local($ONEMODELD)   =
                 "SELECT distinct docid, docformnum
                    FROM pdf_keyword
                   WHERE upper(keyword) LIKE :1
                     AND modelid LIKE :2
                     AND doctypeid LIKE :3
                   ORDER BY docformnum";

   local($C_ALLMODELS)   =
                 "SELECT distinct docid, keywordid, keyword, title, docformnum,
                         doccatnum, pdf_filename, pdf_filesize, doctypeid,
                         doctype
                    FROM pdf_keyword1
                   WHERE upper(keyword) LIKE :1
                     AND doctypeid LIKE :2
                   ORDER BY docformnum";

   local($C_ALLMODELSD)   =
                 "SELECT distinct docid
                    FROM pdf_keyword1
                   WHERE upper(keyword) LIKE :1
                     AND doctypeid LIKE :2";

   local($ONEDOCUMENT)   =
                 "SELECT title, docformnum, doccatnum, pdf_filename, 
                         pdf_filesize, doctype_id, doctype, brandid
                    FROM colls_document
                   WHERE docid = :1
                   ORDER BY docformnum";

   local($DISTINCTDOCIDS)   =
                 "SELECT distinct docid
                    FROM pdf_keyword1
                   WHERE upper(keyword) LIKE :1
                     AND doctypeid LIKE :2";

   local($GET_MODEL)  =
                 "SELECT model 
                    FROM n_models
                   WHERE modelid = :1";

   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";

   $imdl   = 0;
   $idtype = 0;
   $ikw    = 0;

   $ALLMODELS   = 'N';
   $ALLDOCTYPES = 'N';
   $ALLKEYWORDS = 'N';
   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELNO')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdl[0] = "%%";
         }
         &write_comment( "Model ID is $mdl[$imdl]");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtype[0] = "%%";
         }
         &write_comment( "Doctype ID is $dtype[$idtype]");
         $idtype++;
      }
      elsif ($name[$i] eq 'KEYWORD')
      {
         $kwid[$ikw] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLKEYWORDS = 'Y';
         }
         &write_comment( "Keyword ID is $kwid[$ikw]");
         $ikw++;
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_keyword_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

   local($csrkwsel)  = &ora_open($lda, $GET_KWSTR) 
                      || print "failed to open cursor GET_KWSTR $GET_KWSTR <BR>\n";

   local($csrkword)  = &ora_open($lda, $GET_KWORD) 
                      || print "failed to open cursor GET_KWORD $GET_KWORD <BR>\n";

   local($csrdocid)  = &ora_open($lda, $GET_DOCID)
                      || print "failed to open cursor GET_DOCID $GET_DOCID <BR>\n";

# use to get list of distinct documents for each keyword
   local($csronemdld)    = &ora_open($lda, $ONEMODELD)
                      || print "failed to open cursor ONEMODELD $ONEMODELD <BR>\n";

# use to get list of distinct documents for each keyword
   local($csrallmdld)    = &ora_open($lda, $C_ALLMODELSD)
                      || print "failed to open cursor ALLMODELSD $C_ALLMODELSD <BR>\n";

   local($csrdistinct)    = &ora_open($lda, $DISTINCTDOCIDS)
                      || print "failed to open cursor DISTINCTDOCIDS $DISTINCTDOCIDS <BR>\n";

#  use this with $GET_DOC_MODELS
   local($csronedoc)    = &ora_open($lda, $ONEDOCUMENT)
                      || print "failed to open cursor ONEDOCUMENT $ONEDOCUMENT <BR>\n";

   local($csrmdl)    = &ora_open($lda, $GET_MODEL)
                      || print "failed to open cursor GET_MODEL $GET_MODEL <BR>\n";

#  use this with $ONEDOCUMENT
   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS <BR>\n";

   $ipdf = 0;
   for ($ii=0; $ii < $ikw; $ii++)
   {
    # $bindstatus = &ora_bind($csrkwsel, $kwid[$ii]);
    # ($kwid1[$ii], $kwstr[$ii], $kwdisp[$ii]) = &ora_fetch($csrkwsel);
      $bindstatus = &ora_bind($csrkword, $kwid[$ii]);
      ($kwid1[$ii], $kwstr[$ii] ) = &ora_fetch($csrkword);
      if ($DEBUG)
      {
       # print "kwid $kwid1[$ii], kwstr $kwstr[$ii]; kwdisplay $kwdisp[$ii]<BR>\n";
         print "kwid $kwid1[$ii], kwstr $kwstr[$ii] <BR>\n";
      } 
      $ukwstr = "$kwstr[$ii]";
      $ukwstr =~ tr/a-z/A-Z/;
      if ($DEBUG)
      {
         print "kwid $kwid1[$ii], kwstr $kwstr[$ii]; bindstr $ukwstr <BR>\n";
      } 
      $bindstatus = &ora_bind($csronemdld, $ukwstr, $mdl[0], $dtype[0]);
      print "<!-- bind status for keyword GET_DOCID is $bindstatus --> \n";

      while ( ($docid[$ipdf], $formnumber[$ipdf]) = &ora_fetch($csronemdld) )
      {
         $bindstatus = &ora_bind($csronedoc, $docid[$ipdf]);

         ($doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf],
          $pdf_filename[$ipdf], $pdf_filesize[$ipdf], 
          $doctypeid[$ipdf], $doctype[$ipdf], $brandid[$ipdf])
          = &ora_fetch($csronedoc);

       # $kword[$ipdf]  = $kwdisp[$ii];
         $kword[$ipdf]  = $kwstr[$ii];
         $pdfsizekb[$ipdf] = int($pdf_filesize[$ipdf]/1024);
         $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
         $pdfmodel[$ipdf] = "";
         while  ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
         {
            $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
         }
         $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
         print "<!-- docid $docid[$ipdf]; kwid $kwordid[$ipdf]; kw $kword[$ipdf]; size $pdf_filesize[$ipdf] -->\n";
         $ipdf++;
      }
   } 
   $ipdf--;
      $write_form = 'colls_by_keyword.sh';
      &print_search_resultsA($write_form);


   &ora_close($csronemdl);
   &ora_close($csronemdld);
   &ora_close($csrkwsel);
   &ora_close($csrdocid);

}

#*********************************************************

#*********************************************************
sub SearchGeneral 
{
   if ($DEBUG) { &PrintInput; }

   local($GENERAL) =
        "SELECT DISTINCT docid, docformnum
           FROM colls_doctype_0
          WHERE docid in (SELECT DISTINCT docid
                            FROM n_doc_model_assoc
                           WHERE modelid in (SELECT DISTINCT modelid 
                                               FROM colls_capacity
                                              WHERE minclgcap   < TO_NUMBER(:1)
                                                AND maxclgcap   > TO_NUMBER(:2)
                                                AND modelid LIKE :3) )
            AND TO_CHAR(doctype_id) LIKE :4 
            AND TO_CHAR(docid)      LIKE :5
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_keyword_assoc
                           WHERE keywordid LIKE  :6 )
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :7)
                             OR (eqpsubcatid LIKE :8)
                             OR (eqpsubsubcatid LIKE :9) )
          ORDER BY docformnum";
        # ORDER BY TO_NUMBER(docid)";

                         #  FROM doc_keyword

   local($QGENERAL) = 
              "SELECT distinct docid, docformnum
                 FROM colls_doctype_0
                WHERE docid      LIKE  :1 
                  AND docid in  (SELECT DISTINCT docid 
                                 FROM n_doc_model_assoc
                                 WHERE modelid   LIKE  :2)
                  AND doctype_id LIKE  :3
                  AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :4)
                             OR (eqpsubcatid LIKE :5)
                             OR (eqpsubsubcatid LIKE :6) )
                ORDER BY docformnum";


   local($PGENERAL) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";

   local($GETMODELS) =
              "SELECT model, modelid 
                 FROM colls_doc_model
                WHERE docid = :1";

   local($CHECK_CAPACITY) =
             "SELECT modelid, model, colls_model, minclgcap, maxclgcap 
                FROM colls_capacity
               WHERE minclgcap IS NOT NULL
                 AND maxclgcap IS NOT NULL
               ORDER BY model";

   local($CHECK_ONE_CAP)  =
             "SELECT modelid, model, colls_model, minclgcap, maxclgcap 
                FROM colls_capacity
               WHERE minclgcap   < TO_NUMBER(:1)
                 AND maxclgcap   > TO_NUMBER(:2)
                 AND modelid =   :3";

   local($csrmdlcap) = &ora_open($lda, $CHECK_CAPACITY)
                  || print "failed to open cursor $CHECK_CAPACITY<BR>\n";

   local($csronecap) = &ora_open($lda, $CHECK_ONE_CAP)
                  || print "failed to open cursor $CHECK_ONE_CAP<BR>\n";

   local($csrqgeneral) = &ora_open ($lda, $QGENERAL) 
                  || print "failed to open cursor $QGENERAL <BR>\n";

   local($csrpgeneral) = &ora_open ($lda, $PGENERAL) 
                  || print "failed to open cursor $PGENERAL <BR>\n";

   local($csrgeneral) = &ora_open ($lda, $GENERAL) 
                  || print "failed to open cursor $GENERAL <BR>\n";

   local($csrgetmodels) = &ora_open ($lda, $GETMODELS) 
                  || print "failed to open cursor $GETMODELS <BR>\n";

   $imdl     = 0;
   $idtype   = 0;
   $ieqpcat  = 0;
   $ifmnum   = 0;
   $ikword   = 0;

   $ALLMODELS   = 'N';
   $ALLDOCTYPES = 'N';
   $ALLEQPCATS  = 'N';
   $ALLFORMNUMS = 'N';
   $ALLKEYWORDS = 'N';

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELNO')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdlid     = '%%';
         }
         else
         {
            $mdlid     = "$mdl[$imdl]";
         }
         &write_comment( "Model ID is $mdl[$imdl]; mdlid is $mdlid");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtypeid     = '%%';
         }
         else
         {
            $dtypeid     = "$dtype[$idtype]";
         }
         &write_comment( "Doctype ID is $dtype[$idtype]; dtypeid is $dtypeid");
         $idtype++;
      }
      elsif ($name[$i] eq 'FORMNUM')
      {
         $fmnumid[$ifmnum] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLFORMNUMS = 'Y';
            $dcid       = '%%';
         }
         else
         {
            $dcid     = "$fmnumid[$ifmnum]";
         }
         &write_comment( "Formnum ID is $fmnumid[$ifmnum]; docid is $dcid ");
         $ifmnum++;
      }

      elsif ($name[$i] eq 'EQPCAT')
      {
         if ($value[$i] eq 'ALL') 
         {
            $ALLEQPCATS = 'Y';
            $eqcatid   = '%%';
            $eqsubcatid   = '%%';
            $eqsubsubcatid   = '%%';
         }
         else
         {
            $cat = $value[$i]; 
            ($catlevel, $catid) = split(/\./, $cat);
            &write_comment( "Eqpcat ID stem is $cat");
          # print "Eqpcat level is $catlevel[$icat]; id is $catid<BR>\n";
            if ($catlevel eq 'CAT')
            {
               $eqcatid = $catid;
               $eqsubcatid   = '';
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'S')
            {
               $eqcatid     =  '';
               $eqsubcatid = $catid;
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'SS')
            {
               $eqcatid     =  '';
               $eqsubcatid   = '';
               $eqsubsubcatid = $catid;
            }
            &write_comment("Cat Level is $catlevel; eqp(ss)catid is $catid");
            $ieqpcat++;
         }
      }
      elsif ($name[$i] eq 'KEYWORD')
      {
         $kwordid[$ikword] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLKEYWORDS = 'Y';
            $kwordid       = "%%";
         }
         else
         {
            $kwordid     = $kwordid[$ikword];
         }
         &write_comment( "Keyword is $kwordid[$ikword]; keywordid is $kwordid");
         $ikword++;
      }
      elsif ($name[$i] eq 'LOWCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caplow = $value[$i];
      }
      elsif ($name[$i] eq 'HIGHCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caphigh = $value[$i];
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_general_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

   if ( $caphigh < $caplow)
   {
      $write_form = 'colls_general.sh';
      &print_cap_values_switched($write_form);
      return;
   }
   elsif ($caplow == undef || $caphigh == undef)
   {
      &SearchGeneralNocap ($ALLMODELS, $ALLDOCTYPES, $ALLEQPCATS, $ALLFORMNUMS, 
          $ALLKEYWORDS, $mdlid, $dtypeid, $eqcatid, $eqsubcatid, $eqsubsubcatid,
          $dcid, $kwordid);
      return;
   }
   else
   {
      $bindstatus = &ora_bind($csrgeneral, $caphigh, $caplow, $mdlid, $dtypeid,
                              $dcid, $kwordid, $eqcatid, $eqsubcatid, $eqsubsubcatid);

      &write_comment("bind status for general query is $bindstatus");
      $idoc = 0;
      $ipdf = 0;
      while ( ($docidlist[$idoc], $formnumber[$idoc]) = &ora_fetch($csrgeneral) )
      {
         print "<!-- document id number $idoc is $docidlist[$idoc] -->\n";

         $bindstatus1 = &ora_bind($csrpgeneral, $docidlist[$idoc]);

         ($docid[$ipdf],  $doctype_id[$ipdf],
         $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
         $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);
         
         $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
         &ora_bind($csrgetmodels, $docid[$ipdf]);
         while ( ($model, $modelid) = &ora_fetch($csrgetmodels) )
         {
            $pdfmodel[$ipdf]  = "$pdfmodel[$ipdf], $model";
         }
         $pdfmodel[$ipdf] = substr( $pdfmodel[$ipdf], 1);

         &write_comment("(ipdf;idocid:$ipdf.$idocid) docid $docid[$ipdf]; doctype $doctype[$ipdf], 
         $pdfname[$ipdf], $pdfmodel[$ipdf]; ecatdesc $ecatdesc[$ipdf]");


         $ipdf++;
         $idoc++;
      }
      $ipdf--;
      $write_form = 'colls_general.sh';
      &print_search_resultsA($write_form);
   }

   &html_footer;
   &ora_close($csrmdlcap);
   &ora_close($csronecap);
   &ora_close($csrgeneral);
   &ora_close($csrqgeneral);
   &ora_close($csrpgeneral);
}

#*********************************************************

#*********************************************************
sub SearchGeneralNocap 
{
   local ($ALLMODELSNC, $ALLDOCTYPESNC, $ALLEQPCATSNC, $ALLFORMNUMSNC, 
          $ALLKEYWORDSNC, $mdlidNC, $dtypeidNC, $eqpcatidNC, $eqpscatidNC,
          $eqpsscatidNC, $docidNC, $kwordidNC) = @_;


   local($GENERALA) =
        "SELECT DISTINCT docid, docformnum
           FROM colls_doctype_0
          WHERE docid IN (SELECT DISTINCT docid
                            FROM n_doc_model_assoc
                           WHERE TO_CHAR(modelid) LIKE :1)
            AND TO_CHAR(doctype_id) LIKE :2 
            AND TO_CHAR(docid)      LIKE :3
            ORDER BY docformnum";

   local($GENERAL) =
        "SELECT DISTINCT docid, docformnum
           FROM colls_doctype_0
          WHERE docid IN (SELECT DISTINCT docid 
                            FROM n_doc_model_assoc
                           WHERE TO_CHAR(modelid) LIKE :1)
            AND TO_CHAR(doctype_id) LIKE :2 
            AND TO_CHAR(docid)      LIKE :3
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_keyword_assoc
                           WHERE keywordid LIKE  :4 )
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :5)
                             OR (eqpsubcatid LIKE :6)
                             OR (eqpsubsubcatid LIKE :7) )
          ORDER BY docformnum";
        # ORDER BY TO_NUMBER(docid)";

                        #   FROM doc_keyword

   local($PGENERAL) =
              "SELECT docid, doctype_id, doctype, title, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_document
                WHERE docid  =  :1";

   local($GETMODELS) =
              "SELECT model, modelid 
                 FROM colls_doc_model
                WHERE docid = :1";

   local($csrgenerala) = &ora_open($lda, $GENERALA) 
                              || print "failed to open cursor $GENERALA<BR>\n";

   local($csrgeneral) = &ora_open($lda, $GENERAL) 
                              || print "failed to open cursor $GENERAL<BR>\n";

   local($csrpgeneral) = &ora_open($lda, $PGENERAL) 
                              || print "failed to open cursor $PGENERAL<BR>\n";

   &write_comment( "input parameters to SearchGeneralNocap: ");
   &write_comment( "$ALLMODELSNC, $ALLDOCTYPESNC, $ALLEQPCATSNC, $ALLFORMNUMSNC, $ALLKEYWORDSNC ");
   &write_comment( "mdlid $mdlidNC, dtypeid $dtypeidNC, eqpcatid $eqpcatidNC, eqpscatid $eqpscatidNC");
   &write_comment( "eqpsscatid  $eqpsscatidNC, docid $docidNC, kwordid $kwordidNC ");
#===============================

   $bindstatus = &ora_bind($csrgeneral, $mdlidNC, $dtypeidNC, $docidNC, $kwordidNC,
                            $eqpcatidNC, $eqpscatidNC, $eqpsscatidNC);

#  $bindstatus1 = &ora_bind($csrgenerala, "$mdlidNC", "$dtypeidNC", "$docidNC");

   &write_comment ("bind status in GeneralNocap is $bindstatus");

   $idoc = 0;
   $ipdf = 0;
#=========================================

   while ( ($docidlist[$idoc], $formnumber[$idoc]) = &ora_fetch($csrgeneral) )
   {
      print "<!-- document id number $idoc is $docidlist[$idoc] -->\n";

      $bindstatus1 = &ora_bind($csrpgeneral, $docidlist[$idoc]);

      ($docid[$ipdf],  $doctype_id[$ipdf],
      $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
      $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);
      
      $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
      &ora_bind($csrgetmodels, $docid[$ipdf]);
      while ( ($model, $modelid) = &ora_fetch($csrgetmodels) )
      {
         $pdfmodel[$ipdf]  = "$pdfmodel[$ipdf], $model";
      }
      $pdfmodel[$ipdf] = substr( $pdfmodel[$ipdf], 1);

      &write_comment("(ipdf;idocid:$ipdf.$idocid) docid $docid[$ipdf]; doctype $doctype[$ipdf], 
      $pdfname[$ipdf], $pdfmodel[$ipdf]; ecatdesc $ecatdesc[$ipdf]");


      $ipdf++;
      $idoc++;
   }
   $ipdf--;

   $write_form = 'colls_general.sh';
   &print_search_resultsA($write_form);
 
#=========================================
#  print "Number of Documents found is $idoc<BR>\n";

   &ora_close($csrgeneral);
   &ora_close($csrgenerala);
   &ora_close($csrpgeneral);
}

#*********************************************************
#*********************************************************
sub SearchByCategoryA 
{
 # &PrintInput;
   if ($DEBUG) { &PrintInput; }

   local($BYCATEGORY) =
        "SELECT DISTINCT docid, docformnum
           FROM colls_doctype_0
          WHERE TO_CHAR(doctype_id) LIKE :1 
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :2)     
                             OR (eqpsubcatid LIKE :3)    
                             OR (eqpsubsubcatid LIKE :4)  )
          ORDER BY docformnum";
        # ORDER BY TO_NUMBER(docid)";

   local($PGENERAL) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";

   local($GETMODELS) =
              "SELECT model, modelid 
                 FROM colls_doc_model
                WHERE docid = :1";

   local($EQPCAT) =
              "SELECT description
                 FROM n_eqpcat
                WHERE eqpcatid = :1";

   local($EQPSCAT) =
              "SELECT description
                 FROM n_eqp_sub_cat
                WHERE eqpsubcatid = :1";

   local($EQPSSCAT) =
              "SELECT description
                 FROM n_eqp_sub_sub_cat
                WHERE eqpsubsubcatid = :1";

   local($csrbycat) = &ora_open($lda, $BYCATEGORY)
                               || print "<!-- failed to open cursor $BYCATEGORY -->";

   local($csrpgeneral) = &ora_open($lda, $PGENERAL)
                               || print "<!-- failed to open cursor $PGENERAL -->";

   local($csrgetmodels) = &ora_open($lda, $GETMODELS)
                               || print "<!-- failed to open cursor $GETMODELS -->";

   $csrcat   = &ora_open($lda, $EQPCAT)
                  || print "failed to open cursor $EQPCAT<BR>\n";

   $csrscat  = &ora_open($lda, $EQPSCAT)
                  || print "failed to open cursor $EQPSCAT<BR>\n";

   $csrsscat = &ora_open($lda, $EQPSSCAT)
                  || print "failed to open cursor $EQPSSCAT<BR>\n";


   $icat = 0;
   $idocid = 0;

#Get doctype and determine whether All Doctypes was chosen

   $ALLEQPCAT ='N';
   $ALLDOCTYPES='N';
   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'DOCTYPE')
      {
         $dtypein = "$value[$i]";
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtypein = '%%';
         }
         &write_comment( "Doctype ID is $dtypein");
         $idtype++;
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_equipcat_form;
         return;
      }
      elsif ($name[$i] eq 'EQPCAT')
      {
         if ($value[$i] eq 'ALL') 
         {
            $ALLEQPCATS             = 'Y';
            $eqcatid[$icat]         = '';
            $eqsubcatid[$icat]      = '';
            $eqsubsubcatid[$icat]   = '';
            &write_comment("Cat Level is $catlevel[$icat]; eqp(ss)catid is $catid[$icat]");
            $icat++;
         }
         else
         {
            $cat[$icat] = $value[$i]; 
            ($catlevel[$icat], $catid[$icat]) = split(/\./, $cat[$icat]);
            &write_comment( "Eqpcat ID stem is $cat[$icat]");
          # print "Eqpcat level is $catlevel[$icat]; id is $catid[$icat]<BR>\n";
            if ($catlevel[$icat] eq 'CAT')
            {
               $eqcatid[$icat]         = $catid[$icat];
               $eqsubcatid[$icat]      = '';
               $eqsubsubcatid[$icat]   = '';
               &ora_bind($csrcat, $catid[$icat]);
               ($eqpcatdesc[$icat]) = &ora_fetch($csrcat);
               &write_comment("Cat Level is $catlevel[$icat]; 
                               eqpcatid is $catid[$icat]; cat is $eqpcatdesc[$icat]");
            }
            elsif ($catlevel[$icat] eq 'S')
            {
               $eqcatid[$icat]         =  '';
               $eqsubcatid[$icat]      = $catid[$icat];
               $eqsubsubcatid[$icat]   = '';
               &ora_bind($csrscat, $catid[$icat]);
               ($eqpcatdesc[$icat]) = &ora_fetch($csrscat);
               &write_comment("Cat Level is $catlevel[$icat]; 
                               eqp(s)catid is $catid[$icat]; scat is $eqpcatdesc[$icat]");
            }
            elsif ($catlevel[$icat] eq 'SS')
            {
               $eqcatid[$icat]         =  '';
               $eqsubcatid[$icat]      = '';
               $eqsubsubcatid[$icat]   = $catid[$icat];
               &ora_bind($csrsscat, $catid[$icat]);
               ($eqpcatdesc[$icat]) = &ora_fetch($csrsscat);
               &write_comment("Level is $catlevel[$icat]; 
                               eqp(ss)catid is $catid[$icat]; sscat is $eqpcatdesc[$icat]");
            }
            $icat++;
         }
      }
      $icatmax = $icat;
   }

   &write_comment("max number of categories is $icatmax ");

   $idocid = 0;
   $ipdf = -1;
   for ($iicat=0; $iicat< $icatmax; $iicat++)
   {
      $bindstatus1 = &ora_bind($csrbycat, $dtypein, $eqcatid[$iicat], $eqsubcatid[$iicat],
                               $eqsubsubcatid[$iicat] );
      &write_comment ("bind status for csrbycat is $bindstatus1");
      &write_comment ("bind vars for csrbycat (for iicat=$iicat) are $dtypein, $eqcatid[$iicat], 
                       $eqsubcatid[$iicat], $eqsubsubcatid[$iicat]");

    # print the category here:
    
      while ( ($document_id[$idocid], $formnumber[$idocid]) = &ora_fetch($csrbycat) )
      {
         $bindstatus2 = &ora_bind($csrpgeneral, $document_id[$idocid]);
         &write_comment ("bind status for csrpgeneral is $bindstatus1, docid is $document_id[$iicat]");

         ($documentid[$idocid], $documenttype_id[$idocid], $documenttype[$idocid],
                  $dtitle[$idocid],     $dformnum[$idocid],        $dcatnum[$idocid],
                  $docname[$idocid],    $pdfsize[$idocid])
               =  &ora_fetch($csrpgeneral) ;
         $ipdf = $idocid;
         $docid[$ipdf]        = $document_id[$idocid];
         $doctype[$ipdf]      = $documenttype[$idocid];
         $doctitle[$ipdf]     = $dtitle[$idocid];
         $doccatnum[$ipdf]    = $dcatnum[$idocid];
         $docformnum[$ipdf]   = $dformnum[$idocid];
         $docid[$ipdf]        = $document_id[$idocid];
         $pdfname[$ipdf]      = $docname[$idocid];
         $pdfsizekb[$ipdf]    = int($pdfsize[$idocid]/1024);

         $ecatdesc[$ipdf]     = $eqpcatdesc[$iicat]; 

         $pdfmodel[$ipdf]     = ''; 
         $bindstatus3 = &ora_bind($csrgetmodels, $docid[$ipdf]);
         &write_comment ("bind status for csrgetmodels is $bindstatus3");
         while ( ($model, $modelid) = &ora_fetch($csrgetmodels) )
         {
            $pdfmodel[$ipdf]  = "$pdfmodel[$ipdf], $model";
         }
         $pdfmodel[$ipdf] = substr( $pdfmodel[$ipdf], 1);

         &write_comment("(ipdf;idocid:$ipdf.$idocid) docid $docid[$ipdf]; doctype $doctype[$ipdf], 
         $pdfname[$ipdf], $pdfmodel[$ipdf]; ecatdesc $ecatdesc[$ipdf]");

         $idocid++;
      }
   }

 # $ipdf--;

   $write_form = 'colls_by_category.sh';
   &print_search_resultsA($write_form);;

   &ora_close($csrpgeneral);
   &ora_close($csrbycat);
   &ora_close($csrcat);
   &ora_close($csrscat);
   &ora_close($csrsscat);
}

#*********************************************************
#*********************************************************
sub SearchByFormnumA
{

   if ($DEBUG) { &PrintInput; }

   local($DOCID1)    = 
              "SELECT DISTINCT docid 
                 FROM n_documents    
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                   OR upper(docformnum) LIKE :6
                ORDER BY docformnum";
# colls_doctype_0

   local($BY_FORMNUM) =
              "SELECT DISTINCT  docid, docformnum
                 FROM n_documents    
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                   OR upper(docformnum) LIKE :6
                ORDER BY docformnum";
# colls_doctype_0

   local($BY_FORMNUM1) =
              "SELECT DISTINCT  docid
                 FROM n_documents    
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                  AND upper(docformnum) NOT LIKE :6
                ORDER BY docformnum";
# colls_doctype_0

   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";

   local($PGENERAL) =
              "SELECT doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";


#=====================End of global cursors=========================

   local($csrformnum) = &ora_open($lda, $BY_FORMNUM)
                  || print "failed to open cursor BY_FORMNUM $BY_FORMNUM<BR>\n";
             
   local($csrformnum1) = &ora_open($lda, $BY_FORMNUM1) 
                  || print "failed to open cursor BY_FORMNUM1 $BY_FORMNUM1 <BR>\n";

   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS <BR>\n";

   local($csrpgeneral) = &ora_open($lda, $PGENERAL)
                      || print "failed to open cursor PGENERAL $PGENERAL <BR>\n";

   $imdl   = 0;
   $ifnum  = 0;

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'FORMNUM')
      {
         $fm[$ifnum] = $value[$i]; 
         $fm[$ifnum] +~ tr/a-z/A-Z/;
         &write_comment( "Formnum is $fm[$ifnum]");
         $ifnum++;
      }
      elsif ($name[$i] eq 'FORMNUMSTR')
      {
         $fmstr = $value[$i]; 
         $fmstr +~ tr/a-z/A-Z/;
         if ($fmstr eq "")
         {
            $fmstr = "XXXXXXXXX";
         }
         &write_comment( "Formnumstr is $fmstr");
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_formnum_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

# 
#==============================================================

   $ifn = int($ifnum/5);
   &write_comment("ifnum is $ifnum; ifn = $ifn");
   print "<!--Number of selected formnums is 5*$ifn + ($ifnum - 5*$ifn) -->\n";

   if ( $ifnum > 5 * $ifn)
   {   
      for ($if=$ifnum; $if<= 5*$ifn + 5; $if++)
      {
         $fm[$if] = $fm[$ifnum-1];
         &write_comment( "for index $if, the formnum is $fm[$if]");
      }
   }

   $ipdf = 0;

   $jf0 = 0;
   $bfmstr = "%$fmstr%";
   $bfmstr =~ tr/a-z/A-Z/;
   &write_comment("$fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], $bfmstr");

   $stbind = &ora_bind ($csrformnum, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                  $bfmstr); 
   print "<!-- csrformnum bind status stbind is $stbind <BR> -->\n";

   while ( ($docid[$ipdf], $formnum ) = &ora_fetch($csrformnum) )
   {
      $bindstatus = &ora_bind($csrpgeneral, $docid[$ipdf]);
      print "<!-- csrpgeneral bind status is $bindstatus <BR> -->\n";

      ( $doctype_id[$ipdf], $doctype[$ipdf], $doctitle[$ipdf],
                $docformnum[$ipdf], $doccatnum[$ipdf], $pdfname[$ipdf],
                $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);

      $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
      $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
      print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
    
      $pdfmodel[$ipdf] = "";
      while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
      {
         $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
      }
      $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
      print "<!-- docid $docid[$ipdf]; doccatnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
      &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
      $ipdf++;
   }

   if ($ifn > 0)
   {
      for ($jf=1; $jf<=$ifn; $jf++)
      {
         $jf0 = $jf*5;
         $stbind = &ora_bind ($csrformnum1, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                     $bfmstr); 
         print "<!-- bind status is $stbind <BR> -->\n";
   
         while ( ($docid[$ipdf]) = &ora_fetch($csrformnum1) )
         {
             $bindstatus = &ora_bind($csrpgeneral, $docid[$ipdf]);

             ( $doctype_id[$ipdf], $doctype[$ipdf], $doctitle[$ipdf],
                $docformnum[$ipdf], $doccatnum[$ipdf], $pdfname[$ipdf],
                $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);

            $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
            $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
            $pdfmodel[$ipdf] = "";
            while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
            {
               $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
            }
            print "<!-- docid $docid[$ipdf]; catnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
            &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
            $ipdf++;
         }
      }
   }

   $ipdf--;
   &write_comment(" ipdf is $ipdf");
   $write_form = 'colls_by_formnum.sh';
   &print_search_resultsA($write_form);

   &close($csrformnum);
   &close($csrformnum1);
   &close($csrdocmdl);

   &html_footer;
}
#*********************************************************

#*********************************************************
sub SearchByCapacityA 
{
   if ($DEBUG) { &PrintInput; }

   local($GENERAL) =
        "SELECT DISTINCT docid, docformnum
           FROM colls_doctype
          WHERE modelid in (SELECT DISTINCT modelid 
                              FROM colls_capacity
                             WHERE minclgcap   < TO_NUMBER(:1)
                               AND maxclgcap   > TO_NUMBER(:2)
                               AND modelid LIKE :3)
            AND TO_CHAR(doctype_id) LIKE :4 
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :5)
                             OR (eqpsubcatid LIKE :6)
                             OR (eqpsubsubcatid LIKE :7) )
          ORDER BY docformnum";
      #   ORDER BY TO_NUMBER(docid)";


   local($PGENERAL) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";

   local($GETMODELS) =
              "SELECT model, modelid 
                 FROM colls_doc_model
                WHERE docid = :1";

   local($csrpgeneral) = &ora_open ($lda, $PGENERAL) 
                  || print "failed to open cursor $PGENERAL <BR>\n";

   local($csrgeneral) = &ora_open ($lda, $GENERAL) 
                  || print "failed to open cursor $GENERAL <BR>\n";

   local($csrgetmodels) = &ora_open ($lda, $GETMODELS) 
                  || print "failed to open cursor $GETMODELS <BR>\n";

   $imdl     = 0;
   $idtype   = 0;
   $ieqpcat  = 0;

   $ALLMODELS   = 'N';
   $ALLDOCTYPES = 'N';
   $ALLEQPCATS  = 'N';

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELID')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdlid     = '%%';
         }
         else
         {
            $mdlid     = "$mdl[$imdl]";
         }
         &write_comment( "Model ID is $mdl[$imdl]; mdlid is $mdlid");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtypeid     = '%%';
         }
         else
         {
            $dtypeid     = "$dtype[$idtype]";
         }
         &write_comment( "Doctype ID is $dtype[$idtype]; dtypeid is $dtypeid");
         $idtype++;
      }
      elsif ($name[$i] eq 'EQPCAT')
      {
         if ($value[$i] eq 'ALL') 
         {
            $ALLEQPCATS = 'Y';
            $eqcatid   = '%%';
            $eqsubcatid   = '%%';
            $eqsubsubcatid   = '%%';
         }
         else
         {
            $cat = $value[$i]; 
            ($catlevel, $catid) = split(/\./, $cat);
            &write_comment( "Eqpcat ID stem is $cat");
          # print "Eqpcat level is $catlevel[$icat]; id is $catid<BR>\n";
            if ($catlevel eq 'CAT')
            {
               $eqcatid = $catid;
               $eqsubcatid   = '';
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'S')
            {
               $eqcatid     =  '';
               $eqsubcatid = $catid;
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'SS')
            {
               $eqcatid     =  '';
               $eqsubcatid   = '';
               $eqsubsubcatid = $catid;
            }
            &write_comment("Cat Level is $catlevel; eqp(ss)catid is $catid");
            $ieqpcat++;
         }
      }
      elsif ($name[$i] eq 'LOWCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caplow = $value[$i];
      }
      elsif ($name[$i] eq 'HIGHCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caphigh = $value[$i];
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_capacity_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

   if ( $caphigh < $caplow)
   {
      $write_form = 'colls_by_capacity.sh';
      &print_cap_values_switched($write_form);
   #  print "<P>The value you entered for minimum capacity is larger than\n";
   #  print "the value entered for maximum capacity.  Please use the back \n";
   #  print "button and choose a valid range.<P>\n";
      return;
   }
   elsif ($caplow == undef || $caphigh == undef)
   {
      $write_form = 'colls_by_capacity.sh';
      &print_cap_values_needed($write_form);
   #  print "<P>You failed to enter at least one end of the capacity range. \n";
   #  print "Please use the back button and enter values for both minumum and \n";
   #  print "maximum capacity. \n";
      return;
   }
   else
   {
      print "<!-- caphigh $caphigh; caplow $caplow; mdlid $mdlid; dtypeid $dtypeid -->\n";
      print "<!-- eqcatid $eqcatid; eqsubcatid $eqsubcatid; eqsubsubcatid $eqsubsubcatid; -->\n";

      $bindstatus = &ora_bind($csrgeneral, $caphigh, $caplow, $mdlid, $dtypeid,
                              $eqcatid, $eqsubcatid, $eqsubsubcatid);

      &write_comment("bind status for general query is $bindstatus");

      $idoc = 0;
      $ipdf = 0;
      while ( ($docidlist[$idoc], $formnumlist[$idoc]) = &ora_fetch($csrgeneral) )
      {
         print "<!-- document id number $idoc is $docidlist[$idoc] -->\n";

         $bindstatus1 = &ora_bind($csrpgeneral, $docidlist[$idoc]);

         ($docid[$ipdf],  $doctype_id[$ipdf],
         $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
         $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);
         
         $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
         &ora_bind($csrgetmodels, $docid[$ipdf]);
         while ( ($model, $modelid) = &ora_fetch($csrgetmodels) )
         {
            $pdfmodel[$ipdf]  = "$pdfmodel[$ipdf], $model";
         }
         $pdfmodel[$ipdf] = substr( $pdfmodel[$ipdf], 1);

         &write_comment("(ipdf;idocid:$ipdf.$idocid) docid $docid[$ipdf]; doctype $doctype[$ipdf], 
         $pdfname[$ipdf], $pdfmodel[$ipdf]; ecatdesc $ecatdesc[$ipdf]");


         $ipdf++;
         $idoc++;
      }
      $ipdf--;
      $write_form = 'colls_by_capacity.sh';
      &print_search_resultsA($write_form);
   }

   &html_footer;
   &ora_close($csrgetmodels);
#  &ora_close($csronecap);
   &ora_close($csrgeneral);
   &ora_close($csrpgeneral);


}


#*********************************************************
#*********************************************************
sub PrintInput
{
   print "<UL>\n";
   print "<FONT SIZE=4>Input Values from Keyword Form:</FONT><P>\n";
   print "<TABLE CELLSPACING=10 BORDER=2 >\n";
   print "<TR><TH>Index</TH><TH>Name</TH><TH>Value</TH></TR>\n";
   for ($i = 0; $i <= $fields; $i++) 
   {
       if ($value[$i] eq "")
       {  $value[$i] = "&nbsp"; }
       print "<TR><TD>$i </TD><TD> $name[$i] </TD><TD> $value[$i]</TD></TR>\n";
   }
   print "</TABLE><BR>\n";
   print "</UL>\n";
}

#*********************************************************
#*********************************************************
