#!/usr/local/bin/oraperl  

  $DEBUG = 0;

#sub PrintInput
#sub SearchByCapacityA 

require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_specs.pl';
require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_paths.pl';


#*********************************************************
#*********************************************************
sub SearchByCapacityA 
{
#  &PrintInput;

   local($GENERAL) =
        "SELECT DISTINCT docid
           FROM colls_doctype
          WHERE modelid in (SELECT DISTINCT modelid 
                              FROM colls_capacity
                             WHERE minclgcap   < TO_NUMBER(:1)
                               AND maxclgcap   > TO_NUMBER(:2)
                               AND modelid LIKE :3)
            AND TO_CHAR(doctype_id) LIKE :4 
            AND docid IN (SELECT DISTINCT docid
                            FROM n_doc_eqpcat_assoc
                           WHERE (eqpcatid LIKE :5)
                             OR (eqpsubcatid LIKE :6)
                             OR (eqpsubsubcatid LIKE :7) )
          ORDER BY TO_NUMBER(docid)";

   local($GENERALA) =
        "SELECT DISTINCT docid
           FROM colls_doctype
          WHERE modelid in (SELECT DISTINCT modelid 
                              FROM colls_capacity
                             WHERE minclgcap   < TO_NUMBER(:1)
                               AND maxclgcap   > TO_NUMBER(:2)
                               AND modelid LIKE :3)
            AND TO_CHAR(doctype_id) LIKE :4 
          ORDER BY TO_NUMBER(docid)";

   local($QGENERAL) = 
              "SELECT distinct docid 
                 FROM colls_general
                WHERE docid      LIKE  :1 
                  AND modelid    LIKE  :2
                  AND doctype_id LIKE  :3
                  AND eqpcatid   LIKE  :4
                ORDER BY docformnum";
                    # model, modelid, doctype_id, doctype, doc_descr, 
                    # docformnum, doccatnum, pdf_filename, pdf_filesize,
                    # eqpcatid,  eqpcat

#SELECT docid, doctype_id, doctype, doc_descr, 
#docformnum, doccatnum, pdf_filename, pdf_filesize
   local($PGENERAL) =
              "SELECT docid, doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";

   local($GETMODELS) =
              "SELECT model, modelid 
                 FROM colls_doc_model
                WHERE docid = :1";

   local($CHECK_CAPACITY) =
             "SELECT modelid, model, colls_model, minclgcap, maxclgcap 
                FROM colls_capacity
               WHERE minclgcap IS NOT NULL
                 AND maxclgcap IS NOT NULL
               ORDER BY model";

   local($CHECK_ONE_CAP)  =
             "SELECT modelid, model, colls_model, minclgcap, maxclgcap 
                FROM colls_capacity
               WHERE minclgcap   < TO_NUMBER(:1)
                 AND maxclgcap   > TO_NUMBER(:2)
                 AND modelid =   :3";

   local($csrmdlcap) = &ora_open($lda, $CHECK_CAPACITY)
                  || print "failed to open cursor $CHECK_CAPACITY<BR>\n";

   local($csronecap) = &ora_open($lda, $CHECK_ONE_CAP)
                  || print "failed to open cursor $CHECK_ONE_CAP<BR>\n";

   local($csrqgeneral) = &ora_open ($lda, $QGENERAL) 
                  || print "failed to open cursor $QGENERAL <BR>\n";

   local($csrpgeneral) = &ora_open ($lda, $PGENERAL) 
                  || print "failed to open cursor $PGENERAL <BR>\n";

   local($csrgeneral) = &ora_open ($lda, $GENERAL) 
                  || print "failed to open cursor $GENERAL <BR>\n";

   local($csrgenerala) = &ora_open ($lda, $GENERALA) 
                  || print "failed to open cursor $GENERALA <BR>\n";

   local($csrgetmodels) = &ora_open ($lda, $GETMODELS) 
                  || print "failed to open cursor $GETMODELS <BR>\n";

   $imdl     = 0;
   $idtype   = 0;
   $ieqpcat  = 0;

   $ALLMODELS   = 'N';
   $ALLDOCTYPES = 'N';
   $ALLEQPCATS  = 'N';

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'MODELID')
      {
         $mdl[$imdl] = $value[$i]; 
         if ($value[$i] eq 'ALL') 
         {
            $ALLMODELS = 'Y';
            $mdlid     = '%%';
         }
         else
         {
            $mdlid     = "$mdl[$imdl]";
         }
         &write_comment( "Model ID is $mdl[$imdl]; mdlid is $mdlid");
         $imdl++;
      }
      elsif ($name[$i] eq 'DOCTYPE')
      {
         $dtype[$idtype] = $value[$i];
         if ($value[$i] eq 'ALL') 
         {
            $ALLDOCTYPES = 'Y';
            $dtypeid     = '%%';
         }
         else
         {
            $dtypeid     = "$dtype[$idtype]";
         }
         &write_comment( "Doctype ID is $dtype[$idtype]; dtypeid is $dtypeid");
         $idtype++;
      }
      elsif ($name[$i] eq 'EQPCAT')
      {
         if ($value[$i] eq 'ALL') 
         {
            $ALLEQPCATS = 'Y';
            $eqcatid   = '%%';
            $eqsubcatid   = '%%';
            $eqsubsubcatid   = '%%';
         }
         else
         {
            $cat = $value[$i]; 
            ($catlevel, $catid) = split(/\./, $cat);
            &write_comment( "Eqpcat ID stem is $cat");
          # print "Eqpcat level is $catlevel[$icat]; id is $catid<BR>\n";
            if ($catlevel eq 'CAT')
            {
               $eqcatid = $catid;
               $eqsubcatid   = '';
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'S')
            {
               $eqcatid     =  '';
               $eqsubcatid = $catid;
               $eqsubsubcatid   = '';
            }
            elsif ($catlevel eq 'SS')
            {
               $eqcatid     =  '';
               $eqsubcatid   = '';
               $eqsubsubcatid = $catid;
            }
            &write_comment("Cat Level is $catlevel; eqp(ss)catid is $catid");
            $ieqpcat++;
         }
      }
      elsif ($name[$i] eq 'LOWCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caplow = $value[$i];
      }
      elsif ($name[$i] eq 'HIGHCAP')
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
         $caphigh = $value[$i];
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_capacity_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

   if ( $caphigh < $caplow)
   {
      print "<P>The value you entered for minimum capacity is larger than\n";
      print "the value entered for maximum capacity.  Please use the back \n";
      print "button and choose a valid range.<P>\n";
      $write_general_form;
      return;
   }
   elsif ($caplow == undef || $caphigh == undef)
   {
     #&SearchGeneralNocap ($ALLMODELS, $ALLDOCTYPES, $ALLEQPCATS, $ALLFORMNUMS, 
     #    $ALLKEYWORDS, $mdlid, $dtypeid, $eqcatid, $eqsubcatid, $eqsubsubcatid,
     #    $dcid, $kwordid);
      print "<P>You failed to enter at least one end of the capacity range. \n";
      print "Please use the back button and enter values for both minumum and \n";
      print "maximum capacity. \n";
      return;
   }
   else
   {
      print "<!-- caphigh $caphigh; caplow $caplow; mdlid $mdlid; dtypeid $dtypeid -->\n";
      print "<!-- eqcatid $eqcatid; eqsubcatid $eqsubcatid; eqsubsubcatid $eqsubsubcatid; -->\n";

      $bindstatus = &ora_bind($csrgeneral, $caphigh, $caplow, $mdlid, $dtypeid,
                              $eqcatid, $eqsubcatid, $eqsubsubcatid);

      &write_comment("bind status for general query is $bindstatus");

      $idoc = 0;
      $ipdf = 0;
      while ( ($docidlist[$idoc]) = &ora_fetch($csrgeneral) )
      {
         print "<!-- document id number $idoc is $docidlist[$idoc] -->\n";

         $bindstatus1 = &ora_bind($csrpgeneral, $docidlist[$idoc]);

         ($docid[$ipdf],  $doctype_id[$ipdf],
         $doctype[$ipdf], $doctitle[$ipdf], $docformnum[$ipdf], $doccatnum[$ipdf], 
         $pdfname[$ipdf], $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);
         
         $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
         &ora_bind($csrgetmodels, $docid[$ipdf]);
         while ( ($model, $modelid) = &ora_fetch($csrgetmodels) )
         {
            $pdfmodel[$ipdf]  = "$pdfmodel[$ipdf], $model";
         }
         $pdfmodel[$ipdf] = substr( $pdfmodel[$ipdf], 1);

         &write_comment("(ipdf;idocid:$ipdf.$idocid) docid $docid[$ipdf]; doctype $doctype[$ipdf], 
         $pdfname[$ipdf], $pdfmodel[$ipdf]; ecatdesc $ecatdesc[$ipdf]");


         $ipdf++;
         $idoc++;
      }
      $ipdf--;
      $write_form = 'colls_by_capacity.sh';
      &print_search_resultsA($write_form);
   }

   &html_footer;
   &ora_close($csrmdlcap);
   &ora_close($csronecap);
   &ora_close($csrgeneral);
   &ora_close($csrqgeneral);


}

#*********************************************************
#*********************************************************
sub PrintInput
{
   print "<UL>\n";
   print "<FONT SIZE=4>Input Values from Keyword Form:</FONT><P>\n";
   print "<TABLE CELLSPACING=10 BORDER=2 >\n";
   print "<TR><TH>Index</TH><TH>Name</TH><TH>Value</TH></TR>\n";
   for ($i = 0; $i <= $fields; $i++) 
   {
       if ($value[$i] eq "")
       {  $value[$i] = "&nbsp"; }
       print "<TR><TD>$i </TD><TD> $name[$i] </TD><TD> $value[$i]</TD></TR>\n";
   }
   print "</TABLE><BR>\n";
   print "</UL>\n";
}

#*********************************************************
#*********************************************************
