#!/usr/local/bin/oraperl  


#=======================

$DEBUG=0;

require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_specs.pl';
require '/oradata/disk4/carrier/cdata/cgi-bin/COLLS/pl/user_paths.pl';

#=====================Define global cursors=========================

sub SearchByFormnumA
{

   if ($DEBUG)
   {
      &PrintInput;
   }

   local($DOCID1)    = 
              "SELECT DISTINCT docid 
                 FROM colls_doctype_0
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                   OR upper(docformnum) LIKE :6
                ORDER BY docformnum";

   local($BY_FORMNUM) =
              "SELECT DISTINCT  docid, docformnum
                 FROM colls_doctype_0
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                   OR upper(docformnum) LIKE :6
                ORDER BY docformnum";

   local($BY_FORMNUM1) =
              "SELECT DISTINCT  docid
                 FROM colls_doctype_0
                WHERE docformnum IN (:1, :2, :3, :4, :5)
                  AND upper(docformnum) NOT LIKE :6
                ORDER BY docformnum";

   local($GET_DOC_MODELS)  =
                 "SELECT model, modelid
                    FROM colls_doc_model
                   WHERE docid = :1";

   local($PGENERAL) =
              "SELECT doctype_id, doctype, doc_descr, 
                      docformnum, doccatnum, pdf_filename, pdf_filesize
                 FROM colls_doctype_0
                WHERE docid  =  :1";


#=====================End of global cursors=========================

   local($csrformnum) = &ora_open($lda, $BY_FORMNUM)
                  || print "failed to open cursor BY_FORMNUM $BY_FORMNUM<BR>\n";
             
   local($csrformnum1) = &ora_open($lda, $BY_FORMNUM1) 
                  || print "failed to open cursor BY_FORMNUM1 $BY_FORMNUM1 <BR>\n";

   local($csrdocmdl)    = &ora_open($lda, $GET_DOC_MODELS)
                      || print "failed to open cursor GET_DOC_MODELS $GET_DOC_MODELS <BR>\n";

   local($csrpgeneral) = &ora_open($lda, $PGENERAL)
                      || print "failed to open cursor PGENERAL $PGENERAL <BR>\n";

   $imdl   = 0;
   $ifnum  = 0;

   for ($i=0; $i<= $#value; $i++)
   {
      if ($name[$i] eq 'FORMNUM')
      {
         $fm[$ifnum] = $value[$i]; 
         $fm[$ifnum] +~ tr/a-z/A-Z/;
         &write_comment( "Formnum is $fm[$ifnum]");
         $ifnum++;
      }
      elsif ($name[$i] eq 'FORMNUMSTR')
      {
         $fmstr = $value[$i]; 
         $fmstr +~ tr/a-z/A-Z/;
         if ($fmstr eq "")
         {
            $fmstr = "XXXXXXXXX";
         }
         &write_comment( "Formnumstr is $fmstr");
      }
      elsif ($name[$i] eq 'Reset.x')
      {
         &write_formnum_form;
         return;
      }
      else
      {
         &write_comment( "For i= $i, Name is $name[$i], value is $value[$i] ");
      }
   }

# 
#==============================================================

   $ifn = int($ifnum/5);
   &write_comment("ifnum is $ifnum; ifn = $ifn");
   print "<!--Number of selected formnums is 5*$ifn + ($ifnum - 5*$ifn) -->\n";

   if ( $ifnum > 5 * $ifn)
   {   
      for ($if=$ifnum; $if<= 5*$ifn + 5; $if++)
      {
         $fm[$if] = $fm[$ifnum-1];
         &write_comment( "for index $if, the formnum is $fm[$if]");
      }
   }

   $ipdf = 0;

   $jf0 = 0;
   $bfmstr = "%$fmstr%";
   $bfmstr =~ tr/a-z/A-Z/;
   &write_comment("$fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], $bfmstr");

   $stbind = &ora_bind ($csrformnum, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                  $bfmstr); 
   print "<!-- csrformnum bind status stbind is $stbind <BR> -->\n";

   while ( ($docid[$ipdf], $formnum ) = &ora_fetch($csrformnum) )
   {
      $bindstatus = &ora_bind($csrpgeneral, $docid[$ipdf]);
      print "<!-- csrpgeneral bind status is $bindstatus <BR> -->\n";

      ( $doctype_id[$ipdf], $doctype[$ipdf], $doctitle[$ipdf],
                $docformnum[$ipdf], $doccatnum[$ipdf], $pdfname[$ipdf],
                $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);

      $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
      $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
      print "<!-- csrdocmdl bind status is $bindstatus <BR> -->\n";
    
      $pdfmodel[$ipdf] = "";
      while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
      {
         $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
      }
      $pdfmodel[$ipdf] = substr($pdfmodel[$ipdf],1);
      print "<!-- docid $docid[$ipdf]; doccatnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
      &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
      $ipdf++;
   }

   if ($ifn > 0)
   {
      for ($jf=1; $jf<=$ifn; $jf++)
      {
         $jf0 = $jf*5;
         $stbind = &ora_bind ($csrformnum1, $fm[$jf0+0], $fm[$jf0+1], $fm[$jf0+2], $fm[$jf0+3], $fm[$jf0+4], 
                     $bfmstr); 
         print "<!-- bind status is $stbind <BR> -->\n";
   
         while ( ($docid[$ipdf]) = &ora_fetch($csrformnum1) )
         {
             $bindstatus = &ora_bind($csrpgeneral, $docid[$ipdf]);

             ( $doctype_id[$ipdf], $doctype[$ipdf], $doctitle[$ipdf],
                $docformnum[$ipdf], $doccatnum[$ipdf], $pdfname[$ipdf],
                $pdfsize[$ipdf]) = &ora_fetch($csrpgeneral);

            $pdfsizekb[$ipdf] = int( $pdfsize[$ipdf]/1024);
            $bindstatus = &ora_bind($csrdocmdl, $docid[$ipdf]); 
            $pdfmodel[$ipdf] = "";
            while ( ($model, $modelid) = &ora_fetch($csrdocmdl) )
            {
               $pdfmodel[$ipdf] = "$pdfmodel[$ipdf], $model";
            }
            print "<!-- docid $docid[$ipdf]; catnum $doccatnum[$ipdf]; doctype $doctype[$ipdf];  -->\n";
            &write_comment( "NAME: $pdfname[$ipdf]; SIZE: $pdfsizekb[$ipdf] ; DOCID: $docid[$ipdf]" );
            $ipdf++;
         }
      }
   }

   $ipdf--;
   &write_comment(" ipdf is $ipdf");
   $write_form = 'colls_by_formnum.sh';
   &print_search_resultsA($write_form);

   &close($csrformnum);
   &close($csrformnum1);
   &close($csrdocmdl);

   &html_footer;
}


