#!/usr/local/bin/oraperl

# ---------------------------------------------------------
# filename:
# write_com_subroutines.pl
# revised to perl4 subroutine collection Nov 14, 1996
# derived from write_path1_fieldpage.pl written august 1996
# author Barbara Mihalas
# ---------------------------------------------------------

# ========================================================================
# ========================================================================
sub www_user_setup_pr 
{
   # ----------------- set environment variables -------------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/www_user_env.pl';

   # ------------------oraperl setup -------------------------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/www_user_ora_setup.pl';

   # ------------------ set url, cgi and document paths ------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_com_paths_pr.pl';
}

# ========================================================================
# ========================================================================
sub wow_user_setup_pr 
{
   # ----------------- set environment variables -------------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/wow_user_env.pl';

   # ------------------oraperl setup -------------------------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/wow_user_ora_setup.pl';

   # ------------------ set url, cgi and document paths ------------------
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_com_paths_pr.pl';
}

# ========================================================================
# ========================================================================
sub write_global_definitions
{
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_nav_cursors.pl';

   &write_comment(" after call to write_com_cursors.pl ");
   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_com_cursors.pl';
   &write_comment(" after call to write_com_cursors.pl ");

   require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_path1_arrays.pl';
}

# ========================================================================
# ========================================================================

# ==========================================================
#  oraperl cleanup 
# ==========================================================
sub oraperl_cleanup
{
   # --------------------------------------------
   # log out of the database (this is ESSENTIAL!)
   # --------------------------------------------

   do ora_logoff($lda)				|| die $ora_errstr;

   # ==============  end of oraperl cleanup =====================
   # ============================================================
}

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($instring) = @_;
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $instring);
## print "Input string to sub parse is $instring<BR>\n";

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
  #    print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

# *********************************************
# Parse the path 1 input string
# *********************************************
sub parse_path1string
{
   local($pstring) = @_;
   $pstring = substr($pstring,4);
   &write_comment("substr of path1string is $pstring");
   @parr = split(/_/, $pstring);
   &write_comment("$pstring splits into $parr[0], $parr[1], $parr[2]");
}

# *********************************************
# Create and write the path 1 backlinks
# *********************************************
sub path1_links
{
   &write_comment("parr is $parr[0], $parr[1], $parr[2]");
   $btlink = $docpath.'com_sh2/com_shd2.html';
   print "<TABLE CELLSPACING=0 CELLPADDING=0>\n";
   print "<TR><TD>\n";
   print "<A TARGET=\"bodyText\" HREF=\"$btlink\">\n";
   print "<IMG SRC=\"$btimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";
   print "</TD><TD>\n";

   $btdir = 'com_'.$parr[0];
   $btfile = $btdir.'.html';
   $btpath = $docpath.$btdir;
      &write_comment("bldg type directory is $btdir, file is $btfile");
      &write_comment("docpath is $docpath ");
   $sclink = join('/', $btpath, $btfile);
      &write_comment("sclink is $sclink");
   print "<A TARGET=\"bodyText\" HREF=\"$sclink\">\n";
   print "<IMG SRC=\"$scimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   $scfile = join('_', $btdir, $parr[1]);
   $scfile = $scfile.'.html';
   $sctlink = join('/', $btpath, $scfile);
   print "<A TARGET=\"bodyText\" HREF=\"$sctlink\">\n";
   print "<IMG SRC=\"$sctimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   $sctfile = join('_', $btdir, $parr[1], $parr[2]);
   $sctfile = $sctfile.'.html';
   $ctlink = join('/', $btpath, $sctfile);
   print "<A TARGET=\"bodyText\" HREF=\"$ctlink\">\n";
   print "<IMG SRC=\"$ctimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";

   print "</TD><TD>\n";
   print "<IMG SRC=\"$cmimg\" ALIGN=\"center\" WIDTH=81 HEIGHT=35  BORDER=0></A>\n";
   print "</TD></TR>\n";
   print "<TR><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$bttext{$parr[0]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$sctext{$parr[1]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   print "<FONT SIZE=2><B>$cttext{$parr[2]}</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   &get_specific_type($modelno);
   
   print "<FONT SIZE=2><B>$specifictype</FONT></B>\n";
   print "</TD><TD ALIGN=CENTER>\n";
   $YAHgif = 'com_media/you_are_here.gif';
   $YAHimg = $docpath.$YAHgif;
   print "<IMG SRC = \"$YAHimg\" ALIGN=\"LEFT\" WIDTH=57 HEIGHT=20 BORDER=0>\n";
   print "</TD></TR>\n";
   print "</TABLE>\n";

}

# ***************************************************
# Get the specific type for an input model
# ***************************************************
sub get_specific_type
{
   local($modelin) = @_;

   $modeluc = $modelin;
   $modeluc =~ tr/a-z/A-Z/;

   $GET_SPECIFIC_TYPE = 
                  "SELECT specifictype 
                     FROM commercial_products
                    WHERE upper(model) = :1";

   $csrspec = &ora_open ($lda, $GET_SPECIFIC_TYPE) 
                  || print "failed to open $GET_SPECIFIC_TYPE\n";

   &ora_bind($csrspec, $modeluc);
   ($specifictype) = &ora_fetch($csrspec);
   &ora_close($csrspec);

 }

# ***************************************************
# This Procedure shows default and display fields 
# ***************************************************
sub show_default_table_fields {

   $csra  = &ora_open($lda, $GET_TABLE) || die $ora_errstr;
   $csrb  = &ora_open($lda, $GET_DEFAULT_FIELDS) || die $ora_errstr;
   $csrc  = &ora_open($lda, $GET_DISPLAY_FIELDS) || die $ora_errstr;

   while ( ($pdtblname ) = &ora_fetch($csra) )  
   {
      $pdtblname =~ tr/a-z/A-Z/;
      print "<BR><HR>\n";
      print "<BR>Data Table is $pdtblname;<BR> Default Fields:<P>\n";
      $pdtablename = $pdtblname;


      &ora_bind ($csrb, $pdtablename);
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder) = &ora_fetch($csrb) ) 
      {
         $ii++;
         print "default order_num is $forder for $fname alias $fdname, 
            with colname $cname <BR>\n";
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
      }
      print "<CENTER><TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($i=1; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] </TD>\n";
      }
      print "</TR>\n";
      print "</TABLE></CENTER>\n";

      for ($i=1; $i <= $#ord; $i++) {
         $columnname[$i] = '';
      }

      print "<P>Display Fields:<P>\n";
      &ora_bind ($csrc, $pdtablename);
      while ( ($fcname, $ccname, $fcdname, $fcorder, $funits) = &ora_fetch($csrc) ) 
      {
         print "display order_num is $fcorder for $fcname alias $fcdname, 
            with colname $ccname, units $funits <BR>\n";
      }
   }    
   &ora_close($csrb);
   &ora_close($csra);
   &ora_close($csrc);
}

# ***************************************************
# Gets default fields and builds table
# ***************************************************
sub write_default_table
{
   local ($modelin) = @_;

   $GET_TABLENAME = "SELECT datatablename, modelalias
                         FROM commercial_products
                        WHERE upper(model) = :1";  

#  print "<P><HR><P>Input model to write_default_table is $modelin<BR>\n";

   $csra = &ora_open($lda, $GET_TABLENAME)        || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS)   || die $ora_errstr;

#  Get Name of Product Specifications Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname, $modelalias) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
   }
   &ora_close ($csra);
   &write_comment("product data table name is $pdtablename");

#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      &ora_bind ($csrb, $pdtablename); 
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
         $units[$ii] = $funits;
         $ii++;
         &write_comment("$forder, $fname, $fdname, $cname, $funits");
      }

   if ($CAES_CHILLER eq '')
   {
      require '/oradata/disk4/carrier/cdata/cgi-bin/pl/require/write_com_cursors.pl';
   }

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_LPACKROOF_EHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_LPACKROOF_GHEAT_ECOOL')    { $GET_DATA = $CMUS_LPACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P><HR><P>\n";
      &write_comment("product data table name is $pdtablename");
      &write_comment( "query is $GET_DATA ");

      $csrc = &ora_open($lda, $GET_DATA)      || die "failed to open $GET_DATA\n";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

      &write_comment("number of fields is $#ord");

#  Get the indexes for the $#ord default fields 
#  -----------------------------------------------
      for ($ii=0; $ii <= $#ord; $ii++)
      {
         $fieldname[$ii] =~ tr/a-z/A-Z/;
         &write_comment("the $ii th fieldname is $fieldname[$ii]");

    # Get matching fieldname
    # ----------------------
         for ($idat=0; $idat <= $#fldnames; $idat++) 
         {
            $fldnames[$idat] =~ tr/a-z/A-Z/;
            if ($fieldname[$ii] eq $fldnames[$idat] )
            {
               $tord[$ii] = $idat;
               &write_comment( "$idat, tord[$ii] = $tord[$ii], fieldname[$ii]=$fieldname[$ii],");
               &write_comment( "fldname = $fldnames[$tord[$ii] ]");
            }
         }
      }

      $imsize = -1;
      print "<A NAME=\"product_data\"></A>\n";
      print "<A HREF=\"#pagetop\">(top of page)</A><BR>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4> Product Specifications for Model $pdmodel </FONT><P>\n";
      print "<TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($ii=0; $ii <= $#fldnames; $ii++)
      {
          $fldnames[$ii] =~ tr/a-z/A-Z/;
          if ($fldnames[$ii] eq 'MODEL')
          {   $imodel = $ii; }
          if ($fldnames[$ii] eq 'MODELSIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'MODEL_SIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'RECORD_ID')
          {
              $imrecordid =$ii;
            #  print "<TD ALIGN=\"center\">Model</TD> \n";
          }
      }
      for ($i=0; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] ";
         if($units[$i] ne '') { print "<BR> ($units[$i])";}
         print "</TD>\n";
      }
      print "</TR>\n";

      $procedure = 'write_model_page2.sh?';
      &write_comment("$pdmodel, $csrc ");
      &ora_bind ($csrc, $pdmodel);
      &write_comment("after ora_bind  imsize= $imsize");
      $unitstr = 'unittype='.$unittype;
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          print "<TR> \n";
          if ($imsize >= 0)
          {
             $mdl = $pdata[$imodel].$pdata[$imsize];
             $recidstr = 'recid='.$pdata[$imrecid];
             $mdlstr = 'mdlno='.$pdata[$imodel].'&mdlsize='.$pdata[$imsize];
             $mdlstr = join ('&', $mdlstr, $unitstr, $recidstr);
             print "<TD ALIGN=CENTER>";
             print "<A HREF=\"$perlpath$procedure$mdlstr\">$mdl</A></TD>\n";
          }
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>\n";
          }
          print "</TR>\n";
      }
      print "</TABLE></CENTER>\n";
      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

#  print "<BR>Input model is $modelin<BR>\n";
#  print "<A NAME=\"pagetop\"></A>\n";
   &caw_frameD_back_header;
   print "<P>\n";

#  &back_to_caw_products;
   &path1_links;

   print "<BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   &ora_bind ($csrtab, $modelin);
   ($tablename, $modelalias) = &ora_fetch($csrtab);

   $modelprt = $modelin;
   if ( $modelalias ne '')  { $modelprt = $modelalias; }

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }
   &ora_close($csrtab);

   &write_comment(" input model is $modelin\n");

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   $uppermodel = $modelin;
   $uppermodel =~ tr/a-z/A-Z/;
 # print "<BR>uppercase of $modelin is $uppermodel<BR>\n";
   &ora_bind ($csra, $uppermodel);
   &ora_bind ($csrb, $uppermodel);
   &ora_bind ($csrc, $uppermodel, 'product description');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
   #  print "$model has photo file [$photo_filename]-[$photo_extension] for page [$photo_pagetype]<BR>\n";
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;
      $photo_filename_uc = $photo_filename_uc.".jpg";
      $photo_filename_lc = $photo_filename_lc.".jpg";
      $IMG_SRC = $docpath."com_media/".$photo_filename_lc;
      $IMG_ALT = $docpath."com_media/".$photo_filename_uc;
   #  print "Unix photo filename is [$photo_filename]<P>\n";
   #  print "Unix IMG SRC is [$IMG_SRC]<BR>\n";

   #  $IMG_SRC = $IMG_SRC\n";
   #  $IMG_ALT = $IMG_ALT\n";
      print "<CENTER>\n";
   #  print "Image goes here<BR>\n";
      print "<IMG SRC =\"$IMG_SRC\"  ALT=\"$IMG_ALT\" ALIGN=CENTER>\n";
      print "</CENTER>\n";
   }
   close $csrb;
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
 #     print "number of text files is $ntext<BR> \n";
       &write_comment("number of text files is $ntext\n");
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
      #  print "$model has text file [$text_filename]-[$text_extension] 
      #  for page [$text_pagetype]<BR>\n";
         $text_filename =~ s/\s/_/g;
         $text_filename =~ s/-/_/g;
         $text_filename = $text_filename.".html";
         $text_location = $textpath.$text_filename;
      #  print "Unix text filename is [$text_filename]<P>\n";
     #   print "Unix location is [$text_location<BR>\n";
         $text1 = "Unix text filename is [ $text_filename ]\n";
         &write_comment( $text1 );
         $text_link = $text_location;
     #   open(TEXTFILE, $text_link) || print "can't open filename $text_link<BR>\n";
         open(TEXTFILE, $text_link) || print "<BR>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
      }
      close $csra;
   }

#  &write_download_links ($modelin);


   &write_default_table ($modelin);   

   &frameD_topofpage;
}

# ******************************************
# Writes download links for model
# ******************************************
sub write_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND b.model = :1";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}

# ******************************************
# write the caw back header
# ******************************************
sub caw_frameD_back_header
{
   print "<A NAME=\"pagetop\"></A>\n";
   print "<A HREF=\"$docpath/com_ed1/index.html\" TARGET=\"_parent\">\n";
   print "<IMG SRC=\"$docpath/com_media/caw_header_back_button.gif\"\n";
   print " ALIGN=\"MIDDLE\" WIDTH=\"430\" HEIGHT=\"32\" BORDER=0></A>\n";
}

# ******************************************
# write caw back to product list header
# ******************************************
sub back_to_caw_products
{
   print "<BR>\n";
   print "<A HREF=\"$oraclepath/CPDOCS.write_gen_types_B\">\n";
   print "<I>back to product list</I></A>\n";
   print "<BR>\n";
}

# ******************************************
# write the frameD topofpage
# ******************************************
sub frameD_topofpage
{
   print "<P ALIGN=\"RIGHT\">\n";
   print "<I>(<A HREF=\"#pagetop\">top of page</A><I>)\n";
   print "</P>\n";
}

# ******************************************
# writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";

}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Product Specification Table and Information</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}

# ***************************************************
# Gets default fields and builds table
# ***************************************************
sub write_default_table_cs
{
###OBSOLETE?? (replaced with write_default_table in pkg_data_tables.pl)
   local ($modelin, $unittype) = @_;

   $GET_TABLENAME = "SELECT datatablename
                         FROM commercial_products
                        WHERE upper(model) = :1";  

#  print "<P><HR><P>Input model to write_default_table is $modelin<BR>\n";

   $csra = &ora_open($lda, $GET_TABLENAME)        || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_DEFAULT_FIELDS)   || die $ora_errstr;

#  Get Name of Product Specifications Table for input model
# -----------------------------------------------
   $pdmodel = $modelin;
   &ora_bind($csra, $pdmodel);
   while (  ($pdtblname) = &ora_fetch($csra) )
   {
      $pdtablename = $pdtblname;
      $pdtablename =~ tr/a-z/A-Z/;
   }
   &ora_close ($csra);


#  Get the default fields for pdtablename
#  --------------------------------------
   if ($pdtablename ne '')
   {
      &ora_bind ($csrb, $pdtablename); 
      $ii=0;
      while ( ($fname, $cname, $fdname, $forder, $funits) = &ora_fetch($csrb) ) 
      {
         $ord[$ii] = $forder; 
         $fieldname[$ii] = $fname;
         $fielddisplayname[$ii] = $fdname;
         $columnname[$ii] = $cname;
         $units[$ii] = $funits;
         $ii++;
      }

#  Get Cursor for Correct Data Table and determine indexes for default fields
#  --------------------------------------------------------------------------

      if ($pdtablename eq 'CAES_CHILLER')                  { $GET_DATA = $CAES_CHILLER }
      if ($pdtablename eq 'CMUS_AIR_CONDENSER')            { $GET_DATA = $CMUS_AIR_CONDENSER }
      if ($pdtablename eq 'CMUS_AIR_HANDLER')              { $GET_DATA = $CMUS_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL')             { $GET_DATA = $CMUS_AIR_TERMINAL }
      if ($pdtablename eq 'CMUS_AIR_TERMINAL_BOX')         { $GET_DATA = $CMUS_AIR_TERMINAL_BOX }
      if ($pdtablename eq 'CMUS_BOOT_DIFFUSER')            { $GET_DATA = $CMUS_BOOT_DIFFUSER }
      if ($pdtablename eq 'CMUS_CHILLER')                  { $GET_DATA = $CMUS_CHILLER }
      if ($pdtablename eq 'CMUS_DUAL_FUEL_HEAT_PUMP')      { $GET_DATA = $CMUS_DUAL_FUEL_HEAT_PUMP }
      if ($pdtablename eq 'CMUS_DUCTFREE_COOLING')         { $GET_DATA = $CMUS_DUCTFREE_COOLING }
      if ($pdtablename eq 'CMUS_DUCTFREE_HEATPUMP')        { $GET_DATA = $CMUS_DUCTFREE_HEATPUMP }
      if ($pdtablename eq 'CMUS_FANCOILS')                 { $GET_DATA = $CMUS_FANCOILS }
      if ($pdtablename eq 'CMUS_INDOOR_HORZ_PACK')         { $GET_DATA = $CMUS_INDOOR_HORZ_PACK }
      if ($pdtablename eq 'CMUS_INDOOR_VERT_PACK')         { $GET_DATA = $CMUS_INDOOR_VERT_PACK }
      if ($pdtablename eq 'CMUS_INDUCTION_UNIT')           { $GET_DATA = $CMUS_INDUCTION_UNIT }
      if ($pdtablename eq 'CMUS_PACKROOF_EHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_EHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACKROOF_GHEAT_ECOOL')     { $GET_DATA = $CMUS_PACKROOF_GHEAT_ECOOL }
      if ($pdtablename eq 'CMUS_PACK_AIR_HANDLER')         { $GET_DATA = $CMUS_PACK_AIR_HANDLER }
      if ($pdtablename eq 'CMUS_PACK_ELEC_COOL')           { $GET_DATA = $CMUS_PACK_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_GAS_HEAT_ELEC_COOL')  { $GET_DATA = $CMUS_PACK_GAS_HEAT_ELEC_COOL }
      if ($pdtablename eq 'CMUS_PACK_HEATING_AND_COOLING') { $GET_DATA = $CMUS_PACK_HEATING_AND_COOLING }
      if ($pdtablename eq 'CMUS_PACK_HEATPUMP')            { $GET_DATA = $CMUS_PACK_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_ROOFTOP_HEATPUMP')    { $GET_DATA = $CMUS_PACK_ROOFTOP_HEATPUMP }
      if ($pdtablename eq 'CMUS_PACK_TERMINAL_UNIT')       { $GET_DATA = $CMUS_PACK_TERMINAL_UNIT }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM')             { $GET_DATA = $CMUS_SPLIT_SYSTEM }
      if ($pdtablename eq 'CMUS_SPLIT_SYSTEM_HEATPUMP')    { $GET_DATA = $CMUS_SPLIT_SYSTEM_HEATPUMP }
      if ($pdtablename eq 'CMUS_WATER_SOURCE_HEATPUMP')    { $GET_DATA = $CMUS_WATER_SOURCE_HEATPUMP }
      if ($pdtablename eq 'RAC_UNITS_HC')                  { $GET_DATA = $RAC_UNITS_HC }
      if ($pdtablename eq 'RAC_UNITS_COOL_ONLY')           { $GET_DATA = $RAC_UNITS_COOL_ONLY }
      if ($pdtablename eq 'RAC_UNITS_HEAT_COOL')           { $GET_DATA = $RAC_UNITS_HEAT_COOL }
      if ($pdtablename eq 'RAC_UNITS_HEAT_PUMP')           { $GET_DATA = $RAC_UNITS_HEAT_PUMP }

      print "<P><HR><P>\n";
   #  print "product data table name is $pdtablename <BR>\n";
   #  print "query is $GET_DATA <BR>\n";

      $csrc = &ora_open($lda, $GET_DATA)      || die "failed to open $GET_DATA\n";
      @fldnames  = &ora_titles($csrc);
      @flengths  = &ora_lengths($csrc);
      @ftypes    = &ora_types($csrc);

#  Get the indexes for the $#ord default fields 
#  -----------------------------------------------
      for ($ii=0; $ii <= $#ord; $ii++)
      {
         $fieldname[$ii] =~ tr/a-z/A-Z/;

    # Get matching fieldname
    # ----------------------
         for ($idat=0; $idat <= $#fldnames; $idat++) 
         {
            $fldnames[$idat] =~ tr/a-z/A-Z/;
            if ($fieldname[$ii] eq $fldnames[$idat] )
            {
               $tord[$ii] = $idat;
          #    print "$idat, tord[$ii] = $tord[$ii], fieldname[$ii]=$fieldname[$ii],";
          #    print "fldname = $fldnames[$tord[$ii] ]<BR> \n";
            }
         }
      }

      $imsize = -1;
      print "<A NAME=\"product_data\"></A>\n";
      print "<A HREF=\"#pagetop\">(top of page)</A><BR>\n";
      print "<CENTER>\n";
      print "<FONT SIZE=4> Product Specifications for Model $pdmodel </FONT><P>\n";
      print "<TABLE BORDER=3 WIDTH=70%>\n";
      print "<TR>\n";
      for ($ii=0; $ii <= $#fldnames; $ii++)
      {
          $fldnames[$ii] =~ tr/a-z/A-Z/;
          if ($fldnames[$ii] eq 'MODEL')
          {   $imodel = $ii; }
          if ($fldnames[$ii] eq 'MODELSIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
          if ($fldnames[$ii] eq 'MODEL_SIZE')
          {
              $imsize =$ii;
              print "<TD ALIGN=\"center\">Model</TD> \n";
          }
      }
      for ($i=0; $i <= $#ord; $i++) {
         print "<TD ALIGN=\"center\"> $columnname[$i] ";
         if($units[$i] ne '') { print "<BR> ($units[$i])";}
         print "</TD>\n";
      }
      print "</TR>\n";

      $procedure = 'write_model_page2.sh?';
      &ora_bind ($csrc, $pdmodel);
      while (  ( @pdata) = &ora_fetch($csrc)  )
      {
          print "<TR> \n";
          if ($imsize >= 0)
          {
             $mdl = $pdata[$imodel].$pdata[$imsize];
             $mdlstr = 'mdlno='.$pdata[$imodel].'&mdlsize='.$pdata[$imsize];
             print "<TD ALIGN=CENTER>";
             print "<A HREF=\"$perlpath$procedure$mdlstr\">$mdl</A></TD>\n";
          }
          for ($ij =0; $ij<= $#ord; $ij++) 
          {
             print " <TD ALIGN=\"center\"> $pdata[$tord[$ij] ] </TD>\n";
          }
          print "</TR>\n";
      }

      print "</TABLE><HR>\n";
      $currentdate = &formatdate;
      print "<FONT SIZE=2>$currentdate</FONT>\n";
      print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";
      print "</CENTER>\n";

    # print "</TABLE></CENTER>\n";
    # print "<BR><FONT SIZE=2>Specifications subject to change without notice.</FONT><BR>\n";

      &ora_close ($csrc);
   }
   &ora_close($csrb);
}

#****************************************************************
#****************************************************************
