#!/usr/local/bin/oraperl

# -----------------------
# filename:
# write_com_fieldpage.pl
# written august 1996
# author Barbara Mihalas
# -----------------------

require '/oradata/disk3/netscape/cgi-bin/cdata/pl/user_specs.pl';

# ===== HTML setup ======
  &html_header('Product Specification Table and Information');
# ===== HTML setup ======

  &write_comment("End of HTML setup; 11/8/97 revision");

$ENV{'ORACLE_HOME'}= "/usr/oracle";
$ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
$ENV{'WOW_UID'}= "$user/$user";
$ENV{'ORACLE_SID'}= "mindy";

## print "query string is $ENV{'QUERY_STRING'}<BR>\n";
## print "oracle_home is $ENV{'ORACLE_HOME'}<BR>\n";

# ==========================================================
# ================= oraperl setup ==========================
# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit" if 0;
# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;
# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;
# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');
# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', $user, $user)	|| die $ora_errstr;
  &write_comment("End of oraperl setup");
# ==============  end of oraperl setup =======================
# ============================================================

require '/oradata/disk3/netscape/cgi-bin/cdata/pl/user_paths.pl';

# ==============  define cursors =============================
  $GET_TABLE   = "SELECT distinct datatablename 
                    FROM commercial_products 
                   WHERE obsolete = 0
                   ORDER BY datatablename";
 
  $GET_TABLENAME   =
                 "SELECT datatablename, modelalias 
                    FROM commercial_products 
                   WHERE upper(model) = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT a.filename, a.extension, b.pagetype
                    FROM text_objects a, text_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.usage) = 'product description'
                     AND a.textid = b.textid";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE upper(b.model) = :1
                     AND lower(b.pagetype) LIKE 'product page%'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(usage) = :2";
  
# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

##   print "input query string is $ENV{'QUERY_STRING'}<BR>\n";
  $query_string = $ENV{'QUERY_STRING'};
##   print "Query String is set to $query_string <BR>\n";

# Read input buffer
# read( STDIN, $query_string, $ENV{'QUERY_STRING'} );
# print "PATH_INFO =  $ENV{'$PATH_INFO'} <BR>\n";
# Optional printout
# print "<BR>BUFFER is $buffer\n";
# print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
# print "<p><hr>";

# Parse input query string
  &parse($query_string);

# List the default and display fields for the given product data table
# &show_default_table_fields;


  $modelno = $value[0];
  $unit_type = $value[1];


  &write_comment("model is $modelno; unit type is $unit_type");

  &write_modelpage ($modelno);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================
# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;
# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($instring) = @_;
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $instring);
## print "Input string to sub parse is $instring<BR>\n";

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
  #    print "<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n";
   }
   $fields = $i-1;
   $numfields = $fields+1;
}

#  require '/oradata/disk4/httpdstg/cgi-bin/cdata/pl/pkg_english_tables.pl';

# ******************************************
# Writes the product page for input model
# ******************************************
sub write_modelpage
{
   local ($modelin) = @_;

#  print "<A NAME=\"pagetop\"></A>\n";
   &caw_frameD_back_header;
   print "<P>\n";
   &back_to_caw_products;
   print "<BR>\n";

 # Check for product data
 # ----------------------
   $csrtab = &ora_open($lda, $GET_TABLENAME) || die $ora_errstr;
   $modeluc = $modelin; 
   $modeluc =~ tr/a-z/A-Z/;
   &ora_bind ($csrtab, $modeluc);

   ($tablename, $modelalias) = &ora_fetch($csrtab);
   &write_comment(" input model is $modeluc, alias is $modelalias");

   if ($tablename ne '') 
   {
      print "<A HREF=\"#product_data\">";
      print "<I>(down to product specifications)</I></A><BR>\n";
   }

   if ($modelalias ne '') { $modelprt = $modelalias; }
   else { $modelprt = $modelin; }

   &ora_close($csrtab);

   &write_comment(" input model is $modelin, alias is $modelalias\n");

   $csra = &ora_open($lda, $GET_TEXT_FILENAME) || die $ora_errstr;
   $csrb = &ora_open($lda, $GET_GRAPHICS)      || die $ora_errstr;
   $csrc = &ora_open($lda, $CHECK_TEXT)        || die $ora_errstr;

   $uppermodel = $modelin;
   $uppermodel =~ tr/a-z/A-Z/;
 # print "<BR>uppercase of $modelin is $uppermodel<BR>\n";
   &ora_bind ($csra, $uppermodel);
   &ora_bind ($csrb, $uppermodel);
   &ora_bind ($csrc, $uppermodel, 'product description');

   print "<CENTER><FONT SIZE=5>\n";
   print "<P>Product Information for $modelprt <BR>\n";
   print "</FONT></CENTER>\n";

   while ( ($photo_title, $photo_caption, $photo_filename, $photo_extension,
           $photo_pagetype, $photo_usage) = &ora_fetch($csrb) )
   {
      &write_comment("$model has photo file [$photo_filename]-[$photo_extension] for page [$photo_pagetype]");
      $photo_extension =~ tr/A-Z/a-z/;
      if ($photo_extension eq 'bmp') { $photo_extension = 'jpg'; }
      $photo_filename =~ tr/a-z/A-Z/;
      $photo_filename_uc = $photo_filename;
      $photo_filename =~ tr/A-Z/a-z/;
      $photo_filename_lc = $photo_filename;

      $photo_extension_lc = '.'.$photo_extension;
      $photo_extension_uc = '.'.$photo_extension;
      $photo_extension_lc =~ tr/A-Z/a-z/; 
      $photo_extension_uc =~ tr/A-Z/a-z/; 
      
      $photo_filename_uc = $photo_filename_uc.$photo_extension_uc;
      $photo_filename_lc = $photo_filename_lc.$photo_extension_lc;
      $IMG_SRC = $docpath1."com_media/".$photo_filename_lc;
      $IMG_ALT = $docpath1."com_media/".$photo_filename_uc;
      &write_comment("Unix photo filename is [$photo_filename_lc]");
      &write_comment("Unix IMG SRC is [$IMG_SRC]");

  #   $IMG_SRC = \"$IMG_SRC\"\n";
  #   $IMG_ALT = \"$IMG_ALT\"\n";
      print "<CENTER>\n";
      print "<IMG SRC =\"$IMG_SRC\"  ALT=\"$IMG_ALT\" ALIGN=\"CENTER\">\n";
      print "</CENTER>\n";
   }
   close $csrb;
   print "<P><P>\n";

   while ( ($textno) = &ora_fetch ($csrc) )
   {
       $ntext = $textno;
 #     print "number of text files is $ntext<BR> \n";
       &write_comment("number of text files is $ntext\n");
   }
   &ora_close ($csrc);

   if ($ntext > 0 )
   {
      while (  ($text_filename, $text_extension, $text_pagetype)
         = &ora_fetch($csra) )
      {
      #  print "$model has text file [$text_filename]-[$text_extension] 
      #  for page [$text_pagetype]<BR>\n";
         $text_filename_stem = $text_filename;
         $text_filename_stem =~ s/\s/_/g;
         $text_filename_stem =~ s/-/_/g;
         $text_filename = $text_filename_stem.".html";
         $text_location = $textpath.$text_filename;
         $text_filenameA = $text_filename_stem.".htm";
         $text_locationA = $textpath.$text_filenameA;
      #  print "Unix text filename is [$text_filename]<P>\n";
     #   print "Unix location is [$text_location<BR>\n";
         $text1 = "Unix text filename is [ $text_filename ] or [ $text_filenameA]\n";
         &write_comment( $text1 );
         $text_link = $text_location;
         $text_linkA = $text_locationA;
     #   open(TEXTFILE, $text_link) || print "can't open filename $text_link<BR>\n";
         open(TEXTFILE, $text_link) || open(TEXTFILE, $text_linkA) || print "<BR>\n";

         print "</CENTER>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
      }
      close $csra;
   }

#  $unit_type = 'English';

#  $utype = $unit_type;
#  &write_path2_unitchange_link($mdl, $utype);
 
   &write_default_table ($modelin, $unit_type); n;

   &frameD_topofpage;
}
