// a simple client that runs as an independent process and exercies
// the FSA service

import org.omg.CORBA.*;

class FlexiClient {
  
  public static void main(String args[]) {
    try {
      ORB orb = ORB.init();
      // connect to the FSA admin service
      System.out.println("***Binding to FSA admin service");
      Flexi.Admin __admin = Flexi.AdminHelper.bind(orb, "FSA-Admin");
      System.out.println(__admin);
      // open a new account
      System.out.println("***Opening 1st account");
      Flexi.Account __account = __admin.openAccount("Nhoj Eod", (float)4000.22);
      System.out.println(__account);
      // get id of account
      float balance = __account.getBalance();
      System.out.println("***Balance = " + __account.getBalance());
      // submit a claim
      System.out.println("***Submitting a claim");
      Flexi.Claim __claim = __account.submitClaim(500, "27-Mar-97",
						  "Mobile Dental",
						  "Tooth extraction");
      System.out.println(__claim);
      // get status of claim
      System.out.println("***Getting claim status");
      String __status = __claim.getStatus();
      System.out.println(__status);
      // accept claim
      System.out.println("***Accepting claim");
      __claim.accept();
      // get status of claim
      System.out.println("***Getting claim status");
      __status = __claim.getStatus();
      System.out.println(__status);
      // open another account
      System.out.println("***Opening 2nd account");
      Flexi.Account __account2 = __admin.openAccount("Semaj Nworb", 300);
      System.out.println(__account2);
      // get list of accounts
      System.out.println("***Sequencing through accounts and closing");
      Flexi.Account[] __accArray = __admin.getAllAccounts();
      for (int i = 0; i < __accArray.length; i++) {
	Flexi.Account __acc = __accArray[i];
	System.out.println(__acc);
	__admin.closeAccount(__acc.getName());
      }
    }
    catch (org.omg.CORBA.SystemException e) {
      System.err.println(e);
    }
    catch (Flexi.ClaimException e) {
      System.err.println(e);
    }
  }
}
      
      
