/*
 * Account.java	
 *
 * implementation for IDL ::Flexi::Account
 * 
 */

import org.omg.CORBA.*;

/**
 * The <code>Account</code> class implements the
 * <code>::Flexi::Account</code> interface. 
 *
 * @author  Jawahar Malhotra
 * @version 1.0, 05/01/97
 * @see     Admin
 * @see     Claim
 */


public class Account extends Flexi._sk_Account {

  static int _nextId = 1;

  Account(String name, float balance) {
    _name = name;
    _balance = balance;
    _accountId = _nextId++;
  }
  
  public String getName() {
    return _name;
  }

  public float getBalance() {
    return _balance;
  }

  public int getId() {
    return _accountId;
  }

  public synchronized float deposit(float amt) {
    _balance += amt;
    return _balance;
  }
  
  public synchronized float remitPayment(float amt) {
    _balance -= amt;
    System.out.println("Remitting $ " + amt + " to " + _name + "\r\n");
    return _balance;
  };

  /**
   * Creates a new Claim object. Registers the claim object with 
   * the BOA so it can be accessed remotely. Then returns the claim object. 
   *
   */
  public Flexi.Claim submitClaim(float amount, 
			   String serviceDate,
			   String providerName,
			   String details)
  {
    Claim __clm = new Claim(this, amount, serviceDate, providerName, details);
    org.omg.CORBA.ORB.init().BOA_init().obj_is_ready(__clm);
      _current_clm = __clm;
    System.out.println("***Created a new claim: " + __clm);
    return __clm;
  };

  public Flexi.Claim getCurrentClaim()
  {
    return _current_clm;
  }

  public void clearCurrentClaim()
  {
    _current_clm = null;
  }

  int _accountId;
  String _name;
  float _balance;
  Flexi.Claim _current_clm;
}
  
  
