/*
 * Admin.java	
 *
 * implementation for IDL ::Flexi::Admin
 * 
 */

import org.omg.CORBA.*;

/**
 * The <code>Admin</code> class implements the 
 * <code>::Flexi::Admin</code> interface. 
 *
 * @author  Jawahar Malhotra
 * @version 1.0, 05/01/97
 * @see     Account
 * @see     Claim
 */

public class Admin extends Flexi._sk_Admin {

  Admin(String name) {
    super(name);
    _name = name;
    _accounts = new java.util.Hashtable();
  }

  /**
   * Creates a new Account object. Registers the account object with 
   * the BOA so it can be accessed remotely. Then returns the claim object. 
   *
   */
  public Flexi.Account openAccount(String name, float balance) {
    Account __account = new Account(name, balance);
    org.omg.CORBA.ORB.init().BOA_init().obj_is_ready(__account);
    _accounts.put(name, __account);
    System.out.println("Created a new account: " + __account);
    return __account;
  }

  /**
   * Looks up an account object given the employee's name.
   */
  public Flexi.Account lookupAccount(String name) {
    Account __account = (Account)_accounts.get(name);
    return __account;
  }

  public void closeAccount(String name) {
    _accounts.remove(name);
  }

  /**
    * Gets a list of all the accounts that are currently open.
    */
  public Flexi.Account[] getAllAccounts() {
    Flexi.Account[] __accArray = new Flexi.Account[_accounts.size()];
    int i = 0;
    java.util.Enumeration __accEnum = _accounts.elements();
    while (__accEnum.hasMoreElements()) {
      __accArray[i++] = (Flexi.Account) __accEnum.nextElement();
    }
    return __accArray;
  }

  java.util.Hashtable _accounts;
  String _name;
}
