DROP PACKAGE cbss;
CREATE OR REPLACE PACKAGE cbss AS

--|------------------------------
--| Written June 1997
--| Barbara W. Mihalas
--| Forepoint LLC
--| Copyright 1997 Carrier Corp.
--|------------------------------

   ID                  NUMBER(10);

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;

-- basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
-- basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
-- wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
-- owihome             VARCHAR2(70)    := basehtml;

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE numTblType      IS TABLE OF number(10)
                        INDEX BY BINARY_INTEGER;


   PROCEDURE model_nav;

   PROCEDURE get_bss_offices (
             state_name          IN VARCHAR2
             );

   PROCEDURE return_bss_office (
             state_name     IN VARCHAR2,
             alt_state      IN VARCHAR2,
             bss_officeid   IN NUMBER
             );

   PROCEDURE select_office_header (
             state_name         IN VARCHAR2,
             state_fullname     IN VARCHAR2
             );

   PROCEDURE select_county_header (
             state_name         IN VARCHAR2
             );

   PROCEDURE display_bss_office_header (
             state_name         IN VARCHAR2,
             state_fullname     IN VARCHAR2,
             bss_officeid       IN NUMBER
             );

   PROCEDURE display_1_BSS_office_header (
             state_name      IN VARCHAR2
             );


   PROCEDURE format_phone (
             inphone       IN NUMBER,
             outphone     OUT VARCHAR2
             );
END cbss;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cbss IS

/*======================================================*/
   PROCEDURE model_nav IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<I>Carrier Search</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'com_ed1/index.html" TARGET="_parent">');
   htp.p('<I>Comfort At Work</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<I>Comfort At Home</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||basehtml||'cdata/model_number.html" TARGET="_parent">');
   htp.p('<I>Model Search</I></A><P>');
   htp.p('</CENTER>');

   END model_nav;
/*======================================================*/
   PROCEDURE get_bss_offices (
             state_name          IN VARCHAR2
             ) IS

   CURSOR get_alt IS
   SELECT * 
     FROM BSS1_STATE_XREF
    WHERE upper(StateOrProvince) = upper(state_name);

   CURSOR get_offices (alt_name IN VARCHAR2) IS
   SELECT * 
     FROM bss1_offices
    WHERE upper(StateOrProvince) = upper(alt_name)
    ORDER BY city;


   altrec         BSS1_STATE_XREF%ROWTYPE;


   altname        VARCHAR2(50);
   ofcrec         bss1_offices%ROWTYPE;
   irec           NUMBER(5);
   cityTbl        fieldTblType;
   officenameTbl  fieldTblType;
   officeidTbl    numTblType;
   hrefstring     VARCHAR2(120);

   noffices       number(10);

   BEGIN

   CCUTIL.chtml_header ('show offices for '||state_name);


   OPEN get_alt;
   FETCH get_alt INTO altrec;
   altname := altrec.altstateorprovince;
   CLOSE get_alt; 

   htp.p('<!-- '||noffices||' offices found for state '||altrec.altstateorprovince||'');
   htp.p(' representing input state '||altrec.stateorprovince||' -->');
   

   irec := 0;
   OPEN get_offices(altrec.altstateorprovince);
   LOOP
      FETCH get_offices INTO ofcrec;
      EXIT WHEN get_offices%NOTFOUND;
      irec := irec +1;
      cityTbl(irec) := ofcrec.city;
      officenameTbl(irec) := ofcrec.officename2;
      officeidTbl(irec)   := ofcrec.officeid;
   END LOOP;
   CLOSE get_offices;
      
   IF ( noffices = 0) THEN
      CBSS.select_office_header(state_name, altrec.stateorprovincename);
      htp.p('<UL>');
      htp.p('<P><P>');
      htp.p('<B>No offices found for the State of '||altrec.stateorprovincename||'</B><BR>');
      htp.p('</UL>');

   ELSE 
      CBSS.select_office_header(state_name, altrec.stateorprovincename);
      htp.p('<P><P>');
      htp.p('<UL>');

      FOR ir IN 1 .. irec
      LOOP
         IF(state_name = 'NORTHWEST TERRITORIES') THEN
            htp.p('state_name is '||state_name||' and alt_state is '||altname||'<BR>');
            htp.p('officeid is '||officeidTbl(ir)||'<BR>');
         ELSE
            hrefstring := 'state_name='||state_name||'&alt_state='||altname||'&bss_officeid='||officeidTbl(ir);
            CCUTIL.comment(hrefstring);
            hrefstring := REPLACE(hrefstring, ' ', '+');
            hrefstring := REPLACE(hrefstring, '-', '%2D');
            htp.p('<A TARGET="bodyText" ');
            htp.p(' HREF="'||wowhtml||'CBSS.return_bss_office?'||hrefstring||'" >');
        --  htp.p( cityTbl(ir)||', '||altname||'</A><BR>');
            htp.p( officenameTbl(ir)||'<BR>');
        --  htp.p('<P>');
         END IF;
         END LOOP;
      htp.p('</UL>');
   END IF;    

   CCUTIL.chtml_footer;

   END get_bss_offices;
/*======================================================*/
   PROCEDURE return_bss_office (
             state_name     IN VARCHAR2,
             alt_state      IN VARCHAR2,
             bss_officeid   IN NUMBER
             ) IS

   CURSOR get_state_name IS
   SELECT stateorprovincename 
     FROM bss1_state_xref
    WHERE upper(stateorprovince) = upper(state_name);

   CURSOR get_alt_state_name IS
   SELECT stateorprovince
     FROM bss1_state_xref
    WHERE upper(stateorprovince) = upper(alt_state);

   CURSOR get_office IS
   SELECT * 
     FROM bss1_offices
    WHERE officeid = bss_officeid;


   CURSOR get_area_managers (amgrid IN NUMBER) IS
   SELECT * 
     FROM bss1_area_managers
    WHERE areamanagerid = amgrid;

   CURSOR get_account_execs IS
   SELECT *
     FROM bss1_account_executives
    WHERE officeid = bss_officeid
    ORDER BY lastname;

   CURSOR get_service_managers IS
   SELECT *
     FROM bss1_TERRITORY_svc_mgers
    WHERE officeid = bss_officeid
    ORDER BY lastname;

   CURSOR get_service_acc_managers IS
   SELECT *
     FROM bss1_SERVICE_ACCOUNT_MANAGER
    WHERE officeid = bss_officeid
    ORDER BY lastname;

   state_fullname     VARCHAR2(50);

   ofcrec             bss1_offices%ROWTYPE;
   mgrrec             bss1_area_managers%ROWTYPE;   
   excrec             bss1_account_executives%ROWTYPE;   
   svcrec             bss1_TERRITORY_svc_mgers%ROWTYPE;
   svcamrec	      bss1_SERVICE_ACCOUNT_MANAGER%ROWTYPE;

   fs                 number(10) :=3;
   officephone        varchar2(30);
   officephone2       varchar2(30);
   officefax          varchar2(30);
   contacts           NUMBER(5);

   BEGIN

   CCUTIL.chtml_header('print office and contact info');

   OPEN get_state_name;
      FETCH get_state_name INTO state_fullname;
      IF get_state_name%NOTFOUND THEN
           state_fullname := state_name;
      END IF;
   CLOSE get_state_name;

   OPEN get_office;
   FETCH get_office INTO ofcrec;

   IF get_office%NOTFOUND THEN
      CBSS.display_bss_office_header(state_name, state_fullname, bss_officeid);
      htp.p('<BR>No office found for '||alt_state||' representing state '||state_fullname||'<P>');
   ELSE
      CBSS.display_bss_office_header(state_name, state_fullname, bss_officeid);
      htp.p('<UL>');
           
 --   htp.p('<B>Office: '||ofcrec.city||', '||alt_state||'</B><P>');
      htp.p(ofcrec.officename2||':<BR>');
      IF (ofcrec.address1 IS NOT NULL) THEN
         htp.p(ofcrec.address1||'<BR>');
      END IF;
      IF (ofcrec.address2 IS NOT NULL) THEN
         htp.p(ofcrec.address2||'<BR>');
      END IF;
      htp.p(ofcrec.city||', '||alt_state||'  '||ofcrec.postalcode||'<BR>');
      htp.p(ofcrec.country||'<BR>');
      htp.p('<P><P>');

      IF (ofcrec.officephonesales IS NOT NULL) THEN
         FORMAT_PHONE(FLOOR(ofcrec.officephonesales), officephone);
         htp.p('Sales Phone: '||officephone||'<BR>');
      END IF;

      IF (ofcrec.officephoneservice IS NOT NULL) THEN
         FORMAT_PHONE(FLOOR(ofcrec.officephoneservice), officephone2);
         htp.p('Service Phone: '||officephone2||'<BR>');
      END IF;

      IF (ofcrec.faxnumber IS NOT NULL) THEN
         FORMAT_PHONE(FLOOR(ofcrec.faxnumber), officefax);
         htp.p('Fax:   '||officefax||'<BR>');
      END IF;
      htp.p('<P>');

      contacts := 1;
      OPEN get_area_managers (ofcrec.am_id);
        FETCH get_area_managers INTO mgrrec;
        IF get_area_managers%NOTFOUND THEN
           contacts := contacts + 1;
        END IF;
      CLOSE get_area_managers;
      OPEN get_account_execs;
        FETCH get_account_execs INTO excrec;
        IF get_account_execs%NOTFOUND THEN
           contacts := contacts + 1;
        END IF;
      CLOSE get_account_execs;
      OPEN get_service_managers;
        FETCH get_service_managers INTO svcrec;
        IF get_service_managers%NOTFOUND THEN
           contacts := contacts +1;
        END IF;
      CLOSE get_service_managers;

      OPEN  get_service_acc_managers;
        FETCH  get_service_acc_managers INTO svcamrec;
        IF  get_service_acc_managers%NOTFOUND THEN
           contacts := contacts +1;
        END IF;
      CLOSE  get_service_acc_managers;
      
      IF contacts < 5  THEN
         htp.p('<B>Contacts:</B><P>');

         htp.p('<UL>');
         
         OPEN get_area_managers (ofcrec.am_id);
         LOOP
            FETCH get_area_managers INTO mgrrec;
            EXIT WHEN get_area_managers%NOTFOUND;
            htp.p(mgrrec.firstname||' '||mgrrec.lastname||'<BR>');
            htp.p(mgrrec.title||'<BR>');
            IF (mgrrec.emailaddress IS NOT NULL) THEN
               htp.p('<A HREF="mailto:'||mgrrec.emailaddress||'">'||mgrrec.emailaddress||'</A><BR>');
            END IF;
            htp.p('<P>');
         END LOOP;
         CLOSE get_area_managers;
        
         OPEN get_account_execs;
         LOOP
            FETCH get_account_execs INTO excrec;
            EXIT WHEN get_account_execs%NOTFOUND;
            htp.p(excrec.firstname||' '||excrec.lastname||'<BR>');
            htp.p(excrec.title||'<BR>');
            IF (excrec.emailaddress IS NOT NULL) THEN
               htp.p('<A HREF="mailto:'||excrec.emailaddress||'">'||excrec.emailaddress||'</A><BR>');
            END IF;
            htp.p('<P>');
         END LOOP;
         CLOSE get_account_execs;
        
         OPEN get_service_managers;
         LOOP
            FETCH get_service_managers INTO svcrec;
            EXIT WHEN get_service_managers%NOTFOUND;
            htp.p(svcrec.firstname||' '||svcrec.lastname||'<BR>');
            htp.p(svcrec.title||'<BR>');
            IF (svcrec.emailaddress IS NOT NULL) THEN
               htp.p('<A HREF="mailto:'||svcrec.emailaddress||'">'||svcrec.emailaddress||'</A><BR>');
            END IF;
            htp.p('<P>');
         END LOOP;
         CLOSE get_service_managers;
         
	 OPEN  get_service_acc_managers;
         LOOP
            FETCH  get_service_acc_managers INTO svcamrec;
            EXIT WHEN  get_service_acc_managers%NOTFOUND;
            htp.p(svcamrec.firstname||' '||svcamrec.lastname||'<BR>');
            htp.p(svcamrec.title||'<BR>');
            IF (svcamrec.emailaddress IS NOT NULL) THEN
               htp.p('<A HREF="mailto:'||svcamrec.emailaddress||'">'||svcamrec.emailaddress||'</A><BR>');
            END IF;
            htp.p('<P>');
         END LOOP;
         CLOSE  get_service_acc_managers;
         htp.p('</UL>');

      END IF;

      htp.p('<P><P>');
      htp.p('</UL>');
   END IF;
   CLOSE get_office;
           
   CCUTIL.chtml_footer;
   
   END return_bss_office;
/*======================================================*/
   PROCEDURE select_office_header (
             state_name      IN VARCHAR2,
             state_fullname  IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; Select region

   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_bss.html#usandcanada">');
-- htp.p('<IMG SRC="'||owihome||'com_media/com_back_button.gif" BORDER=0 VALIGN="TOP">');
   htp.p('<FONT SIZE=3>back <I>to North America Sales & Service Office map</I></FONT></A>');
   htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales & Service Offices<BR>');
   htp.p('</FONT>');
   htp.p('<P>');

   htp.p('<UL>');
   htp.p('<FONT SIZE 4>');
   htp.p('<B>Select an Office serving '||state_fullname||'</B><P>');
   htp.p('</FONT>');
   htp.p('</UL>');

   END select_office_header;
/*======================================================*/
   PROCEDURE select_county_header (
             state_name      IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; Select county
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_dlr.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   htp.p('<UL>');
   htp.p('<FONT SIZE 4>');
   htp.p('<B>Select the appropriate county for '||state_name||'</B><P>');
   htp.p('</FONT>');
   htp.p('</UL>');

   END select_county_header;
/*======================================================*/
   PROCEDURE display_bss_office_header (
             state_name      IN VARCHAR2,
             state_fullname  IN VARCHAR2,
             bss_officeid    IN NUMBER
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; 
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_bss.html#usandcanada">');
   htp.p('<FONT SIZE=3>back <I> to North America Sales & Service Office map</I></FONT></A>');
   htp.p('<P><P>');
   
   htp.p('<A HREF="'||wowhtml||'CBSS.get_bss_offices?state_name='||state_name||'">');
   htp.p('<FONT SIZE=3>back <I>to Sales & Service Offices serving '||state_fullname||'</I></FONT></A>');
   htp.p('<P><P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales & Service Offices<BR>');
   htp.p('</FONT>');

   END display_BSS_office_header;
/*======================================================*/
   PROCEDURE display_1_BSS_office_header (
             state_name      IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; 
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_bss.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');
   
-- htp.p('<A HREF="'||wowhtml||'CBSS.get_bss_regions?state_name='||state_name||'">');
-- htp.p('<FONT SIZE=2>back to Sales Offices in '||state_name||'</FONT></A>');
-- htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   END display_1_BSS_office_header;
/*======================================================*/
   PROCEDURE format_phone (
             inphone       IN NUMBER,
             outphone     OUT VARCHAR2
             )  IS

   temp         VARCHAR2(30);

   BEGIN

   temp := TO_CHAR(inphone);
   outphone := SUBSTR(temp, 1, 3) || '-' || SUBSTR(temp, 4, 3) || '-' || SUBSTR(temp, 7);
-- outphone := temp;

   END format_phone;
/*======================================================*/
END cbss;
/
show errors;
/
