DROP PACKAGE cmodfld;
CREATE OR REPLACE PACKAGE cmodfld AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;

-- basehtml            VARCHAR2(60)    := 'http://www.carrier.com/';
-- basewow             VARCHAR2(60)    := 'http://wwwd.carrier.com:6399/';
-- wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/interface/';
-- owihome             VARCHAR2(70)    := basehtml||'wp/';
-- widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE numTblType      IS TABLE OF number(10)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE load_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_all_models;

   PROCEDURE list_fields (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             );
 
   PROCEDURE load_generic_fields (
             modelno IN VARCHAR2
             );

   PROCEDURE redisplay_models (
             modelno IN VARCHAR2
             );

   PROCEDURE model_nav;

END cmodfld;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cmodfld IS

/*======================================================*/
   PROCEDURE load_models (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');
   htmlmo     :=  REPLACE(htmlmo, '-', '%2D');

   CCUTIL.chtml_header_frame('load models');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CMODFLD.list_models?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_model_page?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    CCUTIL.chtml_footer;

   END load_models;
/*======================================================*/
   PROCEDURE list_models (
             modelno     IN VARCHAR2
             ) IS
             
   gn_type           VARCHAR2(50);
   sp_type           VARCHAR2(50);

--| NB this used to be carrier_products%ROWTYPE
   fieldrec          commercial_products%ROWTYPE;

   modelnum          fieldTblType;
   modelcount        number(10);
   modelin           VARCHAR2(50);
   modelout          VARCHAR2(50);
   i                 NUMBER(10);
   imax              NUMBER(10);
   j                 NUMBER(10);

   htmlmod           VARCHAR2(50);

--| NB this used to be from carrier_products
   CURSOR get_types (model_name IN VARCHAR2) IS
   SELECT generaltype, specifictype, model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   CURSOR get_model (model_name IN VARCHAR2) IS
   SELECT model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   BEGIN

   CCUTIL.chtml_header ('cmodfld  list_fields');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_comfort_atwork;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   modelin := '%'||upper(modelno)||'%';   

   htp.p('<CENTER>');
   i := 0;
   OPEN get_model (modelin);
   LOOP
      i := i +1;
      FETCH get_model INTO modelnum(i);
      EXIT WHEN (get_model%NOTFOUND);
      imax := i;
   END LOOP;
   CLOSE get_model;

   IF (imax =1) THEN
      modelin := modelnum(1);
      modelin := LTRIM( RTRIM(modelin) );
      htp.p('modelin is '||modelin||' just before call to list_fields<P>');
      CMODFLD.list_fields(modelin);
   ELSIF ( imax > 1) THEN
      FOR j IN 1 .. imax
      LOOP
         modelin := modelnum(j);
         OPEN get_types (modelin);
         LOOP
            FETCH get_types INTO gn_type, sp_type, modelout;
            EXIT WHEN get_types%ROWCOUNT =1;
            EXIT WHEN get_types%NOTFOUND;
         END LOOP;
         htmlmod := REPLACE(modelout, ' ', '+');
         htmlmod := REPLACE(htmlmod, '-', '%2D');
         htp.p('<P><FONT SIZE=2>'||gn_type||': '||sp_type||'</FONT><BR>'); 
         htp.p('<CENTER><FONT SIZE=2>');
         htp.p('<A  TARGET="_parent"
           HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmod||'">'||modelout||'</A>');
         htp.p('</FONT></CENTER><BR>'); 
         CLOSE get_types;
      END LOOP;
   END IF;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;
   
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        htp.p('No data found in new list_models procedure<BR>');
   END list_models;
/*======================================================*/
   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   pdtablename          VARCHAR2(30);
   htmlgen              VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_model_info IS
   SELECT generaltype, specifictype, datatablename
     FROM commercial_products
    WHERE upper(model) = upper(modelno); 

   CURSOR get_fields IS
   SELECT * FROM  field_properties;
   
   BEGIN

   CCUTIL.chtml_header;

   OPEN get_model_info;
   LOOP
      FETCH get_model_info INTO gen_type, sp_type, pdtablename;
      EXIT WHEN get_model_info%ROWCOUNT =1;
      EXIT WHEN get_model_info%NOTFOUND;
   END LOOP;
   htmlgen := REPLACE(gen_type, ' ', '+'); 
   htmlgen := REPLACE(htmlgen, '-', '%2D'); 

   htp.p('<P><BR>');

   CMODFLD.model_nav;
 
   htp.p('<HR><BR>');

   htp.p('<FORM METHOD="POST" TARGET="bodyText"
   ACTION="'||basehtml||'cgi-bin/cdata/cs_general.sh">');
   htp.p('<INPUT TYPE="HIDDEN" NAME="modelno" VALUE="'||modelno||'">');
   htp.p('<SELECT NAME="fieldset" SIZE="5" MULTIPLE>');
   open get_fields;
   loop
      fetch get_fields into fld_rec;
      EXIT WHEN get_fields%NOTFOUND;
      htp.p('<OPTION VALUE="'||fld_rec.fieldname||'">'||fld_rec.fielddisplayname||'');
      htp.p('<P>');
   END LOOP;
   close get_fields;
   htp.p('</SELECT><BR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Show Model Information">');
   htp.p('</FORM>');

   htp.p('<HR><BR>');
   CMODFLD.redisplay_models (modelno);

   htp.p('<HR><BR>');

-- gen_hot_links;

   htp.p('<P>');

   CCUTIL.gen_resource_buttons;

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for field '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
   END list_generic_fields;
/*======================================================*/
   PROCEDURE list_all_models IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

     CURSOR get_commercial_models IS
     SELECT model, specifictype 
       FROM commercial_products
      WHERE division in ('CAES', 'CMUS')
   ORDER BY model; 

     CURSOR get_roomair_models IS
     SELECT model, specifictype
       FROM residential_products
      WHERE division='RAC'
   ORDER BY model;

     CURSOR get_residential_models IS
     SELECT model, specifictype
       FROM residential_products
      WHERE division='RES'
   ORDER BY model;

   BEGIN

   CCUTIL.chtml_header('Model Page');

   htp.p('<P><BR><P>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>Carrier Cooling and Heating Models</FONT>');
 
   htp.p('<P><BR><P>');

   htp.p('<FONT SIZE=4>Commercial Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ACTION="CMODFLD.list_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_commercial_models;
   LOOP
      FETCH get_commercial_models INTO c_model, specific_type;
      EXIT WHEN get_commercial_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||c_model||'"><FONT SIZE=4> '||c_model||'</FONT> ('||specific_type||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Room Air Conditioning Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ACTION="CMODFLD.list_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_roomair_models;
   LOOP
      FETCH get_roomair_models INTO rac_model, capacity;
      EXIT WHEN get_roomair_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||rac_model||'"><FONT SIZE=4> '||rac_model||'</FONT> ('||capacity||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Residential Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ACTION="CMODFLD.list_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_residential_models;
   LOOP
      FETCH get_residential_models INTO res_model, specific_type;
      EXIT WHEN get_residential_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||res_model||'"><FONT SIZE=4> '||res_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_residential_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');
   htp.p('</CENTER>');


   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_all_models;
/*======================================================*/
   PROCEDURE list_fields (
             modelno     IN VARCHAR2
             ) IS

   modelnum          VARCHAR2(50);
   modelin           VARCHAR2(50);
   pdtablename       VARCHAR2(30);

   CURSOR get_model IS
   SELECT model, datatablename 
     FROM commercial_products
    WHERE upper(model) =  upper(modelno);

   BEGIN

      CMODFLD.load_generic_fields (modelnum);

   END list_fields;
/*======================================================*/
   PROCEDURE load_generic_fields (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');

   htp.p('<HTML>'); 
   htp.p('<HEAD>');
   htp.p('<TITLE>Welcome to Carrier Corporation</TITLE>');
   htp.p('</HEAD>');

   CCUTIL.load_carrier_search_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CMODFLD.list_generic_fields?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_fieldpage?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('</BODY>');


   END load_generic_fields;
/*======================================================*/
   PROCEDURE redisplay_models (
             modelno           IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   htmlgeneral          VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_gentype IS
   SELECT generaltype, specifictype
   FROM   commercial_products
   WHERE  upper(model) = upper(modelno);
   
   CURSOR get_models (general_type IN VARCHAR2, 
                     specific_type IN VARCHAR2) IS
   SELECT model
   FROM   commercial_products
   WHERE  generaltype = general_type AND specifictype = specific_type;

   BEGIN

   OPEN get_gentype;
   LOOP
      FETCH get_gentype into gen_type, sp_type;
      EXIT WHEN get_gentype%ROWCOUNT =1;
      EXIT WHEN get_gentype%NOTFOUND;
   END LOOP;
   CLOSE get_gentype;

   htp.p('<P><P>');
   htp.p('<CENTER><I>'||gen_type||'-'||sp_type||'<BR> Models</I></CENTER><P>');

   htp.p('<CENTER>');
   OPEN get_models (gen_type, sp_type);
   LOOP
      FETCH get_models INTO modelnum;
      EXIT WHEN get_models%NOTFOUND;

      htmlmodelno := REPLACE (modelnum, ' ', '+');
      htp.p('<A TARGET="_parent"
         HREF="'||wowhtml||'CMODFLD.list_fields?modelno='||htmlmodelno||'">');
      htp.p(''||modelnum||'</A><BR>');
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

-- htp.p('<HR><BR>');
           
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
   END redisplay_models;
/*======================================================*/
   PROCEDURE model_nav IS

   BEGIN

   htp.p('<CENTER>');
   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<I>Carrier Search</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'com_ed1/index.html" TARGET="_parent">');
   htp.p('<I>Comfort At Work</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<I>Comfort At Home</I></A><P>');

   htp.p('<I>Up to</I><BR>');
   htp.p('<A HREF="'||basehtml||'cdata/model_number.html" TARGET="_parent">');
   htp.p('<I>Model Search</I></A><P>');
   htp.p('</CENTER>');

   END model_nav;
/*======================================================*/
END cmodfld;
/
show errors;
/
