DROP PACKAGE cpdocs;
CREATE OR REPLACE PACKAGE cpdocs AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;

-- basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
-- basewow             VARCHAR2(60)    := 'http://mindy.infomall.org/';
-- wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
-- owihome             VARCHAR2(70)    := basehtml||'wp/';
-- widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE textTblType     IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE write_gen_types_B;

   PROCEDURE write_gen_types_I;

END cpdocs;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cpdocs IS

/*======================================================*/
   PROCEDURE write_gen_types_I IS

   general_type            VARCHAR2(50);
   htmlgeneral             VARCHAR2(50);
   hgen                    VARCHAR2(50);
   stype                   VARCHAR2(50);
   hsp                     VARCHAR2(50);
   igen                    NUMBER(10);
   isgen                   NUMBER(10);

   gentypetab               textTblType;

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_gtypes IS
   SELECT distinct generaltype
     FROM commercial_products
    WHERE obsolete =0;

   CURSOR get_stypes (gentype IN VARCHAR2) IS
   SELECT  distinct specifictype
     FROM commercial_products
    WHERE generaltype = gentype
      AND obsolete=0;

   BEGIN

   CCUTIL.chtml_header('get gen types B');

--|DOC back to caw homepage header
   CCUTIL.caw_frameD_back_header;

   htp.p('<P><P>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>Comfort at Work Products</FONT>');
   htp.p('</CENTER><P>');
   
   htp.p('<UL>');
   igen := 0;
   OPEN get_gtypes;
   LOOP
      igen := igen +1;
      FETCH get_gtypes INTO  general_type;
      EXIT WHEN get_gtypes%NOTFOUND;
      gentypetab(igen) := upper(general_type);  
      htp.p('<P><I>'||gentypetab(igen)||'</I><BR>');
      hgen := REPLACE (general_type, ' ', '+');
      hgen := REPLACE (hgen, '-', '%2D');
      htp.p('<UL>');
      OPEN get_stypes(general_type);
      LOOP
         FETCH get_stypes INTO stype;
         EXIT  when get_stypes%NOTFOUND;
         hsp  := REPLACE (stype, ' ', '+');
         hsp  := REPLACE (hsp, '-', '%2D');
         htp.p('<A  TARGET="_parent" 
          HREF="'||wowhtml||'CPUT.llm?spec_type='||hgen||'$'||hsp||'">');
         htp.p(''||stype||'</A><BR>');
      END LOOP; 
      CLOSE get_stypes;
      htp.p('</UL>');
   END LOOP;
   CLOSE get_gtypes;
   htp.p('</UL>');

   CCUTIL.frameD_topofpage;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||general_type||'');
         CCUTIL.chtml_footer;
   END write_gen_types_I;
/*======================================================*/
   PROCEDURE write_gen_types_B IS

   general_type            VARCHAR2(50);
   gentype_uc              VARCHAR2(50);
   htmlgeneral             VARCHAR2(50);
   hgen                    VARCHAR2(50);
   stype                   VARCHAR2(50);
   hsp                     VARCHAR2(50);
   igen                    NUMBER(10);
   isgen                   NUMBER(10);
   ix                      NUMBER(10);
   numgtypes               NUMBER(10);

   gentypetab               textTblType;

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_gtypes IS
   SELECT distinct generaltype
     FROM commercial_products
    WHERE obsolete =0;

   CURSOR get_stypes (gentype IN VARCHAR2) IS
   SELECT  distinct specifictype
     FROM commercial_products
    WHERE upper(generaltype) = gentype
      AND obsolete=0;

   BEGIN

   CCUTIL.chtml_header('get gen types B');

--|DOC back to caw homepage header
   CCUTIL.caw_frameD_back_header;

   htp.p('<P><P>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>Comfort at Work Products</FONT>');
   htp.p('</CENTER><P>');
   
   htp.p('<UL>');
   igen := 0;
   OPEN get_gtypes;
-- htp.p('<TABLE BORDER=0>');
   LOOP
      igen := igen +1;
      FETCH get_gtypes INTO  general_type;
      EXIT WHEN get_gtypes%NOTFOUND;
      gentypetab(igen) := general_type;  
      htp.p('<A HREF="#'||gentypetab(igen)||'">');
      htp.p('<FONT SIZE=3 FACE="Ariel"><I>'||gentypetab(igen)||'</I></FONT></A><BR>');
      numgtypes := igen;
      IF MOD(igen, 7) = 0 THEN
         FOR ix in 1 .. igen
         LOOP
            htp.p('</UL>');
         END LOOP;
      END IF;
      htp.p('<UL>');
   END LOOP;
   CLOSE get_gtypes;
   htp.p('</UL>');

-- FOR ix in 1 .. 7
-- LOOP
--    htp.p('</UL>');
-- END LOOP;

   htp.p('<P><HR><P>');

   htp.p('<TABLE BORDER=0>');
   FOR igen IN 1 .. numgtypes
   LOOP 
      general_type := gentypetab(igen);
      gentype_uc := UPPER(general_type);
      htp.p('<TR><TD>');
      htp.p('<A NAME="'||gentypetab(igen)||'"></A>');
      htp.p('<I>'||gentype_uc||'</I><BR>');
      hgen := REPLACE (general_type, ' ', '+');
      hgen := REPLACE (hgen, '-', '%2D');
      htp.p('<UL>');
      OPEN get_stypes(gentype_uc);
      LOOP
         FETCH get_stypes INTO stype;
         EXIT  when get_stypes%NOTFOUND;
         hsp  := REPLACE (stype, ' ', '+');
         hsp  := REPLACE (hsp, '-', '%2D');
         htp.p('<A  TARGET="_parent" 
          HREF="'||wowhtml||'CPUT.llm?spec_type='||hgen||'$'||hsp||'">');
         htp.p(''||stype||'</A><BR>');
      END LOOP; 
      CLOSE get_stypes;
      htp.p('</UL>');
      htp.p('</TD>');
      htp.p('<TD VALIGN="TOP"><A HREF="#pagetop"><I>top of page</I></A></TD>');
      htp.p('</TR>');

   END LOOP;
   htp.p('</TABLE>');

   CCUTIL.frameD_topofpage;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||general_type||'');
         CCUTIL.chtml_footer;
   END write_gen_types_B;
/*======================================================*/
END cpdocs;
/
show errors;
/
