DROP PACKAGE csearch;
CREATE OR REPLACE PACKAGE csearch AS

/* **********************************************
copied from backup directory in production 11aug98 
and revised for staging
************************************************/

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE load_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_all_models;

   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             );
 
   PROCEDURE load_generic_fields (
             modelno IN VARCHAR2
             );

   PROCEDURE redisplay_models (
             modelno IN VARCHAR2
             );

   PROCEDURE list_all_models1;

   PROCEDURE cs_res_productpage (
             modelno  IN VARCHAR2
             );

   PROCEDURE load_cs_models (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             );

   PROCEDURE cs_cframe (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             );

   PROCEDURE model_cs_page_frameC (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             );

END csearch;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY csearch IS

/*======================================================*/
   PROCEDURE load_models (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');
   htmlmo     :=  REPLACE(htmlmo, '-', '%2D');

   CCUTIL.chtml_header_frame('load models');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CCUTIL.list_models?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_model_page?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    CCUTIL.chtml_footer;

   END load_models;
/*======================================================*/
   PROCEDURE list_models (
             modelno     IN VARCHAR2
             ) IS
             
   gn_type           VARCHAR2(50);
   sp_type           VARCHAR2(50);

--| NB this used to be carrier_products%ROWTYPE
   fieldrec          commercial_products%ROWTYPE;

   modelnum          fieldTblType;
   modelcount        number(10);
   modelin           VARCHAR2(50);
   modelout          VARCHAR2(50);
   i                 NUMBER(10);
   imax              NUMBER(10);
   j                 NUMBER(10);
   unittype          VARCHAR2(10) := 'English';

   htmlmod           VARCHAR2(50);

--| NB this used to be from carrier_products
   CURSOR get_types (model_name IN VARCHAR2) IS
   SELECT generaltype, specifictype, model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   CURSOR get_model (model_name IN VARCHAR2) IS
   SELECT model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   BEGIN

   CCUTIL.chtml_header ('csearch  load generic fields');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_comfort_atwork;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   modelin := '%'||upper(modelno)||'%';   

   htp.p('<CENTER>');
   i := 0;
   OPEN get_model (modelin);
   LOOP
      i := i +1;
      FETCH get_model INTO modelnum(i);
      EXIT WHEN (get_model%NOTFOUND);
      imax := i;
   END LOOP;
   CLOSE get_model;

   IF (imax =1) THEN
      modelin := modelnum(1);
      modelin := LTRIM( RTRIM(modelin) );
      htp.p('modelin is '||modelin||' just before call to load_generic_fields<P>');
      CSEARCH.load_generic_fields(modelin);
   ELSIF ( imax > 1) THEN
      FOR j IN 1 .. imax
      LOOP
         modelin := modelnum(j);
         OPEN get_types (modelin);
         LOOP
            FETCH get_types INTO gn_type, sp_type, modelout;
            EXIT WHEN get_types%ROWCOUNT =1;
            EXIT WHEN get_types%NOTFOUND;
         END LOOP;
         htmlmod := REPLACE(modelout, ' ', '+');
         htmlmod := REPLACE(htmlmod, '-', '%2D');
         htp.p('<P><FONT SIZE=2>'||gn_type||': '||sp_type||'</FONT><BR>'); 
         htp.p('<CENTER><FONT SIZE=2>');
         htp.p('<A  TARGET="_parent"
           HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmod||'');
         htp.p('&unittype='||unittype||'">'||modelout||'</A>');
         htp.p('</FONT></CENTER><BR>'); 
         CLOSE get_types;
      END LOOP;
   END IF;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;
   
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        htp.p('No data found in new list_models procedure<BR>');
   END list_models;
/*======================================================*/
   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   pdtablename          VARCHAR2(30);
   htmlgen              VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_model_info IS
   SELECT generaltype, specifictype, datatablename
     FROM commercial_products
    WHERE upper(model) = upper(modelno); 

   CURSOR get_fields IS
   SELECT * FROM  field_properties
    WHERE displayfield =1
      AND (units=1 OR units=0);
   
   BEGIN

   CCUTIL.chtml_header;

   OPEN get_model_info;
   LOOP
      FETCH get_model_info INTO gen_type, sp_type, pdtablename;
      EXIT WHEN get_model_info%ROWCOUNT =1;
      EXIT WHEN get_model_info%NOTFOUND;
   END LOOP;
   htmlgen := REPLACE(gen_type, ' ', '+'); 
   htmlgen := REPLACE(htmlgen, '-', '%2D'); 

 
   htp.p('<HR><BR>');

   htp.p('<FORM METHOD="POST" TARGET="bodyText"
   ACTION="'||basehtml||'cgi-bin/cdata/cs_general.sh">');
   htp.p('<INPUT TYPE="HIDDEN" NAME="modelno" VALUE="'||modelno||'">');
   htp.p('<SELECT NAME="fieldset" SIZE="5" MULTIPLE>');
   open get_fields;
   loop
      fetch get_fields into fld_rec;
      EXIT WHEN get_fields%NOTFOUND;
      htp.p('<OPTION VALUE="'||fld_rec.fieldname||'">'||fld_rec.fielddisplayname||'');
      htp.p('<P>');
   END LOOP;
   close get_fields;
   htp.p('</SELECT><BR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Show Model Information">');
   htp.p('</FORM>');

   htp.p('<HR><BR>');
   CSEARCH.redisplay_models (modelno);

   htp.p('<HR><BR>');

   htp.p('<P>');

   CCUTIL.gen_resource_buttons;

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for field '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
   END list_generic_fields;
/*======================================================*/
   PROCEDURE list_all_models IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

     CURSOR get_commercial_models IS
     SELECT model, specifictype 
       FROM commercial_products
      WHERE division in ('CAES', 'CMUS')
        AND obsolete = 0
   ORDER BY model; 

     CURSOR get_roomair_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE division='RAC'
        AND obsolete = 0
   ORDER BY model;

     CURSOR get_residential_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE division='RES'
        AND obsolete = 0
   ORDER BY model;

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<TITLE>Carrier Search Model Number</TITLE>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF BACKGROUND="'||owihome||'nao_bg/nao_shd1_bg1_v1.jpg">');
   htp.p('<A HREF="'||owihome||'nao_media/search_header_back_button.gif" ');
   htp.p(' ALIGN=MIDDLE WIDTH=420 HEIGHT=32 BORDER=0 HSPACE=12 VSPACE=6></A>');

   htp.p('<P><BR><P>');
   htp.p('<CENTER>');
   htp.p('<H2><I>Product Search by</I> Model Number</H2>');
   htp.p('<A NAME="pagetop"></A>');
 
   htp.p('<P><BR><P>');

   htp.p('<FONT SIZE=4>Commercial Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p(' ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_commercial_models;
   LOOP
      FETCH get_commercial_models INTO c_model, specific_type;
      EXIT WHEN get_commercial_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||c_model||'"><FONT SIZE=4> '||c_model||'</FONT> ('||specific_type||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Room Air Conditioning Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_roomair_models;
   LOOP
      FETCH get_roomair_models INTO rac_model, capacity;
      EXIT WHEN get_roomair_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||rac_model||'"><FONT SIZE=4> '||rac_model||'</FONT> ('||capacity||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Residential Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p(' ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_residential_models;
   LOOP
      FETCH get_residential_models INTO res_model, specific_type;
      EXIT WHEN get_residential_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||res_model||'"><FONT SIZE=4> '||res_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_residential_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');
   htp.p('</CENTER>');


   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_all_models;
/*======================================================*/
   PROCEDURE load_generic_fields (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');

   htp.p('<HTML>'); 
   htp.p('<HEAD>');
   htp.p('<TITLE>Welcome to Carrier Corporation</TITLE>');
   htp.p('</HEAD>');

   CCUTIL.load_carrier_search_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CCUTIL.list_generic_fields?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_fieldpage?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('</BODY>');


   END load_generic_fields;
/*======================================================*/
   PROCEDURE redisplay_models (
             modelno           IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   htmlgeneral          VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_gentype IS
   SELECT generaltype, specifictype
   FROM   commercial_products
   WHERE  upper(model) = upper(modelno);
   
   CURSOR get_models (general_type IN VARCHAR2, 
                     specific_type IN VARCHAR2) IS
   SELECT model
   FROM   commercial_products
   WHERE  generaltype = general_type 
     AND specifictype = specific_type
     AND TO_NUMBER(obsolete) = 0;

   BEGIN

   OPEN get_gentype;
   LOOP
      FETCH get_gentype into gen_type, sp_type;
      EXIT WHEN get_gentype%ROWCOUNT =1;
      EXIT WHEN get_gentype%NOTFOUND;
   END LOOP;
   CLOSE get_gentype;

   htp.p('<P><P>');
   htp.p('<CENTER><I>'||gen_type||'-'||sp_type||'<BR> Models</I></CENTER><P>');

   htp.p('<CENTER>');
   OPEN get_models (gen_type, sp_type);
   LOOP
      FETCH get_models INTO modelnum;
      EXIT WHEN get_models%NOTFOUND;

      htmlmodelno := REPLACE (modelnum, ' ', '+');
      htp.p('<A TARGET="_parent"
         HREF="'||wowhtml||'CCUTIL.load_generic_fields?modelno='||htmlmodelno||'">');
      htp.p(''||modelnum||'</A><BR>');
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

-- htp.p('<HR><BR>');
           
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
   END redisplay_models;
/*======================================================*/
   PROCEDURE list_all_models1 IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

     CURSOR get_commercial_models IS
     SELECT model, specifictype 
       FROM commercial_products
      WHERE obsolete = 0
   ORDER BY  model; 

     CURSOR get_roomair_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE upper(division) = 'RAC'
   ORDER BY  model;

     CURSOR get_residential_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE obsolete = 0
      ORDER BY  model;

   specifictype_alias        VARCHAR2(20);

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<TITLE>Carrier Search Model Number</TITLE>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF BACKGROUND="'||owihome||'nao_bg/nao_shd1_bg1_v1.jpg">');
   htp.p('<A HREF="'||owihome||'nao_media/search_header_back_button.gif" ');
   htp.p(' ALIGN=MIDDLE WIDTH=420 HEIGHT=32 BORDER=0 HSPACE=12 VSPACE=6></A>');

   htp.p('<P><BR><P>');
   htp.p('<CENTER>');
   htp.p('<H2><I>Product Search by</I> Model Number</H2>');
   htp.p('</CENTER>');
   htp.p('<A NAME="pagetop"></A>');

 
-- htp.p('<HR><BR>');

   htp.p('<FORM TARGET="bodyText" METHOD="POST" ACTION="'||wowhtml||'CSEARCH.cs_res_productpage">');
   htp.p(' <FONT SIZE=2><B>RESIDENTIAL MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
-- htp.p('<FONT SIZE=4>Residential Model Numbers</FONT>');
-- htp.p('<FONT SIZE=3>(with Specific Type)</FONT><BR>');
   htp.p('<SELECT NAME="modelno"  WIDTH=40% SIZE="7">');
   OPEN get_residential_models;
   LOOP
      FETCH get_residential_models INTO res_model, specific_type;
      EXIT WHEN get_residential_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||res_model||'"><FONT SIZE=4> '||res_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_residential_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');
-- htp.p('</CENTER>');


   htp.p('<FORM TARGET="bodyText" METHOD="POST" ');
   htp.p('ACTION="'||basewow||'cgi-bin/cdata/write_com_fieldpage_roomair.sh">');
-- htp.p('<FONT SIZE=4>Room Air Conditioning Model Numbers</FONT>');
-- htp.p('<FONT SIZE=3>(with Capacity)</FONT><BR>');
   htp.p('<FONT SIZE=2><B>ROOM AIR CONDITIONING MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
   htp.p('<SELECT NAME="modelno" WIDTH=40% SIZE="7">');
   OPEN get_roomair_models;
   LOOP
      FETCH get_roomair_models INTO rac_model, specific_type;
      EXIT WHEN get_roomair_models%NOTFOUND;
      specifictype_alias := '';
      IF (specific_type = 'CO') THEN
         specifictype_alias := 'Cool Only';
      ELSIF (specific_type = 'HC') THEN
         specifictype_alias := 'Heat/Cool';
      ELSIF (specific_type = 'HP') THEN
         specifictype_alias := 'Heat Pump';
      END IF;

      htp.p('<OPTION VALUE="'||rac_model||'"><FONT SIZE=4> '||rac_model||'</FONT> 
        ('||specifictype_alias||')');
   END LOOP;
   CLOSE get_roomair_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');


   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p('ACTION="'||wowhtml||'CSEARCH.load_cs_models">');
   htp.p('<FONT SIZE=2><B>COMMERCIAL MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
   htp.p('<SELECT NAME="modelno" WIDTH=40% SIZE="7">');
   OPEN get_commercial_models;
   LOOP
      FETCH get_commercial_models INTO c_model, specific_type;
      EXIT WHEN get_commercial_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||c_model||'"><FONT SIZE=4> '||c_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_commercial_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="HIDDEN" NAME="unittype" VALUE="English">');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');


   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_all_models1;
/*======================================================*/
   PROCEDURE cs_res_productpage (
             modelno  IN VARCHAR2
             ) IS

   CURSOR get_res_gentype IS
   SELECT generaltype
     FROM residential_products_97
    WHERE upper(model) = upper(modelno)
      AND upper(division) = 'RES';

   gentype        VARCHAR2(60);

   BEGIN


   OPEN get_res_gentype;
   FETCH get_res_gentype INTO gentype;

   IF get_res_gentype%NOTFOUND  THEN
      CCUTIL.chtml_header('res product page on carrier search');
      htp.p('<BR>Product with model number '||modelno||' not found.<BR>');
      CCUTIL.chtml_footer;
   ELSE
      RESFLD.write_res_cs_dfieldpage(gentype);
   END IF;
   CLOSE get_res_gentype; 


   END cs_res_productpage;
/*======================================================*/
   PROCEDURE load_cs_models (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             ) IS

   hrefstring             VARCHAR2(70);
   htmlmodelno            VARCHAR2(70);
   welcomehtml            VARCHAR2(100);
   umodelno               VARCHAR2(40);

   BEGIN

   htmlmodelno  := REPLACE(modelno, ' ', '+');
   htmlmodelno  := REPLACE(htmlmodelno, '-', '%2D');
   htmlmodelno  := REPLACE(htmlmodelno, '/', '%2F');
   hrefstring := '?modelno='||htmlmodelno||'&unittype='||unittype;
   umodelno    :=  UPPER(modelno);
   welcomehtml :=  basehtml||'ptac/welcome/';

   CCUTIL.chtml_header_frame('load commercial path 3 model search'); 

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');

   IF umodelno = '52SE' OR umodelno = '52SQ'
   THEN
      htp.p('   <FRAME SRC="'||owihome||'nao_sh1/nao_shc1.html" 
      NAME="contentNav" SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');

      htp.p('   <FRAME SRC="'||welcomehtml||'index.html" NAME="bodyText"'); 
      htp.p('SCROLLING="no" MARGINWIDTH=16 MARGINHEIGHT=1 NORESIZE>');

   ELSE
      htp.p('<FRAME SRC="'||wowhtml||'CSEARCH.cs_cframe'||hrefstring||'"');
      htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');

      htp.p('<FRAME SRC="'||plhome||'write_com_fieldpage_cs.sh'||hrefstring||'"');
      htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
   END IF;

   htp.p('</FRAMESET>');
   htp.p('</FRAMESET>');

   htp.p('<NOFRAME>');
   htp.p('<P><BR>This is a placeholder for load_com_model_search');
   htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_cs_models;
/*======================================================*/
   PROCEDURE model_cs_page_frameC (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             ) IS

   hrefstring             VARCHAR2(70);
   htmlmodelno            VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;

   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.caw_featured_product;
-- CCUTIL.caw_featured_technology;
-- CCUTIL.caw_new_gif1;
-- CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR>');

   htmlmodelno  := REPLACE(modelno, ' ', '+');
   htmlmodelno  := REPLACE(htmlmodelno, '-', '%2D');
   htmlmodelno  := REPLACE(htmlmodelno, '/', '%2F');
   htp.p('<FONT SIZE=2>');
   IF UPPER(unittype) = 'ENGLISH' THEN
      hrefstring := '?modelno='||htmlmodelno||'&unittype=Metric';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CSEARCH.load_cs_models'||hrefstring||'">');
      htp.p(modelno||' (Metric Data)'); 
   ELSIF UPPER(unittype) = 'METRIC' THEN
      hrefstring := '?modelno='||htmlmodelno||'&unittype=English';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CSEARCH.load_cs_models'||hrefstring||'">');
      htp.p(modelno||' (English Data)'); 
   END IF;
   htp.p('</FONT>');

   htp.p('<HR>');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END model_cs_page_frameC;
/*======================================================*/
   PROCEDURE cs_cframe (
        modelno    IN varchar2,
        unittype   IN varchar2 )
        IS

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('');
   htp.p('<!--');
   htp.p('Carrier Corporation CONFIDENTIAL');
   htp.p('Copyright (C)1996,1997,1998 Carrier Corporation. ');
   htp.p('All Rights Reserved.');
   htp.p('-->');
   htp.p('');
   htp.p('');
   htp.p('<TITLE>derived from nao_shc1.html</title>');
   htp.p('');
   htp.p('</HEAD>');
   htp.p('<A NAME="pagetop"></A>');
   htp.p('');
   htp.p('<body bgcolor="#FFFFFF" ');
   htp.p('BACKGROUND="'||basehtml||'nao_bg/nao_shc1_bg1_v1.jpg">');
   htp.p('<FONT SIZE="2">');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<I>Go to<BR><B>');
   htp.p('<A HREF="'||basehtml||'nao_hm1/index.html" TARGET="_parent">');
   htp.p('   Carrier Homepage</A></B></I>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<HR WIDTH="100">');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<I>Product Search By</I>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<A HREF=');
   htp.p('"http://mindy.infomall.org:6380/cgi-bin/ifc/CSEARCH.list_all_models1" ');
   htp.p('TARGET="bodyText"><B>Model Number</B></A>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<A HREF="'||basehtml||'nao_sh2/nao_shd2.html" TARGET="bodyText">');
   htp.p('<B>Product Type</B></A>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<A HREF="'||basehtml||'com_sh1/index.html" TARGET="_parent">');
   htp.p('<B>Commercial<BR>Building Type</B></A>');
   htp.p('');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<HR WIDTH="100">');
   htp.p('<P ALIGN=CENTER>');
   htp.p('');
   htp.p('<I>Locators</I>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<B>Residential Products</B><BR>');
   htp.p('<A HREF="'||basehtml||'res_dl1/index.html" TARGET="_parent">');
   htp.p('  Find a Dealer or Store</A>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<B>Commercial Products</B><BR>');
   htp.p('<A HREF="'||basehtml||'com_dl1/index.html" TARGET="_parent">');
   htp.p('Find a Sales Office</A>');
   htp.p('');
   htp.p('');
   htp.p('<HR WIDTH="100">');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<B><A HREF="'||basehtml||'nao_sh3/nao_shd3.html" TARGET="bodyText">');
   htp.p('Full Text Search</A></B>');
   htp.p('<HR WIDTH="100">');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<IMG SRC="'||basehtml||'nao_media/three_buttons.gif" ');
   htp.p('ALT="<- Click to see navigation buttons" WIDTH="92" ');
   htp.p('HEIGHT="64" USEMAP="#buttons" BORDER="0">');
   htp.p('');
   htp.p('<MAP NAME="buttons">');
   htp.p('	<AREA SHAPE="rect" COORDS="0,0,74,18" ');
   htp.p('         HREF="'||basehtml||'nao_ht1/nao_htd1.html" TARGET="bodyText">');
   htp.p('	<AREA SHAPE="rect" COORDS="75,0,92,18" ');
   htp.p('         HREF="'||basehtml||'nao_ht1/nao_htd1.html#siteoutline2" TARGET="bodyText">');
   htp.p('	<AREA SHAPE="rect" COORDS="0,24,92,41" ');
   htp.p('         HREF="'||basehtml||'nao_ur1/nao_urd1.html" TARGET="bodyText">');
   htp.p('	<AREA SHAPE="rect" COORDS="0,47,92,64" ');
   htp.p('         HREF="'||basehtml||'nao_cc1/nao_ccd1.html" TARGET="bodyText">');
   htp.p('</MAP>');
   htp.p('');
   htp.p('<P ALIGN=CENTER>');
   htp.p('<HR WIDTH="100" ALIGN=CENTER>');
   htp.p('<P ALIGN=CENTER>');
   htp.p('');
   htp.p('Copyright &copy 1996, 1997, 1998');
   htp.p('<BR>Carrier Corporation.<BR>');
   htp.p('All Rights Reserved.</FONT>');
   htp.p('');
   htp.p('');
   htp.p('</BODY>');
   htp.p('</HTML>');
   htp.p('');

END cs_cframe;

/*======================================================*/
END csearch;
/
show errors;
/
