DROP PACKAGE csearch;
CREATE OR REPLACE PACKAGE csearch AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

/*
   basehtml            VARCHAR2(60)    := 'http://www.carrier.com/';
   basewow             VARCHAR2(60)    := 'http://wwwd.carrier.com:6399/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/interface/';
   owihome             VARCHAR2(70)    := basehtml||'wp/';
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;
*/


   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE load_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_models (
             modelno     IN VARCHAR2
             );

   PROCEDURE list_all_models;

   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             );
 
   PROCEDURE load_generic_fields (
             modelno IN VARCHAR2
             );

   PROCEDURE redisplay_models (
             modelno IN VARCHAR2
             );

   PROCEDURE list_all_models1;

   PROCEDURE cs_res_productpage (
             modelno  IN VARCHAR2
             );

   PROCEDURE load_cs_models (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             );

   PROCEDURE model_cs_page_frameC (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             );

END csearch;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY csearch IS

/*======================================================*/
   PROCEDURE load_models (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');
   htmlmo     :=  REPLACE(htmlmo, '-', '%2D');

   CCUTIL.chtml_header_frame('load models');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CCUTIL.list_models?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_model_page?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    CCUTIL.chtml_footer;

   END load_models;
/*======================================================*/
   PROCEDURE list_models (
             modelno     IN VARCHAR2
             ) IS
             
   gn_type           VARCHAR2(50);
   sp_type           VARCHAR2(50);

--| NB this used to be carrier_products%ROWTYPE
   fieldrec          commercial_products%ROWTYPE;

   modelnum          fieldTblType;
   modelcount        number(10);
   modelin           VARCHAR2(50);
   modelout          VARCHAR2(50);
   i                 NUMBER(10);
   imax              NUMBER(10);
   j                 NUMBER(10);
   unittype          VARCHAR2(10) := 'English';

   htmlmod           VARCHAR2(50);

--| NB this used to be from carrier_products
   CURSOR get_types (model_name IN VARCHAR2) IS
   SELECT generaltype, specifictype, model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   CURSOR get_model (model_name IN VARCHAR2) IS
   SELECT model
     FROM commercial_products
    WHERE upper(model) LIKE  model_name;

   BEGIN

   CCUTIL.chtml_header ('csearch  load generic fields');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_comfort_atwork;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   modelin := '%'||upper(modelno)||'%';   

   htp.p('<CENTER>');
   i := 0;
   OPEN get_model (modelin);
   LOOP
      i := i +1;
      FETCH get_model INTO modelnum(i);
      EXIT WHEN (get_model%NOTFOUND);
      imax := i;
   END LOOP;
   CLOSE get_model;

   IF (imax =1) THEN
      modelin := modelnum(1);
      modelin := LTRIM( RTRIM(modelin) );
      htp.p('modelin is '||modelin||' just before call to load_generic_fields<P>');
      CSEARCH.load_generic_fields(modelin);
   ELSIF ( imax > 1) THEN
      FOR j IN 1 .. imax
      LOOP
         modelin := modelnum(j);
         OPEN get_types (modelin);
         LOOP
            FETCH get_types INTO gn_type, sp_type, modelout;
            EXIT WHEN get_types%ROWCOUNT =1;
            EXIT WHEN get_types%NOTFOUND;
         END LOOP;
         htmlmod := REPLACE(modelout, ' ', '+');
         htmlmod := REPLACE(htmlmod, '-', '%2D');
         htp.p('<P><FONT SIZE=2>'||gn_type||': '||sp_type||'</FONT><BR>'); 
         htp.p('<CENTER><FONT SIZE=2>');
         htp.p('<A  TARGET="_parent"
           HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmod||'');
         htp.p('&unittype='||unittype||'">'||modelout||'</A>');
         htp.p('</FONT></CENTER><BR>'); 
         CLOSE get_types;
      END LOOP;
   END IF;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;
   
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        htp.p('No data found in new list_models procedure<BR>');
   END list_models;
/*======================================================*/
   PROCEDURE list_generic_fields (
             modelno IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   pdtablename          VARCHAR2(30);
   htmlgen              VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_model_info IS
   SELECT generaltype, specifictype, datatablename
     FROM commercial_products
    WHERE upper(model) = upper(modelno); 

   CURSOR get_fields IS
   SELECT * FROM  field_properties
    WHERE displayfield =1
      AND (units=1 OR units=0);
   
   BEGIN

   CCUTIL.chtml_header;

   OPEN get_model_info;
   LOOP
      FETCH get_model_info INTO gen_type, sp_type, pdtablename;
      EXIT WHEN get_model_info%ROWCOUNT =1;
      EXIT WHEN get_model_info%NOTFOUND;
   END LOOP;
   htmlgen := REPLACE(gen_type, ' ', '+'); 
   htmlgen := REPLACE(htmlgen, '-', '%2D'); 

 
   htp.p('<HR><BR>');

   htp.p('<FORM METHOD="POST" TARGET="bodyText"
   ACTION="'||basehtml||'cgi-bin/cdata/cs_general.sh">');
   htp.p('<INPUT TYPE="HIDDEN" NAME="modelno" VALUE="'||modelno||'">');
   htp.p('<SELECT NAME="fieldset" SIZE="5" MULTIPLE>');
   open get_fields;
   loop
      fetch get_fields into fld_rec;
      EXIT WHEN get_fields%NOTFOUND;
      htp.p('<OPTION VALUE="'||fld_rec.fieldname||'">'||fld_rec.fielddisplayname||'');
      htp.p('<P>');
   END LOOP;
   close get_fields;
   htp.p('</SELECT><BR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Show Model Information">');
   htp.p('</FORM>');

   htp.p('<HR><BR>');
   CSEARCH.redisplay_models (modelno);

   htp.p('<HR><BR>');

   htp.p('<P>');

   CCUTIL.gen_resource_buttons;

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for field '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||fld_rec.fieldname||'');
         CCUTIL.chtml_footer;
   END list_generic_fields;
/*======================================================*/
   PROCEDURE list_all_models IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

     CURSOR get_commercial_models IS
     SELECT model, specifictype 
       FROM commercial_products
      WHERE division in ('CAES', 'CMUS')
   ORDER BY model; 

     CURSOR get_roomair_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE division='RAC'
   ORDER BY model;

     CURSOR get_residential_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE division='RES'
   ORDER BY model;

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<TITLE>Carrier Search Model Number</TITLE>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF BACKGROUND="'||owihome||'nao_bg/nao_shd1_bg1_v1.jpg">');
   htp.p('<A HREF="'||owihome||'nao_media/search_header_back_button.gif" ');
   htp.p(' ALIGN=MIDDLE WIDTH=420 HEIGHT=32 BORDER=0 HSPACE=12 VSPACE=6></A>');

   htp.p('<P><BR><P>');
   htp.p('<CENTER>');
   htp.p('<H2><I>Product Search by</I> Model Number</H2>');
   htp.p('<A NAME="pagetop"></A>');
 
   htp.p('<P><BR><P>');

   htp.p('<FONT SIZE=4>Commercial Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p(' ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_commercial_models;
   LOOP
      FETCH get_commercial_models INTO c_model, specific_type;
      EXIT WHEN get_commercial_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||c_model||'"><FONT SIZE=4> '||c_model||'</FONT> ('||specific_type||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Room Air Conditioning Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_roomair_models;
   LOOP
      FETCH get_roomair_models INTO rac_model, capacity;
      EXIT WHEN get_roomair_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||rac_model||'"><FONT SIZE=4> '||rac_model||'</FONT> ('||capacity||')');
   END LOOP;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');

   htp.p('<HR><P>');

   htp.p('<FONT SIZE=4>Residential Model Numbers</FONT><BR>');
   htp.p('<FONT SIZE=3>(with Specific Type)</FONT><P>');
   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p(' ACTION="'||wowhtml||'CSEARCH.load_generic_fields">');
   htp.p('<SELECT NAME="modelno" SIZE="6">');
   OPEN get_residential_models;
   LOOP
      FETCH get_residential_models INTO res_model, specific_type;
      EXIT WHEN get_residential_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||res_model||'"><FONT SIZE=4> '||res_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_residential_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Field Table"></NOBR>');
   htp.p('</FORM>');
   htp.p('</CENTER>');


   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_all_models;
/*======================================================*/
   PROCEDURE load_generic_fields (
             modelno     IN VARCHAR2
             ) IS

   htmlmo           VARCHAR2(50);

   BEGIN

   htmlmo     :=  REPLACE(modelno, ' ', '+');

   htp.p('<HTML>'); 
   htp.p('<HEAD>');
   htp.p('<TITLE>Welcome to Carrier Corporation</TITLE>');
   htp.p('</HEAD>');

   CCUTIL.load_carrier_search_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CCUTIL.list_generic_fields?modelno='||htmlmo||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CMODDOCS.write_fieldpage?modelno='||htmlmo||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('</BODY>');


   END load_generic_fields;
/*======================================================*/
   PROCEDURE redisplay_models (
             modelno           IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   sp_type              VARCHAR2(50);
   htmlgeneral          VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_gentype IS
   SELECT generaltype, specifictype
   FROM   commercial_products
   WHERE  upper(model) = upper(modelno);
   
   CURSOR get_models (general_type IN VARCHAR2, 
                     specific_type IN VARCHAR2) IS
   SELECT model
   FROM   commercial_products
   WHERE  generaltype = general_type AND specifictype = specific_type;

   BEGIN

   OPEN get_gentype;
   LOOP
      FETCH get_gentype into gen_type, sp_type;
      EXIT WHEN get_gentype%ROWCOUNT =1;
      EXIT WHEN get_gentype%NOTFOUND;
   END LOOP;
   CLOSE get_gentype;

   htp.p('<P><P>');
   htp.p('<CENTER><I>'||gen_type||'-'||sp_type||'<BR> Models</I></CENTER><P>');

   htp.p('<CENTER>');
   OPEN get_models (gen_type, sp_type);
   LOOP
      FETCH get_models INTO modelnum;
      EXIT WHEN get_models%NOTFOUND;

      htmlmodelno := REPLACE (modelnum, ' ', '+');
      htp.p('<A TARGET="_parent"
         HREF="'||wowhtml||'CCUTIL.load_generic_fields?modelno='||htmlmodelno||'">');
      htp.p(''||modelnum||'</A><BR>');
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

-- htp.p('<HR><BR>');
           
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
   END redisplay_models;
/*======================================================*/
   PROCEDURE list_all_models1 IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

     CURSOR get_commercial_models IS
     SELECT model, specifictype 
       FROM commercial_products
      WHERE obsolete = 0
   ORDER BY  model; 

     CURSOR get_roomair_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE upper(division) = 'RAC'
   ORDER BY  model;

     CURSOR get_residential_models IS
     SELECT model, specifictype
       FROM residential_products_97
      WHERE obsolete = 0
      ORDER BY  model;

   specifictype_alias        VARCHAR2(20);

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<TITLE>Carrier Search Model Number</TITLE>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF BACKGROUND="'||owihome||'nao_bg/nao_shd1_bg1_v1.jpg">');
   htp.p('<A HREF="'||owihome||'nao_media/search_header_back_button.gif" ');
   htp.p(' ALIGN=MIDDLE WIDTH=420 HEIGHT=32 BORDER=0 HSPACE=12 VSPACE=6></A>');

   htp.p('<P><BR><P>');
   htp.p('<CENTER>');
   htp.p('<H2><I>Product Search by</I> Model Number</H2>');
   htp.p('</CENTER>');
   htp.p('<A NAME="pagetop"></A>');

 
-- htp.p('<HR><BR>');

   htp.p('<FORM TARGET="bodyText" METHOD="POST" ACTION="'||wowhtml||'CSEARCH.cs_res_productpage">');
   htp.p(' <FONT SIZE=2><B>RESIDENTIAL MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
-- htp.p('<FONT SIZE=4>Residential Model Numbers</FONT>');
-- htp.p('<FONT SIZE=3>(with Specific Type)</FONT><BR>');
   htp.p('<SELECT NAME="modelno"  WIDTH=40% SIZE="7">');
   OPEN get_residential_models;
   LOOP
      FETCH get_residential_models INTO res_model, specific_type;
      EXIT WHEN get_residential_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||res_model||'"><FONT SIZE=4> '||res_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_residential_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');
-- htp.p('</CENTER>');


   htp.p('<FORM TARGET="bodyText" METHOD="POST" ');
   htp.p('ACTION="'||basewow||'cgi-bin/cdata/write_com_fieldpage_roomair.sh">');
-- htp.p('<FONT SIZE=4>Room Air Conditioning Model Numbers</FONT>');
-- htp.p('<FONT SIZE=3>(with Capacity)</FONT><BR>');
   htp.p('<FONT SIZE=2><B>ROOM AIR CONDITIONING MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
   htp.p('<SELECT NAME="modelno" WIDTH=40% SIZE="7">');
   OPEN get_roomair_models;
   LOOP
      FETCH get_roomair_models INTO rac_model, specific_type;
      EXIT WHEN get_roomair_models%NOTFOUND;
      specifictype_alias := '';
      IF (specific_type = 'CO') THEN
         specifictype_alias := 'Cool Only';
      ELSIF (specific_type = 'HC') THEN
         specifictype_alias := 'Heat/Cool';
      ELSIF (specific_type = 'HP') THEN
         specifictype_alias := 'Heat Pump';
      END IF;

      htp.p('<OPTION VALUE="'||rac_model||'"><FONT SIZE=4> '||rac_model||'</FONT> 
        ('||specifictype_alias||')');
   END LOOP;
   CLOSE get_roomair_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');


   htp.p('<FORM TARGET="_parent" METHOD="POST" ');
   htp.p('ACTION="'||wowhtml||'CSEARCH.load_cs_models">');
   htp.p('<FONT SIZE=2><B>COMMERCIAL MODEL NUMBERS</B> (WITH PRODUCT TYPE)</FONT><BR>');
   htp.p('<SELECT NAME="modelno" WIDTH=40% SIZE="7">');
   OPEN get_commercial_models;
   LOOP
      FETCH get_commercial_models INTO c_model, specific_type;
      EXIT WHEN get_commercial_models%NOTFOUND;
      htp.p('<OPTION VALUE="'||c_model||'"><FONT SIZE=4> '||c_model||'</FONT> 
        ('||specific_type||')');
   END LOOP;
   CLOSE get_commercial_models;
   htp.p('</SELECT><NOBR>');
   htp.p('<INPUT TYPE="HIDDEN" NAME="unittype" VALUE="English">');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Get Info"></NOBR>');
   htp.p('</FORM>');


   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_all_models1;
/*======================================================*/
   PROCEDURE cs_res_productpage (
             modelno  IN VARCHAR2
             ) IS

   CURSOR get_res_gentype IS
   SELECT generaltype
     FROM residential_products_97
    WHERE upper(model) = upper(modelno)
      AND upper(division) = 'RES';

   gentype        VARCHAR2(60);

   BEGIN


   OPEN get_res_gentype;
   FETCH get_res_gentype INTO gentype;

   IF get_res_gentype%NOTFOUND  THEN
      CCUTIL.chtml_header('res product page on carrier search');
      htp.p('<BR>Product with model number '||modelno||' not found.<BR>');
      CCUTIL.chtml_footer;
   ELSE
      RESFLD.write_res_cs_dfieldpage(gentype);
   END IF;
   CLOSE get_res_gentype; 


   END cs_res_productpage;
/*======================================================*/
   PROCEDURE load_cs_models (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             ) IS

   hrefstring             VARCHAR2(70);
   htmlmodelno            VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header_frame('load commercial path 3 model search'); 

   CCUTIL.load_comfort_atwork_ab;

   htmlmodelno  := REPLACE(modelno, ' ', '+');
   htmlmodelno  := REPLACE(htmlmodelno, '-', '%2D');
   htmlmodelno  := REPLACE(htmlmodelno, '/', '%2F');
   hrefstring := '?modelno='||htmlmodelno||'&unittype='||unittype;

   htp.p('<FRAMESET COLS="'||widthll||',*">');

   htp.p('<FRAME SRC="'||wowhtml||'CSEARCH.model_cs_page_frameC'||hrefstring||'"');
   htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');

   htp.p('<FRAME SRC="'||plhome||'write_com_fieldpage_cs.sh'||hrefstring||'"');
   htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');

   htp.p('</FRAMESET>');
   htp.p('</FRAMESET>');

   htp.p('<NOFRAME>');
   htp.p('<P><BR>This is a placeholder for load_com_model_search');
   htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_cs_models;
/*======================================================*/
   PROCEDURE model_cs_page_frameC (
             modelno      IN VARCHAR2,
             unittype     IN VARCHAR2
             ) IS

   hrefstring             VARCHAR2(70);
   htmlmodelno            VARCHAR2(70);

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;

   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.caw_featured_product;
-- CCUTIL.caw_featured_technology;
-- CCUTIL.caw_new_gif1;
-- CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR>');

   htmlmodelno  := REPLACE(modelno, ' ', '+');
   htmlmodelno  := REPLACE(htmlmodelno, '-', '%2D');
   htmlmodelno  := REPLACE(htmlmodelno, '/', '%2F');
   htp.p('<FONT SIZE=2>');
   IF UPPER(unittype) = 'ENGLISH' THEN
      hrefstring := '?modelno='||htmlmodelno||'&unittype=Metric';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CSEARCH.load_cs_models'||hrefstring||'">');
      htp.p(modelno||' (Metric Data)'); 
   ELSIF UPPER(unittype) = 'METRIC' THEN
      hrefstring := '?modelno='||htmlmodelno||'&unittype=English';
      htp.p('<A TARGET="_parent" ');
      htp.p(' HREF="'||wowhtml||'CSEARCH.load_cs_models'||hrefstring||'">');
      htp.p(modelno||' (English Data)'); 
   END IF;
   htp.p('</FONT>');

   htp.p('<HR>');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   END model_cs_page_frameC;
/*======================================================*/
END csearch;
/
show errors;
/
