DROP PACKAGE resdlUPD;
CREATE OR REPLACE PACKAGE resdlUPD AS

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;

   basepdf             VARCHAR2(70)    := 'http://mork.infomall.org/';
   pdfhome             VARCHAR2(80)    := basepdf||'private/residential/staging_mar97/';

   PROCEDURE list_res_gentypes;

   PROCEDURE get_download_page (
             general_type       IN VARCHAR2
             );

   PROCEDURE res_pdf_page;

   PROCEDURE pdf_header_txt;

   PROCEDURE dummy_page (
             general_type       IN VARCHAR2
             );

   PROCEDURE get_password (
             pdf       IN VARCHAR2 
             );

   PROCEDURE res_pdf_table;

END resdlUPD;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY resdlUPD IS

/*======================================================*/
   PROCEDURE list_res_gentypes IS

   CURSOR res_gentypes IS
   SELECT distinct generaltype 
     FROM residential_products_97
    ORDER BY generaltype;

   gtype                  VARCHAR2(50);
   hg                     VARCHAR2(50);

   BEGIN

   CCUTIL.chtml_header('Links of Residential General Types to PDFs');

   htp.p('<H2>Links of Residential General Types to PDFs</H2>');

   OPEN res_gentypes;
   LOOP
      FETCH res_gentypes INTO gtype;
      EXIT WHEN res_gentypes%NOTFOUND;
      hg   := REPLACE(gtype,' ','+');
      hg   := REPLACE(hg,'-','%2D');
      htp.p('<LI><B>');
      htp.p('<A HREF="'||wowhtml||'RESDLUPD.get_download_page?general_type='||hg||'">');
      htp.p('Get Download File List for '||gtype||' Residential Products</A></B>');
   END LOOP;
   CLOSE res_gentypes;
   
   CCUTIL.chtml_footer;

   END list_res_gentypes;
/*======================================================*/
   PROCEDURE get_download_page (
             general_type       IN VARCHAR2
             ) IS

   CURSOR get_info ( gentype    IN VARCHAR2 ) IS
   SELECT *
     FROM residential_products_97
    WHERE upper(generaltype) = upper(gentype);

   BEGIN

--|DOC: this is the structure that will be used -- for each generaltype

   IF (upper(general_type) LIKE '%%') THEN
      RESDLUPD.dummy_page(general_type);
   END IF;

   END get_download_page;
/*======================================================*/
   PROCEDURE res_pdf_page IS

   CURSOR pdf_index IS
   SELECT *
     FROM res_index_new
    ORDER BY pdf_formno;

   pdfr             res_index_new%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Residential Product Data Digests in Adobe Acrobat');

   RESDLUPD.pdf_header_txt;

   htp.p('<P>');

   htp.p('<TABLE BORDER=3 WIDTH=100%>');
   htp.p('<TR>');
   htp.p('      <TH>PDD Form Number</TH>');
   htp.p('      <TH>RES General Product Type</TH>');
   htp.p('      <TH>PDF Number(Size in KB)<BR>(Click to download)</TH>');
   htp.p('</TR>');

   OPEN pdf_index;
   LOOP
      FETCH pdf_index INTO pdfr;
      EXIT WHEN pdf_index%NOTFOUND;
      CCUTIL.table_3col(3,
         pdfr.pdf_formno, 
         pdfr.description,
         '<A HREF="'||pdfhome||pdfr.pdf_number||'.PDF">'||pdfr.pdf_number||'.PDF</A> ('||pdfr.pdf_size_kb||' k)'); 
   END LOOP;
   CLOSE pdf_index;
   htp.p('</TABLE>');

--|RESDLUPD.dummy_page('dummy_type');

   END res_pdf_page;
/*======================================================*/
   PROCEDURE pdf_header_txt IS

   BEGIN

   htp.p('<H2>');
   htp.p('<CENTER>');
   htp.p('Residential Product Data Digests');
   htp.p('</CENTER>');
   htp.p('</H2>');
   htp.p('To download or view <B>Product Data Digests</B> you must');
   htp.p('first <A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText">register</A>');
   htp.p('with Carrier.');
   htp.p('<P>');
   htp.p('<P>');
   htp.p('<A HREF="http://www.adobe.com/acrobat/readstep.html"');
   htp.p('TARGET="EXTERNAL"><IMG SRC="'||owihome||'res_media/getacro.gif" ALIGN=MIDDLE');
   htp.p('WIDTH="88" HEIGHT="31" BORDER="0"></A>');
   htp.p('<P>The Product Data Digests listed below are in Adobe''s <B>Acrobat</B><FONT');
   htp.p('SIZE="2">&reg;</FONT> Portable Document Format (PDF). In order to view or');
   htp.p('print these files, you will need to <A TARGET=EXTERNAL ');
   htp.p('HREF="http://www.adobe.com/acrobat/readstep.html">download</A> and install');
   htp.p('the free <B>Acrobat Reader</B> or obtain one of Adobe''s commercial Acrobat');
   htp.p('<A TARGET=EXTERNAL HREF="http://www.adobe.com/acrobat/prodinfo.html">products</A>.');
   htp.p('<P>');
   htp.p('Additional publications are available on CD-ROM to');
   htp.p('qualified dealers and distributors through our<BR><A');
   htp.p('HREF="'||owihome||'res_pd4/res_pdd4.html" TARGET="bodyText">Residential On-line');
   htp.p('Literature System</A> (ROLLS).');
   htp.p('<P>');
   htp.p('<FONT SIZE="2">Acrobat and the Acrobat logo are registered');
   htp.p('trademarks of Adobe Systems Incorporated.</FONT>');

   END pdf_header_txt;
/*======================================================*/
   PROCEDURE dummy_page (
             general_type       IN VARCHAR2
             ) IS

   pdfname                 VARCHAR2(100);

   BEGIN

   CCUTIL.chtml_header('Dummy page for RES PDF downloads');

   htp.p('<CENTER>');
   htp.p('<H2>Acrobat File Information for Carrier Residential Products</H2><P>');
   htp.p('</CENTER>');

   htp.p('<UL>');
   htp.p('<FONT SIZE=4>Paragraph on registration</FONT> goes here.<P>');
   htp.p('<FONT SIZE=4>Link to registration form</FONT> goes here.<BR>');
   htp.p('<P><P>');
   
   htp.p('Description of PDF file goes here<BR>');
   pdfname      :=  'PDF1.pdf';
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF2.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF3.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF4.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF5.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF6.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF7.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF8.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   pdfname    :=  'PDF9.pdf';
   htp.p('Description of PDF file goes here<BR>');
   htp.p('<A  TARGET="bodyText"
              HREF="'||wowhtml||'RESDLUPD.get_password?pdf='||pdfname||'">');
   htp.p(''||pdfname||'</A>');
   htp.p('<P><P>');
   
   htp.p('</UL>');

   CCUTIL.chtml_footer;

   END dummy_page;
/*======================================================*/
   PROCEDURE get_password (
             pdf       IN VARCHAR2 
             ) IS

   BEGIN

   RESDLUPD.dummy_page('Boilers');     

   END get_password;
/*======================================================*/
   PROCEDURE res_pdf_table IS

   CURSOR pdf_index IS
   SELECT *
     FROM res_index_new
    ORDER BY pdf_formno;

   pdfr             res_index_new%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Residential PDF Index Table');

   htp.p('<CENTER>');
   htp.p('<H2>Residential PDF Index Table</H2>');
   htp.p('</CENTER>');

   htp.p('<TABLE BORDER=3 WIDTH=100%>');
   htp.p(' <TR> <TH>ID</TH>');
   htp.p('      <TH>PDF Publication Name</TH>');
   htp.p('      <TH>RES General Product Type</TH>');
   htp.p('      <TH>PDF Number</TH>');
   htp.p('</TR>');
   OPEN pdf_index;
   LOOP
      FETCH pdf_index INTO pdfr;
      EXIT WHEN pdf_index%NOTFOUND;
      CCUTIL.table_4col_fill(3,pdfr.record_id, pdfr.pdf_formno, pdfr.description,
                                pdfr.pdf_number); 
   END LOOP;
   CLOSE pdf_index;
   htp.p('</TABLE>');

   CCUTIL.chtml_footer;

   END res_pdf_table;
/*======================================================*/
END resdlUPD;
/
show errors;
/
