DROP PACKAGE resdocs_hc;
CREATE OR REPLACE PACKAGE resdocs_hc AS

   ID                  NUMBER(10);
   racr                rac_units_hc%ROWTYPE;

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   widthll             NUMBER(10)   := 162;
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE textTblType     IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   CURSOR get_tables (gentype IN VARCHAR2) 
       IS
   SELECT distinct datatablename
     FROM residential_products_97
    WHERE upper(generaltype) = upper(gentype);

   itab                        NUMBER(5);
   tablenametab                textTblType;

   PROCEDURE write_room_air_conditioners(
             generaltype          IN VARCHAR2);

END resdocs_hc;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY resdocs_hc IS

/*======================================================*/
   PROCEDURE write_room_air_conditioners (
             generaltype      IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   sptype               VARCHAR2(50);
   smin                 number(10);
   smax                 number(10);
   xseq                 NUMBER(10);
   mname                VARCHAR2(50);
   htmlmo               VARCHAR2(50);
   msize                VARCHAR2(20);
   cap                  VARCHAR2(20);
   modelsize            VARCHAR2(100);
   mdlid                varchar2(70);
   temp                 VARCHAR2(100);

   general_type         VARCHAR2(50);
   pagelink             VARCHAR2(20);
   pagelinkin           VARCHAR2(20);

   rprec                residential_products%ROWTYPE;

   CURSOR get_info (gentype IN VARCHAR2) IS
   SELECT distinct specifictype
     FROM residential_products_97
    WHERE upper(generaltype) = upper(gentype)
    ORDER BY specifictype;

   CURSOR get_rac_data (
          stype      IN VARCHAR2)
          IS
   SELECT * 
     FROM RAC_UNITS_HC
    WHERE specific_type = stype
     ORDER BY TO_NUMBER(xsequence), TO_NUMBER(cool_capacity);

  CURSOR get_rac_hcdata  (
          stype      IN VARCHAR2)
         IS
  SELECT *
    FROM RAC_UNITS_HC
    WHERE specific_type = stype
   ORDER BY TO_NUMBER(xsequence), TO_NUMBER(cool_capacity);

    rachcr                rac_units_hc%ROWTYPE; 

   BEGIN

   CCUTIL.chtml_header;

   IF ( generaltype LIKE '%$%') THEN
      general_type := SUBSTR(generaltype, 1, INSTR(generaltype,'$') -1);
      pagelinkin   := SUBSTR(generaltype, INSTR(generaltype,'$',1,1) +1);
   ELSE
      general_type := generaltype;
      pagelinkin   := '';
   END IF;

   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif" 
        ALIGN=MIDDLE WIDTH="430" HEIGHT="32" BORDER="0"></A><BR>');

   htp.p('<FONT SIZE=2><A HREF="#Heat Cool Units">Down to Heat/Cool Units</A><BR>');
   htp.p('<A HREF="#Heat Pump Units">Down to Heat Pumps</A></NOBR><BR>');

   htp.p('<P>');
   htp.p('<A HREF="#top"></A>'); 

   OPEN get_info (general_type);
   LOOP
      FETCH get_info INTO sptype;
      EXIT WHEN get_info%NOTFOUND;

      IF ( sptype = 'CO' ) THEN

         htp.p('<CENTER><FONT SIZE=5>Room Air Conditioning Units </FONT><BR>');
         htp.p('<FONT SIZE=4>Cool Only</FONT></CENTER><P>');
         htp.p('<FONT SIZE=2>');

         htp.p('<P>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> ');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/TCA081D_tn.gif"
                       ALIGN="center" WIDTH=65 HEIGHT="50" BORDER="0" ALT="TCA"></TD>');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/ECB121D_2_tn.gif"
                       ALIGN="center" WIDTH=67 HEIGHT="50" BORDER="0" ALT="ECB"></TD>');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/LCA061P_1_tn.gif"
                       ALIGN="center" WIDTH=79 HEIGHT="50" BORDER="0" ALT="LCA"></TD>');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/UCB061B_1_tn.gif"
                       ALIGN="center" WIDTH=66 HEIGHT="50" BORDER="0" ALT="UCB"></TD>');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/XCB_183d_1_tn.gif"
                       ALIGN="center" WIDTH=69 HEIGHT="50" BORDER="0" ALT="XCB"></TD>');
         htp.p('      <TD> <IMG SRC="'||owihome||'rac_media/HCA313D_tn.gif"
                       ALIGN="center" WIDTH=58 HEIGHT="50" BORDER="0" ALT="HCA"></TD>');
         htp.p('</TR>'); 
         htp.p(' <TR>'); 
         htp.p('      <TD ALIGN="center"><A HREF="#TCseries">TC Series </A></TD>');
         htp.p('      <TD ALIGN="center"><A HREF="#ECseries">EC Series </A></TD>'); 
         htp.p('      <TD ALIGN="center"><A HREF="#LCseries">LC Series </A></TD>'); 
         htp.p('      <TD ALIGN="center"><A HREF="#UCseries">UC Series </A></TD>'); 
         htp.p('      <TD ALIGN="center"><A HREF="#XC_YCseries">XC/YC Series </A></TD>');
         htp.p('      <TD ALIGN="center"><A HREF="#HCseries">HC Series </A></TD>');
         htp.p('</TR>'); 
         htp.p('</TABLE >');

         htp.p('<A HREF="#Cool Only">Down to Cooling Units Product Data</A>');
         htp.p('<P><HR><P>');

         htp.p('</FONT>');
         htp.p('<P>');
         htp.p('<TABLE  WIDTH=100%>');
         htp.p(' <TR> <TD VALIGN="top"><A NAME=TCseries></A>'); 
         htp.p('      <IMG SRC="'||owihome||'rac_media/TCA081D.jpg" ALIGN="center"
                      HEIGHT="150" BORDER="0" ALT="TC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">TC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_TC_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('');
         htp.p('<BR><HR><BR>');

         htp.p('<P>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD VALIGN="top"> <A NAME=ECseries></A>');
         htp.p('      <IMG SRC="'||owihome||'rac_media/ECB121D_2.jpg"
                       ALIGN="center" VALIGN="top"
                       HEIGHT="150" BORDER="0" ALT="EC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">EC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_EC_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
       
         htp.p('<BR><HR><BR>');

         htp.p('<P>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD VALIGN="top"> <A NAME=LCseries></A>');
         htp.p('       <IMG SRC="'||owihome||'rac_media/LCA061P_1.jpg"
                       ALIGN="center" VALIGN="top"
                       HEIGHT="150" BORDER="0" ALT="LC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">LC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_LC_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');
         htp.p('<BR><HR><BR>');

         htp.p('<P><CENTER>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD VALIGN="top"> <A NAME=UCseries></A>');
         htp.p('       <IMG SRC="'||owihome||'rac_media/UCB061B_1.jpg"
                       ALIGN="center" VALIGN="top"
                       HEIGHT="150" BORDER="0" ALT="UC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">UC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_UC_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');
         htp.p('<BR><HR><BR>');

         htp.p('<P><CENTER>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD VALIGN="top"> <A NAME=XC_YCseries></A>');
         htp.p('      <IMG SRC="'||owihome||'rac_media/XCB_183d_1.jpg"
                       ALIGN="center" VALIGN="top"
                       HEIGHT="150" BORDER="0" ALT="XC/YC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">XC/YC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_XC_YC_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');
         htp.p('<BR><HR><BR>');

         htp.p('<P><CENTER>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD VALIGN="top"> <A NAME=HCseries></A>');
         htp.p('       <IMG SRC="'||owihome||'rac_media/HCA313D.jpg"
                       ALIGN="center" VALIGN="top"
                       HEIGHT="150" BORDER="0" ALT="HC series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Cool Only">HC Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Cool Only">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_COOL_HC_TEXT;
--|      htp.p('<FONT SIZE=4>PlaceHolder for RACTXT.RAC_COOL_HC_TEXT</FONT>');
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');

      ELSIF ( sptype = 'HC') THEN
         htp.p('<P><P><P>');
         htp.p('<A NAME="Heat Cool Units"></A>');
         htp.p('<CENTER><FONT SIZE=5>Room Air Conditioning Units </FONT><BR>');
         htp.p('<FONT SIZE=4>Heat-Cool</FONT></CENTER><P>');
         htp.p('<P><CENTER>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD> <IMG SRC="'||owihome||'rac_media/xh_wh.jpg"
                       ALIGN="center" HEIGHT="150" BORDER="0" ALT="XH series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Heat Cool">XH/YH Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Heat Cool">Down to product data</A></FONT></NOBR><BR>');
         RACTXT.RAC_HEAT_COOL_UNITS_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');
         smin := 25;
         smax := 29;
         pagelink := 'Heat Cool';
      -- OPEN get_rac_hcdata ('HC');
         htp.p('<CENTER>');
         htp.p('<A NAME="Heat Cool"></A>');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A></FONT><BR>');
         htp.p('<P><FONT SIZE=4>Heat/Cool Models</FONT><P>');
         htp.p('</CENTER>');
      ELSIF ( sptype = 'HP') THEN
         htp.p('<P><P><P>');
         htp.p('<A NAME="Heat Pump Units"></A>');
         htp.p('<CENTER><FONT SIZE=5>Room Air Conditioning Units </FONT><BR>');
         htp.p('<FONT SIZE=4>Heat Pump Units</FONT></CENTER><P>');
         htp.p('<P><CENTER>');
         htp.p('<TABLE  WIDTH=90%>');
         htp.p(' <TR> <TD> <IMG SRC="'||owihome||'rac_media/xq.jpg"
                       ALIGN="center" HEIGHT="130" BORDER="0" ALT="XQ series">');
         htp.p('      <P  ALIGN="center"><A HREF="#Heat Pumps">XQ Series</A></TD>');
         htp.p('      <TD VALIGN="top">');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A> ... </FONT><NOBR>');
         htp.p('<FONT SIZE="-1"><A HREF="#Heat Pumps">Down to product data</A></NOBR></FONT><BR>');
         RESTXT.RAC_HEAT_PUMPS_TEXT;
         htp.p('      </TD></TR>');
         htp.p('</TABLE>');
         htp.p('</CENTER>');
         smin := 30;
         smax := 33;
         pagelink := 'Heat Pumps';
      -- OPEN get_rac_hcdata ('HP');
         htp.p('<CENTER>');
         htp.p('<A NAME="Heat Pumps"></A>');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A></FONT><BR>');
         htp.p('<P><FONT SIZE=4>Heat Pump Models</FONT><P>');
         htp.p('</CENTER>');
      END IF;

      IF ( sptype = 'CO' ) THEN
         smin := 1;
         smax := 24;
         pagelink := 'Cool Only';
         OPEN get_rac_data ('CO');
         htp.p('<A NAME="Cool Only"></A>');
         htp.p('<CENTER>');
         htp.p('<FONT SIZE="-1"><A HREF="#top">top of page</A></FONT><BR>');
         htp.p('<P><FONT SIZE=4>Cooling Only Models</FONT><P>');
         htp.p('<TABLE BORDER=3 CELLPADDING=2 WIDTH=90%>');
         htp.p(' <TR><TD ALIGN="center">Model</TD>');
         htp.p('     <TD ALIGN="center">Cooling<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Voltage</TD>');
         htp.p('     <TD ALIGN="center">EER</TD>');
         htp.p('     <TD ALIGN="center">Airflow (CFM)<BR>Hi/Low</TD>');
         htp.p('     <TD ALIGN="center">Height<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Width<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Depth<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Shipping<BR>Weight</TD></TR>');
   

         LOOP
            FETCH get_rac_data INTO racr;
            EXIT WHEN get_rac_data%NOTFOUND;
            mdlid        := racr.id||'$RESDOCS_HC_RACPAGE$'||pagelink;
            mdlid        := REPLACE(mdlid, ' ', '+');
            mdlid        := REPLACE(mdlid, '-', '%2D');
            msize        := racr.model_size;
            htmlmo       := REPLACE(racr.model,' ','+');
            htmlmo       := REPLACE(htmlmo,'-','%2D');
            cap          := TO_NUMBER(racr.cool_capacity);
            modelsize    := htmlmo||'$'||msize||'$'||cap;
            mname        := racr.model||racr.model_size;
            htp.p(' <TR>');
            htp.p('     <TD ALIGN="center"><A  METHOD="GET"  TARGET="_top"
                   HREF="'||wowhtml||'RACDOCS.load_rac_page2_res?modelid='||mdlid||'">');
            htp.p(      ''||mname||'</A></TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.cool_capacity)||'</A></TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(racr.volts)||'</TD>');
            htp.p('     <TD ALIGN="center">'||racr.EER||'</TD>');
            htp.p('     <TD ALIGN=
                        "center">'||TO_NUMBER(racr.CFM_HI)||'/'||TO_NUMBER(racr.CFM)||'</TD>');
            htp.p('     <TD ALIGN="center">'||racr.Height||'</TD>');
            htp.p('     <TD ALIGN="center">'||racr.Width||'</TD>');
            htp.p('     <TD ALIGN="center">'||racr.Depth||'</TD>');
            temp :=      SUBSTR(racr.weight_ship, 1, INSTR(racr.weight_ship, '.') -1); 
            htp.p('     <TD ALIGN="center">'||temp||'</TD>');
            htp.p('</TR>');
         END LOOP;

         CLOSE get_rac_data; 
         htp.p('</TABLE>');
         htp.p('<P><P>');

      ELSIF ( sptype = 'HC') THEN
         OPEN get_rac_hcdata ('HC');
         htp.p('<CENTER>');
         htp.p('<TABLE BORDER=3 CELLPADDING=2 WIDTH=90%>');
         htp.p(' <TR><TD ALIGN="center">Model</TD>');
         htp.p('     <TD ALIGN="center">Nominal<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Electric Heat<BR>Capacity</TD>');
     --  htp.p('     <TD ALIGN="center">Heat Pump<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Voltage</TD>');
         htp.p('     <TD ALIGN="center">EER</TD>');
         htp.p('     <TD ALIGN="center">Airflow (CFM)<BR>Hi/Low</TD>');
         htp.p('     <TD ALIGN="center">Height<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Width<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Depth<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Shipping<BR>Weight</TD></TR>');
   

         LOOP
            FETCH get_rac_hcdata INTO rachcr;
            EXIT WHEN get_rac_hcdata%NOTFOUND;
            mdlid        := racr.id||'$RESDOCS_HC_RACPAGE$'||pagelink;
            mdlid        := REPLACE(mdlid, ' ', '+');
            mdlid        := REPLACE(mdlid, '-', '%2D');
            msize        := rachcr.model_size;
            htmlmo       := REPLACE(rachcr.model,' ','+');
            htmlmo       := REPLACE(htmlmo,'-','%2D');
            cap          := TO_NUMBER(rachcr.cool_capacity);
            modelsize    := htmlmo||'$'||msize||'$'||cap;
            mname        := rachcr.model||rachcr.model_size;
            htp.p(' <TR>');
            htp.p('     <TD ALIGN="center"><A  METHOD="GET"  TARGET="_top"
                   HREF="'||wowhtml||'RACDOCS.load_rac_page2_res?modelid='||mdlid||'">');
            htp.p(      ''||mname||'</A></TD>');

            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.cool_capacity)||'</TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.el_ht_capacity)||'</TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.volts)||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.EER||'</TD>');
            htp.p('     <TD ALIGN=
                        "center">'||TO_NUMBER(racr.CFM_HI)||'/'||TO_NUMBER(racr.CFM)||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Height||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Width||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Depth||'</TD>');
            temp :=      SUBSTR(racr.weight_ship, 1, INSTR(racr.weight_ship, '.') -1); 
            htp.p('     <TD ALIGN="center">'||temp||'</TD>');
            htp.p('</TR>');
         END LOOP;

         CLOSE get_rac_hcdata; 
         htp.p('</TABLE');

      ELSIF ( sptype = 'HP') THEN
         OPEN get_rac_hcdata ('HP');
         htp.p('<CENTER>');
         htp.p('<TABLE BORDER=3 CELLPADDING=2 WIDTH=90%>');
         htp.p(' <TR><TD ALIGN="center">Model</TD>');
         htp.p('     <TD ALIGN="center">Nominal<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Electric Heat<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Heat Pump<BR>Capacity</TD>');
         htp.p('     <TD ALIGN="center">Voltage</TD>');
         htp.p('     <TD ALIGN="center">EER</TD>');
         htp.p('     <TD ALIGN="center">Airflow (CFM)<BR>Hi/Low</TD>');
         htp.p('     <TD ALIGN="center">Height<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Width<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Depth<BR>(In)</TD>');
         htp.p('     <TD ALIGN="center">Shipping<BR>Weight</TD></TR>');
   

         LOOP
            FETCH get_rac_hcdata INTO rachcr;
            EXIT WHEN get_rac_hcdata%NOTFOUND;
            mdlid        := racr.id||'$RESDOCS_HC_RACPAGE$'||pagelink;
            mdlid        := REPLACE(mdlid, ' ', '+');
            mdlid        := REPLACE(mdlid, '-', '%2D');
            msize        := rachcr.model_size;
            htmlmo       := REPLACE(rachcr.model,' ','+');
            htmlmo       := REPLACE(htmlmo,'-','%2D');
            cap          := TO_NUMBER(rachcr.cool_capacity);
            modelsize    := htmlmo||'$'||msize||'$'||cap;
            mname        := rachcr.model||rachcr.model_size;
            htp.p(' <TR>');
            htp.p('     <TD ALIGN="center"><A  METHOD="GET"  TARGET="_top"
                   HREF="'||wowhtml||'RACDOCS.load_rac_page2_res?modelid='||mdlid||'">');
            htp.p(      ''||mname||'</A></TD>');

            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.cool_capacity)||'</TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.el_ht_capacity)||'</TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.ht_pump_capacity)||'</TD>');
            htp.p('     <TD ALIGN="center">'||TO_NUMBER(rachcr.volts)||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.EER||'</TD>');
            htp.p('     <TD ALIGN=
                        "center">'||TO_NUMBER(racr.CFM_HI)||'/'||TO_NUMBER(racr.CFM)||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Height||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Width||'</TD>');
            htp.p('     <TD ALIGN="center">'||rachcr.Depth||'</TD>');
            temp :=      SUBSTR(racr.weight_ship, 1, INSTR(racr.weight_ship, '.') -1); 
            htp.p('     <TD ALIGN="center">'||temp||'</TD>');
            htp.p('</TR>');
         END LOOP;

         CLOSE get_rac_hcdata; 
         htp.p('</TABLE');
      END IF;
   END LOOP;
   CLOSE get_info;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         htp.p('<BR>No data found in write_room_air_conditioners<BR>');
   END write_room_air_conditioners;
/*======================================================*/
END resdocs_hc;
/
show errors;
/
