DROP PACKAGE resfld;
CREATE OR REPLACE PACKAGE resfld AS

   ID                  NUMBER(10);
   cacfld_rec          res_cac%ROWTYPE;
   hpfld_rec           res_hp%ROWTYPE;

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   widthll             NUMBER(10)   := 162;
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

 
   PROCEDURE list_res_dfields (
             general_type          IN VARCHAR2
             );

   PROCEDURE load_res_dfields (
             general_type IN VARCHAR2
             );

   PROCEDURE write_res_dfieldpage (
             generaltype        IN VARCHAR2
             );

   PROCEDURE write_res_cs_dfieldpage (
             generaltype         IN VARCHAR2
             );

END resfld;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY resfld IS

/*======================================================*/
   PROCEDURE load_res_dfields (
             general_type   IN VARCHAR2
             ) IS

   htmlgen             VARCHAR2(50);

   BEGIN

   htmlgen    :=  REPLACE(general_type, ' ', '+');
   htmlgen    :=  REPLACE(htmlgen, '-', '%2D');

   CCUTIL.chtml_header_frame('load res fields by datatable name');

   CCUTIL.load_comfort_athome_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'RESFLD.list_res_dfields?general_type='||htmlgen||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'RESFLD.write_res_dfieldpage?generaltype='||htmlgen||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('<NOFRAME>');
    htp.p('<BR>Placeholder for noframe version of load_res_fields<BR>');
    htp.p('</NOFRAME>');

    CCUTIL.html_footer;

   END load_res_dfields;
/*======================================================*/
   PROCEDURE list_res_dfields (
             general_type          IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   ftablein        VARCHAR2(30);
   rac_frec        rac_fields%ROWTYPE;

   gn_type         VARCHAR2(50);

   CURSOR get_tablename IS
   SELECT datatablename 
     FROM residential_products_97
    WHERE upper(generaltype) = upper(general_type);
 
   BEGIN

   CCUTIL.chtml_header(' List Res Fields by datatablename');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_comfort_athome;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_comfort_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_downloads;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   RESMOD.reload_res_types;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.res_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06512 in RAC_UNITS');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 in RAC_UNITS');
         CCUTIL.chtml_footer;
   END list_res_dfields;
/*======================================================*/
   PROCEDURE write_res_dfieldpage (
             generaltype         IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   ftable               VARCHAR2(30);
   general_type         VARCHAR2(50);
   htgtype              VARCHAR2(50);
   pagelinkin           VARCHAR2(20)   := '';

   BEGIN

   CCUTIL.chtml_header;

--|---------------------------------------------------------
--|DOC: For Room Air Conditioners only:
--|---------------------------------------------------------
   IF ( generaltype LIKE '%$%') THEN
        general_type := SUBSTR(generaltype, 1, INSTR(generaltype,'$') -1);
        pagelinkin   := '#'||SUBSTR(generaltype, INSTR(generaltype,'$') +1);
   ELSE
        general_type := generaltype;
   END IF;
   htgtype   := REPLACE(general_type||pagelinkin, ' ', '+'); 
   htgtype   := REPLACE(htgtype, '-', '%2D'); 
--|---------------------------------------------------------

   IF (upper(general_type) = 'AIR CLEANERS') THEN
      RESDOCS.write_air_cleaner(general_type);

   ELSIF (upper(general_type) = 'BOILERS - STEAM') THEN
      RESDOCS.write_boiler_steam(general_type);

   ELSIF (upper(general_type) = 'BOILERS - WATER') THEN
      RESDOCS.write_boiler_water(general_type);

   ELSIF (upper(general_type) = 'CENTRAL AIR CONDITIONERS' ) THEN
      RESDOCS.write_central_air_conditioners(general_type);

   ELSIF (upper(general_type) = 'FAN COILS') THEN
      RESDOCS.write_fancoil(general_type);

   ELSIF (upper(general_type) = 'FAN COILS - ELECTRIC FURNACE') THEN
      RESDOCS.write_fancoil_efurnace(general_type);

   ELSIF (upper(general_type) = 'GAS FURNACES') THEN
      RESDOCS.write_gas_furnaces(general_type);

   ELSIF (upper(general_type) = 'GAS FURNACES - CONDENSING') THEN
      RESDOCS.write_gas_furnaces_condensing(general_type);

   ELSIF (upper(general_type) = 'HEAT PUMPS') THEN
      RESDOCS.write_heat_pump(general_type);

   ELSIF (upper(general_type) = 'HUMIDIFIERS') THEN
      RESDOCS.write_humidifier(general_type);

   ELSIF (upper(general_type) = 'INDOOR COILS') THEN
      RESDOCS.write_indoor_coil(general_type);

   ELSIF (upper(general_type) = 'OIL FURNACES') THEN
      RESDOCS.write_oil_furnaces(general_type);

   ELSIF (upper(general_type) = 'ROOM AIR CONDITIONERS') THEN
      RESDOCS_HC.write_room_air_conditioners(generaltype);

   ELSIF (upper(general_type) = 'VENTILATORS') THEN
      RESDOCS.write_ventilator(general_type);

   ELSIF (upper(general_type) = 'ZONING CONTROLS') THEN
      RESDOCS.write_zone_control(general_type);

   ELSIF (upper(general_type) = 'ZONING CONTROLS - DAMPERS') THEN
      RESDOCS.write_zone_control_dampers(general_type);

   ELSIF (upper(general_type) = 'THERMOSTATS') THEN
      RESDOCS.write_zone_control_thermostats(general_type);

   ELSIF (upper(general_type) = 'LIGHT COMMERCIAL UNITS') THEN
      RESDOCSLTC.write_light_commercial_units(general_type);

   ELSIF (upper(general_type) = 'WATER SOURCE HEAT PUMPS') THEN
      RESDOCSLTC.write_water_source_heat_pumps(general_type);

   ELSE
      RESDOCS.write_no_table_found(general_type);
   END IF;

   CCUTIL.chtml_footer;

   END write_res_dfieldpage;
/*======================================================*/
   PROCEDURE write_res_cs_dfieldpage (
             generaltype         IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   ftable               VARCHAR2(30);
   general_type         VARCHAR2(50);
   htgtype              VARCHAR2(50);
   pagelinkin           VARCHAR2(20)   := '';

   BEGIN

   CCUTIL.chtml_header;
   htp.p('<P><A HREF="'||wowhtml||'CSEARCH.list_all_models1"><I>back to model search</I></A><P>');

--|---------------------------------------------------------
--|DOC: For Room Air Conditioners only:
--|---------------------------------------------------------
   IF ( generaltype LIKE '%$%') THEN
        general_type := SUBSTR(generaltype, 1, INSTR(generaltype,'$') -1);
        pagelinkin   := '#'||SUBSTR(generaltype, INSTR(generaltype,'$') +1);
   ELSE
        general_type := generaltype;
   END IF;
   htgtype   := REPLACE(general_type||pagelinkin, ' ', '+'); 
   htgtype   := REPLACE(htgtype, '-', '%2D'); 
--|---------------------------------------------------------

   IF (upper(general_type) = 'AIR CLEANERS') THEN
      RESDOCS.write_air_cleaner(general_type);

   ELSIF (upper(general_type) = 'BOILERS - STEAM') THEN
      RESDOCS.write_boiler_steam(general_type);

   ELSIF (upper(general_type) = 'BOILERS - WATER') THEN
      RESDOCS.write_boiler_water(general_type);

   ELSIF (upper(general_type) = 'CENTRAL AIR CONDITIONERS' ) THEN
      RESDOCS.write_central_air_conditioners(general_type);

   ELSIF (upper(general_type) = 'FAN COILS') THEN
      RESDOCS.write_fancoil(general_type);

   ELSIF (upper(general_type) = 'FAN COILS - ELECTRIC FURNACE') THEN
      RESDOCS.write_fancoil_efurnace(general_type);

   ELSIF (upper(general_type) = 'GAS FURNACES') THEN
      RESDOCS.write_gas_furnaces(general_type);

   ELSIF (upper(general_type) = 'GAS FURNACES - CONDENSING') THEN
      RESDOCS.write_gas_furnaces_condensing(general_type);

   ELSIF (upper(general_type) = 'HEAT PUMPS') THEN
      RESDOCS.write_heat_pump(general_type);

   ELSIF (upper(general_type) = 'HUMIDIFIERS') THEN
      RESDOCS.write_humidifier(general_type);

   ELSIF (upper(general_type) = 'INDOOR COILS') THEN
      RESDOCS.write_indoor_coil(general_type);

   ELSIF (upper(general_type) = 'OIL FURNACES') THEN
      RESDOCS.write_oil_furnaces(general_type);

   ELSIF (upper(general_type) = 'ROOM AIR CONDITIONERS') THEN
      RESDOCS_HC.write_room_air_conditioners(generaltype);

   ELSIF (upper(general_type) = 'VENTILATORS') THEN
      RESDOCS.write_ventilator(general_type);

   ELSIF (upper(general_type) = 'ZONING CONTROLS') THEN
      RESDOCS.write_zone_control(general_type);

   ELSIF (upper(general_type) = 'ZONING CONTROLS - DAMPERS') THEN
      RESDOCS.write_zone_control_dampers(general_type);

   ELSIF (upper(general_type) = 'THERMOSTATS') THEN
      RESDOCS.write_zone_control_thermostats(general_type);

   ELSIF (upper(general_type) = 'LIGHT COMMERCIAL UNITS') THEN
      RESDOCSLTC.write_light_commercial_units(general_type);

   ELSIF (upper(general_type) = 'WATER SOURCE HEAT PUMPS') THEN
      RESDOCSLTC.write_water_source_heat_pumps(general_type);

   ELSE
      RESDOCS.write_no_table_found(general_type);
   END IF;

   CCUTIL.chtml_footer;

   END write_res_cs_dfieldpage;
/*======================================================*/
END resfld;
/
show errors;
/
