DROP PACKAGE resmod;
CREATE OR REPLACE PACKAGE resmod AS

   ID                  NUMBER(10);
   cac_fldrec          res_cac%ROWTYPE;
   hp_fldrec           res_hp%ROWTYPE;

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
*/
   widthll1            NUMBER(10)      := 162;
   widthll2            NUMBER(10)      := 162;

   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;


   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE get_res_types;

   PROCEDURE reload_res_types;

   PROCEDURE load_res_ptypes;

   PROCEDURE res_specific_types (
             general_type       IN VARCHAR2
             );

   PROCEDURE load_res_specific_types (
             general_type       IN VARCHAR2
             );

   PROCEDURE write_spectype_page (
             general_type       IN VARCHAR2
             );

   PROCEDURE list_res_models (
             spec_type    IN VARCHAR2
             );

   PROCEDURE load_res_models (
             spec_type    IN VARCHAR2
             );

   PROCEDURE write_res_modelpage (
             spec_type    IN VARCHAR2
             );

END resmod;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY resmod IS

/*======================================================*/
   PROCEDURE get_res_types IS

   general_type            VARCHAR2(50);
   htmlgen                 VARCHAR2(50);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_gtypes IS
   SELECT distinct generaltype 
     FROM residential_products_97
    ORDER BY generaltype;

   CURSOR get_ltcom_types IS
   SELECT distinct generaltype
     FROM residential_prods
    WHERE upper(division) = 'CMUS'
    ORDER BY generaltype;

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<CENTER>');
   CCUTIL.nav_upto_comfort_athome;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_comfort_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_res_downloads;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   htp.p('<A TARGET="bodyText" HREF="'||owihome||'res_ed2/res_edd2_plain.html">');
   htp.p('<B><FONT SIZE=2>Residential<BR>Systems</FONT></B></A><BR>');
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER><I>Residential Products</I><P></CENTER>');
   htp.p('</FONT>');
   
   htp.p('<CENTER>');
   OPEN get_gtypes;
   LOOP
      FETCH get_gtypes INTO  general_type;
      EXIT WHEN get_gtypes%NOTFOUND;

      htmlgen := REPLACE (general_type, ' ', '+');
      htmlgen := REPLACE (htmlgen, '-', '%2D');

      htp.p('<FONT SIZE=2>');
      htp.p('<A TARGET="bodyText" 
       HREF="'||wowhtml||'RESFLD.write_res_dfieldpage?generaltype='||htmlgen||'"> ');
      htp.p(''||general_type||'</A><BR>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
      htp.p('</FONT>');
   END LOOP;
   CLOSE get_gtypes;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER><I>Light Commercial<BR>Products</I><P></CENTER>');
   htp.p('</FONT>');

   htp.p('<CENTER>');
   OPEN get_ltcom_types;
   LOOP
      FETCH get_ltcom_types INTO general_type;
      EXIT WHEN get_ltcom_types%NOTFOUND;

      htmlgen := REPLACE (general_type, ' ', '+');
      htmlgen := REPLACE (htmlgen, '-', '%2D');

      htp.p('<FONT SIZE=2>');
      htp.p('<A TARGET="bodyText" 
       HREF="'||wowhtml||'RESFLD.write_res_dfieldpage?generaltype='||htmlgen||'"> ');
      htp.p(''||general_type||'</A><BR>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
      htp.p('</FONT>');
   END LOOP;
   CLOSE get_ltcom_types;
   htp.p('</CENTER>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.res_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||general_type||'');
         CCUTIL.chtml_footer;
   END get_res_types;
/*======================================================*/
   PROCEDURE reload_res_types IS

   general_type            VARCHAR2(35);
   htmlgeneral             VARCHAR2(40);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_gtypes IS
   SELECT distinct generaltype 
     FROM residential_products_97
    ORDER BY generaltype;

   BEGIN

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=2>');
   htp.p('<I>Residential Products</I>');
   htp.p('</FONT><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="12" BORDER="0"><BR>');
   
   OPEN get_gtypes;
   LOOP
      FETCH get_gtypes INTO  general_type;
      EXIT WHEN get_gtypes%NOTFOUND;

      htmlgeneral := REPLACE (general_type, ' ', '+');
      htmlgeneral := REPLACE (htmlgeneral, '-', '%2D');

      htp.p('<FONT SIZE=2>');
      htp.p('<A  TARGET="bodyText" 
       HREF="'||wowhtml||'RESFLD.write_res_dfieldpage?generaltype='||htmlgeneral||'">');
      htp.p(''||general_type||'</A><BR>');
      htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
      htp.p('</FONT>');
   END LOOP;
   CLOSE get_gtypes;
   htp.p('</CENTER>');

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||general_type||'');
         CCUTIL.chtml_footer;
   END reload_res_types;
/*======================================================*/
   PROCEDURE load_res_ptypes AS

   BEGIN

   CCUTIL.chtml_header_frame('load res ptypes');

   CCUTIL.load_comfort_athome_ab;

   htp.p('<FRAMESET COLS="'||widthll1||',*">');
        htp.p('<FRAME SRC="'||wowhtml||'RESMOD.get_res_types"');
        htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
        htp.p('<FRAME SRC="'||owihome||'res_ed2/res_edd2_plain.html" ');
         htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');

   CCUTIL.chtml_footer;

   END load_res_ptypes;
/*======================================================*/
   PROCEDURE res_specific_types (
             general_type       IN VARCHAR2
             ) IS

   specific_type_tab        fieldTblType;
   gentype_tab              fieldTblType; 
   min_cap_tab              fieldTblType; 
   max_cap_tab              fieldTblType; 
   specific_type            VARCHAR2(50);
   gentype                  VARCHAR2(50);
   min_cap                  VARCHAR2(15);
   max_cap                  VARCHAR2(15);
   hspec                    VARCHAR2(50);
   hgen                     VARCHAR2(50);
   
   i            NUMBER(10);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_stypes IS
   SELECT generaltype, specifictype, mincap, maxcap 
   FROM residential_products_97
   WHERE generaltype = general_type;

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<I>Up to <BR>Carrier Search</I></A><P>');

   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<I>Up to <BR>Comfort At Home</I></A><P>');

   htp.p('<A TARGET="_parent"
     HREF="'||wowhtml||'RESMOD.load_res_ptypes">');
   htp.p('<I>Up to <BR>Residential<BR>Product Types</I></A>');
   htp.p('</CENTER>');

   htp.p('<HR><BR>');

   htp.p('<CENTER><I>'||general_type||'</FONT></I><P>');

   open get_stypes;
   i := 0;
   htp.p('<CENTER>');
   LOOP
      i := i+1;
      FETCH get_stypes 
       INTO gentype_tab(i), specific_type_tab(i), min_cap_tab(i), max_cap_tab(i);
      EXIT WHEN get_stypes%NOTFOUND; 
      IF (i = 1 ) THEN
         hgen := REPLACE (gentype_tab(i), ' ', '+');
         hspec := REPLACE (specific_type_tab(i), ' ', '+');
         hspec := REPLACE (hspec, '-', '%2D');
         htp.p('<A TARGET="_parent"
            HREF="'||wowhtml||'RESMOD.load_res_models?spec_type='||hgen||'$'||hspec||'">');  
            htp.p(''||specific_type_tab(i)||'</A><P>');
      ELSE
         IF (specific_type_tab(i)  = specific_type_tab(i-1) ) THEN
            NULL;
         ELSE
            hgen := REPLACE (gentype_tab(i), ' ', '+');
            hspec := REPLACE (specific_type_tab(i), ' ', '+');
            hspec := REPLACE (hspec, '-', '%2D');
            htp.p('<A TARGET="_parent"
               HREF="'||wowhtml||'RESMOD.load_res_models?spec_type='||hgen||'$'||hspec||'">');  
               htp.p(''||specific_type_tab(i)||'</A><P>');
         END IF;
      END IF;
   END LOOP;
   htp.p('</CENTER>');

   htp.p('<P><HR>');
   CCUTIL.hotlink_wahlstrom;
   CCUTIL.res_resource_buttons;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||specific_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||specific_type||'');
         CCUTIL.chtml_footer;
   END res_specific_types;
/*======================================================*/
   PROCEDURE write_spectype_page (
             general_type       IN VARCHAR2
             ) IS

   specific_type_tab        fieldTblType;
   gentype_tab              fieldTblType; 
   min_cap_tab              fieldTblType; 
   max_cap_tab              fieldTblType; 
   specific_type            VARCHAR2(50);
   gentype                  VARCHAR2(50);
   min_cap                  VARCHAR2(15);
   max_cap                  VARCHAR2(15);
   hspec                    VARCHAR2(50);
   hgen                     VARCHAR2(50);
   
   i            NUMBER(10);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_stypes IS
   SELECT generaltype, specifictype
     FROM residential_products_97
    WHERE generaltype = general_type;

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<P><BR>');

   htp.p('<CENTER><FONT SIZE=5>About '||general_type||'</FONT></CENTER><P>');

   open get_stypes;
   i := 0;
   LOOP
      i := i+1;
      FETCH get_stypes 
       INTO gentype_tab(i), specific_type_tab(i);
      EXIT WHEN get_stypes%NOTFOUND; 
      IF (i = 1 ) THEN
         htp.p('<P><P>');
         htp.p('<FONT SIZE=4>'||specific_type_tab(i)||'</FONT>');
         htp.p('<P><UL>');
         htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
         htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
         htp.p('</UL>');
      ELSE
         IF (specific_type_tab(i)  = specific_type_tab(i-1) ) THEN
            NULL;
         ELSE
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||specific_type_tab(i)||'</FONT>');
            htp.p('<P><UL>');
            htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
            htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
            htp.p('</UL>');
         END IF;
      END IF;
   END LOOP;

   htp.p('<P><HR>');

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||specific_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||specific_type||'');
   END write_spectype_page;
/*======================================================*/
   PROCEDURE load_res_specific_types (
             general_type       IN VARCHAR2
             ) IS

   htmlgeneral        VARCHAR2(50); 
   htmltitle          VARCHAR2(50); 

   BEGIN

   htmlgeneral     :=  REPLACE(general_type, ' ', '+');
   htmlgeneral     :=  REPLACE(htmlgeneral, '-', '%2D');
   htmltitle       :=  REPLACE(general_type, ' ', '_');


   CCUTIL.chtml_header_frame('load res ptypes');

   CCUTIL.load_comfort_athome_ab;

   htp.p('<FRAMESET COLS="'||widthll1||',*">');
        htp.p('<FRAME  TARGET="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'RESMOD.res_specific_types?general_type='||htmlgeneral||'">');

        htp.p('<FRAME TARGET="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
         SRC="'||wowhtml||'RESMOD.write_spectype_page?general_type='||htmlgeneral||'"> ');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('</BODY>');
    htp.p('</HTML>');

   END load_res_specific_types;
/*======================================================*/
   PROCEDURE list_res_models (
             spec_type    IN VARCHAR2
             ) IS

   modelno                 VARCHAR2(35);
   htmlmodelno             VARCHAR2(35);
   general_type            VARCHAR2(50);
   specific_type           VARCHAR2(50);
   sg_type                 VARCHAR2(100);
   min_cap                 VARCHAR2(50);
   max_cap                 VARCHAR2(50);

   hgen                    VARCHAR2(50);
   hspec                   VARCHAR2(50);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);
   
   CURSOR get_models (gn_type IN VARCHAR2,
                      sp_type IN VARCHAR2) IS
   SELECT substr(model,1,50), generaltype, mincap, maxcap 
   FROM   residential_products_97
   WHERE  generaltype = gn_type AND specifictype = sp_type
   ORDER BY model;

   BEGIN

   CCUTIL.chtml_header;

   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$') -1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

   htp.p('<CENTER>');
   htp.p('<A HREF="'||owihome||'nao_sh1/index.html" TARGET="_parent">');
   htp.p('<I>Up to <BR>Carrier Search</I></A><P>');

   htp.p('<A HREF="'||owihome||'res_hm1/index.html" TARGET="_parent">');
   htp.p('<I>Up to <BR>Comfort at Home</I></A><P>');

   htp.p('<A TARGET="_parent"
     HREF="'||wowhtml||'RESMOD.load_res_ptypes">');
   htp.p('<I>Up to <BR>Residential<BR>Product Types</I></A><P>');

   hgen  := REPLACE (general_type, ' ', '+');
   hspec := REPLACE (specific_type, ' ', '+');
   hspec := REPLACE (hspec, '-', '%2D');
   htp.p('<A TARGET="_parent"  HREF=
      "'||wowhtml||'RESMOD.load_res_specific_types?general_type='||hgen||'">');  
   htp.p('<I>Up to '||general_type||'</I></A>');
   htp.p('</CENTER>');

   htp.p('<HR><BR>');

   htp.p('<CENTER>');
   htp.p('<I>'||specific_type||'</I>');
   htp.p('</CENTER>');
   htp.p('<P>');

   htp.p('<CENTER>');
   OPEN get_models (general_type, specific_type);
   LOOP
      FETCH get_models INTO modelno, general_type, min_cap, max_cap;
      EXIT WHEN get_models%NOTFOUND;

      htmlmodelno := REPLACE (modelno, ' ', '+');

      IF (min_cap IS NOT NULL AND max_cap IS NOT NULL) THEN
         htp.p('<A TARGET="_parent"
          HREF="'||wowhtml||'RESFLD.list_fields?modelno='||htmlmodelno||'">');
         htp.p(''||modelno||' </A><P>');
     --  htp.p(''||modelno||' ('||min_cap||'-'||max_cap||')</A><P>');
      ELSE
         htp.p('<A TARGET="_parent"
          HREF="'||wowhtml||'RESFLD.list_fields?modelno='||htmlmodelno||'">');
         htp.p(''||modelno||'</A><P>');
     --  htp.p(''||modelno||' (capacity not available)</A><P>');
      END IF;
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

   htp.p('<P><HR>');
   CCUTIL.hotlink_wahlstrom;
   CCUTIL.res_resource_buttons;
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
   END list_res_models;
/*======================================================*/
   PROCEDURE load_res_models (
             spec_type    IN VARCHAR2
             ) AS
   htmlsp              VARCHAR2(50);
   htmlgen             VARCHAR2(50);
   general_type        VARCHAR2(50); 
   specific_type       VARCHAR2(50); 

   BEGIN

   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$') -1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

   htmlgen    :=  REPLACE(general_type, ' ', '+');
   htmlsp     :=  REPLACE(specific_type, ' ', '+');
   htmlsp     :=  REPLACE(htmlsp, '-', '%2D');


   CCUTIL.chtml_header_frame('load res models');

   CCUTIL.load_comfort_athome_ab;

   htp.p('<FRAMESET COLS="'||widthll1||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'RESMOD.list_res_models?spec_type='||htmlgen||'$'||htmlsp||'">');

        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'RESMOD.write_res_modelpage?spec_type='||htmlgen||'$'||htmlsp||'">');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');

    CCUTIL.chtml_footer;

   END load_res_models;
/*======================================================*/
   PROCEDURE write_res_modelpage (
             spec_type    IN VARCHAR2
             ) IS

   modelno                 VARCHAR2(50);
   htmlmodelno             VARCHAR2(50);
   general_type            VARCHAR2(50);
   specific_type           VARCHAR2(50);
   min_cap                 VARCHAR2(50);
   max_cap                 VARCHAR2(50);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);
   
   CURSOR get_models (gn_type   IN VARCHAR2,
                      sp_type   IN VARCHAR2) IS
   SELECT substr(model,1,50), generaltype, mincap, maxcap 
   FROM   residential_products_97
   WHERE  upper(generaltype) = upper(gn_type) 
     AND  upper(specifictype) = upper(sp_type)
   ORDER BY model;

   BEGIN

   CCUTIL.chtml_header('Model Page');

   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$')-1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

   htp.p('<P><BR>');
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>About '||general_type||': '||specific_type||'</FONT></A><P>');
   htp.p('</CENTER>');
   htp.p('<P><HR><BR>');

   OPEN get_models (general_type, specific_type);
   LOOP
      FETCH get_models INTO modelno, general_type, min_cap, max_cap;
      EXIT WHEN get_models%NOTFOUND;

      IF (min_cap IS NOT NULL AND max_cap IS NOT NULL) THEN
         htp.p('<P><P>');
         htp.p('<FONT SIZE=4>'||modelno||': Capacity Range = '||min_cap||'-'||max_cap||'</FONT></A><P>');
         htp.p('<UL>');
         htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
         htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
         htp.p('</UL>');
      ELSE
         htp.p('<P><P>');
         htp.p('<FONT SIZE=4>'||modelno||' (capacity not available)</FONT></A><P>');
         htp.p('<UL>');
         htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
         htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
         htp.p('</UL>');
      END IF;
      htp.p('<P><HR>');
   END LOOP;
   CLOSE get_models;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
   END write_res_modelpage;
/*======================================================*/
END resmod;
/
show errors;
/
