DROP PACKAGE resource_center;
CREATE OR REPLACE PACKAGE resource_center AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   plhome              VARCHAR2(70)    := basewow||'cgi-bin/cdata/';
   widthll             NUMBER(10)      := 162;
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;
   plhome              VARCHAR2(70)    := basewow||'cgi-bin/cdata/';

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE cframe;

   PROCEDURE list_caw_downloads;

   PROCEDURE load_caw_downloads;

   PROCEDURE list_electronic_literature;

   PROCEDURE list_electronic_catalogs;

   PROCEDURE list_cad_templates;

   PROCEDURE list_engineering_software;

   PROCEDURE registration_header_txt;

   PROCEDURE pdf_header_txt;

   PROCEDURE eleclit_header_txt;

   PROCEDURE catalog_header_txt;

   PROCEDURE template_header_txt;

   PROCEDURE eng_software_header_txt;

   PROCEDURE eng_download_header_txt;

END resource_center;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY resource_center IS

/*======================================================*/
   PROCEDURE cframe  IS
             
   BEGIN

-- CCUTIL.chtml_header ('resource center download C frame');
   htp.p('<HTML><HEAD></HEAD>');

   htp.p('<BODY BGCOLOR ="#FFFFFF">');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.nav_upto_resource_center;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_glossary;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_press_releases;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_external_urls;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_search_tools;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_event_calendar;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_case_studies;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.hotlink_rc_white_papers;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

-- CCUTIL.hotlink_rc_carrier_software;
-- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
-- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||wowhtml||'RESDLUPD.res_pdf_page">');
   htp.p('<FONT SIZE=2>Comfort at Home<BR>Product Data Digests</A></FONT><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   CCUTIL.caw_colls_search;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="_top" HREF=');
   htp.p('"'||wowhtml||'RESOURCE_CENTER.load_caw_downloads">');
   htp.p('<FONT SIZE=2>Comfort at Work<BR>Software</A></FONT><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER>');
-- htp.p('<A TARGET="bodyText" HREF=');
-- htp.p('"'||plhome||'write_download_list_rc.sh?dltype=eleclit">');
-- htp.p('<I>Electronic <BR>Literature</I></A><BR>');
-- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
-- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=eleccat">');
   htp.p('<I>Electronic <BR>Catalogs</I></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=template">');
   htp.p('<I>CAD Templates</I></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||owihome||'nao_sw1/nao_swd1.html">');
   htp.p('<I>Engineering<BR> Software<BR> Descriptions</I></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=E20%2DII">');
   htp.p('<I>Engineering<BR> Software<BR> Downloadables</I></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('</FONT>');

   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.com_resource_buttons;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   CCUTIL.hotlink_copyright;
   
   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
        htp.p('No data found in resource center C frame procedure<BR>');
   END cframe;
/*======================================================*/
   PROCEDURE load_caw_downloads  IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);
   
   BEGIN

   CCUTIL.chtml_header_frame('load comfort at work download info');
   CCUTIL.load_resource_center_ab;
-- RESOURCE_CENTER.cframe;
   
   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME SRC="'||wowhtml||'RESOURCE_CENTER.cframe"');
        htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
        htp.p('<FRAME SRC="'||wowhtml||'RESOURCE_CENTER.list_caw_downloads" ');
         htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');

   htp.p('<HR><BR>');

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
   END load_caw_downloads;
/*======================================================*/
   PROCEDURE list_caw_downloads IS

   c_model          VARCHAR2(30);
   rac_model        VARCHAR2(30);
   res_model        VARCHAR2(30);
   specific_type    VARCHAR2(50);
   capacity         VARCHAR2(30);

   CURSOR get_eleclit IS
   SELECT *
     FROM download_objects
    WHERE upper(extension) = 'PDF'
      AND downloadable =1;

   CURSOR get_eleccat IS
   SELECT *
     FROM download_objects
    WHERE upper(downloadfiletype) = 'E-CAT'
      AND downloadable =1;

   CURSOR get_templates IS
   SELECT *
     FROM download_objects
    WHERE upper(downloadfiletype) LIKE 'CAD%TEMPLATE%'
      AND downloadable =1;

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('<TITLE>List Downloads for Comfort at Work</TITLE>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF >');
   CCUTIL.rc_frameD_back_header;

   htp.p('<P><BR><P>');
   htp.p('<A NAME="pagetop"></A>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=5>Comfort at Work Software Products');
   htp.p('</FONT><P>');
   htp.p('</CENTER>');
   RESOURCE_CENTER.registration_header_txt;
   htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');

-- htp.p('<CENTER>');
-- htp.p('<FONT SIZE=4>Electronic Literature</FONT><P>');
-- htp.p('</CENTER>');
-- RESOURCE_CENTER.pdf_header_txt;
-- htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=4>Electronic Catalogs </FONT><P>');
   htp.p('</CENTER>');
   RESOURCE_CENTER.catalog_header_txt;
   htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=4>Electronic Templates </FONT><P>');
   htp.p('</CENTER>');
   RESOURCE_CENTER.template_header_txt;
   htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=4>Engineering Software Description</FONT><P>');
   htp.p('</CENTER>');
   RESOURCE_CENTER.eng_software_header_txt;
   htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');
 
   htp.p('<CENTER>');
   htp.p('<FONT SIZE=4>Engineering Software Downloads</FONT><P>');
   htp.p('</CENTER>');
   RESOURCE_CENTER.eng_download_header_txt;
   htp.p('<HR ALIGN="center" WIDTH="400"><P><P>');
 
   htp.p('<P><BR><P>');

   CCUTIL.chtml_footer; 

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header ('No Models Found') ;
         CCUTIL.chtml_footer;
   END list_caw_downloads;
/*======================================================*/
   PROCEDURE registration_header_txt IS

   BEGIN

   htp.p('To download or view <B>Software Products</B> you must');
   htp.p('first <A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText">register</A>');
   htp.p('with Carrier.');
   htp.p('<P>');

   END registration_header_txt;
/*======================================================*/
   PROCEDURE pdf_header_txt IS

   BEGIN

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=eleclit">');
   htp.p('<B>Electronic Literature</B></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<P>');
   htp.p('<FONT SIZE=2>');
   htp.p('<A HREF="http://www.adobe.com/acrobat/readstep.html"');
   htp.p('TARGET="bodyText"><IMG SRC="'||owihome||'res_media/getacro.gif" ALIGN=MIDDLE');
   htp.p('WIDTH="88" HEIGHT="31" BORDER="0"></A>');
   htp.p('<P>The Product Data Digests listed below are in Adobe''s <B>Acrobat</B><FONT');
   htp.p('SIZE="2">&reg;</FONT> Portable Document Format (PDF). In order to view or');
   htp.p('print these files, you will need to <A');
   htp.p('HREF="http://www.adobe.com/acrobat/readstep.html">download</A> and install');
   htp.p('the free <B>Acrobat Reader</B> or obtain one of Adobe''s commercial Acrobat');
   htp.p('<A HREF="http://www.adobe.com/acrobat/prodinfo.html">products</A>.');
   htp.p('<P>');
   htp.p('Additional publications are available on CD-ROM to');
   htp.p('qualified dealers and distributors.'); 
-- htp.p('through our<BR><A');
-- htp.p('HREF="'||owihome||'res_pd4/res_pdd4.html" TARGET="bodyText">Residential On-line');
-- htp.p('Literature System</A> (ROLLS).');
   htp.p('<P>');
   htp.p('</FONT>');
   htp.p('<FONT SIZE="2">Acrobat and the Acrobat logo are registered');
   htp.p('trademarks of Adobe Systems Incorporated.</FONT>');

   END pdf_header_txt;
/*======================================================*/
   PROCEDURE eleclit_header_txt IS

   BEGIN

   htp.p('To download or view <B>Software Products</B> you must');
   htp.p('first <A HREF="'||owihome||'nao_ur1/nao_urd1.html" TARGET="bodyText">register</A>');
   htp.p('with Carrier.');
   htp.p('<P>');

   END eleclit_header_txt;
/*======================================================*/
   PROCEDURE catalog_header_txt IS

   BEGIN

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=eleccat">');
   htp.p('<B>Electronic Catalogs</B></A><BR>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');

   htp.p('<B><FONT SIZE=2 FACE="Times New Roman">Electronic Catalog</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2 FACE="Times New Roman">Carrier''s Electronic Catalog');
   htp.p('is a series of software programs available to the HVAC design');
   htp.p('community.  These programs assist in the selection, specification,');
   htp.p('and application of specific Carrier models of commercial HVAC');
   htp.p('equipment.  Each class of equipment (e.g.  rooftop packaged cooling/heating');
   htp.p('units) has its own program which can be downloaded separately.');
   htp.p(' Each program has a selection procedure optimized for the class');
   htp.p('of equipment, and provides outputs with all pertinent engineering');
   htp.p('information about the unit selected - as applied.  The programs');
   htp.p('are available for downloading if you have received a Carrier Internet');
   htp.p('ID and password from your local Carrier sales office.<BR>');
   htp.p('</FONT>');

   END catalog_header_txt;
/*======================================================*/
   PROCEDURE eng_software_header_txt IS

   BEGIN

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||owihome||'nao_sw1/nao_swd1.html">');
   htp.p('<B>Engineering Software Description</B></A><BR>');

-- htp.p('<B><FONT SIZE=2 FACE="Times New Roman">E20-II Engineering Software</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2 FACE="Times New Roman">Carrier has a family of engineering');
   htp.p('software products called E20-II.  E20-II contains a collection');
   htp.p('of programs created specifically for the HVAC system designer.');
   htp.p(' These programs are specifically crafted to increase productivity');
   htp.p('and accuracy, improve analysis capabilities and job documentation,');
   htp.p('and add a level of &quot;marketability&quot; to a designer''s estimates.');
   htp.p(' Individual programs are available to assist in heating &amp;');
   htp.p('cooling load estimating, annual building operating cost estimating,');
   htp.p('duct system design and layout, water and refrigerant piping system');
   htp.p('design, end economic life cycle analysis.  These programs are');
   htp.p('written by HVAC systems engineers for HVAC systems engineers,');
   htp.p('and are supported by more HVAC system engineers with years of');
   htp.p('field application experience.<BR>');
   htp.p('</FONT>');

   END eng_software_header_txt;
/*======================================================*/
   PROCEDURE eng_download_header_txt IS

   BEGIN

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=E20%2DII">');
   htp.p('<B>Engineering Software Downloadables</B></A><BR>');

   htp.p('<P>');
   htp.p('Selections are now available of demonstration versions of the ');
   htp.p('E20-II Engineering software and of program weather for the');
   htp.p('HAP program.');
   

   END eng_download_header_txt;
/*======================================================*/
   PROCEDURE template_header_txt IS

   BEGIN

   htp.p('<A TARGET="bodyText" HREF=');
   htp.p('"'||plhome||'write_download_list_rc.sh?dltype=template">');
   htp.p('<B>Electronic Templates</B></A><BR>');

-- htp.p('<B><FONT SIZE=2 FACE="Times New Roman">Electronic Templates</FONT></B>');
   htp.p('<P>');
   htp.p('<FONT SIZE=2 FACE="Times New Roman">Carrier''s Electronic Templates');
   htp.p('are a collection of CAD drawings of Carrier equipment.  These');
   htp.p('drawings are simple 2D views of the equipment which are drawn');
   htp.p('to actual physical dimensions, and are intended for use by the');
   htp.p('mechanical system designer when producing CAD drawings of mechanical');
   htp.p('equipment rooms and other similar drawings.  In addition to dimensional');
   htp.p('information, the Electronic Templates also include connection');
   htp.p('size and location information for ducts, piping, and electrical');
   htp.p('connections along with recommended service clearance areas.  The');
   htp.p('templates are collected into groupings by Carrier model number,');
   htp.p('and are available for downloading on a group by group basis. ');
   htp.p('The CAD drawings themselves are in AutoCAD DXF format, enabling');
   htp.p('them to be used with nearly all releases of AutoCAD and the majority');
   htp.p('of CAD systems with DXF interchange capability.<BR>');
   htp.p('</FONT>');

   END template_header_txt;
/*======================================================*/
   PROCEDURE list_electronic_literature IS

   CURSOR get_eleclit IS
   SELECT *
     FROM download_objects
    WHERE upper(extension) = 'PDF';

   cdo          download_objects%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Listing of Electronic Literature');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE =4>Electronic Literature Downloads</FONT>');
   htp.p('</CENTER><P>');

   OPEN get_eleclit;
   LOOP
      FETCH get_eleclit INTO cdo;
      EXIT WHEN get_eleclit%NOTFOUND;
      htp.p('<B>Download: '||cdo.downloadmodel||'</B>');
      htp.p('<UL>');
      htp.p(cdo.description||'<BR>');
      htp.p('descriptionID '||cdo.descriptionid||'; licenseID '||cdo.licenseid);
      htp.p('; installID '||cdo.installid||'<BR>');
      htp.p('</UL><P>');
   END LOOP;
   CLOSE get_eleclit;

   CCUTIL.chtml_footer;

   END list_electronic_literature;
/*======================================================*/
   PROCEDURE list_electronic_catalogs IS

   CURSOR get_eleccat IS
   SELECT *
     FROM download_objects
    WHERE upper(downloadfiletype) = 'E-CAT';

   cdo          download_objects%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Listing of Electronic Catalogs');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE =4>Electronic Catalog Downloads</FONT>');
   htp.p('</CENTER><P>');

   OPEN get_eleccat;
   LOOP
      FETCH get_eleccat INTO cdo;
      EXIT WHEN get_eleccat%NOTFOUND;
      htp.p('<B>Download: '||cdo.downloadmodel||'</B>');
      htp.p('<UL>');
      htp.p(cdo.description||'<BR>');
      htp.p('descriptionID '||cdo.descriptionid||'; licenseID '||cdo.licenseid);
      htp.p('; installID '||cdo.installid||'<BR>');
      htp.p('</UL><P>');
   END LOOP;
   CLOSE get_eleccat;

   CCUTIL.chtml_footer;

   END list_electronic_catalogs;
/*======================================================*/
   PROCEDURE list_cad_templates IS

   CURSOR get_templates IS
   SELECT *
     FROM download_objects
    WHERE upper(downloadfiletype) LIKE 'CAD%TEMPLATE%';

   cdo          download_objects%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Listing of CAD Templates');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE =4>CAD Template Downloads</FONT>');
   htp.p('</CENTER><P>');

   OPEN get_templates;
   LOOP
      FETCH get_templates INTO cdo;
      EXIT WHEN get_templates%NOTFOUND;
      htp.p('<B>Download: '||cdo.downloadmodel||'</B>');
      htp.p('<UL>');
      htp.p(cdo.description||'<BR>');
      htp.p('descriptionID '||cdo.descriptionid||'; licenseID '||cdo.licenseid);
      htp.p('; installID '||cdo.installid||'<BR>');
      htp.p('</UL><P>');
   END LOOP;
   CLOSE get_templates;

   CCUTIL.chtml_footer;

   END list_cad_templates;
/*======================================================*/
   PROCEDURE list_engineering_software IS

   CURSOR get_engsoft IS
   SELECT *
     FROM download_objects
    WHERE upper(downloadfiletype) = 'E20-II';

   cdo          download_objects%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header('Listing of Engineering Software Downloads');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE =4>Engineering Software Downloads</FONT>');
   htp.p('</CENTER><P>');

   OPEN get_engsoft;
   LOOP
      FETCH get_engsoft INTO cdo;
      EXIT WHEN get_engsoft%NOTFOUND;
      htp.p('<B>Download: '||cdo.downloadmodel||'</B>');
      htp.p('<UL>');
      htp.p(cdo.description||'<BR>');
      htp.p('descriptionID '||cdo.descriptionid||'; licenseID '||cdo.licenseid);
      htp.p('; installID '||cdo.installid||'<BR>');
      htp.p('</UL><P>');
   END LOOP;
   CLOSE get_engsoft;

   CCUTIL.chtml_footer;

   END list_engineering_software;
/*======================================================*/
END resource_center;
/
show errors;
/
