/* ======================================================== */
DROP PACKAGE ziplocator;
CREATE OR REPLACE PACKAGE ziplocator AS
/* ======================================================== */

/*
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
*/
   basehtml            VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:7080/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml;
   widthll             NUMBER(10)      := 162;



   TYPE        numArrTbl   IS TABLE OF NUMBER(15)
                           INDEX BY BINARY_INTEGER;

   TYPE        intArrTbl   IS TABLE OF INTEGER(10)
                           INDEX BY BINARY_INTEGER;

   TYPE        numArrTbl1   IS TABLE OF NUMBER(15,1)
                           INDEX BY BINARY_INTEGER;

   TYPE        txtArrTbl   IS TABLE OF VARCHAR2(50)
                           INDEX BY BINARY_INTEGER;


   PROCEDURE load_latlon;

   PROCEDURE input;

   PROCEDURE get_stores (
             zip5           IN NUMBER
             );

   PROCEDURE list_single_zip (
             zipcode        IN NUMBER
             );

   PROCEDURE check_loczip;

   PROCEDURE get_nearest_zip(
             zipin          IN NUMBER, 
             zipout        OUT NUMBER, 
             placeout      OUT VARCHAR2,
             stateout      OUT VARCHAR2,
             mmlatout      OUT NUMBER, 
             mmlonout      OUT NUMBER );

   PROCEDURE sort_by_distance (
             distance      IN     numArrTbl1,
             distorder     IN OUT numArrTbl,
             nin           IN     NUMBER,
             nout          IN     NUMBER
             );
              
   PROCEDURE list_canadian_stores;

END ziplocator;
/
show errors;
/
/* ======================================================== */

CREATE OR REPLACE PACKAGE BODY ziplocator IS

/* ======================================================== */
   PROCEDURE load_latlon IS

   CURSOR get_latlon (zipin IN NUMBER) IS
   SELECT lat_mdeg, lon_mdeg 
     FROM ziploc
    WHERE zipcode5 = zipin;

   CURSOR get_raczip IS
   SELECT zip_code
     FROM rac_locator
    WHERE record_id > 822;

   zip             NUMBER(20);
   lat             NUMBER(20);
   lon             NUMBER(20);

   BEGIN

   OPEN get_raczip;
   LOOP
      FETCH get_raczip INTO zip;
      EXIT WHEN get_raczip%NOTFOUND;
      OPEN get_latlon (zip);
      LOOP
         FETCH get_latlon INTO lat, lon;
         EXIT WHEN get_latlon%ROWCOUNT =1;
         EXIT WHEN get_latlon%NOTFOUND;
      END LOOP;
      CLOSE get_latlon;
      UPDATE rac_locator
         SET lat_mdeg = lat,
             lon_mdeg = lon
      WHERE zip_code = zip;
      COMMIT;
   END LOOP;
   CLOSE get_raczip;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         htp.p('no data found for zip '||zip||'<BR>');

   END load_latlon;
/* ======================================================== */
   PROCEDURE input IS

   zzip       NUMBER(5) := 99000;

   BEGIN

-- htp.p('input zipcode value is '||zzip||'<BR>');

   ZIPLOCATOR.get_stores(zzip);
  
   END input;
/* ======================================================== */
   PROCEDURE get_stores (
             zip5           IN NUMBER
             ) IS

   zip         number(10);
   place       VARCHAR2(50);
   state       VARCHAR2(4);
   placenear   VARCHAR2(50);
   statenear   VARCHAR2(4);

   recid       numArrTbl;
   nrzip       numArrTbl;
   nrlat       numArrTbl;
   nrlon       numArrTbl;
   nrcount     numArrTbl;
   nrtot       NUMBER(10);
   nstores     NUMBER(10);

   dname       txtArrTbl;
   dcity       txtArrTbl;
   dstate      txtArrTbl;
   dzip        numArrTbl;
   distance    numArrTbl1;
   iorder      numArrTbl;

   mmlat       NUMBER(15);
   mmlon       NUMBER(15);
   dlat        NUMBER(15);
   dlon        NUMBER(15);
   dmdeg       NUMBER(15) := 100000;

   ii          NUMBER(10);
   i           NUMBER(10);
   imax        NUMBER(10);

   mmlatp      NUMBER(15);
   mmlatm      NUMBER(15);
   mmlonp      NUMBER(15);
   mmlonm      NUMBER(15);

   CURSOR csra IS
   SELECT lat_mdeg, lon_mdeg, place_name, state_ab
     FROM ziploc
    WHERE zipcode5 = zip5;

   CURSOR csranear (zipnear IN NUMBER) IS
   SELECT lat_mdeg, lon_mdeg, place_name, state_ab
     FROM ziploc
    WHERE zipcode5 = zipnear;

   CURSOR get_count (zipin IN NUMBER) IS
   SELECT count(*)
     FROM rac_locator
    WHERE zip_code = zipin;

   CURSOR get_countll (
          latmax       IN NUMBER,
          latmin       IN NUMBER,
          lonmax       IN NUMBER,
          lonmin       IN NUMBER
          ) IS
   SELECT count(*)
     FROM rac_locator
    WHERE lat_mdeg < latmax
      AND lat_mdeg > latmin
      AND lon_mdeg < lonmax
      AND lon_mdeg > lonmin;

   CURSOR csrb  (
          latmax       IN NUMBER,
          latmin       IN NUMBER,
          lonmax       IN NUMBER,
          lonmin       IN NUMBER
          ) IS
   SELECT record_id, zip_code, lat_mdeg, lon_mdeg, company_name, city, state
     FROM rac_locator
    WHERE lat_mdeg < latmax
      AND lat_mdeg > latmin
      AND lon_mdeg < lonmax
      AND lon_mdeg > lonmin
    ORDER BY ABS(lat_mdeg - (latmin+latmax)/2), ABS(lon_mdeg - (lonmax+lonmin)/2);

   BEGIN

   htp.p('<HTML>');
   htp.p('<HEAD>');
   htp.p('</HEAD>');
   htp.p('<BODY BGCOLOR=#FFFFFF BACKGROUND="'||owihome||'/res_bg/res_hmd1_bg1_v4.jpg">');
-- CCUTIL.chtml_header ('get dealer stores by input zipcode');

   htp.p('<A HREF="'||owihome||'res_dl1/res_dld1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_header_back_button.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="430" HEIGHT="32" HSPACE="12" VSPACE="6" BORDER="0"></A>');
   htp.p('<P>');

-- htp.p('<P ALIGN=RIGHT><I>Carrier Perspective:</I><BR>');
-- htp.p('<A HREF="'||owihome||'res_dl1/res_dld1a.html" TARGET="bodyText">comfort at home</A>');

-- htp.p('<CENTER>');
   htp.p('<FONT SIZE=4><I> &nbsp Your Local Carrier&#160;&#147;Indoor Weather Experts&#148;</I></FONT>');
-- htp.p('</CENTER>');

   htp.p('<UL>');

   OPEN csra;
   FETCH csra INTO mmlat, mmlon, place, state;
   IF csra%NOTFOUND THEN
      htp.p('<P><P>');
      ZIPLOCATOR.get_nearest_zip(zip5, zip, placenear, statenear, mmlat, mmlon );
      htp.p('Zipcode '||zip5||' was not found.  The nearest numerical zipcode was used to');
      htp.p(' locate the following dealers for the area:');
      htp.p(''||placenear||', '||statenear||' '||zip||'<P><P>');
--    htp.p('Input zip is '||zip||'; lat/lon in mmdeg are '||mmlat||' / '||mmlon||'<BR>');
   ELSE 
      htp.p('The following dealers were found in your area:');
      htp.p(''||place||', '||state||' '||zip5||'<P><P>');
--    htp.p('Input zip is '||zip5||'; lat/lon in mmdeg are '||mmlat||' / '||mmlon||'<BR>');
      zip := zip5;
   END IF;
   CLOSE csra;

   OPEN get_count (zip);
   FETCH get_count INTO nstores;
   CLOSE get_count;
   IF (nstores >= 5) THEN
      ZIPLOCATOR.list_single_zip (zip);
   ELSE
      <<reset>>
      mmlatp  := mmlat + dmdeg; 
      mmlatm  := mmlat - dmdeg; 
      mmlonp  := mmlon + dmdeg; 
      mmlonm  := mmlon - dmdeg; 

      OPEN get_countll (mmlatp, mmlatm, mmlonp, mmlonm);
      FETCH get_countll INTO nstores;
      CLOSE get_countll;
      IF (nstores = 0 ) THEN
         dmdeg := dmdeg * 7;
         GOTO reset;
      ELSIF (nstores > 0 AND nstores < 5) THEN
         dmdeg := dmdeg * 3;
         GOTO reset;
      ELSE 

         OPEN csrb (mmlatp, mmlatm, mmlonp, mmlonm);
         ii := 0;
         LOOP
            ii := ii +1;
            FETCH csrb INTO recid(ii), nrzip(ii), nrlat(ii), nrlon(ii), dname(ii), dcity(ii), dstate(ii);
            EXIT WHEN csrb%NOTFOUND;
            EXIT WHEN csrb%ROWCOUNT = 20;
            dlat :=  nrlat(ii) - mmlat;
            dlon :=  nrlon(ii) - mmlon;
            distance(ii) := .00007 * SQRT (dlat * dlat  + dlon * dlon );
            iorder(ii) := ii;
            imax := ii;
         END LOOP;
         CLOSE csrb;
         ZIPLOCATOR.sort_by_distance(distance, iorder, imax, 5);
        
         
         FOR  io in 1..5 
         LOOP
         -- htp.p('iorder  is '||iorder(io)||'<BR>');
            htp.p(''||recid(iorder(io))||'; ');
            htp.p(''||dname(iorder(io))||' in '||dcity(iorder(io))||', '||dstate(iorder(io))||'');
            htp.p(''||nrzip(iorder(io))||'<BR>');  
         -- htp.p('Approx. Distance = '||distance(iorder(io))||' mi.<BR>');
         -- htp.p(' '||nrzip(io)||' lat/lon '||nrlat(io)||' / '||nrlon(io)||'<BR>');
         END LOOP;
      END IF;
   END IF;

   htp.p('<HR ALIGN="center" WIDTH=70%>');
   htp.p('<FORM METHOD="GET"');
   htp.p(' ACTION="'||wowhtml||'ZIPLOCATOR.get_stores">');
   htp.p('For U.S. offices, enter a zip code in the box below:<BR>');
   htp.p('<b>Zip Code : &nbsp</B> ');
   htp.p('<INPUT TYPE="text" NAME="zip5" Value="" SIZE=7 MAXLENGTH=5>');
   htp.p('</b> &nbsp <B><INPUT TYPE="Submit"  VALUE="Search">');
   htp.p('</B> &nbsp <INPUT TYPE="Reset" NAME="Clear" VALUE="Clear">');
   htp.p('</FORM>');

   htp.p('<P><P>');
   htp.p('For Canadian Offices, click on the button below:<BR>');

   htp.p('<FORM ACTION="'||wowhtml||'ZIPLOCATOR.list_canadian_stores"');
   htp.p(' METHOD="GET">');

-- htp.p('<DL><DD>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="List Canadian Offices">');
   htp.p('</FORM>');

   htp.p('<HR ALIGN="center" WIDTH=70%>');

   htp.p('</UL>');

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         NULL;
   END get_stores;
/* ======================================================== */
   PROCEDURE sort_by_distance (
             distance   IN       numArrTbl1,
             distorder  IN OUT   numArrTbl,
             nin        IN       NUMBER,
             nout       IN       NUMBER
             ) IS

   reorder        numArrTbl;
   recount        NUMBER(10);
   nloop          NUMBER(10);
   redist         numArrTbl;

   BEGIN

-- htp.p(' Number of elements in distorder is '||nin||'<BR>');
-- htp.p(' Number of elements to return is '||nout||'<BR>');

   recount := 1;

   nloop := 1;
   LOOP
      recount := 0;
      FOR ii in 1..(nin-1)
      LOOP
         IF (distance(distorder(ii+1)) < distance(distorder(ii) ) ) THEN
            recount := recount +1; 
            reorder(ii)     := distorder(ii+1);
            reorder(ii+1)   := distorder(ii);
            distorder(ii)   := reorder(ii);
            distorder(ii+1) := reorder(ii+1);
--          htp.p(''||ii||', '||distorder(ii)||', '||distorder(ii+1)||'<BR>');
         END IF;
      END LOOP;
--    htp.p(' Loop '||nloop||', recount = '||recount||'<BR>');
      nloop := nloop +1;
      EXIT WHEN nloop = 10;
      EXIT WHEN recount = 0;
   END LOOP;
   
   END sort_by_distance;
/* ======================================================== */
   PROCEDURE get_nearest_zip(
             zipin          IN NUMBER, 
             zipout        OUT NUMBER, 
             placeout      OUT VARCHAR2,
             stateout      OUT VARCHAR2,
             mmlatout      OUT NUMBER, 
             mmlonout      OUT NUMBER ) IS

   zip          NUMBER(10);
   zipup        NUMBER(10);
   zipdown      NUMBER(10);
   place        varchar2(50);
   state        varchar2(4);
 
   CURSOR check_zipup IS
   SELECT zipcode5  
     FROM ziploc
    WHERE zipcode5 > zipin
    ORDER BY zipcode5 ASC;

   CURSOR check_zipdown IS
   SELECT zipcode5  
     FROM ziploc
    WHERE zipcode5 < zipin
    ORDER BY zipcode5 DESC;

   CURSOR get_latlon (zipvar IN NUMBER) IS
   SELECT lat_mdeg, lon_mdeg, place_name, state_ab
     FROM ziploc
    WHERE zipcode5 = zipvar;

   BEGIN

-- htp.p('find nearest zipcode to '||zipin||'<BR>');

   OPEN check_zipup;
   FETCH check_zipup INTO zipup;
   CLOSE check_zipup;
   
   OPEN check_zipdown;
   FETCH check_zipdown INTO zipdown;
   CLOSE check_zipdown;

   IF ( (zipup - zipin) < (zipin - zipdown) ) THEN
      zipout := zipup;
      zip    := zipup;
   ELSE
      zipout := zipdown;
      zip    := zipdown;
   END IF;

   OPEN get_latlon (zip);
   FETCH get_latlon INTO mmlatout, mmlonout, place, state;
   CLOSE get_latlon;
   placeout := place;
   stateout := state;

-- htp.p('next higher valid zip is '||zipup||'; next lower is '||zipdown||'<BR>');
-- htp.p('(The search used the nearest zip, which is '||zip||' in '||place||', '||state||')<BR>');

   END get_nearest_zip;
/* ======================================================== */
   PROCEDURE list_single_zip (
             zipcode        IN NUMBER
             ) IS

   dzip                NUMBER(10);
   dlat                NUMBER(15); 
   dlon                NUMBER(15); 
   dcompany            VARCHAR2(50);
   dcity               VARCHAR2(50);
   dstate              VARCHAR2(4);

   CURSOR fetch_stores IS
   SELECT zip_code, lat_mdeg, lon_mdeg, company_name, city, state
     FROM rac_locator
    WHERE zip_code = zipcode
    ORDER BY company_name;

   BEGIN

-- htp.p('There were at least 5 stores within zipcode '||zipcode||'.<BR>');
-- htp.p('All stores within this zipcode are therefore listed.<P>');

   OPEN fetch_stores;
   LOOP
      FETCH fetch_stores INTO dzip, dlat, dlon, dcompany, dcity, dstate;
      EXIT WHEN fetch_stores%NOTFOUND;
      htp.p(''||dcompany||' in '||dcity||', '||dstate||'  '||dzip||'<BR>');
   END LOOP;

   END list_single_zip;
/* ======================================================== */

   PROCEDURE check_loczip  IS

   CURSOR csra IS
   SELECT zip_code, city, county, state
     FROM rac_locator
    ORDER BY zip_code;

   CURSOR csrb (zipvar IN NUMBER) IS
   SELECT zipcode5, place_name, state_ab
     FROM ziploc
    WHERE zipcode5 = zipvar;

   BEGIN

   htp.p('This is a placeholder for check_loczip<BR>');

   END check_loczip;
/* ======================================================== */
   PROCEDURE list_canadian_stores IS

   comname             VARCHAR2(50);
   city                VARCHAR2(50);
   state               VARCHAR2(25);
   zip                 VARCHAR2(25);
   phone               VARCHAR2(25);

   CURSOR list_canada IS
   SELECT company_name, city, state, zip_code, phone_number_1
     FROM rac_loc_canada
    WHERE UPPER(country) = 'CANADA'
    ORDER BY state, city;

   BEGIN

   CCUTIL.chtml_header('Canadian Room Air Sales Offices');

   htp.p('<A HREF="'||owihome||'res_dl1/res_dld1.html" TARGET="bodyText">');
   htp.p('<IMG SRC="'||owihome||'res_media/res_back_button.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="89" HEIGHT="40" BORDER="0"></A>');

   htp.p('<CENTER>');
   htp.p('<FONT SIZE=4> Canadian Room Air Conditioner Sales Offices</FONT><P><P>');
   htp.p('</CENTER>');

   htp.p('<UL>');
   OPEN list_canada;
   LOOP
      FETCH list_canada INTO comname, city, state, zip, phone;
      EXIT WHEN list_canada%NOTFOUND;
      htp.p(''||comname||'<BR>');
      htp.p(''||city||', '||state||'  '||zip||'<BR><P>');
      -- ; phone '||phone||'<BR><P>');
   END LOOP;
   CLOSE list_canada;
   htp.p('</UL>');

   CCUTIL.chtml_footer;

   END list_canadian_stores;
/* ======================================================== */
END ziplocator;
/
show errors;
/
