DROP PACKAGE cdealer;
CREATE OR REPLACE PACKAGE cdealer AS

   ID                  NUMBER(10);
   fld_rec             field_properties%ROWTYPE;

   basehtml            VARCHAR2(60)    := 'http://www.carrier.com/';
   basewow             VARCHAR2(60)    := 'http://wwwd.carrier.com:6399/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wp/';

   widthll             NUMBER(10)      := 162;

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE numTblType      IS TABLE OF number(10)
                        INDEX BY BINARY_INTEGER;


   PROCEDURE locate_dealer;

   PROCEDURE get_locator_counties (
             state_name          IN VARCHAR2
             );

   PROCEDURE get_locator_dealers (
             state_name        IN VARCHAR2,
             county_name       IN VARCHAR2
             );

   PROCEDURE get_canadian_dealers (
             province          IN VARCHAR2
             );

   PROCEDURE select_region_header (
             state_name         IN VARCHAR2
             );

   PROCEDURE select_county_header (
             state_name         IN VARCHAR2
             );

   PROCEDURE display_DLR_office_header (
             state_name         IN VARCHAR2
             );

   PROCEDURE display_CAN_DLR_office_header (
             province            IN VARCHAR2
             );


END cdealer;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cdealer IS

/*======================================================*/
   PROCEDURE locate_dealer IS

   state2                    VARCHAR2(20);

   CURSOR get_states IS
   SELECT distinct state
     FROM dist_merged;

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<P><BR><P>');

   htp.p('<CENTER><FONT SIZE=4>Select State for Dealer/Distributor');
   htp.p('</FONT></CENTER><P>');

   htp.p('<UL>');
   htp.p('<FORM METHOD="POST" TARGET="bodyText"
   ACTION="'||wowhtml||'CMODFLD.get_locator_counties">');
   htp.p('<SELECT NAME="state_name" SIZE="10" >');
   OPEN get_states;
   LOOP
      FETCH get_states INTO state2;
      EXIT WHEN get_states%NOTFOUND;
      htp.p('<OPTION VALUE="'||state2||'">'||state2||'');
      htp.p('<P>');
   END LOOP;
   close get_states;
   htp.p('<OPTION VALUE="NONE" SELECTED>NONE<P>');
   htp.p('</SELECT><BR>');
   htp.p('<INPUT TYPE="SUBMIT" VALUE="Select State">');
   htp.p('</FORM>');
   htp.p('</UL>');
   
   CCUTIL.chtml_footer;

   END locate_dealer;
/*======================================================*/
   PROCEDURE get_locator_counties (
             state_name          IN VARCHAR2
             ) IS

   county2                  VARCHAR2(50);

   CURSOR get_counties IS
   SELECT distinct county
     FROM dist_merged
    WHERE upper(state) = upper(state_name);

   CURSOR count_counties IS
   SELECT count(county) 
     FROM dist_merged
    WHERE upper(state) = upper(state_name);

   county_num       NUMBER(10) := 0;
   loopcount        NUMBER(10);

   BEGIN

   CCUTIL.chtml_header;

   CMODFLD.select_county_header(state_name);

   htp.p('<P><BR>');

   OPEN count_counties;
   FETCH count_counties INTO county_num;
   IF count_counties%NOTFOUND THEN 
      county_num := 0;
   END IF;
   CLOSE count_counties;

   htp.p('<UL>');
-- htp.p('<CENTER>');
   IF (county_num = 0) THEN
      htp.p('<FONT SIZE=4>No Counties were listed for state '||state_name||'</FONT><P>');
      CMODFLD.locate_dealer;
   ELSE
   
--    htp.p('<UL>');
      htp.p('<FORM METHOD="POST" TARGET="bodyText"
        ACTION="'||wowhtml||'CMODFLD.get_locator_dealers">');
      htp.p('<INPUT TYPE="HIDDEN" NAME="state_name" VALUE="'||state_name||'">');
      htp.p('<SELECT NAME="county_name" SIZE="10" >');
      loopcount := 0;
      OPEN get_counties;
      LOOP
         loopcount := loopcount +1;
         FETCH get_counties INTO county2;
         EXIT WHEN get_counties%NOTFOUND;
         IF (loopcount = 1) THEN
            CCUTIL.comment('loopcount is 1, this should be selected');
            htp.p('<OPTION VALUE="'||county2||'"  SELECTED>'||county2||'');
         ELSE
            htp.p('<OPTION VALUE="'||county2||'">'||county2||'');
         END IF;
         htp.p('<P>');
      END LOOP;
      close get_counties;
--    htp.p('<OPTION VALUE="NONE" SELECTED>NONE');
      htp.p('<P>');
      htp.p('</SELECT><BR>');
      htp.p('<INPUT TYPE="SUBMIT" VALUE="List Sales Offices">');
      htp.p('</FORM>');
--    htp.p('</UL>');
   
      CCUTIL.chtml_footer;
   END IF;
-- htp.p('</CENTER>');

   htp.p('</UL>');

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         htp.p('<P><BR><P>');
         htp.p('<FONT SIZE=4>You Must Select A State</FONT><P>');
         CMODFLD.locate_dealer;
   END get_locator_counties;
/*======================================================*/
   PROCEDURE get_locator_dealers (
             state_name        IN VARCHAR2,
             county_name       IN VARCHAR2
             ) IS

   county2                  VARCHAR2(50);
   state2                   VARCHAR2(5);
   locrec                   dist_merged%ROWTYPE;
   iid                      number(10);
   street_address           VARCHAR2(50);

   distidno                 dist_merged.dist_id%TYPE;
   distidtab                numTblType;
   num_branches             NUMBER(10) := 0;

   CURSOR get_distid  IS
   SELECT distinct dist_id 
     FROM dist_merged
    WHERE upper(state) LIKE upper(SUBSTR(state_name,1,2) )
      AND upper(county) = upper(county_name);

   CURSOR get_main_office  (distid IN varchar2) IS
   SELECT *
     FROM dist_merged
    WHERE SUBSTR(dist_id,1,5) = distid
      AND upper(state) LIKE upper(SUBSTR(state_name,1,2) )
      AND upper(county) = upper(county_name)
      AND office_type = 'MAIN';

   CURSOR get_num_branches (distid IN varchar2) IS
   SELECT count(*) 
     FROM dist_merged
    WHERE substr(dist_id,1,5) = SUBSTR(distid,1,5)
      AND upper(state) LIKE upper(SUBSTR(state_name,1,2) )
      AND upper(county) = upper(county_name)
      AND office_type = 'BRANCH';

   CURSOR get_branches  (distid IN varchar2) IS
   SELECT *
     FROM dist_merged
    WHERE substr(dist_id,1,5) = SUBSTR(distid,1,5)
      AND upper(state) LIKE upper(SUBSTR(state_name,1,2) )
      AND upper(county) = upper(county_name)
      AND office_type = 'BRANCH';

   BEGIN

   CCUTIL.chtml_header;

   county2 := county_name;
   state2  := state_name;

   htp.p('<UL>');
   IF (county_name ='NONE') THEN
      htp.p('<FONT SIZE=5> You Must Select A County</FONT><P><P>');
      get_locator_counties(state_name);
   ELSE
      CMODFLD.display_dlr_office_header(state_name);

      CCUTIL.comment('state is '||state_name||', county is ['||county_name||'];');
      htp.p('<P><BR><P>');
      iid :=0;
      OPEN get_distid;
      LOOP
         iid := iid+1;
         FETCH get_distid INTO distidtab(iid);
         EXIT WHEN get_distid%NOTFOUND;
         CCUTIL.comment('for iid = '||iid||' distid is '||distidtab(iid)||';');
      END LOOP;
      CLOSE get_distid;

      distidno := SUBSTR(distidtab(1),1,5);
      OPEN get_main_office (distidno);
      FETCH get_main_office INTO locrec;
      IF get_main_office%NOTFOUND THEN
         htp.p('Suitable error message -- main office not found<BR>');
      ELSE
         htp.p('<TABLE CELLSPACING=3 BORDER=0>');
         htp.p('<TR>');
         htp.p('<TD><B>Office:</B></TD>');
         htp.p('<TD>'||locrec.dist_name||'</TD>');
         htp.p('</TR>');
         IF (locrec.st_zip IS NOT NULL) THEN
            street_address := locrec.st_address||' (ZIP '||locrec.st_zip||')';
         ELSE
            street_address := locrec.st_address;
         END IF;
         CCUTIL.if_table_2col(3, '<BR>', street_address);
         IF (locrec.po_box IS NOT NULL) THEN
            CCUTIL.if_table_2col(3, '<BR>', 'PO Box '||locrec.po_box);
         END IF;
         CCUTIL.if_table_2col(3, '<BR>', 
             locrec.city||', '||locrec.state_abbr||' '||locrec.zip_code);
         CCUTIL.if_table_2col(3, 'Phone:', locrec.phone_1);
         CCUTIL.if_table_2col(3, '<BR>', locrec.phone_2);
         CCUTIL.if_table_2col(3, 'Fax:', locrec.Fax);
         IF (locrec.url IS NOT NULL) THEN
            CCUTIL.if_table_2col(3, 'URL:', '<A TARGET=EXTERNAL HREF="http://'||locrec.url||'">'||locrec.url||'</A>');
         END IF;
         CCUTIL.if_table_2col(3, 'Contact:', locrec.Contact);
         CCUTIL.if_table_2col(3, 'Email:', locrec.e_mail);
         htp.p('</TABLE>');
      END IF;
      CLOSE get_main_office;
      htp.p('<P>');

      OPEN get_num_branches(distidno);
      FETCH get_num_branches INTO num_branches;
      IF get_num_branches%NOTFOUND THEN
         num_branches := 0;
      END IF;

      IF (num_branches > 0) THEN
         htp.p('<B>Branches:</B><P>');
      END IF;
      OPEN get_branches (distidno);
      LOOP
         FETCH get_branches INTO locrec;
         EXIT WHEN get_branches%NOTFOUND;
         htp.p('<TABLE CELLSPACING=3 BORDER=0>');
     --  htp.p('<TR>');
     --  htp.p('<TD><B>Office:</B></TD>');
     --  htp.p('<TD>'||locrec.dist_name||'</TD>');
     --  htp.p('</TR>');
         IF (locrec.st_zip IS NOT NULL) THEN
            street_address := locrec.st_address||' (ZIP '||locrec.st_zip||')';
         ELSE
            street_address := locrec.st_address;
         END IF;
         CCUTIL.if_table_2col(3, '<BR>', street_address);
         IF (locrec.po_box IS NOT NULL) THEN
            CCUTIL.if_table_2col(3, '<BR>', 'PO Box '||locrec.po_box);
         END IF;
         CCUTIL.if_table_2col(3, '<BR>', 
             locrec.city||', '||locrec.state_abbr||' '||locrec.zip_code);
         CCUTIL.if_table_2col(3, 'Phone:', locrec.phone_1);
         CCUTIL.if_table_2col(3, '<BR>', locrec.phone_2);
         CCUTIL.if_table_2col(3, 'Fax:', locrec.Fax);
         CCUTIL.if_table_2col(3, 'URL:', locrec.url);
         CCUTIL.if_table_2col(3, 'Contact:', locrec.Contact);
         CCUTIL.if_table_2col(3, 'Email:', locrec.e_mail);
         htp.p('</TABLE>');
         htp.p('<P>');
      END LOOP;
      CLOSE get_branches;

      CCUTIL.chtml_footer;
   END IF;
   htp.p('</UL>');

   END get_locator_dealers;
/*======================================================*/
   PROCEDURE get_canadian_dealers (
             province         IN VARCHAR2
             )  IS

   CURSOR get_dealers IS
   SELECT * 
     FROM com_locator
    WHERE upper(country) LIKE 'CA%';

   street_address          VARCHAR2(80);
   carec                   get_dealers%ROWTYPE;

   BEGIN

   CCUTIL.chtml_header;

   CMODFLD.display_can_dlr_office_header(province);
   htp.p('<P>');

   htp.p('<UL>');
   OPEN get_dealers;
   LOOP
      FETCH get_dealers INTO carec;
      EXIT WHEN get_dealers%NOTFOUND;

      htp.p('<TABLE CELLSPACING=3 BORDER=0>');
      htp.p('<TR>');
      htp.p('<TD><B>Office:</B></TD>');
      htp.p('<TD>'||carec.dist_name||'</TD>');
      htp.p('</TR>');
      IF (carec.st_zip IS NOT NULL) THEN
         street_address := carec.st_address||' (ZIP '||carec.st_zip||')';
      ELSE
         street_address := carec.st_address;
      END IF;
      CCUTIL.if_table_2col(3, '<BR>', street_address);
      IF (carec.po_box IS NOT NULL) THEN
         CCUTIL.if_table_2col(3, '<BR>', 'PO Box '||carec.po_box);
      END IF;
      CCUTIL.if_table_2col(3, '<BR>', 
          carec.city||', '||carec.state||' '||carec.zip_code);
      CCUTIL.if_table_2col(3, 'Phone:', carec.phone_1);
      CCUTIL.if_table_2col(3, '<BR>', carec.phone_2);
      CCUTIL.if_table_2col(3, 'Fax:', carec.Fax);
      CCUTIL.if_table_2col(3, 'URL:', carec.url);
      CCUTIL.if_table_2col(3, 'Contact:', carec.Contact);
      CCUTIL.if_table_2col(3, 'Email:', carec.e_mail);
      htp.p('</TABLE>');
      htp.p('<P>'); 
   END LOOP;
   CLOSE get_dealers;
   htp.p('</UL>');
   
   END get_canadian_dealers;
/*======================================================*/
/*======================================================*/
   PROCEDURE select_region_header (
             state_name      IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; Select region

   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_bss.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   htp.p('<UL>');
   htp.p('<FONT SIZE 4>');
   htp.p('<B>Select the appropriate region for '||state_name||'</B><P>');
   htp.p('</FONT>');
   htp.p('</UL>');

   END select_region_header;
/*======================================================*/
   PROCEDURE select_county_header (
             state_name      IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices; Select county
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_dlr.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   htp.p('<UL>');
   htp.p('<FONT SIZE 4>');
   htp.p('<B>Select the appropriate county for '||state_name||'</B><P>');
   htp.p('</FONT>');
   htp.p('</UL>');

   END select_county_header;
/*======================================================*/
   PROCEDURE display_DLR_office_header (
             state_name      IN VARCHAR2
             ) IS

   BEGIN

-- back buttons; N Am. Sales Offices;
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_dlr.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');
   
   htp.p('<A HREF="'||wowhtml||'CMODFLD.get_locator_counties?state_name='||state_name||'">');
   htp.p('<FONT SIZE=2>back to Sales Offices in '||state_name||'</FONT></A>');
   htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   END display_DLR_office_header;
/*======================================================*/
   PROCEDURE display_CAN_DLR_office_header (
             province            IN VARCHAR2
             )  IS

   BEGIN

-- back buttons; N Am. Sales Offices;
   
   htp.p('<A HREF="'||owihome||'com_dl1/com_dld1_dlr.html#usandcanada">');
   htp.p('<FONT SIZE=2>back to North America Sales Office map</FONT></A>');
   htp.p('<P><P>');
   
-- htp.p('<A HREF="'||wowhtml||'CMODFLD.get_locator_counties?state_name='||state_name||'">');
-- htp.p('<FONT SIZE=2>back to Sales Offices in '||state_name||'</FONT></A>');
-- htp.p('<P><P>');

   htp.p('<FONT SIZE=5>');
   htp.p('North America Sales Offices<BR>');
   htp.p('</FONT>');

   END display_CAN_DLR_office_header;
/*======================================================*/
END cdealer;
/
show errors;
/
