DROP PACKAGE cput;
CREATE OR REPLACE PACKAGE cput AS

   ID                  NUMBER(10);

   basehtml            VARCHAR2(60)    := 'http://mork.infomall.org/';
   basewow             VARCHAR2(60)    := 'http://mindy.infomall.org:6380/';
   wowhtml             VARCHAR2(70)    := basewow||'cgi-bin/ifc/';
   owihome             VARCHAR2(70)    := basehtml||'wpstg/';
   plhome              VARCHAR2(100)   := basewow||'cgi-bin/cdata/';

-- wow6377             VARCHAR2(70)    := 'http://mindy.infomall.org:6377/';
   widthll             NUMBER(10)      := 162;

   TYPE fieldTblType    IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   TYPE textTblType     IS TABLE OF VARCHAR2(50)
                        INDEX BY BINARY_INTEGER;

   PROCEDURE get_gen_types_B;

   PROCEDURE load_commercial_ptypes_B;

   PROCEDURE list_models (
             spec_type    IN VARCHAR2
             );

   PROCEDURE llm (
             spec_type    IN VARCHAR2
             );

   PROCEDURE write_modelpage (
             spec_type    IN VARCHAR2
             );

END cput;
/
show errors;
/
/*======================================================*/

CREATE OR REPLACE PACKAGE BODY cput IS

/*======================================================*/
   PROCEDURE get_gen_types_B IS

   general_type            VARCHAR2(50);
   htmlgeneral             VARCHAR2(50);
   hgen                    VARCHAR2(50);
   stype                   VARCHAR2(50);
   hsp                     VARCHAR2(50);
   igen                    NUMBER(10);
   isgen                   NUMBER(10);

   gentypetab               textTblType;

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   CURSOR get_gtypes IS
   SELECT distinct generaltype
     FROM commercial_products
    WHERE obsolete=0;

   CURSOR get_stypes (gentype IN VARCHAR2) IS
   SELECT  distinct specifictype
     FROM commercial_products
    WHERE generaltype = gentype
      AND obsolete=0;

   BEGIN

   CCUTIL.chtml_header('get com general types drilldown B');

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.nav_upto_comfort_atwork;
-- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
-- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.caw_featured_product;
-- CCUTIL.caw_featured_technology;
-- CCUTIL.caw_new_gif1;
-- CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<P>');

   htp.p('<CENTER>');
   CCUTIL.com_resource_buttons;
   htp.p('<BR><HR ALIGN="center" WIDTH="100"><BR>');
   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for type '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for type '||general_type||'');
         CCUTIL.chtml_footer;
   END get_gen_types_B;
/*======================================================*/
   PROCEDURE load_commercial_ptypes_B IS

   BEGIN

   CCUTIL.chtml_header_frame('load commercial product types');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME SRC="'||wowhtml||'CPUT.get_gen_types_B"');
        htp.p('NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8 >');
        htp.p('<FRAME SRC="'||basewow||'cgi-bin/cdata/write_gen_types_B.sh" ');
         htp.p('NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 >');
    htp.p('</FRAMESET>');
    htp.p('</FRAMESET>');
    htp.p('<NOFRAME>');
    htp.p('<P><BR>This is a placeholder for load_commercial_ptypes_B');
    htp.p('</NOFRAME>');

   CCUTIL.chtml_footer;

   END load_commercial_ptypes_B;
/*======================================================*/
   PROCEDURE llm (
             spec_type    IN VARCHAR2
             ) IS

   htmlgen          VARCHAR2(50);
   htmlsp           VARCHAR2(50);
   htmlst           VARCHAR2(100);
   htmlstpl         VARCHAR2(100);
   specific_type    VARCHAR2(50);
   general_type     VARCHAR2(50);

   BEGIN

   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$')-1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

   htmlsp     :=  REPLACE(specific_type, ' ', '+');
   htmlsp     :=  REPLACE(htmlsp, '-', '%2D');
   htmlgen    :=  REPLACE(general_type, ' ', '+');
   htmlgen    :=  REPLACE(htmlgen, '-', '%2D');
   htmlst     :=  htmlgen||'$'||htmlsp;
   htmlstpl   :=  'generaltype='||htmlgen||'&specifictype='||htmlsp;
  

   CCUTIL.chtml_header_frame('load list com models');

   CCUTIL.load_comfort_atwork_ab;

   htp.p('<FRAMESET COLS="'||widthll||',*">');
        htp.p('<FRAME  NAME="contentNav" SCROLLING="auto" MARGINWIDTH=8 MARGINHEIGHT=8
          SRC="'||wowhtml||'CPUT.list_models?spec_type='||htmlst||'">');

    IF ( upper(general_type) LIKE 'ROOM AIR%') THEN  
        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||wowhtml||'CPUT.write_modelpage?spec_type='||htmlst||'"> ');
    ELSE
        htp.p('<FRAME NAME="bodyText" SCROLLING="vert" MARGINWIDTH=12 MARGINHEIGHT=12 
          SRC="'||basewow||'cgi-bin/cdata/write_com_seguepage.sh?'||htmlstpl||'"> ');
    END IF;


   htp.p('</FRAMESET>');
   htp.p('</FRAMESET>');
   htp.p('</BODY>');

   END llm;
/*======================================================*/
   PROCEDURE write_modelpage (
             spec_type    IN VARCHAR2
             ) IS

   modelno                 VARCHAR2(50);
   htmlmodelno             VARCHAR2(50);
   general_type            VARCHAR2(50);
   specific_type           VARCHAR2(50);
   min_cap                 VARCHAR2(50);
   max_cap                 VARCHAR2(50);

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);
   
   CURSOR get_models (g_type IN VARCHAR2, 
                      s_type IN VARCHAR2) IS
   SELECT substr(model,1,50),  minclgcap, maxclgcap 
   FROM   commercial_products
   WHERE  generaltype = g_type AND specifictype = s_type;

   BEGIN

   CCUTIL.chtml_header('Commercial Model Page Path ?');

   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$')-1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

-- STAGING TEMP
   IF (upper(general_type) LIKE 'ROOM AIR%') THEN
   -- CRACDOCSZ.write_rac_modelpage(general_type, specific_type);
      NULL;
   ELSE

      htp.p('<P><HR><P>');
      htp.p('<CENTER>');
      htp.p('<FONT SIZE=5>About '||general_type||': '||specific_type||'</FONT></A><P>');
      htp.p('</CENTER>');
      htp.p('<P><HR><P>');
   
      OPEN get_models (general_type, specific_type);
      LOOP
         FETCH get_models INTO modelno, min_cap, max_cap;
         EXIT WHEN get_models%NOTFOUND;
   
         IF (min_cap IS NOT NULL AND max_cap IS NOT NULL) THEN
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||modelno||': Cooling Capacity Range is ');
            htp.p(to_number(min_cap)||'-'||to_number(max_cap)||' Tons</FONT><P>');
            htp.p('<UL>');
            htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
            htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
            htp.p('</UL>');
         ELSE
            htp.p('<P><P>');
            htp.p('<FONT SIZE=4>'||modelno||'</FONT><P>');
            htp.p('<UL>');
            htp.p('Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy');
            htp.p('nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.');
            htp.p('</UL>');
         END IF;
         htp.p('<P><HR>');
      END LOOP;
      CLOSE get_models;

   END IF;

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
   END write_modelpage;
/*======================================================*/
   PROCEDURE list_models (
             spec_type    IN VARCHAR2
             ) IS

   modelno                 VARCHAR2(35);
   htmlmodelno             VARCHAR2(35);
   general_type            VARCHAR2(50);
   specific_type           VARCHAR2(50);
   min_cap                 VARCHAR2(50);
   max_cap                 VARCHAR2(50);
   downloadtag             NUMBER(10);

   unittype1               VARCHAR2(10) := 'English';
   unittype2               VARCHAR2(10) := 'metric';

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);
   
   CURSOR get_models (g_type IN VARCHAR2, 
                      s_type IN VARCHAR2) IS
   SELECT substr(model,1,50),  minclgcap, maxclgcap, downloadables
   FROM   commercial_products
   WHERE  generaltype = g_type AND specifictype = s_type
     AND  obsolete = 0;

   BEGIN

   CCUTIL.chtml_header;

   htp.p('<CENTER>');
   CCUTIL.nav_upto_carrier_homepage;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.nav_upto_comfort_atwork;
-- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
-- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.nav_upto_commercial_products_B;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_whatsnew;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
-- CCUTIL.caw_featured_product;
-- CCUTIL.caw_featured_technology;
-- CCUTIL.caw_new_gif1;
-- CCUTIL.caw_case_study;
   CCUTIL.hotlink_commercial_qa;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.hotlink_commercial_locator;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
   CCUTIL.caw_colls_search;

   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<P>');
   htp.p('</CENTER>');


   general_type  := SUBSTR(spec_type, 1, INSTR(spec_type, '$')-1 ); 
   specific_type := SUBSTR(spec_type, INSTR(spec_type, '$') +1 );

   htp.p('<FONT SIZE=2>');
   htp.p('<CENTER>');
   htp.p('<I>'||general_type||' - '||specific_type||' Models</I>');
   htp.p('<P>');
   OPEN get_models(general_type, specific_type);
   LOOP
      FETCH get_models INTO modelno, min_cap, max_cap, downloadtag;
      EXIT WHEN get_models%NOTFOUND;
      htmlmodelno := REPLACE (modelno, ' ', '+');
      htmlmodelno := REPLACE (modelno, '-', '%2D');

      IF (min_cap IS NOT NULL AND max_cap IS NOT NULL) THEN
         htp.p('<A TARGET="_parent"
          HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'');
         htp.p('&unittype='||unittype1||'">');
     --  htp.p(''||modelno||' ('||min_cap||'-'||max_cap||')</A><P>');
         htp.p(''||modelno||'</A><BR>');
      ELSE
         htp.p('<A TARGET="_parent"
          HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'');
         htp.p('&unittype='||unittype1||'">');
         htp.p(''||modelno||'</A><BR>');
      -- htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
      -- htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="8" BORDER="0"><BR>');
      END IF;
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</FONT>');

/*  reinstate this for DOWNLOADABLES
   htp.p('<CENTER>');
   IF (downloadtag =1) THEN
      htp.p('<I>Downloadables</I><BR>');
      htp.p('<HR ALIGN="center" WIDTH="100">');
   ELSE
      NULL;
   END IF;
   htp.p('</CENTER>');
*/

   htp.p('<CENTER>');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.com_resource_buttons;
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('<IMG SRC="'||owihome||'nao_media/xp.gif"');
   htp.p(' ALIGN=MIDDLE WIDTH="100" HEIGHT="16" BORDER="0">');

   CCUTIL.hotlink_copyright;
   htp.p('<HR ALIGN="center" WIDTH="100">');
   htp.p('</CENTER>');

   CCUTIL.chtml_footer;

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||general_type||'');
         CCUTIL.chtml_footer;
   END list_models;
/*======================================================*/
   PROCEDURE redisplay_models (
             modelno           IN VARCHAR2
             ) IS

   value_error             EXCEPTION;
   PRAGMA    EXCEPTION_INIT (value_error, -06502);

   str_line_num            EXCEPTION;
   PRAGMA    EXCEPTION_INIT (str_line_num, -06512);

   gen_type             VARCHAR2(50);
   spec_type            VARCHAR2(50);
   htmlgeneral          VARCHAR2(50);
   modelnum             VARCHAR2(50);
   htmlmodelno          VARCHAR2(50);

   CURSOR get_gentype IS
   SELECT generaltype, specifictype
   FROM   commercial_products
   WHERE  upper(model) = upper(modelno);
   
   CURSOR get_models (general_type IN VARCHAR2, specific_type IN VARCHAR2) IS
   SELECT substr(model,1,50)
   FROM   commercial_products
   WHERE  generaltype = general_type AND specifictype = specific_type;

   BEGIN

   OPEN get_gentype;
   LOOP
      FETCH get_gentype into gen_type, spec_type;
      EXIT WHEN get_gentype%ROWCOUNT =1;
      EXIT WHEN get_gentype%NOTFOUND;
   END LOOP;
   CLOSE get_gentype;

   htp.p('<HR><BR>');
   htp.p('<CENTER><I>'||gen_type||' - '||spec_type||'</I><BR> Models</CENTER><P>');

   htp.p('<CENTER>');
   OPEN get_models (gen_type, spec_type);
   LOOP
      FETCH get_models INTO modelnum;
      EXIT WHEN get_models%NOTFOUND;

      htmlmodelno := REPLACE (modelnum, ' ', '+');
      htp.p('<A  TARGET="_parent"
       HREF="'||wowhtml||'CPUTT.load_com_product_info?modelno='||htmlmodelno||'">');
      htp.p('<NOBR>'||modelnum||'</A><BR>');
   END LOOP;
   CLOSE get_models;
   htp.p('</CENTER>');

   htp.p('<P>');

   CCUTIL.chtml_footer;
           
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         CCUTIL.chtml_header('No Products Found');
         CCUTIL.chtml_footer;
      WHEN value_error THEN
         CCUTIL.chtml_header('ORA-06502 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
      WHEN str_line_num THEN
         CCUTIL.chtml_header('ORA-06512 for model '||modelno||' of '||gen_type||'');
         CCUTIL.chtml_footer;
   END redisplay_models;
/*======================================================*/
END cput;
/
show errors;
/
