#include "utils.h"

/*
 To delete an agent, pass the agent id (not the agent name)
 as displayed by the server.
*/

int DeleteAgent(const char* server, 
				int port,
				const char* user, 
				const char* passwd,
				const char* agentId)
{
	char* 		auth = 0;
	char       *response = NULL;
	char       *toc = NULL;
	char       *response_header = NULL;
	int 		status = 0;
    char 		header[1024];
    char 		cleanAgent[512];
    char 		body[1024];
    char 		post_msg[1024];
	int 		rc = 0;
	const char* uri = "/agents";

#ifdef WIN32

    if (gSocketInitDone == 0) {
        wVersionRequested = MAKEWORD(1, 1);

        err = WSAStartup(wVersionRequested, &wsaData);
        gSocketInitDone = 1;

        if (err != 0) {
            /* Tell the user that we couldn't find a useable */
            /* winsock.dll.     */
            printf("Failed to initialize socket library\n");
            return (-1);
        }
    }
#endif

	MakeBasicAuthentication(user, passwd, &auth);

	EncodeUrl(cleanAgent, agentId); 

	sprintf(body, "NS-agent-page=delete&nsAgentId=%s", cleanAgent);

	sprintf(header, "Content-Length:%d\n \
	 Content-Type: application/x-www-form-urlencoded; charset=US-ASCII\n\
	 Content-Transfer-Encoding: 7bit\nAuthorization: %s", 
								strlen(body), auth);

	/* build post message */
	sprintf(post_msg, "%s\n\n%s\n", header, body);

	rc = DoHttpPost(server, port, uri, post_msg, auth,  &response_header, 
					&response, &status);

	if (response && strstr(response, "result = \"Success\"") == 0) {
		printf("response: %s\n", response);
		rc = FAILURE;
	}
	else {
		rc = SUCCESS;
	}
	

	if (response_header)
		free(response_header);
	if (response) {
		free(response);
	}
	free(auth);
	return rc;
}


main(int argc, char* argv[])
{
	int rc;

	if (argc <= 1) {
		printf("Usage: remove <agentid>\n");
		exit(-1);
	}

	rc = DeleteAgent("hyperion.mcom.com", 80, "user", "user", argv[1]);

	printf("Delete of agent %s returned %s\n", argv[1], rc==SUCCESS?"Success":
														"Failure");
}

