#include "utils.h"

const char* NextAgent(const char* input, char* output)
{
        const char* p1, *p2;
        char* idp;
        char id[256];

        p1 = input;
		*output = 0;
        if ( (p1 = strstr(p1, "<option")) ) {
                while (*p1 != '"') ++p1;
                idp = output;
                ++p1;
                while (*p1 != '"')
                        if (*p1 != ' ' && *p1 != '\n' && *p1 != '\r')
                                *idp++ = *p1++;
                        else p1++;
                *idp = 0;
        }
		else return 0;

		return p1;


}


/* Caller must free the returned buffer */
char* GetToc(const char* server,
        int port,
        const char* user,
        const char* passwd
        )
{
    char*       auth = 0;
    char       *response = NULL;
    char       *response_header = NULL;
    int         status = 0;
    char        header[1024];
    char        body[1024];
    char        post_msg[1024];
    int         rc = 0;
    const char* uri = "/Agents";

    MakeBasicAuthentication(user, passwd, &auth);

    sprintf(body, "nsAgentPage=toc&nsAgentAction=no&nsUserType=Standard");

    sprintf(header, "Content-Length:%d\n\
    Content-Type: application/x-www-form-urlencoded; charset=US-ASCII\n\
    Content-Transfer-Encoding: 7bit", strlen(body));

    /* build post message except PUT uri HTTP/1.0 */
    sprintf(post_msg, "%s\n\n%s\n", header, body);


    rc = DoHttpPost(server, port, uri, post_msg, auth,  &response_header,
                        &response, &status);

    /* printf("Response Header: %s\n", response_header);
    printf("Response status: %d\n", status);
    fprintf(logFp, "Response: %s\n", response);
    printf( "Response: %s\n", response);
    printf( "TOC Response: %s\n", response);
    */


    if (response_header)
        free(response_header);

    free(auth);

    return response;
}


int ListAgents(const char* server, 
				int port,
				const char* user, 
				const char* passwd,
				short maxCount /* how many to list */)
{
	char* 		auth = 0;
	char       *response = NULL;
	char       *toc = NULL;
	char       *response_header = NULL;
	int 		status = 0;
    char 		header[1024];
    char 		body[1024];
    char 		post_msg[1024];
	int 		rc = 0;
	const char* uri = "/Agents";
	char nextAgent[512];
	char cleanAgent[512];
	const char* savedPtr;
	int count = 0;
	int i;

#ifdef WIN32

    if (gSocketInitDone == 0) {
        wVersionRequested = MAKEWORD(1, 1);

        err = WSAStartup(wVersionRequested, &wsaData);
        gSocketInitDone = 1;

        if (err != 0) {
            /* Tell the user that we couldn't find a useable */
            /* winsock.dll.     */
            printf("Failed to initialize socket library\n");
            return (-1);
        }
    }
#endif

#ifdef DEBUG
	printf("server: %s\n", server);
	printf("User: %s\n", user);
	printf("Password: %s\n", passwd);
#endif

	toc = GetToc(server, port, user, passwd);
	if (!toc)
		return rc;

	savedPtr = toc;
	printf("User: %s\n", user);
	for(i=1; ( (savedPtr = NextAgent(savedPtr, nextAgent)) && maxCount > 0 );
				i++) {
		printf("%d.  Agent Id:\t\t%s\n", i, nextAgent);
		*cleanAgent = *nextAgent = 0;
	}

	free(toc);
	free(auth);

	return count;
}


main(int argc, char* argv[])
{
	int beginIndex = 0;
	int endIndex = 0;

	int i, j, k;
	char scratch[40];
	char document[40];
	const char *server = "hyperion.mcom.com";
	int port = 80;
	const char *user = "user";
	const char *passwd = "user";
	int rc;
	int instance;
	int total;
	int failedCount = 0;

	rc = ListAgents(server, 			/* server */
				port, 				/* port */
				user, 			/* user name */
				passwd, 			/* passwd */
				100);

	return 0;
}

