

/*
 * What is this file?
 * This is a utility that allows a remote program to create an agent
 * on any server (provided the user has access permissions).
 * All you need is a network connection to that server
 * Also note that the remote server must support agent creation
 * WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
 * THIS UTILITY SENDS YOUR PASSWORD IN ROT13 FORMAT TO THE REMOTE SERVER
 * FOR AUTHENTICATION. THIS IS NOT A VERY SECURE CHANNEL. IF YOU ARE
 * NOT COMFORTABLE WITH THIS SCHEME, PLEASE DO NOT USE THIS ON ANY OTHER
 * UTILITY IN THIS PACKAGE. 

 * These are all C programs and all you need are standard C compilers and
 * C libraries. A simple makefile is also provided.
 *
 */
#include <sys/types.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef UNIX
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#endif

#ifdef WIN32
#include <winsock.h>
#endif

#ifdef WIN32
WORD wVersionRequested;
WSADATA wsaData;
int err;
static gSocketInitDone = 0;
#endif


#ifdef UNIX
#define SOCKET_ERROR 0
#endif

#ifdef WIN32
#define CLOSESOCKET closesocket
#else
#define CLOSESOCKET close
#endif

extern const char* TRICKY_POST_MSG;

/*
 * These are the events that are currently supported in the Netscape server
 * There is absolutely no guarantee that these event encodings will remain
 * the same nor is there any guarantee that the same event set will be
 * supported in the future. All these are subject to change without prior
 * notice.
 */

typedef enum _NS_Message {
    /* Document Object Messages */
    NS_DELETE_MSG           = 0,
    NS_ACCESS_MSG           = 1,
    NS_PUT_MSG              = 2,
    NS_EDIT_MSG             = 3,
    NS_SAVE_MSG             = 4,
    NS_MODIFY_MSG           = 5,
    NS_VIEW_MSG             = 6,
    NS_HEAD_MSG             = 7,
    NS_POST_MSG             = 8,
    NS_OPEN_MSG             = 9,
    NS_CLOSE_MSG            = 10,
    NS_READ_MSG             = 11,
    NS_WRITE_MSG            = 12,
    NS_MOVE_MSG             = 13,
    NS_QUERY_ATTR_MSG       = 14,
    NS_SET_ATTR_MSG         = 15,
    NS_GET_PROPERTIES_MSG   = 16,
    NS_SET_PROPERTIES_MSG   = 17,
    NS_COPY_MSG             = 18,
    NS_UNLOCK_MSG           = 19,
    NS_LOCK_MSG             = 20,

    /* Revision Control Messages */
    NS_RC_CHECKIN_MSG       = 21,
    NS_RC_CHECKOUT_MSG      = 22,
    NS_RC_GET_LOG_MSG       = 23,
    NS_RC_LABEL_MSG         = 24,
    NS_RC_GET_REV_MSG       = 25,
    NS_RC_DIFF_MSG          = 26,
    NS_RC_STOP_VER_MSG      = 27,
    NS_RC_UNCHECKOUT_MSG    = 28,

    /* Directory Object Messages */
    NS_DELETE_DIR_MSG       = 29,
    NS_MAKE_DIR_MSG         = 30,
    NS_INDEX_MSG            = 31,
    NS_MOVE_DIR_MSG         = 32,
    NS_RM_ALL_DIR_MSG       = 33,
    NS_QUERY_DIR_ATTR_MSG   = 34,
    NS_SET_DIR_ATTR_MSG     = 35,
    NS_COPY_DIRMSG          = 36,

    /* Timer message */
    NS_TIMER_MSG            = 37,

    /* Link management */
    NS_VERIFY_LINK          = 38,

    /* Acl's */
    NS_GETACL_MSG           = 39,
    NS_SETACL_MSG           = 40
} NS_Messages;

/* Various timers supported */

typedef enum ns_agent_timer_type{
    eTimerSpecific,
    eTimerPeriodicMinutes,
    eTimerPeriodicHours,
    eTimerPeriodicDays,
    eTimerPeriodicWeeks,
    eTimerPeriodicMonths,
    eTimerPeriodicYears,
    eTimerSelective,
    eUnknown=-1
} ETimerType;

/* Used by Search Agents */
typedef enum { eSearchUpdated, /* Search updated documents only */
				 eSearchAll   /* search all documents */
			 } ESearchType;

/* The magic set of 64 chars in the uuencoded data */
static unsigned char uuset[] = {
    'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
    'P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d',
    'e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
    't','u','v','w','x','y','z','0','1','2','3','4','5','6','7',
    '8','9','+','/' };

extern const int NET_CONNECT_ERROR;
extern const int OUT_OF_MEMORY ;
extern const int NET_SOCKET_ERROR ;
extern const int HTTP_ERROR ;
extern const int NO_SUCH_HOST ;
extern const int NO_SERVER_NAME ;
extern const int SUCCESS ;
extern const int FAILURE ;

typedef int RC;

int ConnectToServer(const char* server, unsigned int port );

int Write(int mySocket, const char* fromBuf, int n);

int DoHttpRequest(const char* server,
          unsigned int port,
          const char* msg,
          char** oheader,  /* out */
          char** oresponse,  /* out */
          int* status); /* out */


/* uuencode a src string into dst string - dst must be long enough! */
/* return the length of the uuencoded string */

size_t
NetUUEncode(const unsigned char *src, unsigned char *dst, const int srclen);

RC MakeBasicAuthentication(const char *userid, const char *passwd,
               char** authentication);


int DoHttpPost(const char* server,
          unsigned int port,
          const char* uri,
          const char* msg,
          const char* authentication,
          char** header,  /* out */
          char** response,  /* out */
          int* status); /* out */

/*
 * Scan the incoming strins s and replace special characters by the
 * appropriate encodings and place the new string in od
 * if od is 0, memory is allocated
 * This is a special version. It also encodes & and = because with agents,
 * the POST message (say B) is sent in another POST message (say A).
 * We don't want the server interpreting the contents of message B.
 * Therefore, we encode even the = and & characters.
 */
char* EncodeUrl(char *od, const char *s);

/*
 * scan the response from the server and extract the id of the agent
 * created
 */
void
GetAgentId(const char* response, char* id);

