#include <sys/types.h>
#include "ONEiiop.h"
#ifndef WIN32
#ifndef HPUX
extern "C" int gethostname(char *name, int namelen);
#endif
#endif
long
MyRunFunction(ServerSession_t obj)
{
	char *buffer = "Hello World\n";
	size_t bufflen = strlen(buffer);
	WAIsetResponseContentLength(obj, bufflen);
	WAIStartResponse(obj);
	WAIWriteClient(obj, (const unsigned char *)buffer, bufflen);
	return 0;
}

//
// Two different ways to build here.
// WinMain if you want a windows app.
// main for Unix and windows console app.

#if defined(WIN32)
int WINAPI WinMain(
    HINSTANCE hInstance,	// handle to current instance
    HINSTANCE hPrevInstance,	// handle to previous instance
    LPSTR lpCmdLine,	// pointer to command line
    int nCmdShow 	// show state of window
   )
{
	int argc = 0;
	char **argv = NULL;
#else
int main(int argc, char **argv)
{
#endif
    char localhost[256];
    char *host;
    IIOPWebAppService_t obj;

	//
	// Normally we expect to see a hostname:port as
	// our one and only argument.  If we are started by
	// the OAD we will see an extra argument which should
	// be ignored.
	// The recommended registration with the OAD should 
	// specify the hostname:port as an argument to the
	// object provider.
	//
	// So try to ferrit out the hostname:port
#ifndef WIN32
	// Easier if we just have a normal main.
	if (argc > 1){
		if (argc == 1)
			host = argv[1];
		else if (*argv[1] != '-')
			host = argv[1];

#else
	// Windows command line drops the program name
	// that appears as argv[0].
	// GetCommandLine can be used to retrieve the
	// whole thing.
	if (lpCmdLine && *lpCmdLine){
		if (*lpCmdLine != '-'){
			char *sep = strchr(lpCmdLine, ' ');
			if (sep)
				*sep = '\0';
			host = lpCmdLine;
		}
#endif
	}else{
		gethostname(localhost, sizeof(localhost));
		host = localhost;
	}

	//
	// Pass in argc/argv if we have 'em.
#ifndef WIN32
	obj = WAIcreateWebAppService("CAPIIIOP", MyRunFunction, argc, argv);
#else
	obj = WAIcreateWebAppService("CAPIIIOP", MyRunFunction, 0, 0);
#endif
	WAIregisterService(obj, host);
	WAIimplIsReady();
	return 0;
}
