#include <sys/types.h>
#include "ONESrvPI.hpp"


#define FALSE 0
#define TRUE 1

#ifdef WIN32
#include <windows.h>
#include <strstrea.h>
#else
#include <strstream.h>
#ifndef HPUX
extern "C" int gethostname(char *, int);
extern "C" int sleep(int);
#endif /* HPUX */
#define Sleep(_t) sleep(_t)
#endif



const char *instanceName="WASP";
//
// Declare a WAS class deriving from Netscape base class
//
class WebApplicationServicePrototype: public WAIWebApplicationService
{
public:
    WebApplicationServicePrototype(const char *object_name = (const char *)NULL, int argc=0, char **argv=0);
    long Run(WAIServerRequest_ptr session);
	char *getServiceInfo();
};

WebApplicationServicePrototype::WebApplicationServicePrototype(const char *object_name, int argc, char **argv):
WAIWebApplicationService(object_name, argc, argv)
{
}

long
WebApplicationServicePrototype::Run(WAIServerRequest_ptr session)
{

	//
	// Defaults to status 200 OK.
	//
	char *cookiebuff = NULL;
	if (session->getCookie(cookiebuff)== WAISPIFailure)
		session->setCookie("INSTANCE", instanceName, "", "", "/", WAI_FALSE);
		session->setCookie("TYPE", "WABS", "", "", "/iiop-cgi", WAI_FALSE);

	// Defaults to "text/html" content type.

	WAIServerContext_ptr context = session->getContext();
	ostrstream outstr;
	outstr << "<P><FONT SIZE=+3>The easy WAI to powerful Web Applications.</FONT></P>";
	if (cookiebuff){
		outstr << "<P><B>Cookie:</B> " << cookiebuff << "</P>";
		StringDelete(cookiebuff);
	}
	char *var;
	if ((var = context->getHost()) && *var){
		outstr << "<P><B>Web Server host:</B> " << var << "</P>";
	}
	StringDelete(var);
	if ((var = context->getName()) && *var){
		outstr << "<P><B>Web Server name:</B> " << var << "</P>";
	}
	StringDelete(var);
	if ((var = context->getServerSoftware()) && *var){
		outstr << "<P><B>Web Server software:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestHeader("user-agent", var) == WAISPISuccess){
		outstr << "<P><B>User agent:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("REMOTE_HOST", var) == WAISPISuccess){
		outstr << "<P><B>Client host:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("REMOTE_ADDR", var) == WAISPISuccess){
		outstr << "<P><B>Client addr:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("CLIENT_CERT", var) == WAISPISuccess){
		outstr << "<P><B>Client cert:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("HTTPS_KEYSIZE", var) == WAISPISuccess){
		outstr << "<P><B>HTTPS keysize:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("REMOTE_USER", var) == WAISPISuccess){
		outstr << "<P><B>Client user:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("HTTPS_SECRETKEYSIZE", var) == WAISPISuccess){
		outstr << "<P><B>HTTPS secret key size:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("AUTH_TYPE", var) == WAISPISuccess){
		outstr << "<P><B>Auth type:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("SERVER_PROTOCOL", var) == WAISPISuccess){
		outstr << "<P><B>Server protocol:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("REQUEST_METHOD", var) == WAISPISuccess){
		outstr << "<P><B>Request method:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("URL", var) == WAISPISuccess){
		outstr << "<P><B>URL:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("URI", var) == WAISPISuccess){
		outstr << "<P><B>URI:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("SCRIPT_NAME", var) == WAISPISuccess){
		outstr << "<P><B>Script name:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("QUERY", var) == WAISPISuccess){
		outstr << "<P><B>Query:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("PATH_TRANSLATED", var) == WAISPISuccess){
		outstr << "<P><B>Path translated:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("PATH_INFO", var) == WAISPISuccess){
		outstr << "<P><B>Path info:</B> " << var << "</P>";
	}
	StringDelete(var);
	if (session->getRequestInfo("HTTPS", var) == WAISPISuccess){
		outstr << "<P><B>HTTPS:</B> " << var << "</P>";
	}
	StringDelete(var);
	outstr << endl;

	session->setResponseContentLength(outstr.pcount());
	//	oreqstream httpstr(*session);
	session->StartResponse();
	session->WriteClient((const unsigned char *)outstr.str(), outstr.pcount()); 
	outstr.rdbuf()->freeze(0);

    return 0;
}


char *
WebApplicationServicePrototype::getServiceInfo(void)
{
	return StringDup("test ver 1.0");
}


WebApplicationServicePrototype *anObject;


//
// Three different ways to build here.
// WASPinit is for in process.
// WinMain if you want a windows app.
// main for Unix and windows console app.

#if defined(BUILD_WASPDLL)
#if defined(WIN32)
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT
#endif
extern "C" {
	DLLEXPORT int WASPinit(pblock *pb, Session *sn, Request *rq);
}

//
// This function allows this thing to be loaded from a dll.
int
WASPinit(pblock *pb, Session *sn, Request *rq)
{

	anObject = new WebApplicationServicePrototype("WASPip");
	anObject->RegisterService();

	return 0;
}
#else
#if WIN32
int WINAPI WinMain(
    HINSTANCE hInstance,	    // handle to current instance
    HINSTANCE hPrevInstance,	// handle to previous instance
    LPSTR lpCmdLine,	        // pointer to command line
    int nCmdShow 	            // show state of window
   )
{
#else
int main(int argc, char **argv)
{
#endif
    char localhost[256];
	char *host;
    WAIBool rv;

	//
	// Normally we expect to see a hostname:port as
	// our one and only argument.  If we are started by
	// the OAD we will see an extra argument which should
	// be ignored.
	// The recommended registration with the OAD should 
	// specify the hostname:port as an argument to the
	// object provider.
	//
	// So try to ferrit out the hostname:port
#ifndef WIN32
	// Easier if we just have a normal main.
	if (argc > 1){
		if (argc == 1)
			host = argv[1];
		else if (*argv[1] != '-')
			host = argv[1];

#else
	// Windows command line drops the program name
	// that appears as argv[0].
	// GetCommandLine can be used to retrieve the
	// whole thing.
	if (lpCmdLine && *lpCmdLine){
		if (*lpCmdLine != '-'){
			char *sep = strchr(lpCmdLine, ' ');
			if (sep)
				*sep = '\0';
			host = lpCmdLine;
		}
#endif
	}else{
		gethostname(localhost, sizeof(localhost));
		host = localhost;
	}
	//
	// Note the extra args which would be argc, argv to pass
	// in ORB/BOA related settings...
    WebApplicationServicePrototype ExeFoo(instanceName, 0, 0);
	rv = ExeFoo.RegisterService(host);
    if (rv == WAI_FALSE) {
        printf("Failed to Register with %s\n", host);
    } else {
        /* Wait forever */
        while(1)
            Sleep(1000);
    }

	return 0;
}
#endif
