import java.applet.*;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import org.omg.CORBA.*;
import CosNaming.*;
import netscape.WAI.*;

/*
 * Implementation class for A WAS.
 * Extends wrapper class for WAI CORBA object
 * @Author Robin J. Maxwell Netscape Communications Corporation
 */

class MyWebApplicationService extends WAIWebApplicationService {
    String instanceName;
    int hitCount;
    MyWebApplicationService(java.lang.String name) throws
    CosNaming.NamingContextPackage.CannotProceed,
    CosNaming.NamingContextPackage.InvalidName,
    CosNaming.NamingContextPackage.AlreadyBound,
    org.omg.CORBA.SystemException{
        super(name);
        instanceName = name;
    }
    /*
     * This method demonstrates private member functions and
     * cross request persistent data.  This is just a simple
     * hit counter but serves to illustrate the point.
     */
    
    private synchronized int getHitCount(){
        return hitCount++;
    }
    public java.lang.String getServiceInfo(){
        return "Java Test Web Application Service V1.0";
    }
    /*
     * This is the meat of the application.
     * The method is invoked to fulfill an HTTP request.
     * @return 0 if no error, !0 if error occures.
     */
    public int Run(HttpServerRequest request){
        ByteArrayOutputStream streamBuf = new ByteArrayOutputStream();
        PrintStream content = new PrintStream(streamBuf);
       	HttpServerContext context = request.getContext();

        org.omg.CORBA.StringHolder cookiebuff = new org.omg.CORBA.StringHolder();
    	if (request.getCookie(cookiebuff)== HttpServerReturnType.Failure)
    		request.setCookie("INSTANCE", instanceName, "", "", "/", false);
   		request.setCookie("TYPE", "WABS", "", "", "/iiop-cgi", false);

        content.print("<P><FONT SIZE=+3>The easy WAI to powerful Java Web Applications.</FONT></P>");
        content.print("<P><FONT SIZE=+1><B>Hit count:</B> ");
        content.print(getHitCount());
        content.print("</FONT></P>");
    	if (cookiebuff.value != null)
	    	content.print("<P><B>Cookie:</B> " + cookiebuff.value + "</P>");

        String svar;
    	if ((svar = context.getHost()) != null){
            content.print("<P><B>Web Server host:</B> " + svar + "</P>");
        }
       	if ((svar = context.getName()) != null){
            content.print("<P><B>Web Server name:</B> " + svar + "</P>");
        }
    	if ((svar = context.getServerSoftware()) != null){
            content.print("<P><B>Web Server software:</B> " + svar + "</P>");
        }
        org.omg.CORBA.StringHolder value = new org.omg.CORBA.StringHolder();

    	if (request.getRequestHeader("user-agent", value) == HttpServerReturnType.Success){
            content.print("<P><B>User agent:</B> " + value.value + "</P>");
        }
    	if (request.getRequestInfo("REMOTE_HOST", value) == HttpServerReturnType.Success){
            content.print("<P><B>Client host:</B> " + value.value + "</P>");
        }
        if (request.getRequestInfo("REMOTE_ADDR", value) == HttpServerReturnType.Success){
            content.print("<P><B>Client addr:</B> " + value.value + "</P>");
        }
        if (request.getRequestInfo("CLIENT_CERT", value) == HttpServerReturnType.Success){
            content.print("<P><B>Client cert:</B> " + value.value + "</P>");
        }
        if (request.getRequestInfo("HTTPS_KEYSIZE", value) == HttpServerReturnType.Success){
            content.print("<P><B>HTTPS keysize:</B> " + value.value + "</P>");
        }
    	if (request.getRequestInfo("REMOTE_USER", value) == HttpServerReturnType.Success){
            content.print("<P><B>Client user:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("HTTPS_SECRETKEYSIZE", value) == HttpServerReturnType.Success){
            content.print("<P><B>HTTPS secret key size:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("AUTH_TYPE", value) == HttpServerReturnType.Success){
            content.print("<P><B>Auth type:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("SERVER_PROTOCOL", value) == HttpServerReturnType.Success){
            content.print("<P><B>Server protocol:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("REQUEST_METHOD", value) == HttpServerReturnType.Success){
            content.print("<P><B>Request method:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("URL", value) == HttpServerReturnType.Success){
            content.print("<P><B>URL:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("URI", value) == HttpServerReturnType.Success){
            content.print("<P><B>URI:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("SCRIPT_NAME", value) == HttpServerReturnType.Success){
            content.print("<P><B>Script name:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("QUERY", value) == HttpServerReturnType.Success){
            content.print("<P><B>Query:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("PATH_TRANSLATED", value) == HttpServerReturnType.Success){
            content.print("<P><B>Path translated:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("PATH_INFO", value) == HttpServerReturnType.Success){
            content.print("<P><B>Path info:</B> " + value.value + "</P>");
    	}
    	if (request.getRequestInfo("HTTPS", value) == HttpServerReturnType.Success){
            content.print("<P><B>HTTPS:</B> " + value.value + "</P>");
    	}

        HttpServerReturnType rc;
        byte[] outbuff = streamBuf.toByteArray();
        try {
            rc = request.setResponseContentLength(outbuff.length);
            request.StartResponse();
        }
        catch(org.omg.CORBA.SystemException e){
        }
		catch(java.lang.Exception e) {
		  System.err.println(e);
		}
        int write_cnt = request.WriteClient(outbuff);
        return 0;
    }

}

public class WASP {
  public static void main(java.lang.String[] args)throws UnknownHostException {
    try {
      // Initialize the ORB.
      ORB orb = org.omg.CORBA.ORB.init();
      // Initialize the BOA.
      BOA boa = orb.BOA_init();
      // Create the plug-in object.
      StringBuffer host = new StringBuffer(InetAddress.getLocalHost ().getHostName());
      if (args.length > 0)
        host = new StringBuffer(args[0]);
      try {
          MyWebApplicationService mpi = new MyWebApplicationService("JavaWASP");
          System.out.println(mpi + " is ready.");
          mpi.RegisterService(host.toString());
          // Wait for incoming requests
          boa.impl_is_ready();
      }
	  catch (org.omg.CORBA.UserException e){
	  }
      catch(java.lang.Exception e){
          System.out.println("WAS failed to initialize.");
          System.err.println(e);
      }
    }
    catch(org.omg.CORBA.SystemException e) {
      System.err.println(e);
    }
	catch(java.lang.Exception e) {
	  System.err.println(e);
	}
  }
}
