#ifndef _linklist_h
#define _linklist_h

template <class T> class LinkedList;

template <class T>
class ListEntry {
  T thisentry;
  ListEntry *nextentry;
  ListEntry *preventry;
  ListEntry(T& entry);
  friend class LinkedList<T>;
};

template <class T>
class LinkedList {
  ListEntry<T> *firstentry;
  ListEntry<T> *lastentry;
  ListEntry<T> *iterator;
  void RemoveEntry(ListEntry<T> *lentry);
  void InsertEntry(T& entry, ListEntry<T> *lentry);
 public:
  LinkedList();
  ~LinkedList();
  void AppendEntry(T& entry);
  void RemoveEntry(int pos = -1);
  void InsertEntry(T& entry, int pos=-1);
  T *FindEntry(int pos);
  T *CurrentEntry();
  T *FirstEntry();
  T *LastEntry();
  T *NextEntry();
  T *PrevEntry();
};






#endif

