#include <linklist.h>
#include <fact_s.hh>

class Calc : public _sk_calc
{
    public:
	Calc(const char *object_name = NULL);
	~Calc();
	CORBA::Long add(CORBA::Long x, CORBA::Long y);
};

Calc::Calc(const char *object_name) : _sk_calc(object_name)
{
}

Calc::~Calc()
{
}

CORBA::Long Calc::add(CORBA::Long x, CORBA::Long y)
{
	return x + y;
}


class Factory: public _sk_factory
{
    private:
	LinkedList<obj_entry>	object_list;
    public:
	Factory(const char *object_name = NULL);
	~Factory();
	calc_ptr create_obj(const char * name);
	void delete_obj(const char * name);
};

Factory::Factory(const char *object_name) : _sk_factory(object_name)
{
}

Factory::~Factory()
{
}

calc_ptr Factory::create_obj(const char * name) 
{
	CORBA::BOA_var boa = _boa();
	cout << "Creating object " << name << endl;
	Calc *new_calc_obj = new Calc(name);
	obj_entry *new_obj_ent = new obj_entry;
	new_obj_ent->obj_name = (const char *)name;
	new_obj_ent->obj_ref = ((calc *)new_calc_obj);
	calc::_duplicate(new_calc_obj);
	object_list.AppendEntry(*new_obj_ent);	
	boa->obj_is_ready(new_calc_obj);
	return new_calc_obj;
}

void Factory::delete_obj(const char * name)
{
	int counter = 0;
	cout << "Deleting object " << name << endl;
	obj_entry *ent = object_list.FirstEntry();

	while (ent != NULL) {
		if (strcmp(ent->obj_name, name) == 0) {
			calc *calc_obj = ent->obj_ref;
			calc_obj->_release();
			object_list.RemoveEntry(counter);
			return;
		}
		counter++;
		ent = object_list.NextEntry();
	}
	cout << "Deletion failed: Object not found" << endl;
}


int main(int argc, char * const *argv)
{
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
	CORBA::BOA_var boa = orb->BOA_init(argc, argv);

	Factory fact;

	boa->obj_is_ready(&fact);
	boa->impl_is_ready();
	
	return(1);
}
