#include <iostream.h>
#include <lib_c.hh>


int main(int argc, char *const *argv)
{
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
	CORBA::Boolean ret;
	if (argc < 3) {
		cout << "library_client: You must specify an author and title"
			<< endl;
		return(0);
	}
	book book_entry;
	book_entry.author = (const char *)argv[1];
	book_entry.title = (const char *)argv[2];

	library_var library_object;
	try {
		library_object = library::_bind();
	}
	catch(const CORBA::Exception& excep) {
		cout << "Error binding to library" << endl;
		cout << excep;
		return(0);
	}
	cout << "Bound to library server" << endl;
	try {
		ret = library_object->add_book(book_entry);
	}
	catch(const CORBA::SystemException& excep) {
		cout << "Error adding book" << endl;
		cout << excep;
		return(0);
	}
	if (ret)
		cout << "add_book invocation succeeded" << endl;
	else 
		cout << "add_book invocation failed" << endl;

	return(1);

}


