#include <signal.h>
#include "libsrv.h"

class LibraryActivator : public CORBA::Activator
{
	CORBA::Object_ptr activate(CORBA::ImplementationDef_ptr impl);
	void deactivate(CORBA::Object_ptr, 
			CORBA::ImplementationDef_ptr impl );
};

CORBA::Object_ptr LibraryActivator::activate(CORBA::ImplementationDef_ptr impl)
{
	return new Library(impl->object_name());
}

void LibraryActivator::deactivate(CORBA::Object_ptr obj, 
			CORBA::ImplementationDef_ptr )
{
	CORBA::release(obj);
} 

int main(int argc, char * const *argv)
{
	// Initialize ORB. 
	// Conforms to ORB initialization spec - 94-10-24
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
	CORBA::BOA_var boa = orb->BOA_init(argc, argv);
	
	CORBA::ReferenceData id;


	CORBA::ActivationImplDef impl("library", "Harvard", id, 
			new LibraryActivator);

	boa->obj_is_ready(NULL, &impl);

	// do something, and get ready to receive requests
	boa->impl_is_ready();

	return(1);
}


Library::Library(const char *object_name) : _sk_library(object_name)
{
	cout << "object is instantiated" << endl;
}


CORBA::Boolean Library::add_book(const book& book_info)
{
	return bk_list.add_to_list(book_info);
}
