#include <iostream.h>
#include <fstream.h>
#include "db_c.hh"


int main(int argc, char *const *argv)
{
	CORBA::ORB_ptr orb = CORBA::ORB_init(argc, argv);


	DB_var db;
	try {
		db = DB::_bind();
	}
	catch(CORBA::Exception& excep) {
			cout << "Error binding to library" << endl;
			cout << excep;
	}

	ofstream obj_file("objref.out");
	for (CORBA::ULong i=0; i< 100; i++) {
		char str[100];
		sprintf(str, "Object%-d", i);
		DBObject_var obj(db->create_object(str));
		CORBA::String_var objref(orb->object_to_string((DBObject_ptr)obj));
		obj_file << objref << endl;
	}

	return(1);

}


