#ifndef _xdispatcher_h
#define _xdispatcher_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1992, 1993 by PostModern Computing Technologies, Inc.         */
/*                          1032 Elwell Court, Suite 240                    */
/*                          Palo Alto, California, USA                      */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#ifdef INTERACTIVE
#define Object XObject
#define class Xclass
#include <X11/Intrinsic.h>
#undef class
#undef Object
#else
extern "C" {
#define Object XObject
#define class Xclass
#include <X11/Intrinsic.h>
#undef class
#undef Object
}
#endif

#include "dispatch.h"

class XTimerMap;
class XFileMap;
class XDispatcher: public Dispatcher
{
        friend XTimerMap;
    public:
#ifdef AIXV3
	XDispatcher(XtAppContext app_context=(XtAppContext)NULL);
#else
	XDispatcher(XtAppContext app_context=NULL);
#endif
	virtual ~XDispatcher();

	virtual void link(int fd, DispatcherMask, IOHandler*);
	virtual IOHandler* handler(int fd, DispatcherMask) const;
	virtual void unlink(int fd);

	virtual void startTimer(long sec, long usec, IOHandler *);
	virtual void stopTimer(IOHandler *);

	virtual iv_boolean setReady(int , DispatcherMask) 
		{ return 0; } // Not implemented
	virtual void dispatch(); 
	virtual iv_boolean dispatch(long&, long& ) 
		{ return 0; } // Not implemented
	virtual iv_boolean dispatch(timeval *val) {
		return Dispatcher::dispatch(val);
	}

	XtAppContext   appContext() const { return _app; }
     private: 
	XtAppContext 	_app;
	XTimerMap	*_first;
	XTimerMap	*_last;
	XFileMap	*_files;
};

#endif
