#ifndef _iiop_h
#define _iiop_h
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc   		    */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive				    */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

// This file was generated by Orbeline compiler and later modified

#include <strvar.h>
#include <oseq.h>
#include <stexcep.h>

#if defined(BYTE_ORDER)
#undef BYTE_ORDER
#endif

class _PMCEXPORT IIOP {
    public:
	
	struct _PMCEXPORT Version {
		CORBA::Char	major;
		CORBA::Char	minor;
		
	};

	static Version		CURRENT_VERSION;
	static CORBA::Char	MAGIC_WORD[4];
	static CORBA::Char	BYTE_ORDER;


        _PMCEXPORT friend NCostream& operator<<(NCostream&, const Version& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, Version& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const Version& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, Version& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
	_PMCEXPORT friend CORBA::Boolean operator==(const Version& _o1, 
				const Version& _o2) {
		return (_o1.major == _o2.major && _o1.minor == _o2.minor);
	}
	
	struct _PMCEXPORT ObjectLocator {
		Version			iiop_version;
		CORBA::String_var	host;
		CORBA::UShort		port;
		CORBA::OctetSequence	object_key;

		ObjectLocator()  {
			iiop_version.major = CURRENT_VERSION.major;
			iiop_version.minor = CURRENT_VERSION.minor;
			port = 0;
		}
		ObjectLocator(const ObjectLocator& loc) :
			host(loc.host),
			port(loc.port),
			object_key(loc.object_key) {
			iiop_version.major = loc.iiop_version.major;
			iiop_version.minor = loc.iiop_version.minor;
		}
		static ObjectLocator *convert(const CORBA::OctetSequence&);
		CORBA::OctetSequence *convert() const;

#ifdef gcc272
                ~ObjectLocator() {}
#endif
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const ObjectLocator& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, ObjectLocator& );
	_PMCEXPORT friend NCistream& operator>>(NCistream& _strm, ObjectLocator*& _obj) {
		_obj = new ObjectLocator;
		_strm >> *_obj;
		return _strm;
	}
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const ObjectLocator& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, ObjectLocator& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	_PMCEXPORT friend istream& operator>>(istream& _strm, ObjectLocator*& _obj) {
		_obj = new ObjectLocator;
		_strm >> *_obj;
		return _strm;
	}
	
#endif
		
	enum MsgType {
		Request,
		Reply,
		CancelRequest,
		LocateRequest,
		LocateReply,
		CloseConnection,
		MessageError,
		ShmConnectRequest,
		ShmConnectReply
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream& _strm, MsgType _enum_type) {
		_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend NCistream& operator>>(NCistream& _strm, MsgType& _enum_type) {
		CORBA::ULong temp;
		_strm >> temp;
		_enum_type = MsgType(temp);
		return _strm;
	}
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream& _strm, MsgType _enum_type) {
#if !defined(_PMC_NOSTDSTREAM)
		if( &_strm == &cout || &_strm == &cerr || &_strm == &clog) {
			_strm << "MsgType:";
			switch(_enum_type) {
				case Request:
					_strm << "Request" << endl;
					break;
				case Reply:
					_strm << "Reply" << endl;
					break;
				case CancelRequest:
					_strm << "CancelRequest" << endl;
					break;
				case LocateRequest:
					_strm << "LocateRequest" << endl;
					break;
				case LocateReply:
					_strm << "LocateReply" << endl;
					break;
				case CloseConnection:
					_strm << "CloseConnection" << endl;
					break;
				case MessageError:
					_strm << "MessageError" << endl;
					break;
				case ShmConnectRequest:
					_strm << "ShmConnectRequest" << endl;
					break;
				case ShmConnectReply:
					_strm << "ShmConnectReply" << endl;
					break;
			}
		}
		else 
#endif
			_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend istream& operator>>(istream& _strm, MsgType& _enum_type) {
		CORBA::ULong _temp;
		_strm >> _temp;
		_enum_type = MsgType(_temp);
		return _strm;
	}
	
#endif
	
		
	struct _PMCEXPORT MessageHeader {
		CORBA::Char	magic[4];
		Version		iiop_version;
		CORBA::Char	byte_order;
		CORBA::Char	message_type;
		CORBA::ULong	message_size;
		
		MessageHeader() {
			strncpy(magic, MAGIC_WORD, sizeof(magic));
			iiop_version.major = CURRENT_VERSION.major;
			iiop_version.minor = CURRENT_VERSION.minor;
			byte_order = BYTE_ORDER;
			message_size = 0;
		}
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const MessageHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, MessageHeader& );
					
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const MessageHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, MessageHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
	_PMCEXPORT friend CORBA::Boolean is_valid_header(const MessageHeader& hdr) {
		return (strncmp(hdr.magic, MAGIC_WORD, 4) ==0 &&
			hdr.iiop_version == CURRENT_VERSION);
	}

		
	typedef CORBA::ULong ServiceID;
	
	struct _PMCEXPORT ServiceContext {
		ServiceID		context_id;
		CORBA::OctetSequence	context_data;
		
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const ServiceContext& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, ServiceContext& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const ServiceContext& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, ServiceContext& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
	
	class _PMCEXPORT ServiceContextList
	{
	    public:
		static ServiceContext *allocbuf(CORBA::ULong nelems) {
			return new ServiceContext[nelems];
		}
		static void freebuf(ServiceContext *data) {
			if (data) delete[] data;
		}
		ServiceContextList(CORBA::ULong max=0);
		ServiceContextList(CORBA::ULong max,
			CORBA::ULong length,
			ServiceContext *data,
			CORBA::Boolean release=0);
		ServiceContextList(const ServiceContextList&);
		~ServiceContextList();
		ServiceContextList& operator=(const ServiceContextList&);
		CORBA::ULong maximum() const { return _num_allocated; }
		void length(CORBA::ULong len);
		CORBA::ULong length() const { return _count;}
		ServiceContext& operator[](CORBA::ULong index) {
			return _contents[index];
		}
		const ServiceContext& operator[](CORBA::ULong index) 
						const {
			return _contents[index];
		}
		_PMCEXPORT friend NCostream& operator<<(NCostream&, const ServiceContextList&);
		_PMCEXPORT friend NCostream& operator<<(NCostream& strm, 
					const ServiceContextList *obj) {
			if ( obj == (ServiceContextList*)NULL)
				PMCTHROW(CORBA::BAD_PARAM());
			else
				strm << *obj;
			return strm;
		}
		_PMCEXPORT friend NCistream& operator>>(NCistream&, ServiceContextList&);
		_PMCEXPORT friend NCistream& operator>>(NCistream& strm, 
					ServiceContextList*& obj) {
		obj = new ServiceContextList;
			strm >> *obj;
			return strm;
		}
#ifndef OPTIMIZE
		_PMCEXPORT friend ostream& operator<<(ostream&, const ServiceContextList&);
		_PMCEXPORT friend istream& operator>>(istream& strm, 
					ServiceContextList& obj) {
			NCistream istrm(strm);
			istrm >> obj;
			return strm;
		}
		_PMCEXPORT friend istream& operator>>(istream& strm, 
					ServiceContextList *& obj) {
			NCistream istrm(strm);
			istrm >> obj;
			return strm;
		}
#endif
		static ServiceContextList *duplicate(ServiceContextList* ptr) {
			if (ptr) ptr->_ref_count++;
			return ptr;
		}
		static void release(ServiceContextList *ptr) {
			if (ptr && ( --ptr->_ref_count == 0) )
				delete ptr;
		}
	    private:
		ServiceContext	*_contents;
		CORBA::ULong	_count;
		CORBA::ULong	_num_allocated;
		CORBA::Boolean	_release_flag;
		CORBA::Long	_ref_count;
	};
	
	
		
	static const ServiceID TransactionService; /* 0 */
		
	struct _PMCEXPORT RequestHeader {
		ServiceContextList		service_context;
		CORBA::ULong			request_id;
		CORBA::Boolean			response_expected;
		CORBA::OctetSequence		object_key;
		CORBA::String_var		operation;
		CORBA::OctetSequence		requesting_principal;
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const RequestHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, RequestHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream& _strm, RequestHeader*& _obj) {
		_obj = new RequestHeader;
		_strm >> *_obj;
		return _strm;
	}
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const RequestHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, RequestHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	_PMCEXPORT friend istream& operator>>(istream& _strm, RequestHeader*& _obj) {
		_obj = new RequestHeader;
		_strm >> *_obj;
		return _strm;
	}
	
#endif
		
	enum ReplyStatusType {
		NO_EXCEPTION,
		USER_EXCEPTION,
		SYSTEM_EXCEPTION,
		LOCATION_FORWARD
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream& _strm, 
					ReplyStatusType _enum_type) {
		_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend NCistream& operator>>(NCistream& _strm, 
					ReplyStatusType& _enum_type) {
		CORBA::ULong temp;
		_strm >> temp;
		_enum_type = ReplyStatusType(temp);
		return _strm;
	}
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream& _strm, ReplyStatusType _enum_type) {
#if !defined(_PMC_NOSTDSTREAM)
		if( &_strm == &cout || &_strm == &cerr || &_strm == &clog) {
			_strm << "ReplyStatusType:";
			switch(_enum_type) {
				case NO_EXCEPTION:
					_strm << "NO_EXCEPTION" << endl;
					break;
				case USER_EXCEPTION:
					_strm << "USER_EXCEPTION" << endl;
					break;
				case SYSTEM_EXCEPTION:
					_strm << "SYSTEM_EXCEPTION" << endl;
					break;
				case LOCATION_FORWARD:
					_strm << "LOCATION_FORWARD" << endl;
					break;
			}
		}
		else 
#endif
			_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend istream& operator>>(istream& _strm, 
					ReplyStatusType& _enum_type) {
		CORBA::ULong _temp;
		_strm >> _temp;
		_enum_type = ReplyStatusType(_temp);
		return _strm;
	}
	
#endif
	
		
	struct _PMCEXPORT ReplyHeader {
		ServiceContextList	service_context;
		CORBA::ULong		request_id;
		ReplyStatusType		reply_status;
		
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const ReplyHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, ReplyHeader& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const ReplyHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, ReplyHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
		
	struct _PMCEXPORT CancelRequestHeader {
		CORBA::ULong	request_id;
		
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const CancelRequestHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, CancelRequestHeader& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const CancelRequestHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, CancelRequestHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
		
	struct _PMCEXPORT LocateRequestHeader {
		CORBA::ULong		request_id;
		CORBA::OctetSequence	object_key;
		LocateRequestHeader() : request_id(0) {}
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const LocateRequestHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, LocateRequestHeader& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const LocateRequestHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, LocateRequestHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif
		
	enum LocateStatusType {
		UNKNOWN_OBJECT,
		OBJECT_HERE,
		OBJECT_FORWARD
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream& _strm, 
			LocateStatusType _enum_type) {
		_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend NCistream& operator>>(NCistream& _strm, 
			LocateStatusType& _enum_type) {
		CORBA::ULong temp;
		_strm >> temp;
		_enum_type = LocateStatusType(temp);
		return _strm;
	}
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream& _strm, 
			LocateStatusType _enum_type) {
#if !defined(_PMC_NOSTDSTREAM)
		if( &_strm == &cout || &_strm == &cerr || &_strm == &clog) {
			_strm << "LocateStatusType:";
			switch(_enum_type) {
				case UNKNOWN_OBJECT:
					_strm << "UNKNOWN_OBJECT" << endl;
					break;
				case OBJECT_HERE:
					_strm << "OBJECT_HERE" << endl;
					break;
				case OBJECT_FORWARD:
					_strm << "OBJECT_FORWARD" << endl;
					break;
			}
		}
		else 
#endif
			_strm << (CORBA::ULong)_enum_type;
		return _strm;
	}
	_PMCEXPORT friend istream& operator>>(istream& _strm, 
					LocateStatusType& _enum_type) {
		CORBA::ULong _temp;
		_strm >> _temp;
		_enum_type = LocateStatusType(_temp);
		return _strm;
	}
	
#endif
	
		
	struct _PMCEXPORT LocateReplyHeader {
		CORBA::ULong		request_id;
		LocateStatusType	locate_status;
		
	};
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const LocateReplyHeader& );
	_PMCEXPORT friend NCistream& operator>>(NCistream&, LocateReplyHeader& );
	
#ifndef OPTIMIZE
	_PMCEXPORT friend ostream& operator<<(ostream&, const LocateReplyHeader& );
	_PMCEXPORT friend istream& operator>>(istream& _strm, LocateReplyHeader& _obj) {
		NCistream _istrm(_strm);
		_istrm >> _obj;
		return _strm;
	}
	
#endif

	struct _PMCEXPORT ShmConnectRequestHeader {
		CORBA::ULong		request_id;
		CORBA::String_var	filename;
	};

	inline _PMCEXPORT friend NCostream& operator<<(NCostream& strm, 
				const ShmConnectRequestHeader& req) {
		strm << req.request_id << req.filename;
		return strm;
	}
	inline _PMCEXPORT friend NCistream& operator>>(NCistream& strm,
				ShmConnectRequestHeader& req) {
		strm >> req.request_id >> req.filename;
		return strm;
	}

	enum ShmConnectStatusType {
		SHM_NOT_SUPPORTED,
		SHM_CONNECTED,
		SHM_CONN_FAILED
	};
	inline _PMCEXPORT friend NCostream& operator<<(NCostream& strm, 
				ShmConnectStatusType typ) {
		strm << (CORBA::ULong)typ;
		return strm;
	}
	inline _PMCEXPORT friend NCistream& operator>>(NCistream& strm,
				ShmConnectStatusType& typ) {
		CORBA::ULong temp;
		strm >> temp;
		typ = ShmConnectStatusType(temp);
		return strm;
	}
		

	struct _PMCEXPORT ShmConnectReplyHeader {
		CORBA::ULong		request_id;
		ShmConnectStatusType	reply_status;
	};

	inline _PMCEXPORT friend NCostream& operator<<(NCostream& strm, 
				const ShmConnectReplyHeader& req) {
		strm << req.request_id << req.reply_status;
		return strm;
	}
	inline _PMCEXPORT friend NCistream& operator>>(NCistream& strm,
				ShmConnectReplyHeader& req) {
		strm >> req.request_id >> req.reply_status;
		return strm;
	}

};

#endif

