#ifndef _mstrm_h
#define _mstrm_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include "typecode.h"

// Base class for all Marshalling/Unmarshalling streams
class _PMCEXPORT CORBA_MarshalStream: public NCistream, public NCostream
{
    private:
	static const char	*_class_name;
    protected:
	CORBA_MarshalStream() {}
    public:
	virtual ~CORBA_MarshalStream() {}
	virtual CORBA::MarshalStream& rewindInBuffer() = 0;
	virtual CORBA::MarshalStream& rewindOutBuffer() = 0;
	virtual CORBA::MarshalStream& rewindBuffer() {
		rewindInBuffer(); 
		return rewindOutBuffer(); 
	}
	virtual CORBA::MarshalStream& flushRead() =0;
	virtual CORBA::MarshalStream& sendMessage(CORBA::ULong timeout_secs=0) = 0;
	virtual CORBA::MarshalStream& receiveMessage(CORBA::ULong timeout_secs = 0) = 0;
	virtual CORBA::MarshalStream&  sendAndWaitForReply(CORBA::ULong timeout_secs = 0) 
				= 0;

	virtual void putTypeCode(const CORBA::TypeCode_ptr) =0;
	virtual void getTypeCode(CORBA::TypeCode_ptr&) =0;

	static const char *desc() { return _class_name; }
	virtual const char *className() const { return _class_name; }
	virtual NCbool isKindOf(const char *name) const {
			return (name == _class_name || 
				NCistream::isKindOf(name) ||
				NCostream::isKindOf(name));
	}
};

#endif
