// "@(#)Module Name: ncobjmacros.h Version:2.3 Date: 94/06/19"
#ifndef _ncobjmacros_h
#define _ncobjmacros_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <pmcdef.h>

// -------------------------------------------------------------------------
// Definition of macros used by classes deriving from NCObject class
// -------------------------------------------------------------------------

#ifndef STRINGIZE
#if defined(__STDC__) || defined(_Windows) || defined(__DECCXX) || defined(hpux)
#define STRINGIZE(s)            #s
#else
#define STRINGIZE(s)            "s"
#endif
#endif

#ifdef PSOS
#define DECLARE_CLASSINFO(classname)                            \
        static NCTypeInfo               class_info;
#else
#define DECLARE_CLASSINFO(classname)                            \
        static const NCTypeInfo         class_info;
#endif


#define DECLARE_NCOBJECT_CLASS(classname)				\
   private:								\
	DECLARE_CLASSINFO(classname)					\
   public:								\
	static const NCTypeInfo *desc();				\
	virtual const NCTypeInfo *classInfo() const;			\
	inline friend NCistream& operator>>(NCistream& strm,		\
				classname*& obj) {			\
		obj = (classname *)strm.readTransObj();			\
		return strm;						\
	}								\
	virtual void write(NCostream& ) const;				\
	virtual void prettyPrint(NCostream& ) const;			\
									\
	virtual unsigned hash() const;					\
	virtual int compare(const NCObject& ) const;			\
	static NCTransObject *readFrom(NCistream& strm);		\
	classname(NCistream& strm)

#if defined(PSOS)
#define DEFINE_NCOBJECT_CLASS(classname)				\
const NCTypeInfo *classname::classInfo() const				\
	{ return &classname::class_info; }				\
const NCTypeInfo *classname::desc() { return &classname::class_info; }	\
NCTransObject *classname::readFrom(NCistream& strm)			\
	{ return new classname(strm); }					\
NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)&classname::readFrom, NCObject::desc(), 0)

#elif defined(_MSC_BUG)
#define DEFINE_NCOBJECT_CLASS(classname)				\
const NCTypeInfo *classname::classInfo() const				\
	{ return &class_info; }				\
const NCTypeInfo *classname::desc() { return &class_info; }	\
NCTransObject *classname::readFrom(NCistream& strm)			\
	{ return new classname(strm); }					\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)&classname::readFrom, NCObject::desc(), 0)

#else
#define DEFINE_NCOBJECT_CLASS(classname)				\
const NCTypeInfo *classname::classInfo() const				\
	{ return &classname::class_info; }				\
const NCTypeInfo *classname::desc() { return &classname::class_info; }	\
NCTransObject *classname::readFrom(NCistream& strm)			\
	{ return new classname(strm); }					\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)&classname::readFrom, NCObject::desc(), 0)
#endif
	
#define DEFINE_NCOBJECT_CLASS1(classname, base)				\
	DEFINE_TRANS_CLASS1(classname, base)

#define DEFINE_NCOBJECT_CLASS2(classname, base1, base2)			\
	DEFINE_TRANS_CLASS2(classname, base1, base2)

#define DEFINE_NCOBJECT_CLASS3(classname, base1, base2, base3)		\
	DEFINE_TRANS_CLASS3(classname, base1, base2, base3)

#define DECLARE_NCOBJECT_ABSTRACT_CLASS(classname)			\
    private:								\
	DECLARE_CLASSINFO(classname)					\
    public:								\
	static const NCTypeInfo *desc();				\
	virtual const NCTypeInfo *classInfo() const;			\
	inline friend NCistream& operator>>(NCistream& strm,		\
				classname*& obj) {			\
		obj = (classname *)strm.readTransObj();			\
		return strm;						\
	}								\
	classname(NCistream& strm);					\
	virtual void write(NCostream& ) const;				\
	virtual void prettyPrint(NCostream& ) const;			\
									\
	virtual unsigned hash() const;					\
	virtual int compare(const NCObject& ) const			

#ifdef PSOS
#define DEFINE_NCOBJECT_ABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::classInfo() const				\
	{ return &classname::class_info; }				\
const NCTypeInfo *classname::desc() { return &classname::class_info; }	\
NCTypeInfo classname::class_info(STRINGIZE(classname), \
	(NCTransReadFunc)0, NCObject::desc(), 0)

#elif defined(_MSC_BUG)
#define DEFINE_NCOBJECT_ABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::classInfo() const				\
	{ return &class_info; }				\
const NCTypeInfo *classname::desc() { return &class_info; }	\
const NCTypeInfo classname::class_info(STRINGIZE(classname), \
	(NCTransReadFunc)0, NCObject::desc(), 0)

#else	
#define DEFINE_NCOBJECT_ABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::classInfo() const				\
	{ return &classname::class_info; }				\
const NCTypeInfo *classname::desc() { return &classname::class_info; }	\
const NCTypeInfo classname::class_info(STRINGIZE(classname), \
	(NCTransReadFunc)0, NCObject::desc(), 0)
#endif
	
#define DEFINE_NCOBJECT_ABSTRACT_CLASS1(classname, base)		\
	DEFINE_TABSTRACT_CLASS1(classname, base)

#define DEFINE_NCOBJECT_ABSTRACT_CLASS2(classname, base1, base2)	\
	DEFINE_TABSTRACT_CLASS2(classname, base1, base2)

#define DEFINE_NCOBJECT_ABSTRACT_CLASS3(classname, base1, base2, base3)	\
	DEFINE_TABSTRACT_CLASS3(classname, base1, base2, base3)


#endif
