// "@(#)Module Name: nctypeinfo.h Version:2.2 Date: 94/06/19"
#ifndef _nctypeinfo_h
#define _nctypeinfo_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <pmcdef.h>

// ---------------------------------------------------------------------
// This class contains bare bones class information required to 
// facilitate Object I/O
// ---------------------------------------------------------------------
class _PMCEXPORT NCTransObject;
class _PMCEXPORT NCistream;

typedef NCTransObject *( *NCTransReadFunc)(NCistream& );
class _PMCEXPORT NCTypeInfo
{
    private:
	const char 		*_name;			// Class name
	NCTransReadFunc		_read_func;		// Read Function
	short			_num_bases;		// Num of bases
	NCTypeInfo		**_bases;		// Base type info

	NCTypeInfo(const NCTypeInfo& );			// Prevent copying
	NCTypeInfo& operator=(const NCTypeInfo&); 	// Prevent assignment
    public:
	NCTypeInfo(const char *name,  NCTransReadFunc readfunc, ...);
	virtual ~NCTypeInfo();
	int operator==(const NCTypeInfo& p) const {
		return (_name == p._name);
	}
	int operator!=(const NCTypeInfo& p) const {
		return (! (*this == p) );
	}
	const char *className() const { return _name; }
	NCTransReadFunc readFunc() const { return _read_func; }

	int hasBase(const NCTypeInfo& p) const; 
	int canCast(const NCTypeInfo& p) const {
		return ( this == &p || hasBase(p) );
	}
	static const NCTypeInfo *typeInfo(const char *name);
	static NCTransReadFunc readFunc(const char *name); 

};

#endif
