// "@(#)Module Name: nctransobj.h Version:2.1 Date: 94/06/19"
#ifndef	_nc_transobj_h
#define	_nc_transobj_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <pmcdef.h>

// ----------------------------------------------------------------------
// Base class for all NetClasses generic Objects. Classes derived from
// Object can perform Object I/O
// ----------------------------------------------------------------------
#ifndef _NCbool
#define _NCbool
typedef int NCbool;
#define NC_YES	1
#define NC_NO	0
#endif

#ifndef _ncboolean
#define _ncboolean
typedef unsigned char ncboolean;
#endif

#ifndef _ncoctet
#define _ncoctet
typedef unsigned char ncoctet;
#endif


#include <nciostrm.h>
#include <nctinfo.h>


extern void NCinit();
class _PMCEXPORT NCTransObject
{
    public:
  	virtual void	           	write(NCostream& strm) const =0;
  	virtual const NCTypeInfo*  	classInfo() const = 0;
	virtual void			printOn(ostream& strm=cout) const;
 	virtual void             	prettyPrint(NCostream& strm) const { 
						write(strm); 
					}
	virtual void			readFromStream(istream& ) {}
	inline friend  NCistream& operator>>(NCistream& strm, 
			NCTransObject*& obj) {
		obj = strm.readTransObj();
		return strm;
	}
	virtual   ~NCTransObject() {}
	NCTransObject() {}
	NCTransObject(NCistream& strm) { strm.addToTbl(*this); }
	int hasBase(const NCTypeInfo& p) const {
		return ( classInfo()->hasBase(p) );
	}
	int canCast(const NCTypeInfo& p) const {
		return ( classInfo() == &p || hasBase(p) );
	}
};


#if defined(__BORLANDC__)
ostream& _PMCEXPORT operator<<(ostream& ostrm, const NCTransObject& obj);
istream& _PMCEXPORT operator>>(istream& istrm, NCTransObject& obj);
#else
_PMCEXPORTFUNC ostream& operator<<(ostream& ostrm, const NCTransObject& obj);
_PMCEXPORTFUNC istream& operator>>(istream& istrm, NCTransObject& obj);
#endif

#include <nctrmacr.h>

#endif
