// "@(#)Module Name: nctrmacros.h Version:2.1 Date: 94/03/11"
#ifndef	_nctrmacros_h
#define	_nctrmacros_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <pmcdef.h>

#ifdef PSOS
#include <psos.h>
#include <prepc.h>
#else
#include <stdlib.h>
#endif

// Macro to define some members for classes derived from NCTransObject
#ifndef STRINGIZE
#if defined(__STDC__) || defined(_Windows) || defined(__DECCXX) || defined(hpux)
#define STRINGIZE(s)		#s
#else
#define STRINGIZE(s)		"s"
#endif
#endif


#ifdef PSOS
#define DECLARE_CLASSINFO(classname)				\
	static NCTypeInfo		class_info;	
#else
#define DECLARE_CLASSINFO(classname)				\
	static const NCTypeInfo		class_info;	
#endif

#define  DECLARE_TRANS_CLASS(classname)				\
     private:							\
	DECLARE_CLASSINFO(classname)				\
     public:							\
	static const NCTypeInfo *desc();			\
	virtual const NCTypeInfo*  classInfo() const;            \
	inline friend NCistream& operator>>(NCistream& strm, 	\
				classname*& obj) {		\
		obj = (classname *)strm.readTransObj();		\
		return strm;					\
	}							\
      	virtual void         write(NCostream& ) const;     	\
	static NCTransObject*      readFrom(NCistream& strm);	\
	classname(NCistream& strm)

// Macro for abstract classes derived from NCTransObject
#define DECLARE_TABSTRACT_CLASS(classname)			\
    private:							\
	DECLARE_CLASSINFO(classname)				\
    public:							\
	static const NCTypeInfo *desc();			\
	virtual const NCTypeInfo*  classInfo() const;           \
	inline friend NCistream& operator>>(NCistream& strm, 	\
				classname*& obj) {		\
		obj = (classname *)strm.readTransObj();		\
		return strm;					\
	}							\
	classname(NCistream& strm);				\
	virtual void write(NCostream& ) const	

#ifdef PSOS
#define  DEFINE_TRANS_CLASS(classname)				\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, 0) 
	   
#define  DEFINE_TRANS_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, baseclass::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS2(classname, base1, base2)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), \
	base2::desc(), base3::desc(), 0)

#define  DEFINE_TRANS_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(),   \
	base2::desc(), base3::desc(), base4::desc(), 0)	


#define  DEFINE_TABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, 0) 
	   
#define  DEFINE_TABSTRACT_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, baseclass::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS2(classname, base1, base2)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),  \
	 base3::desc(), 0)

#define  DEFINE_TABSTRACT_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),	\
		base3::desc(), base4::desc(), 0)	
#elif defined(_MSC_BUG)
#define  DEFINE_TRANS_CLASS(classname)				\
const NCTypeInfo *classname::desc() { return &class_info;} 	\
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}					\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, 0) 
	   
#define  DEFINE_TRANS_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, baseclass::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS2(classname, base1, base2)		\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), \
	base2::desc(), base3::desc(), 0)

#define  DEFINE_TRANS_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(),   \
	base2::desc(), base3::desc(), base4::desc(), 0)	


#define  DEFINE_TABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, 0) 
	   
#define  DEFINE_TABSTRACT_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, baseclass::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS2(classname, base1, base2)	\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),  \
	 base3::desc(), 0)

#define  DEFINE_TABSTRACT_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),	\
		base3::desc(), base4::desc(), 0)	

#else
#define  DEFINE_TRANS_CLASS(classname)				\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, 0) 
	   
#define  DEFINE_TRANS_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, baseclass::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS2(classname, base1, base2)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TRANS_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(), \
	base2::desc(), base3::desc(), 0)

#define  DEFINE_TRANS_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
NCTransObject *classname::readFrom(NCistream& strm)		\
	{ return new classname(strm); }				\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)&classname::readFrom, base1::desc(),   \
	base2::desc(), base3::desc(), base4::desc(), 0)	


#define  DEFINE_TABSTRACT_CLASS(classname)			\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, 0) 
	   
#define  DEFINE_TABSTRACT_CLASS1(classname, baseclass)		\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, baseclass::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS2(classname, base1, base2)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 	\
	(NCTransReadFunc)0, base1::desc(), base2::desc(), 0)
	   
#define  DEFINE_TABSTRACT_CLASS3(classname, base1, base2, base3)	\
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),  \
	 base3::desc(), 0)

#define  DEFINE_TABSTRACT_CLASS4(classname, base1, base2, base3, base4) \
const NCTypeInfo *classname::desc() { return &classname::class_info;} \
const NCTypeInfo *classname::classInfo() const			\
	{ return &classname::class_info;}			\
const NCTypeInfo classname::class_info(STRINGIZE(classname), 		\
	(NCTransReadFunc)0, base1::desc(), base2::desc(),	\
		base3::desc(), base4::desc(), 0)	

#endif

inline NCTransObject *NCSafeCast(const NCTypeInfo *t, NCTransObject *p, 
		const char *file_name, int line_num)
{
	if ( p == (NCTransObject *)NULL )
		return p;
	if ( ! p->canCast(*t) ) {
		if ( t->className() == (const char *)NULL || 
				p->classInfo()->className() == 
				(const char *)NULL) {
			cout << "ClassInfo has not been initialized properly.";
			cout << " Make sure you have 'NCinit()' (for generic) ";
			cout << " or 'NCTinit()' (typed objects) at the ";
			cout << " begining of main to ensure proper static ";
			cout << " class initialization. \n";
			cout.flush();
			abort();
			return (NCTransObject *)NULL;
		}
		cout << "Invalid cast: Cannot cast '" 
			<< p->classInfo()->className()  
			<< "' to '" << t->className() << "'\n" ;
		cout << "File: " << file_name << ", Line: " << line_num << "\n";
		cout.flush();					
		abort();
		return (NCTransObject *)NULL;
	}
	else
		return p;
}

inline const NCTransObject *NCConstSafeCast(const NCTypeInfo *t, 
		const NCTransObject *p, const char *file_name, int line_num)
{
	if ( p == (NCTransObject *)NULL )
		return p;
	if ( ! p->canCast(*t) ) {
		if ( t->className() == (const char *)NULL || 
			p->classInfo()->className() == (const char *)NULL) {
			cout << "ClassInfo has not been initialized properly.";
			cout << " Make sure you have 'NCinit()' (for generic) ";
			cout << " or 'NCTinit()' (typed objects) at the ";
			cout << " begining of main to ensure proper static ";
			cout << " class initialization. \n";
			cout.flush();
			abort();
			return (NCTransObject *)NULL;
		}
		cout << "Invalid cast: Cannot cast '" 
			<< p->classInfo()->className()  
			<< "' to '" << t->className() << "'\n" ;
		cout << "File: " << file_name << ", Line: " << line_num << "\n";
		cout << "Object is \n" << *p << "\n";
		cout.flush();					
		abort();
		return (NCTransObject *)NULL;
	}
	else
		return p;
}

// -------------------------------------------------------------------------
// Macros to perform run-time type checking. 
// -------------------------------------------------------------------------

#ifdef  IGNORE_RUNTIME_CHECK

#define NCPTR_CAST(T, p) \
	(T *)(p)

#define NCREF_CAST(T, r) \
	(T&)(*(&r))

#define NCCONST_PTR_CAST(T, p) \
	(const T *)(p)

#define NCCONST_REF_CAST(T, r) \
	(const T&)(*(&r))

#else

#define NCPTR_CAST(T, p) \
	(T *)NCSafeCast(T::desc(), (p), __FILE__, __LINE__)

#define NCREF_CAST(T, r) \
	(T&)(*NCSafeCast(T::desc(), &(r), __FILE__, __LINE__))

#define NCCONST_PTR_CAST(T, p) \
	(const T *)NCConstSafeCast(T::desc(), (p), __FILE__, __LINE__)

#ifdef PSOS
#define NCCONST_REF_CAST(T, r) \
	(const T&)(*(T *)NCConstSafeCast(T::desc(), &(r), __FILE__, __LINE__))
#else
#define NCCONST_REF_CAST(T, r) \
	(const T&)(*NCConstSafeCast(T::desc(), &(r), __FILE__, __LINE__))
#endif

#endif

#endif
