#ifndef _orbtypes_h
#define _orbtypes_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <nciostrm.h>
#include <pmcdef.h>

class CORBA;

class CORBA_Object;
class CORBA_Object_var;

class CORBA_Environment;
class CORBA_Environment_var;

class CORBA_ORB;
class CORBA_ORB_var;

class CORBA_BOA;
class CORBA_BOA_var;

class CORBA_Any;
class CORBA_Any_var;

class CORBA_TypeCode;
class CORBA_TypeCode_var;

class CORBA_Context;
class CORBA_Context_var;

class CORBA_ImplementationDef;
class CORBA_ImplementationDef_var;

class CORBA_CreationImplDef;
class CORBA_CreationImplDef_var;

class CORBA_Activator;
class CORBA_Activator_var;

class CORBA_ActivationImplDef;
class CORBA_ActivationImplDef_var;

class CORBA_Request;
class CORBA_Request_var;

class CORBA_RequestSeq;
class CORBA_RequestSeq_var;

class CORBA_ServerRequest;
class CORBA_ServerRequest_var;

class CORBA_DynamicImplementation;
class CORBA_DynamicImplementation_var;

class CORBA_NamedValue;
class CORBA_NamedValue_var;

class CORBA_NVList;
class CORBA_NVList_var;

struct CORBA_BindOptions;
class CORBA_BindOptions_var;

class CORBA_Exception;
class CORBA_UserException;
class CORBA_SystemException;

class CORBA_UNKNOWN;
class CORBA_BAD_PARAM;
class CORBA_NO_MEMORY;
class CORBA_IMP_LIMIT;
class CORBA_COMM_FAILURE;
class CORBA_INV_OBJREF;
class CORBA_NO_PERMISSION;
class CORBA_INTERNAL;
class CORBA_MARSHAL;
class CORBA_INITIALIZE;
class CORBA_NO_IMPLEMENT;
class CORBA_BAD_TYPECODE;
class CORBA_BAD_OPERATION;
class CORBA_NO_RESOURCES;
class CORBA_NO_RESPONSE;
class CORBA_PERSIST_STORE;
class CORBA_BAD_INV_ORDER;
class CORBA_TRANSIENT;
class CORBA_FREE_MEM;
class CORBA_INV_IDENT;
class CORBA_INV_FLAG;
class CORBA_INTF_REPOS;
class CORBA_BAD_CONTEXT;
class CORBA_OBJ_ADAPTER;
class CORBA_DATA_CONVERSION;
class CORBA_OBJECT_NOT_EXIST;

class CORBA_StringSequence;
class CORBA_StringSequence_var;

class CORBA_OctetSequence;
class CORBA_OctetSequence_var;

class CORBA_MarshalStream;
class CORBA_MarshalOutBuffer;
class CORBA_MarshalInBuffer;

struct CORBA_MethodDescription;
class CORBA_TypeInfo;

class CORBA_String_var;

class PMCObjectImpl;
class PMCTypeInfo;
class PMCMarshalBuffer;

// IR interfaces 
class CORBA_AliasDef;
class CORBA_AliasDef_var;
class CORBA_ArrayDef;
class CORBA_ArrayDef_var;
class CORBA_AttributeDef;
class CORBA_AttributeDef_var;
class CORBA_ConstantDef;
class CORBA_ConstantDef_var;
class CORBA_Contained;
class CORBA_Contained_var;
class CORBA_Container;
class CORBA_Container_var;
class CORBA_EnumDef;
class CORBA_EnumDef_var;
class CORBA_ExceptionDef;
class CORBA_ExceptionDef_var;
class CORBA_IDLType;
class CORBA_IDLType_var;
class CORBA_IRObject;
class CORBA_IRObject_var;
class CORBA_InterfaceDef;
class CORBA_InterfaceDef_var;
class CORBA_ModuleDef;
class CORBA_ModuleDef_var;
class CORBA_OperationDef;
class CORBA_OperationDef_var;
class CORBA_PrimitiveDef;
class CORBA_PrimitiveDef_var;
class CORBA_Repository;
class CORBA_Repository_var;
class CORBA_StringDef;
class CORBA_StringDef_var;
class CORBA_StructDef;
class CORBA_StructDef_var;
class CORBA_TypedefDef;
class CORBA_TypedefDef_var;
class CORBA_UnionDef;
class CORBA_UnionDef_var;

// IR structs
struct CORBA_AttributeDescription;
class  CORBA_AttributeDescription_var;
struct CORBA_ConstantDescription;
class  CORBA_ConstantDescription_var;
struct CORBA_ExceptionDescription;
class  CORBA_ExceptionDescription_var;
struct CORBA_InterfaceDescription;
class  CORBA_InterfaceDescription_var;
struct CORBA_ModuleDescription;
class  CORBA_ModuleDescription_var;
struct CORBA_OperationDescription;
class  CORBA_OperationDescription_var;
struct CORBA_ParameterDescription;
class  CORBA_ParameterDescription_var;
struct CORBA_StructMember;
class  CORBA_StructMember_var;
struct CORBA_TypeDescription;
class  CORBA_TypeDescription_var;
struct CORBA_UnionMember;
class  CORBA_UnionMember_var;
struct CORBA_VersionSpec;
class  CORBA_VersionSpec_var;

// IR sequences 
class CORBA_AttrDescriptionSeq;
class CORBA_AttrDescriptionSeq_var;
class CORBA_ContainedSeq;
class CORBA_ContainedSeq_var;
class CORBA_ContextIdSeq;
class CORBA_ContextIdSeq_var;
class CORBA_EnumMemberSeq;
class CORBA_EnumMemberSeq_var;
class CORBA_ExcDescriptionSeq;
class CORBA_ExcDescriptionSeq_var;
class CORBA_ExceptionDefSeq;
class CORBA_ExceptionDefSeq_var;
class CORBA_InterfaceDefSeq;
class CORBA_InterfaceDefSeq_var;
class CORBA_OpDescriptionSeq;
class CORBA_OpDescriptionSeq_var;
class CORBA_ParDescriptionSeq;
class CORBA_ParDescriptionSeq_var;
class CORBA_RepositoryIdSeq;
class CORBA_RepositoryIdSeq_var;
class CORBA_SequenceDef;
class CORBA_SequenceDef_var;
class CORBA_StructMemberSeq;
class CORBA_StructMemberSeq_var;
class CORBA_UnionMemberSeq;
class CORBA_UnionMemberSeq_var;

class _PMCEXPORT CORBA
{
    public:
	typedef CORBA_Object Object;
	typedef CORBA_Object_var Object_var;
	typedef Object* Object_ptr;
	typedef Object* ObjectRef;
	
	typedef CORBA_Environment Environment;
	typedef CORBA_Environment_var Environment_var;
	typedef Environment* Environment_ptr;
	typedef Environment* EnvironmentRef;
	
	typedef CORBA_ORB ORB;
	typedef CORBA_ORB_var ORB_var;
	typedef ORB* ORB_ptr;
	typedef ORB* ORBRef;
	
	typedef CORBA_BOA BOA;
	typedef CORBA_BOA_var BOA_var;
	typedef BOA* BOA_ptr;
	typedef BOA* BOARef;
	
	typedef CORBA_Any Any;
	typedef CORBA_Any_var Any_var;
	typedef Any* Any_ptr;
	typedef Any* AnyRef;
	
	typedef CORBA_TypeCode TypeCode;
	typedef CORBA_TypeCode_var TypeCode_var;
	typedef TypeCode* TypeCode_ptr;
	typedef TypeCode* TypeCodeRef;
	
	typedef CORBA_Context Context;
	typedef CORBA_Context_var Context_var;
	typedef Context* Context_ptr;
	typedef Context* ContextRef;
	
	typedef CORBA_ImplementationDef ImplementationDef;
	typedef CORBA_ImplementationDef_var ImplementationDef_var;
	typedef ImplementationDef* ImplementationDef_ptr;
	typedef ImplementationDef* ImplementationDefRef;
	
	typedef CORBA_CreationImplDef CreationImplDef;
	typedef CORBA_CreationImplDef_var CreationImplDef_var;
	typedef CreationImplDef* CreationImplDef_ptr;
	typedef CreationImplDef* CreationImplDefRef;
	
	typedef CORBA_Activator Activator;
	typedef CORBA_Activator_var Activator_var;
	typedef Activator* Activator_ptr;
	typedef Activator* ActivatorRef;
	
	typedef CORBA_ActivationImplDef ActivationImplDef;
	typedef CORBA_ActivationImplDef_var ActivationImplDef_var;
	typedef ActivationImplDef* ActivationImplDef_ptr;
	typedef ActivationImplDef* ActivationImplDefRef;
	
	typedef CORBA_Request Request;
	typedef CORBA_Request_var Request_var;
	typedef Request* Request_ptr;
	typedef Request* RequestRef;

	typedef CORBA_RequestSeq RequestSeq;
	typedef CORBA_RequestSeq_var RequestSeq_var;
	typedef RequestSeq* RequestSeq_ptr;
	
	typedef CORBA_ServerRequest ServerRequest;
	typedef CORBA_ServerRequest_var ServerRequest_var;
	typedef ServerRequest* ServerRequest_ptr;
	typedef ServerRequest* ServerRequestRef;

	typedef CORBA_DynamicImplementation DynamicImplementation;
	typedef CORBA_DynamicImplementation_var DynamicImplementation_var;
	typedef CORBA_DynamicImplementation *DynamicImplementation_ptr;
	typedef CORBA_DynamicImplementation *DynamicImplementationRef;
	
	typedef CORBA_NamedValue NamedValue;
	typedef CORBA_NamedValue_var NamedValue_var;
	typedef NamedValue* NamedValue_ptr;
	typedef NamedValue* NamedValueRef;

	typedef CORBA_NVList NVList;
	typedef CORBA_NVList_var NVList_var;
	typedef NVList* NVList_ptr;
	typedef NVList* NVListRef;

	typedef CORBA_BindOptions BindOptions;
	typedef CORBA_BindOptions_var BindOptions_var;

	typedef CORBA_Exception Exception;
	typedef Exception* Exception_ptr;
	typedef Exception* ExceptionRef;

	typedef CORBA_UserException UserException;
	typedef CORBA_SystemException SystemException;
	typedef CORBA_UNKNOWN UNKNOWN;
	typedef CORBA_BAD_PARAM BAD_PARAM;
	typedef CORBA_NO_MEMORY NO_MEMORY;
	typedef CORBA_IMP_LIMIT IMP_LIMIT;
	typedef CORBA_COMM_FAILURE COMM_FAILURE;
	typedef CORBA_INV_OBJREF INV_OBJREF;
	typedef CORBA_NO_PERMISSION NO_PERMISSION;
	typedef CORBA_INTERNAL INTERNAL;
	typedef CORBA_MARSHAL MARSHAL;
	typedef CORBA_INITIALIZE INITIALIZE;
	typedef CORBA_NO_IMPLEMENT NO_IMPLEMENT;
	typedef CORBA_BAD_TYPECODE BAD_TYPECODE;
	typedef CORBA_BAD_OPERATION BAD_OPERATION;
	typedef CORBA_NO_RESOURCES NO_RESOURCES;
	typedef CORBA_NO_RESPONSE NO_RESPONSE;
	typedef CORBA_PERSIST_STORE PERSIST_STORE;
	typedef CORBA_BAD_INV_ORDER BAD_INV_ORDER;
	typedef CORBA_TRANSIENT TRANSIENT;
	typedef CORBA_FREE_MEM FREE_MEM;
	typedef CORBA_INV_IDENT INV_IDENT;
	typedef CORBA_INV_FLAG INV_FLAG;
	typedef CORBA_INTF_REPOS INTF_REPOS;
	typedef CORBA_BAD_CONTEXT BAD_CONTEXT;
	typedef CORBA_OBJ_ADAPTER OBJ_ADAPTER;
	typedef CORBA_DATA_CONVERSION DATA_CONVERSION;
	typedef CORBA_OBJECT_NOT_EXIST OBJECT_NOT_EXIST;

	typedef CORBA_StringSequence StringSequence;
	typedef CORBA_StringSequence_var StringSequence_var;
	typedef StringSequence* StringSequence_ptr;

	typedef CORBA_OctetSequence OctetSequence;
	typedef CORBA_OctetSequence_var OctetSequence_var;
	typedef OctetSequence* OctetSequence_ptr;

	typedef OctetSequence	  Principal;
	typedef Principal*	  Principal_ptr;
	typedef OctetSequence_var Principal_var;	

	typedef OctetSequence     ReferenceData;
	typedef OctetSequence*    ReferenceData_ptr;
	typedef OctetSequence_var ReferenceData_var;

	typedef CORBA_MarshalStream     MarshalStream;
	typedef CORBA_MarshalStream*    MarshalStream_ptr;
	typedef CORBA_MarshalOutBuffer  MarshalOutBuffer;
	typedef CORBA_MarshalOutBuffer* MarshalOutBuffer_ptr;
	typedef CORBA_MarshalInBuffer   MarshalInBuffer;
	typedef CORBA_MarshalInBuffer*  MarshalInBuffer_ptr;

	typedef CORBA_MethodDescription MethodDescription;
	typedef CORBA_TypeInfo TypeInfo;

	typedef Object *(*ObjectFactory)();
	typedef void (*Skeleton)(void *, 
				 MarshalStream& strm,
				 Principal_ptr principal, 
				 const char *operation_name,
				 void *priv_data);

	typedef char*			char_ptr;
	typedef CORBA_String_var	String_var;
	typedef char*        		Identifier;
	typedef CORBA_String_var        Identifier_var;
	typedef char*        		RepositoryId;
	typedef CORBA_String_var        RepositoryId_var;

	typedef short			Short;
	typedef unsigned short		UShort;

#if defined(CRAY)
	typedef short			Long;
	typedef long			LongLong;
	typedef unsigned short		ULong;
	typedef unsigned long		ULongLong;
#elif defined(__alpha)
	typedef int			Long;
	typedef long			LongLong;
	typedef unsigned int 		ULong;
	typedef unsigned long		ULongLong;
#else
	typedef long			Long;
	typedef unsigned long		ULong;
#endif

	typedef char			Char;
	typedef float			Float;
	typedef double			Double;
	typedef unsigned char		Boolean;
	typedef unsigned char		Octet;


#if defined(gcc272)
	// GCC complains that Status declared void
	typedef int Status;
#else
	typedef void Status;
#endif
	typedef Long Flags;
	static const Long ARG_IN;
	static const Long ARG_OUT;
	static const Long ARG_INOUT;
	static const Long IN_COPY_VALUE;

	enum TCKind {
	  tk_null,
	  tk_void,
	  tk_short,
	  tk_long,
	  tk_ushort,
	  tk_ulong,
	  tk_float,
	  tk_double,
	  tk_boolean,
	  tk_char,
	  tk_octet,
	  tk_any,
	  tk_TypeCode,
	  tk_Principal,
	  tk_objref,
	  tk_struct,
	  tk_union,
	  tk_enum,
	  tk_string,
	  tk_sequence,
	  tk_array,
	  tk_alias,
	  tk_except
	};

	enum exception_type { 
	  NO_EXCEPTION =0, 
	  USER_EXCEPTION=1, 
	  SYSTEM_EXCEPTION=2 
	};

	enum CompletionStatus {
	  COMPLETED_YES = 0,
	  COMPLETED_NO = 1,
	  COMPLETED_MAYBE = 2
	};

	enum Policy {
	  SHARED_SERVER,
	  UNSHARED_SERVER,
	  SERVER_PER_METHOD
	};

	enum DefinitionKind {
	  dk_none,
	  dk_all,
	  dk_Attribute,
	  dk_Constant,
	  dk_Exception,
	  dk_Interface,
	  dk_Module,
	  dk_Operation,
	  dk_Typedef,
	  dk_Alias,
	  dk_Struct,
	  dk_Union,
	  dk_Enum,
	  dk_Primitive,
	  dk_String,
	  dk_Sequence,
	  dk_Array,
	  dk_Repository
	};

	enum PrimitiveKind {
	  pk_null,
	  pk_void,
	  pk_short,
	  pk_long,
	  pk_ushort,
	  pk_ulong,
	  pk_float,
	  pk_double,
	  pk_boolean,
	  pk_char,
	  pk_octet,
	  pk_any,
	  pk_TypeCode,
	  pk_Principal,
	  pk_string,
	  pk_objref
	};

	enum AttributeMode {
	  ATTR_NORMAL,
	  ATTR_READONLY
	};

	enum OperationMode {
	  OP_NORMAL,
	  OP_ONEWAY
	};

	enum ParameterMode {
	  PARAM_IN,
	  PARAM_OUT,
	  PARAM_INOUT
	};

	// Context class conforming to C++ mapping as specified in OMG Document
	// 94-9-14, Page 100
	static const Long CTX_RESTRICT_SCOPE;

	static Boolean ByteOrder;

	// TypeCode constants as specified by Interface Repository Document
	// (OMG doc 94-11-7) page 46 and C++ mapping (OMG doc 94-9-14)
	// page 74.
	// The TypeCode constants for Interface Repository structures are
	// defined in the ir.h file
	
	static TypeCode_ptr _tc_null;
	static TypeCode_ptr _tc_void;
	static TypeCode_ptr _tc_short;
	static TypeCode_ptr _tc_long;
	static TypeCode_ptr _tc_ushort;
	static TypeCode_ptr _tc_ulong;
	static TypeCode_ptr _tc_float;
	static TypeCode_ptr _tc_double;
	static TypeCode_ptr _tc_boolean;
	static TypeCode_ptr _tc_char;
	static TypeCode_ptr _tc_octet;
	static TypeCode_ptr _tc_any;
	static TypeCode_ptr _tc_TypeCode;
	static TypeCode_ptr _tc_Principal;
	static TypeCode_ptr _tc_Object;
	static TypeCode_ptr _tc_string;
	static TypeCode_ptr _tc_NamedValue;
	static TypeCode_ptr _tc_DefinitionKind;
	static TypeCode_ptr _tc_PrimitiveKind;
	static TypeCode_ptr _tc_AttributeMode;
	static TypeCode_ptr _tc_OperationMode;
	static TypeCode_ptr _tc_ParameterMode;
	static TypeCode_ptr& _tc_AttributeDescription;
	static TypeCode_ptr& _tc_ConstantDescription;
	static TypeCode_ptr& _tc_ExceptionDescription;
	static TypeCode_ptr& _tc_InterfaceDescription;
	static TypeCode_ptr& _tc_ModuleDescription;
	static TypeCode_ptr& _tc_OperationDescription;
	static TypeCode_ptr& _tc_ParameterDescription;
	static TypeCode_ptr& _tc_TypeDescription;

	static void string_free(char *data);
	static char *string_alloc(ULong len);
	static char *strdup(const char *str);
	static inline char *string_dup(const char *str) {
		return strdup(str);
	}
	static ULong hash(const char *str);	

	static Environment& current_environment();

#if defined(_Windows)
	static ORB_ptr ORB_init(int& argc, char *const *argv, 
				const char *orb_id= (char *)NULL,
				ostream& outstr=cout,
				ostream& logstr=clog,
				ostream& errstr=cerr);
#else
	static ORB_ptr ORB_init(int& argc, char *const *argv, 
				const char *orb_id= (char *)NULL);
#endif

	static void release(BOA_ptr) {}
	static void release(ORB_ptr) {}

	static void release(ActivationImplDef_ptr);
	static void release(Any_ptr);
	static void release(Context_ptr);
	static void release(CreationImplDef_ptr);
	static void release(Environment_ptr);
	static void release(Exception_ptr);
	static void release(ImplementationDef_ptr);
	static void release(MarshalInBuffer_ptr);
	static void release(MarshalOutBuffer_ptr);
	static void release(NamedValue_ptr);
	static void release(NVList_ptr);
	static void release(Object_ptr);
	static void release(OctetSequence_ptr);
	static void release(Request_ptr);
	static void release(ServerRequest_ptr);
	static void release(TypeCode_ptr);
	static void release(DynamicImplementation_ptr);

	static Boolean is_nil(Any_ptr);
	static Boolean is_nil(Context_ptr);
	static Boolean is_nil(Environment_ptr);
	static Boolean is_nil(Object_ptr);
	static Boolean is_nil(NamedValue_ptr);
	static Boolean is_nil(NVList_ptr);
	static Boolean is_nil(Request_ptr);
	static Boolean is_nil(ServerRequest_ptr);
	static Boolean is_nil(TypeCode_ptr);
	static Boolean is_nil(DynamicImplementation_ptr);

#       define TYPEDEF(TypeName) \
	  typedef CORBA_##TypeName TypeName; \
	  typedef CORBA_##TypeName##_var TypeName##_var; \
	  typedef TypeName* TypeName##_ptr; \
	  typedef TypeName* TypeName##Ref

	// IR Interfaces
	TYPEDEF(AliasDef);
	TYPEDEF(ArrayDef);
	TYPEDEF(AttributeDef);
	TYPEDEF(ConstantDef);
	TYPEDEF(Contained);
	TYPEDEF(Container);
	TYPEDEF(EnumDef);
	TYPEDEF(ExceptionDef);
	TYPEDEF(IDLType);
	TYPEDEF(IRObject);
	TYPEDEF(InterfaceDef);
	TYPEDEF(ModuleDef);
	TYPEDEF(OperationDef);
	TYPEDEF(PrimitiveDef);
	TYPEDEF(Repository);
	TYPEDEF(SequenceDef);
	TYPEDEF(StringDef);
	TYPEDEF(StructDef);
	TYPEDEF(TypedefDef);
	TYPEDEF(UnionDef);

#       undef TYPEDEF
	
#       define TYPEDEF(TypeName) \
	  typedef CORBA_##TypeName TypeName; \
	  typedef CORBA_##TypeName##_var TypeName##_var

	// IR Structures
	TYPEDEF(AttributeDescription);
	TYPEDEF(ConstantDescription);
	TYPEDEF(ExceptionDescription);
	TYPEDEF(InterfaceDescription);
	TYPEDEF(ModuleDescription);
	TYPEDEF(OperationDescription);
	TYPEDEF(ParameterDescription);
	TYPEDEF(StructMember);
	TYPEDEF(TypeDescription);
	TYPEDEF(UnionMember);
	TYPEDEF(VersionSpec);

	// IR Sequences 
	TYPEDEF(AttrDescriptionSeq);
	TYPEDEF(ContainedSeq);
	TYPEDEF(ContextIdSeq);
	TYPEDEF(EnumMemberSeq);
	TYPEDEF(ExcDescriptionSeq);
	TYPEDEF(ExceptionDefSeq);
	TYPEDEF(InterfaceDefSeq);
	TYPEDEF(OpDescriptionSeq);
	TYPEDEF(ParDescriptionSeq);
	TYPEDEF(RepositoryIdSeq);
	TYPEDEF(StructMemberSeq);
	TYPEDEF(UnionMemberSeq);

#       undef TYPEDEF

};

#endif
