#ifndef _oseq_h
#define _oseq_h
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc   		    */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive				    */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include "orbtypes.h"

class _PMCEXPORT CORBA_OctetSequence
{
    public:
	static CORBA::Octet *allocbuf(CORBA::ULong nelems) {
		return new CORBA::Octet[nelems];
	}
	static void freebuf(CORBA::Octet *data) {
		if (data) delete[] data;
	}
	CORBA_OctetSequence(CORBA::ULong max=0);
	CORBA_OctetSequence(CORBA::ULong max,
		CORBA::ULong length,
		CORBA::Octet *data,
		CORBA::Boolean release=0);
	CORBA_OctetSequence(const CORBA::OctetSequence&);
	~CORBA_OctetSequence();
	CORBA::OctetSequence& operator=(const CORBA::OctetSequence&);
	CORBA::ULong maximum() const { return _num_allocated; }
	void length(CORBA::ULong len);
	CORBA::ULong length() const { return _count;}
	CORBA::Octet& operator[](CORBA::ULong index) {
		return _contents[index];
	}
	const CORBA::Octet& operator[](CORBA::ULong index) const {
		return _contents[index];
	}
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const CORBA::OctetSequence&);
	_PMCEXPORT friend NCostream& operator<<(NCostream& strm, const CORBA::OctetSequence *obj);
	_PMCEXPORT friend NCistream& operator>>(NCistream&, CORBA::OctetSequence&);
	_PMCEXPORT inline friend NCistream& operator>>(NCistream& strm, 
			CORBA::OctetSequence*& obj) {
		obj = new CORBA::OctetSequence;
		strm >> *obj;
		return strm;
	}
	_PMCEXPORT friend ostream& operator<<(ostream&, const CORBA::OctetSequence&);
	_PMCEXPORT inline friend istream& operator>>(istream& strm, CORBA::OctetSequence& obj) {
		NCistream istrm(strm);
		istrm >> obj;
		return strm;
	}
	_PMCEXPORT inline friend istream& operator>>(istream& strm, CORBA::OctetSequence *& obj) {
		NCistream istrm(strm);
		istrm >> obj;
		return strm;
	}
	_PMCEXPORT friend CORBA::ULong hash(const CORBA::OctetSequence&);
	_PMCEXPORT friend CORBA::Long compare(const CORBA::OctetSequence&, const CORBA::OctetSequence& );
	static CORBA::OctetSequence *_duplicate(CORBA::OctetSequence* ptr) {
		if (ptr) ptr->_ref_count++;
		return ptr;
	}
	static void _release(CORBA::OctetSequence *ptr) {
		if (ptr && ( --ptr->_ref_count == 0) )
			delete ptr;
	}

	CORBA::Octet *data() const { return _contents; }
    private:
	CORBA::Octet	*_contents;
	CORBA::ULong	_count;
	CORBA::ULong	_num_allocated;
	CORBA::Boolean	_release_flag;
	CORBA::Long	_ref_count;
};

class _PMCEXPORT CORBA_OctetSequence_var
{
    public:
	CORBA_OctetSequence_var() { _ptr = (CORBA::OctetSequence *)NULL; }
	CORBA_OctetSequence_var(CORBA::OctetSequence *ptr) {
		_ptr = ptr;
	}
	CORBA_OctetSequence_var(const CORBA::OctetSequence_var& var) {
		_ptr = CORBA::OctetSequence::_duplicate((CORBA::OctetSequence *)var);
	}
	~CORBA_OctetSequence_var() { CORBA::OctetSequence::_release(_ptr); }
	CORBA::OctetSequence_var& operator=(CORBA::OctetSequence *ptr) {
		if (_ptr != ptr) {
			CORBA::OctetSequence::_release(_ptr);
			_ptr = ptr;
		}
		return *this;
	}
	CORBA::OctetSequence_var& operator=(const CORBA::OctetSequence_var& var) {
		CORBA::OctetSequence::_release(_ptr);
		_ptr = CORBA::OctetSequence::_duplicate((CORBA::OctetSequence *)var);
		return *this;
	}
	CORBA::OctetSequence *operator->() { return _ptr; }
	CORBA::Octet& operator[](CORBA::ULong index) {
		return _ptr->operator[](index);
	}
	const CORBA::Octet& operator[](CORBA::ULong index) const {
		return _ptr->operator[](index);
	}
	operator CORBA::OctetSequence *() const { return _ptr; }
#if defined(_HPCC_BUG)
	operator CORBA::OctetSequence*& () { return _ptr; }
#else
	operator CORBA::OctetSequence_ptr& () { return _ptr; }
#endif
	operator const CORBA::OctetSequence& () const { return *_ptr; }
	operator CORBA::OctetSequence& () { return *_ptr; }
	_PMCEXPORT friend NCostream& operator<<(NCostream& strm, 
			const CORBA::OctetSequence_var& var);
	_PMCEXPORT inline friend NCistream& operator>>(NCistream& strm,
			CORBA::OctetSequence_var& var) {
		if ( var._ptr == (CORBA::OctetSequence *)NULL )
			var._ptr = new CORBA::OctetSequence;
		strm >> *var._ptr;
		return strm;
	}
    private:
	CORBA::OctetSequence *_ptr;
};

#endif

