#ifndef _pmcdef_h_
#define _pmcdef_h_
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc   		    */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive				    */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

// OS specfic definitions
#if defined(WIN32)
#if !defined(_Windows)
#define _Windows 1
#define _MSC_BUG 1
#endif
#endif

#if defined(_Windows)
#if defined(BUILD_DLL)
#if defined(_MSC_VER)
#define _PMCEXPORT __declspec( dllexport )
#define _PMCEXPORTFUNC _PMCEXPORT
#else
#define _PMCEXPORT _export
#endif		// MSC_VER
#else
#if defined(_MSC_VER)
#define _PMCEXPORT __declspec( dllimport )
#define _PMCEXPORTFUNC _PMCEXPORT
#else
#define _PMCEXPORT _import
#endif	// MSC_VER
#endif	// BUILD_DLL

#else
#define _PMCEXPORT 
#define _PMCEXPORTFUNC
#endif 	// _Windows

// #define _PMC_NOEXCEPTIONS 1
// #define _PMC_NOEXCEPSPEC 1

#if defined(WIN32)
#define _PMC_NOEXCEPSPEC 1
#endif



#if defined(_PMC_NOEXCEPTIONS)
#define PMCTRY		CORBA::current_environment().clear(); 
#define PMCCATCH(type, var)	\
	if (type::_narrow(CORBA::current_environment().exception()) 	\
			!= NULL) {					\
		const type& var = *(type *)CORBA::current_environment().exception(); 

#define PMCAND_CATCH(type, var)	\
	}\
	if (type::_narrow(CORBA::current_environment().exception()) 	\
			!= NULL) {					\
		const type& var = *(type *)CORBA::current_environment().exception(); 

#define PMCEND_CATCH	\
	}\

#define PMCTHROW(type)	CORBA::current_environment().exception(new type)
#define PMCTHROW_LAST		
#define PMCTHROW_SPEC(x)	
#else
#define PMCTRY	try
#define PMCCATCH(type, var)	catch (const type & var)	
#define PMCTHROW(type)		throw type
#define PMCTHROW_LAST		throw;
#define PMCAND_CATCH(type,var)	catch (const type & var)
#define PMCEND_CATCH
#if defined(_PMC_NOEXCEPSPEC)
#define PMCTHROW_SPEC(x)
#else
#define PMCTHROW_SPEC(x)	throw x
#endif
#endif

#if defined(_WINDLL)
#include <pmclog.h>
#endif

#endif
