#ifndef _srequest_h_
#define _srequest_h_
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc   		    */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive				    */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: jkw & psm                                                       */
/*                                                                          */
/****************************************************************************/
#include "orbtypes.h"

class PMCDynamicImpl;
class _PMCEXPORT CORBA_ServerRequest 
{
	friend PMCDynamicImpl;
    public:
	const char* op_name() const { return _operation; }
	CORBA::Context_ptr ctx() { return CORBA::Context::_duplicate(_ctx); }
	void params(CORBA::NVList_ptr);
	void result(CORBA::Any_ptr);
	void exception(CORBA::Any_ptr exception);

	static CORBA::ServerRequest_ptr _duplicate(CORBA::ServerRequest_ptr 
						req) {
		if(req) req->_ref_count++;
    		return req;
  	}
	static CORBA::ServerRequest_ptr _nil() { return 0; }
	static void _release(CORBA::ServerRequest_ptr ptr) {
		if(ptr && --ptr->_ref_count <= 0) delete ptr;
  	}
    private:
	CORBA_ServerRequest(CORBA::MarshalStream& strm, 
			CORBA::Principal_ptr principal,
			const char* operation,
			void *);
	~CORBA_ServerRequest();
	CORBA_ServerRequest(const CORBA_ServerRequest&) {}
	CORBA::ServerRequest& operator=(const CORBA::ServerRequest&);

	CORBA::MarshalStream *_strm;
	CORBA::String_var _operation;
	CORBA::Context_var _ctx;
	CORBA::NVList_var _params;
	CORBA::Any_var _result;
	CORBA::Long _ref_count;
};


class CORBA_ServerRequest_var
{
    public:
	CORBA_ServerRequest_var() { _ptr = CORBA::ServerRequest::_nil(); }
	CORBA_ServerRequest_var(CORBA::ServerRequest_ptr ptr) { _ptr = ptr; }
	CORBA_ServerRequest_var(const CORBA::ServerRequest_var& var) {
		_ptr = CORBA::ServerRequest::_duplicate(var._ptr);
  	}
	~CORBA_ServerRequest_var() { CORBA::ServerRequest::_release(_ptr); }
	CORBA::ServerRequest_var& operator=(CORBA::ServerRequest_ptr p) {
		if (p != _ptr) reset(p);
		return *this;
  	}
	operator CORBA::ServerRequest_ptr() const { return _ptr; }
#if defined(_HPCC_BUG)
	operator CORBA::ServerRequest*&() { return _ptr; }
#else
	operator CORBA::ServerRequest_ptr&() { return _ptr; }
#endif
	CORBA::ServerRequest_ptr operator->() const { return _ptr; }
    private:
	CORBA::ServerRequest_ptr     _ptr;
	void reset(CORBA::ServerRequest_ptr p) {
		CORBA::ServerRequest::_release(_ptr);
		_ptr = p;
	}
	void operator=(const CORBA::ServerRequest_var&) {}
};

#endif
