#ifndef _stexcep_h
#define _stexcep_h	
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

#include "except.h"

#if !defined(_PMC_NOEXCEPTIONS)
#define PMCTHROW_THIS_EXCEP	throw *this
#else
#define PMCTHROW_THIS_EXCEP	\
	CORBA::current_environment().exception(_deep_copy())
#endif

#ifndef gcc272
#define declareStExcep(classname)					\
class _PMCEXPORT CORBA_##classname : public CORBA_SystemException	\
{									\
    public:								\
	static const Description	_description;			\
	CORBA_##classname(CORBA::ULong minor, CORBA::CompletionStatus status) : \
		CORBA_SystemException(minor, status) {}			\
	CORBA_##classname() {}						\
									\
	virtual const Description& _desc() const;			\
	static CORBA::classname *_narrow(CORBA::Exception *exc); 	\
	static CORBA::Exception *_factory() { return new CORBA::classname; } \
	virtual CORBA::Exception *_deep_copy() const { return new CORBA::classname(*this); } \
	void _throw() const;						\
}
#else
// GCC requires OBJECT_NOT_EXIST to have a destructor defined -- compiler bug
#define declareStExcep(classname)					\
class _PMCEXPORT CORBA_##classname : public CORBA_SystemException	\
{									\
    public:								\
	static const Description	_description;			\
	CORBA_##classname(CORBA::ULong minor, CORBA::CompletionStatus status) : \
		CORBA_SystemException(minor, status) {}			\
	CORBA_##classname() {}						\
									\
	virtual const Description& _desc() const;			\
	static CORBA::classname *_narrow(CORBA::Exception *exc); 	\
	static CORBA::Exception *_factory() { return new CORBA::classname; } \
	virtual CORBA::Exception *_deep_copy() const { return new CORBA::classname(*this); } \
	void _throw() const;						\
	~CORBA_##classname() {}						\
}
#endif

// Standard exception classes
declareStExcep(UNKNOWN);
declareStExcep(BAD_PARAM);
declareStExcep(NO_MEMORY);
declareStExcep(IMP_LIMIT);
declareStExcep(COMM_FAILURE);
declareStExcep(INV_OBJREF);
declareStExcep(NO_PERMISSION);
declareStExcep(INTERNAL);
declareStExcep(MARSHAL);
declareStExcep(INITIALIZE);
declareStExcep(NO_IMPLEMENT);
declareStExcep(BAD_TYPECODE);
declareStExcep(BAD_OPERATION);
declareStExcep(NO_RESOURCES);
declareStExcep(NO_RESPONSE);
declareStExcep(PERSIST_STORE);
declareStExcep(BAD_INV_ORDER);
declareStExcep(TRANSIENT);
declareStExcep(FREE_MEM);
declareStExcep(INV_IDENT);
declareStExcep(INV_FLAG);
declareStExcep(INTF_REPOS);
declareStExcep(BAD_CONTEXT);
declareStExcep(OBJ_ADAPTER);
declareStExcep(DATA_CONVERSION);
declareStExcep(OBJECT_NOT_EXIST);

#endif
