#ifndef _strvar_h_
#define _strvar_h_
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc   		    */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive				    */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include "orbtypes.h"

class _PMCEXPORT CORBA_String_var
{
    private:
	char		*_p;
    public:
	CORBA_String_var() : _p((char *)NULL) {}
	CORBA_String_var(const CORBA::String_var& var) : _p(CORBA::strdup(var._p)) {}
	CORBA_String_var(char *p) : _p(p) {}
	CORBA_String_var(const char *p) : _p(CORBA::strdup(p)) {}
	~CORBA_String_var() { CORBA::string_free(_p); }
	
	CORBA::String_var& operator=(const char *p) {
		CORBA::string_free(_p);
		_p = CORBA::strdup(p);
		return *this;
	}
	CORBA::String_var& operator=(char *p) {
		if (_p != p) {
			CORBA::string_free(_p);
			_p = p;
		}
		return *this;
	}
	CORBA::String_var& operator=(const CORBA::String_var& s) {
		CORBA::string_free(_p);
		_p = CORBA::strdup(s._p);
		return *this;
	}
	operator const char *() const { return _p; }
#if defined(_HPCC_BUG)
	operator char* &() { return _p; }
#else
	operator CORBA::char_ptr &() { return _p; }
#endif
	char &operator[](CORBA::ULong index) { return _p[index]; }
	char operator[](CORBA::ULong index) const { return _p[index]; }

#if !defined(_HPCC_BUG)
	_PMCEXPORT friend NCostream& operator<<(NCostream&, const CORBA::String_var&);
#endif
	_PMCEXPORT friend NCistream& operator>>(NCistream&, CORBA::String_var&);
	_PMCEXPORT friend ostream& operator<<(ostream&, const CORBA::String_var& );
	_PMCEXPORT friend CORBA::Long compare(const CORBA::String_var& s1, const CORBA::String_var& s2);
	_PMCEXPORT inline friend CORBA::ULong hash(const CORBA::String_var& s1) {
		return hash((const char *)s1);
	}
};



#endif
