#ifndef _typecode_h
#define _typecode_h
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc                   */
/*                                                                          */
/*  Copyright 1992, 1993, 1994 by PostModern Computing Technologies, Inc.   */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include "strvar.h"
#include "stexcep.h"

// This code was generated by orbeline and later modified

// Typecode definition conforms to the definition given in Interface
// Repository document (OMG doc 94-11-7 page 64).
// The C++ mapping (OMG doc 94-9-14) however specfies the mapping for
// 1.2 CORBA typecode spec. So the typecode mapping corresponds to C++
// mapping for the definitions that exist in C++ mapping (page 75) and
// also extend the mappping to conform to 94-11-7. The mapping for
// the new functions comply to the general mapping for psuedo objects
// as specified in OMG doc 94-9-14 page 67. 
// The argument passing rules are as specified under OMG doc 94-9-14
// page 62, 63.
//
// NOTE: The return parameters (Objects, Any etc ) need to be 'released' by
//      user just as they would be for normal Objects. The exception to this
//      rule is string. strings are returned as const char * and not
//      released. If '_var' types are used to hold returned values,
//      the returned values will be managed properly (even const char *)


_PMCEXPORT inline NCostream& operator<<(NCostream& _strm, CORBA::TCKind _enum_type) {
	_strm << (CORBA::ULong)_enum_type;
	return _strm;
}
_PMCEXPORT inline NCistream& operator>>(NCistream& _strm, CORBA::TCKind& _enum_type) {
	CORBA::ULong _temp;
	_strm >> _temp;
	_enum_type = CORBA::TCKind(_temp);
	return _strm;
}

_PMCEXPORT inline ostream& operator<<(ostream& _strm, CORBA::TCKind _enum_type) {
#if !defined(_PMC_NOSTDSTREAM)
	if( &_strm == &cout || &_strm == &cerr || &_strm == &clog) {
		_strm << "CORBA::TCKind:";
		switch(_enum_type) {
			case CORBA::tk_null:
				_strm << "tk_null" << endl;
				break;
			case CORBA::tk_void:
				_strm << "tk_void" << endl;
				break;
			case CORBA::tk_short:
				_strm << "tk_short" << endl;
				break;
			case CORBA::tk_long:
				_strm << "tk_long" << endl;
				break;
			case CORBA::tk_ushort:
				_strm << "tk_ushort" << endl;
				break;
			case CORBA::tk_ulong:
				_strm << "tk_ulong" << endl;
				break;
			case CORBA::tk_float:
				_strm << "tk_float" << endl;
				break;
			case CORBA::tk_double:
				_strm << "tk_double" << endl;
				break;
			case CORBA::tk_boolean:
				_strm << "tk_boolean" << endl;
				break;
			case CORBA::tk_char:
				_strm << "tk_char" << endl;
				break;
			case CORBA::tk_octet:
				_strm << "tk_octet" << endl;
				break;
			case CORBA::tk_any:
				_strm << "tk_any" << endl;
				break;
			case CORBA::tk_TypeCode:
				_strm << "tk_TypeCode" << endl;
				break;
			case CORBA::tk_Principal:
				_strm << "tk_Principal" << endl;
				break;
			case CORBA::tk_objref:
				_strm << "tk_objref" << endl;
				break;
			case CORBA::tk_struct:
				_strm << "tk_struct" << endl;
				break;
			case CORBA::tk_union:
				_strm << "tk_union" << endl;
				break;
			case CORBA::tk_enum:
				_strm << "tk_enum" << endl;
				break;
			case CORBA::tk_string:
				_strm << "tk_string" << endl;
				break;
			case CORBA::tk_sequence:
				_strm << "tk_sequence" << endl;
				break;
			case CORBA::tk_array:
				_strm << "tk_array" << endl;
				break;
			case CORBA::tk_alias:
				_strm << "tk_alias" << endl;
				break;
			case CORBA::tk_except:
				_strm << "tk_except" << endl;
				break;
		}
	}
	else 
#endif
		_strm << (CORBA::ULong)_enum_type;
	return _strm;
}
_PMCEXPORT inline istream& operator>>(istream& _strm, CORBA::TCKind& _enum_type) {
	CORBA::ULong _temp;
	_strm >> _temp;
	_enum_type = CORBA::TCKind(_temp);
	return _strm;
}

class _PMCEXPORT CORBA_TypeCode
{
	friend CORBA_Any;
    private:
	CORBA::TCKind          _kind;
	CORBA::Any             **_parameters;
	CORBA::ULong           _num_params;
	CORBA::Long            _default_index;
	CORBA::Boolean         _is_constant;
	CORBA::String_var      _id;
	CORBA::Long            _ref_count;
	
	
	CORBA_TypeCode(const CORBA_TypeCode&) {}
	void operator=(const CORBA_TypeCode&){}

    protected:
	CORBA_TypeCode();
    public:
	~CORBA_TypeCode();

	static CORBA::TypeCode_ptr _duplicate(CORBA::TypeCode_ptr obj);
	static CORBA::TypeCode_ptr _nil() { return (CORBA::TypeCode_ptr)NULL;}
	static void _release(CORBA::TypeCode_ptr obj);

	CORBA_TypeCode(NCistream& strm);
	void _write(NCostream& strm) const;
	
	// Constructor for types with no parameters
	CORBA_TypeCode(CORBA::TCKind kind, CORBA::Boolean is_constant);

	// Constructor for structures and exceptions
	CORBA_TypeCode(CORBA::TCKind kind, const char *rep_id, const char *name, 
		const CORBA::StructMemberSeq& members,
		CORBA::Boolean is_constant);

	// Constructor for Unions
	CORBA_TypeCode(const char *rep_id, const char *name,
		CORBA::TypeCode_ptr discrim_type, 
		const CORBA::UnionMemberSeq& members,
		CORBA::Boolean is_constant);

	// Constructor for enums
	CORBA_TypeCode(const char *rep_id, const char *name,
		const CORBA::EnumMemberSeq& members,
		CORBA::Boolean is_constant);

	// Constructor for alias
	CORBA_TypeCode(const char *rep_id, const char *name,
		CORBA::TypeCode_ptr original_type,
		CORBA::Boolean is_constant);

	// Constructor for interface
	CORBA_TypeCode(const char *rep_id, const char *name,
		CORBA::Boolean is_constant);

	// Constructor for strings
	CORBA_TypeCode(CORBA::ULong bound,
		CORBA::Boolean is_constant);

	// Constructor for sequence/arrays
	CORBA_TypeCode(CORBA::TCKind kind, CORBA::ULong len, 
		        CORBA::TypeCode_ptr element_type,	
		        CORBA::Boolean is_constant);

	// Constructor for recursive sequences
	CORBA_TypeCode(CORBA::ULong bound, CORBA::ULong offset, 
			CORBA::Boolean is_constant);


	class _PMCEXPORT Bounds: public CORBA_UserException
	{
	    public:
		static const Description        _description;
		
	
		Bounds() {}
		static CORBA::Exception *_factory() { return new Bounds(); }
		~Bounds() {}
		virtual const Description& _desc() const;
		static Bounds *_narrow(CORBA::Exception *exc);
		CORBA::Exception *_deep_copy() const { return new Bounds(*this); }
		void _throw() const;
	};
	
	
	class _PMCEXPORT BadKind: public CORBA_UserException
	{
	    public:
		static const Description        _description;
		
	
		BadKind() {}
		static CORBA::Exception *_factory() { return new BadKind(); }
		~BadKind() {}
		virtual const Description& _desc() const;
		static BadKind *_narrow(CORBA::Exception *exc);
		CORBA::Exception *_deep_copy() const { return new BadKind(*this); }
		void _throw() const {
#if !defined(_PMC_NOEXCEPTIONS)
			throw *this;
#else
			current_environment().exception(
				_deep_copy());
#endif
		}
	};
	
	
	// For all CORBA::TypeCode kinds
	CORBA::Boolean equal(CORBA::TypeCode_ptr tc) const;
	CORBA::TCKind kind() const { return _kind; }

	// For tk_objref, tk_struct, tk_union, tk_enum, tk_alias and tk_except
	const char* id() const 
			PMCTHROW_SPEC((BadKind));
	const char *name() const 
			PMCTHROW_SPEC((BadKind));

	// For tk_struct, tk_union, tk_enum and tk_except
	CORBA::ULong member_count() const
			PMCTHROW_SPEC((BadKind));
	const char *member_name(CORBA::ULong index) const
			PMCTHROW_SPEC((BadKind, Bounds));


	// For tk_struct, tk_union and tk_except
	CORBA::TypeCode_ptr member_type(CORBA::ULong index) const
			PMCTHROW_SPEC((BadKind, Bounds));

	// For tk_union
	CORBA::Any_ptr  member_label(CORBA::ULong index) const
			PMCTHROW_SPEC((BadKind, Bounds));
	CORBA::TypeCode_ptr discriminator_type() const
			PMCTHROW_SPEC((BadKind));
	CORBA::Long default_index() const
			PMCTHROW_SPEC((BadKind));


	// For tk_string, tk_sequence and tk_array
	CORBA::ULong length() const
			PMCTHROW_SPEC((BadKind));


	// For tk_sequence, tk_array and tk_alias
	CORBA::TypeCode_ptr content_type() const
			PMCTHROW_SPEC((BadKind));


	// deprecated  interface
	CORBA::Long param_count() const;
	CORBA::Any_ptr parameter(CORBA::Long index) const
			PMCTHROW_SPEC((Bounds));
	

	// PMC extensions
	_PMCEXPORT friend NCistream& operator>>(NCistream& strm, CORBA::TypeCode_ptr& obj);
	_PMCEXPORT friend NCostream& operator<<(NCostream& strm, const CORBA::TypeCode_ptr obj);
	_PMCEXPORT friend ostream& operator<<(ostream& strm, const CORBA::TypeCode_ptr obj);
	_PMCEXPORT inline friend istream& operator>>(istream& strm, CORBA::TypeCode_ptr& obj) {
		NCistream istrm(strm);
		istrm >> obj;
		return strm;
	}
	_PMCEXPORT friend CORBA::Long compare(const CORBA::TypeCode_ptr, const CORBA::TypeCode_ptr);
	_PMCEXPORT friend CORBA::ULong hash(const CORBA::TypeCode_ptr);
	CORBA::ULong _hash(CORBA::ULong maximum);
};

class _PMCEXPORT CORBA_TypeCode_var
{
    public:
	CORBA_TypeCode_var() : _ptr(CORBA::TypeCode::_nil()) {}
	CORBA_TypeCode_var(CORBA::TypeCode_ptr ptr) :_ptr(ptr) {}
	CORBA_TypeCode_var(const CORBA::TypeCode_var& var)
		:_ptr(CORBA::TypeCode::_duplicate((CORBA::TypeCode_ptr)var)) {}
	~CORBA_TypeCode_var() { CORBA::release(_ptr); }
	CORBA::TypeCode_var& operator=(CORBA::TypeCode_ptr p) {
		if (_ptr != p ) {
			CORBA::release(_ptr);
			_ptr = p;
		}
		return *this;
	}
	operator CORBA::TypeCode_ptr() const { return _ptr; }
#if defined(_HPCC_BUG)
	operator CORBA::TypeCode*&() { return _ptr; }
#else
	operator CORBA::TypeCode_ptr&() { return _ptr; }
#endif
	CORBA::TypeCode_ptr operator->() const { return _ptr; }
	_PMCEXPORT inline friend NCistream& operator>>(NCistream& strm, 
				CORBA::TypeCode_var& obj) {
		CORBA::release(obj._ptr);
		strm >> obj._ptr;
		return strm;
	}
	_PMCEXPORT inline friend ostream& operator<<(ostream& strm,
				const CORBA::TypeCode_var& obj) {
		strm << obj._ptr;
		return strm;
	}
    protected:
	CORBA::TypeCode_ptr    _ptr;
    private:
	void operator=(const CORBA::TypeCode_var& ) {}
};


#endif

