#ifndef _typeinfo_h_
#define _typeinfo_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include "orbtypes.h"

struct _PMCEXPORT CORBA_MethodDescription {
	char 		*method_name;
	CORBA::Skeleton	skeleton;
};

class _PMCEXPORT CORBA_TypeInfo
{
    private:
	PMCTypeInfo	*_impl;

	CORBA_TypeInfo(const CORBA::TypeInfo& );
	CORBA::TypeInfo& operator=(const CORBA::TypeInfo& );
    public:
	CORBA_TypeInfo(const char *name, const char *id, 
		CORBA::ObjectFactory factory, ...);
	CORBA_TypeInfo(const char *name, 
		CORBA::ULong num_methods,
		CORBA::MethodDescription *methods);

	~CORBA_TypeInfo();
	
	CORBA::Boolean operator==(const CORBA::TypeInfo& p) const;
	const char *interface_name() const;
	const char *repository_id() const;
	CORBA::Boolean has_base(const CORBA::TypeInfo& info, CORBA::Boolean direct=0) const;
	CORBA::Boolean can_cast(const CORBA::TypeInfo& info) const {
		return (*this == info || has_base(info));
	}
	
	static const CORBA::TypeInfo *type_info(const char *interface_name);


	PMCTypeInfo *impl() const;
};
#endif
	
