#!/usr/local/bin/oraperl

# -----------------------
# filename:
# write_cmodel_seguepage.pl
# written august 20 1996
# author Barbara Mihalas
# -----------------------

require '/oradata/disk4/httpd80/cgi-bin/cdata/pl/user_specs.pl';

#$user = 'stg_user';

# ===== HTML setup ======
  &html_header;
# ===== HTML setup ======

  print "<!-- 11/8/97 revision --><BR>\n";

$ENV{'ORACLE_HOME'}= "/usr/oracle";
$ENV{'PATH'} = "$path /usr/oracle/bin /bin /usr/bin /usr/ucb /usr/local/bin . ";
$ENV{'WOW_UID'}= "$user/$user";
$ENV{'ORACLE_SID'}= "mindy";
#print "query string is $ENV{'QUERY_STRING'}<BR>\n";

# ==========================================================
# ================= oraperl setup ==========================

# ------------------------------------------------------------
# First make sure that we are running under some form of perl.
# ------------------------------------------------------------
  eval "echo 'You must specify oraperl or coraperl.' ; exit"
	if 0;

# -----------------------------------------------
# make sure that we really are running (c)oraperl
# -----------------------------------------------
  die ("You should use oraperl, not perl\n") unless defined &ora_login;

# -----------------
# Set up debugging 
# -----------------
  $ora_debug = shift if $ARGV[0] =~ /^-#/;

# ----------------
# get error codes
# ----------------
  require('/usr/oracle/oraperl/src/oraperl.ph');

# ---------------------
# login to the database
# ---------------------
  $lda = &ora_login('mindy', $user, $user)	|| die $ora_errstr;

# ==============  end of oraperl setup =======================
# ============================================================

require '/oradata/disk4/httpd80/cgi-bin/cdata/pl/user_paths.pl';

# $mindypath = 'http://mindy.infomall.org:6380/';
# $oraclepath   = $mindypath.'cgi-bin/ifc/';
# $morkpath  = 'http://mork.infomall.org/';
# $docpath   = $mindypath.'wpdv/';
# $textpath  = '/oradata/disk4/carrier/wpdv/com_docs/';

# ==============  define cursors =============================

  $COUNT_MODELS  =
               "SELECT count(*)
                  FROM commercial_products
                 WHERE upper(model) LIKE :1
                   AND obsolete = 0";

  $GET_MODEL     =
               "SELECT model, modelalias  
                  FROM commercial_products
                 WHERE upper(model) LIKE :1 
                   AND obsolete = 0
                 ORDER BY model";

  $GET_TABLENAME   =
                 "SELECT datatablename 
                    FROM commercial_products 
                   WHERE model = :1";
 
  $GET_DEFAULT_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         defaultfieldorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND defaultfield=1
                     AND upper(tablename) = :1";
 
  $GET_DISPLAY_FIELDS = 
                 "SELECT fieldname, columncaption, fielddisplayname,
                         displayorder, englishunits
                    FROM field_properties
                   WHERE (units=1 OR units=0) 
                     AND displayfield=1
                     AND upper(tablename) = :1";

  $GET_TEXT_FILENAME  =
                 "SELECT t_filename, t_extension, t_pagetype
                    FROM model_text_pp_view
                   WHERE upper(model) = :1
                     AND lower(t_pagetype) = 'product page'";

  $GET_SEGUE_FILENAME  =
                 "SELECT t_filename, t_extension, t_pagetype
                    FROM model_text_pp_view
                   WHERE upper(model) = :1
                     AND lower(t_usage) LIKE 'segue to product%'";

  $GET_GRAPHICS       =
                 "SELECT a.title, a.caption, a.filename, a.extension,
                         b.pagetype, b.usage
                    FROM graphic_objects a, 
                         graphic_model_association b
                   WHERE b.model = :1
                     AND lower(b.pagetype) = 'product page'
                     AND a.graphicid = b.graphicid";

  $CHECK_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(pagetype) = :2";
  
  $CHECK_SEGUE_TEXT         =
                 "SELECT count(*) 
                    FROM text_model_association
                   WHERE upper(model) = :1
                     AND lower(usage) LIKE 'segue to product%'";
  

# require('get_com_data.pl');
# ==============  end of cursors =============================

# ============================================================
# =================== body of program ========================

# $query_string = $ENV{'QUERY_STRING'};
##   &write_comment("Query String is set to $query_string ");

# Read input buffer
#read( STDIN, $query_string, $ENV{'QUERY_STRING'} );
read( STDIN, $query_string, $ENV{'CONTENT_LENGTH'} );
# print "PATH_INFO =  $ENV{'$PATH_INFO'} <BR>\n";
# Optional printout
##print "<BR>BUFFER is $buffer\n";
#print "\n<br>CONTENT_LENGTH = $ENV{'CONTENT_LENGTH'}<br>\n";
#print "Query String is set to $query_string <BR>\n";
# print "<p><hr>";

# Parse input query string
  &parse($query_string);

  $modelstr = $value[0];
# $specifictype = $value[1];

  &write_model_seguepage ($modelstr);

# ==================end  body of program =====================
# ============================================================

# ===== HTML cleanup ====
  &html_footer;
# ===== HTML cleanup ====

# ==========================================================
# ================= oraperl cleanup ========================

# --------------------------------------------
# log out of the database (this is ESSENTIAL!)
# --------------------------------------------
  do ora_logoff($lda)				|| die $ora_errstr;

# ==============  end of oraperl cleanup =====================
# ============================================================

# =============== start of subroutines =======================

# *********************************************
# This Procedure Parses the Input from any Form
# *********************************************
sub parse {
   local($instring) = @_;
   local($x, $y);
   local(@temp);
   local(%fields);
   @temp = split("&", $instring);
## print "Input string to sub parse is $instring<BR>\n";

   for ($i = 0; $i <= $#temp; $i++) 
   {
       ($x, $y) = ($temp[$i] =~ /(\S*)=(\S*)/);
       $fields{$x} = $y;
       $value[$i]=$y;
       $value[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $value[$i]=~ tr/\+/ /;
       $name[$i] = $x;
       $name[$i]=~ s/%(..)/pack("c",hex($1))/ge;
       $name[$i]=~ tr/\+/ /;
       &write_comment("<FONT SIZE=4>$i . $name[$i] . $value[$i]</FONT> <br>\n");
   }
   $fields = $i-1;
   $numfields = $fields+1;
}


# **********************************************************************
# Writes the segue to the product page for the generaltype/specifictype
# **********************************************************************
sub write_model_seguepage
{
   local ($mdlstr) = @_;


 # print "<A NAME=\"pagetop\"></A>\n";
   &caw_frameD_back_header;
   &back_to_caw_model_search;
   print "<P><BR>\n";

   $csrcnt = &ora_open($lda, $COUNT_MODELS) || print "failed to open $COUNT_MODELS\n";
   $mdl = '%'.$mdlstr;
   $mdl = $mdl.'%';
   $mdl =~ tr/a-z/A-Z/;
   &ora_bind ($csrcnt, $mdl);
   ($mdlcount) = &ora_fetch($csrcnt);
   &ora_close($csrcnt);

   print "<CENTER><FONT SIZE=4>\n";
   print "Search Results<P>\n";
   print "The search for [$mdlstr] returned $mdlcount items.<BR>\n";
   print "</FONT></CENTER>\n";
   print "<P>\n";

   $csrmod = &ora_open($lda, $GET_MODEL) || die $ora_errstr;
   $csra   = &ora_open($lda, $GET_SEGUE_FILENAME) || die $ora_errstr;
   $csrc   = &ora_open($lda, $CHECK_SEGUE_TEXT) || die $ora_errstr;

   &write_comment("modelstring is $mdlstr\n");

   $modelin = "%$mdlstr%";
   $modelin =~ tr/a-z/A-Z/;
   &ora_bind ($csrmod, $modelin);

   &write_comment("after ora_bind to string ($modelin) of get_model cursor\n");

   $ii = 0;
   while ( ($mdl, $mdlalias) = &ora_fetch($csrmod) )
   {
      $model[$ii] = $mdl;
      $modelalias[$ii] = $mdlalias;

      &write_comment("$ii model is $model[$ii] \n");

      if ($modelalias[$ii] ne '')  
      {
         $modelname = $modelalias[$ii].' ('.$model[$ii].')';
      }
      else 
      {
         $modelname = $model[$ii];
      }
      $htmodelname = $model[$ii];
      $htmodelname =~ s/ /+/g;
      $htmodelname =~ s/-/%2D/g;

      if ($unittype eq '')
      {
         $unittype = 'English';
         $newunittype ='Metric';
      }
      $unitstring = "&unittype=$unittype";

    # $hreflink = 'cgi-bin/cdata/write_commdl_fieldpage.sh?modelno=';
      $hreflink = '/CMODDOCS.load_commdl_page?modelno=';
    # $unittype = '&unit_type=english';
      print "<BR><FONT SIZE=4>\n";
      print "<A  TARGET=\"_parent\" HREF=\"$oraclepath$hreflink$htmodelname$unitstring\" >\n";
      print "$modelname</A><P>\n";
      print "</FONT>\n";

      $uppermodel = $model[$ii];
      $uppermodel =~ tr/a-z/A-Z/;
    # print "<BR>uppercase of model is $uppermodel<BR>\n";
      &ora_bind($csrc, $uppermodel);
      while ( ($textno) = &ora_fetch ($csrc) )
      {
          $ntext = $textno;
          &write_comment("number of text files is $ntext \n");
      }

      if ($ntext == 0) 
      {
         print "<UL>\n";
         &write_comment("ntext = $ntext");
         print "<P><P>\n";
         print "</UL>\n";
      }
      if ($ntext > 0 )
      {
         $uppermodel = $model[$ii];
         $uppermodel =~ tr/a-z/A-Z/;
         &ora_bind ($csra, $uppermodel);
      #  print "<BR>upper model is $uppermodel<BR>\n";
      #  print "<BR>$ntext files to open: <BR>\n";
         while (  ($text_filename, $text_extension, $text_pagetype)
            = &ora_fetch($csra) )
         {
       #    print "$model[$ii] has text file [$text_filename]-[$text_extension] for page [$text_pagetype]<BR>\n";
            $text_filename =~ s/\s/_/g;
            $text_filename =~ s/-/_/g;
            $text_filename =~ s/&/and/g;
            $text_filename = $text_filename.".html";
            $text_location = $textpath.$text_filename;
            $print_text = "Unix text filename is [".$text_filename;
            &write_comment($print_text);
        #   print "<FONT SIZE=2>(Unix text filename is [$text_filename])</FONT><P>\n";
        #   print "Unix location is [$text_location<BR>\n";
            $text_link = $text_location;
         }
         print "<UL>\n";
         open(TEXTFILE, $text_link) || print "<P><P>\n";
         while (<TEXTFILE>)
         {
            chop;
            print "$_\n";
         } 
         close TEXTFILE;
         print "</UL>\n";
         print "<P>\n";
      }
      $ii++;
   }
   &ora_close ($csra);
   &ora_close ($csrc);
   &ora_close($csrmod);

   &frameD_topofpage;

#  &write_download_links ($modelin);
}

# ******************************************
# Writes lorum ipsum text
# ******************************************
sub write_lorem_ipsum
{
   print "<FONT SIZE=2>\n";
   print "Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy\n";
   print "nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.\n";
   print "Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy\n";
   print "nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.<BR>\n";
   print "</FONT>\n";
}
# ******************************************
# Writes download links for model
# ******************************************
sub write_download_links
{

   local ($modelin) = @_;

   $GET_DOWNLOADS  =
                  "SELECT a.downloadmodel, a.filename, a.extension,
                          a.description, b.model
                     FROM download_objects a, 
                          download_model_association b
                    WHERE a.downloadmodel = b.downloadmodel
                      AND b.model = :1";

   $csra = &ora_open($lda, $GET_DOWNLOADS) || die $ora_errstr;
   &ora_bind ($csra, $modelin);
   $ii = 0;
   while ( ($dlmodelid, $dlfilename, $dlext, $dldescribe, $dlmodel) = &ora_fetch($csra) )
   {
      $dlmid[$ii] = $dlmodelid;
      $dlfname[$ii] = $dlfilename;
      $dlfext[$ii] = $dlext;
      $dldesc[$ii] = $dldesc;
      $dlm[$ii] = $dlmodel;
      if ($ii == 0)
      {
         print "<HR>\n";
         print "<B>\n";
         print "For further information about this product, the following documents\n";
         print " are available for downloading by registered users.  The registration\n";
         print " procedure and form are available through the blue 'register' button\n";
         print " in the left frame.<P>\n";
         print "</B>\n";
      }
      print "<P>$dldesc[$ii]<P>\n";
      print "$dlm[$ii] has download $dlfname[$ii].$dlext[$ii]<P>\n";
      $ii++;
   }
   &ora_close($csra);
}

# ******************************************
# write the caw back header
# ******************************************
sub caw_frameD_back_header
{
   print "<A NAME=\"pagetop\"><A>\n";
   print "<A HREF=\"$docpath/com_ed1/index.html\" TARGET=\"_parent\">\n";
   print "<IMG SRC=\"$docpath/com_media/caw_header_back_button.gif\"\n";
   print " ALIGN=\"MIDDLE\" WIDTH=\"430\" HEIGHT=\"32\" BORDER=0></A>\n";
}

# ******************************************
# write caw back to product list header
# ******************************************
sub back_to_caw_products
{
   print "<BR>\n";
   print "<A HREF=\"$oraclepath/CPDOCS.write_gen_types_B\">back to product list</A>\n";
   print "<BR>\n";
}

# ******************************************
# write caw back to model search header
# ******************************************
sub back_to_caw_model_search
{
   print "<BR>\n";
   print "<A HREF=\"$oraclepath/CMODDOCS.com_model_search\">back to model search</A>\n";
   print "<BR>\n";
}

# ******************************************
# write the frameD topofpage
# ******************************************
sub frameD_topofpage
{
   print "<P ALIGN=\"RIGHT\">\n";
   print "<I>(<A HREF=\"#pagetop\">top of page</A><I>)\n";
   print "</P>\n";
}

# ******************************************
# writes text as HTML comment
# ******************************************
sub write_comment 
{
   local ($text) = @_; 
   print "<!-- $text -->\n";

}

# ******************************************
# This Procedure writes the HTML header
# ******************************************
sub html_header 
{
 print "Content-type:text/html\n\n";
 print "<HTML>\n";
 print +"<HEAD>\n";
 print +"<TITLE>Product Data Table and Information</TITLE>\n";
 print +"</HEAD>\n";
 print "<BODY BGCOLOR=\#FFFFFF >\n";
}

# ******************************************
# This Procedure writes the HTML footer
# ******************************************
sub html_footer 
{
  print "</BODY>";
  print "</HTML>";
}
